// geo.okapi See https://sg.geodatenzentrum.de/geo.okapi/
// License: https://raw.githubusercontent.com/de-bkg/geo.okapi/master/LICENSE
// Version: v1.0.2
// Proj4js definitions of all default projections that can be used in BKG WebMap
proj4.defs('EPSG:4258', '+proj=longlat +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +no_defs');
proj4.defs('EPSG:4839', '+proj=lcc +lat_1=48.66666666666666 +lat_2=53.66666666666666 +lat_0=51 +lon_0=10.5 +x_0=0 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:25832', '+proj=utm +zone=32 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:25833', '+proj=utm +zone=33 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:4647', '+proj=tmerc +lat_0=0 +lon_0=9 +k=0.9996 +x_0=32500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:5650', '+proj=tmerc +lat_0=0 +lon_0=15 +k=0.9996 +x_0=33500000 +y_0=0 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:3034', '+proj=lcc +lat_1=35 +lat_2=65 +lat_0=52 +lon_0=10 +x_0=4000000 +y_0=2800000 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:3035', '+proj=laea +lat_0=52 +lon_0=10 +x_0=4321000 +y_0=3210000 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:3044', '+proj=utm +zone=32 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:3045', '+proj=utm +zone=33 +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:31466', '+proj=tmerc +lat_0=0 +lon_0=6 +k=1 +x_0=2500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:31467', '+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:31468', '+proj=tmerc +lat_0=0 +lon_0=12 +k=1 +x_0=4500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:31469', '+proj=tmerc +lat_0=0 +lon_0=15 +k=1 +x_0=5500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:5676', '+proj=tmerc +lat_0=0 +lon_0=6 +k=1 +x_0=2500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:5677', '+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:5678', '+proj=tmerc +lat_0=0 +lon_0=12 +k=1 +x_0=4500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:5679', '+proj=tmerc +lat_0=0 +lon_0=15 +k=1 +x_0=5500000 +y_0=0 +ellps=bessel +towgs84=598.1,73.7,418.2,0.202,0.045,-2.455,6.7 +units=m +no_defs');
proj4.defs('EPSG:2397', '+proj=tmerc +lat_0=0 +lon_0=9 +k=1 +x_0=3500000 +y_0=0 +ellps=krass +towgs84=26,-121,-78,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:2398', '+proj=tmerc +lat_0=0 +lon_0=12 +k=1 +x_0=4500000 +y_0=0 +ellps=krass +towgs84=26,-121,-78,0,0,0,0 +units=m +no_defs');
proj4.defs('EPSG:2399', '+proj=tmerc +lat_0=0 +lon_0=15 +k=1 +x_0=5500000 +y_0=0 +ellps=krass +towgs84=26,-121,-78,0,0,0,0 +units=m +no_defs');

/**
 * Namespace: BKGWebMap
 * The BKGWebMap object provides a namespace for all BKGWebMap things.
 * @namespace BKGWebMap
 * @constructor BKGWebMap
 * @returns {object}
 */
var BKGWebMap = function () {
    return {};
};

/**
 * BKG WebMap Version
 * @type {string}
 * @constant BKGWebMap.VERSION
 */
BKGWebMap.VERSION = '0.7.4';

/**
 * OpenLayers version used in BKG WebMap
 * @type {string}
 * @constant BKGWebMap.OPENLAYERS_VERSIO
 */
BKGWebMap.OPENLAYERS_VERSION = '4.6.5';

/**
 * Native Projektion of WebAtlasDE
 * @type {string}
 * @constant BKGWebMap.PROJECTION
 */
BKGWebMap.PROJECTION = 'EPSG:25832';

/**
 * Default div id for map
 * @type {string}
 * @constant BKGWebMap.DEFAULT_MAP_DIV
 */
BKGWebMap.DEFAULT_MAP_DIV = 'map';

/**
 * Standard URL for BKG services
 * @type {string}
 * @constant BKGWebMap.BASE_URL
 */
BKGWebMap.BASE_URL = 'https://sg.geodatenzentrum.de/';

/**
 * URL of BKG maps services registry
 * @type {string}
 * @constant BKGWebMap.SERVICE_REGISTRY
 */
BKGWebMap.SERVICE_REGISTRY = ' https://sg.geodatenzentrum.de/gdz_service_registry/webmap/services';

/**
 * Configuration for secure BKG services (/security)
 * @type {Object}
 * @constant BKGWebMap.SECURITY
 * @property {string|null} UUID - BKG UUID (/security/UUID)
 * @property {string|null} appID - BKG Application ID (/security/appID)
 * @property {string|null} appDomain - Domain for BKG Application ID (/security/appDomain)
 */
BKGWebMap.SECURITY = {
    UUID: null,
    appID: null,
    appDomain: null,
    cookieCheck: false
};

/**
 * Default layer, if user does not define any layer in config
 * @type {Object}
 * @constant BKGWebMap.DEFAULT_LAYER
 * @property {string} type - Type of layer
 * @property {string} name - Name of layer shown in menu.
 * @property {string} ref - Reference of layer in BKG layer registry. This is the name of BKG layer to load.
 * @property {string|null} srsName - Projection of layer. If null, then map projection will be used.
 * @property {boolean} visibility - Initial visibility of layer.
 */
BKGWebMap.DEFAULT_LAYER = {
    type: 'BKG',
    name: 'WebAtlasDE',
    ref: 'webatlasde_light',
    srsName: 'EPSG:25832',
    visibility: true
};

/**
 * Standard extent of Germany in various projections
 * @type {Object}
 * @constant BKGWebMap.EXTENTS
 */
BKGWebMap.EXTENTS = {
    'EPSG:4326': [2.07498609301, 46.4840034677, 18.6083668593, 55.0242047281],
    'EPSG:4258': [2.07498609301, 46.4840034677, 18.6083668593, 55.0242047281],
    'EPSG:3857': [230986.395277, 5858253.27918, 2071473.92327, 7366565.17486],
    'EPSG:4839': [-588294.218731, -816874.468761, 697029.429872, 782107.671922],
    // (U)TM
    'EPSG:25832': [-31457.2, 5171172.3, 1113266.0, 6139784.2],
    'EPSG:25833': [-491561.055747, 5229609.57213, 730630.700903, 6103438.87585],
    'EPSG:4647': [31968542.8007, 5171172.29888, 33113265.9755, 6139784.18944],
    'EPSG:5650': [32331206.6246, 5023799.91841, 33927672.7555, 6400503.87422],
    'EPSG:3034': [3411878.17838, 2238751.12694, 4531884.85677, 3156427.30041],
    'EPSG:3035': [3713155.60384, 2629215.23991, 4870256.61293, 3579362.40517],
    'EPSG:3044': [-31457.1993059, 5171172.29888, 1113265.97552, 6139784.18944],
    'EPSG:3045': [-491561.055747, 5229609.57213, 730630.700903, 6103438.87585],
    // GK
    'EPSG:31466': [2198674.97164, 5156935.03086, 3304138.59087, 6172478.95319],
    'EPSG:31467': [2968406.76329, 5172797.1438, 4113580.06377, 6141807.67656],
    'EPSG:31468': [3738224.07893, 5197527.23054, 4922420.07541, 6119480.25774],
    'EPSG:31469': [4508181.06836, 5231250.21482, 5730855.01451, 6105438.37812],
    'EPSG:5676': [2198674.97164, 5156935.03086, 3304138.59087, 6172478.95319],
    'EPSG:5677': [2968406.76329, 5172797.1438, 4113580.06377, 6141807.67656],
    'EPSG:5678': [3738224.07893, 5197527.23054, 4922420.07541, 6119480.25774],
    'EPSG:5679': [4508181.06836, 5231250.21482, 5730855.01451, 6105438.37812],

    'EPSG:2397': [2801653.04641, 5050072.5876, 4398909.7451, 6362436.76306],
    'EPSG:2398': [3566148.11787, 5046287.77486, 5163397.24898, 6367094.20891],
    'EPSG:2399': [4330719.40757, 5025898.84992, 5927851.03379, 6403177.11818]
};

/**
 * Projected bounds of various coordinate systems
 * @type {Object}
 * @constant BKGWebMap.PROJECTIONS_EXTENTS
 */
BKGWebMap.PROJECTIONS_EXTENTS = {
    'EPSG:4326': [-180.0, -90.0, 180.0, 90.0],
    'EPSG:4258': [-35.999991, 18.404252, 53.999994, 79.321963],
    'EPSG:3857': [-20037508.3428, -20037508.3428, 20037508.3428, 20037508.3428],
    'EPSG:4839': [-2275549.54467, -5292558.65892, 3682077.51074, 4993562.02194],
    'EPSG:25832': [-1370000, 3800000, 2100000, 8020000],
    'EPSG:25833': [-1700000, 3700000, 1900000, 7950000],
    'EPSG:4647': [30630000, 3800000, 34100000, 8020000],
    'EPSG:5650': [31050000, 3800000, 34530000, 8020000],
    'EPSG:3034': [2122254.2378, 1164627.9290, 5955457.4541, 5021872.0731],
    'EPSG:3035': [2426378.0132, 1528101.2618, 6293974.6215, 5446513.5222],
    'EPSG:3044': [-1370000, 3800000, 2100000, 8020000],
    'EPSG:3045': [-1700000, 3700000, 1900000, 7950000],
    'EPSG:31466': [2411408, 5129732, 3218656, 6235087],
    'EPSG:31467': [3175708, 5133776, 4024237, 6207551],
    'EPSG:31468': [3952421, 5152678, 4836381, 6189322],
    'EPSG:31469': [4718975, 5180252, 5646048, 6176060],
    'EPSG:5676': [2411408, 5129732, 3218656, 6235087],
    'EPSG:5677': [3175708, 5133776, 4024237, 6207551],
    'EPSG:5678': [3952421, 5152678, 4836381, 6189322],
    'EPSG:5679': [4718975, 5180252, 5646048, 6176060],
    'EPSG:2397': [3175708, 5133776, 4024237, 6207551],
    'EPSG:2398': [3952421, 5152678, 4836381, 6189322],
    'EPSG:2399': [4718975, 5180252, 5646048, 6176060]
};

// TODO: find right place
// TODO: lazy init?
for (var srs in BKGWebMap.PROJECTIONS_EXTENTS) {
    var projection = ol.proj.get(srs);
    projection.setExtent(BKGWebMap.PROJECTIONS_EXTENTS[srs]);
}

/**
 * Standard resolutions for UTM32s.
 * These will be used in all coordinate system with meter as unit
 * @type {number[]}
 * @constant BKGWebMap.RESOLUTIONS
 */
BKGWebMap.RESOLUTIONS = [
    4891.96981025128, // AdV-Level 0 (1:17471320.7508974)
    2445.98490512564, // AdV-Level 1 (1:8735660.37544872)
    1222.99245256282, // AdV-Level 2 (1:4367830.18772436)
    611.49622628141, // AdV-Level 3 (1:2183915.09386218)
    305.748113140705, // AdV-Level 4 (1:1091957.54693109)
    152.874056570353, // AdV-Level 5 (1:545978.773465545)
    76.4370282851763, // AdV-Level 6 (1:272989,386732772)
    38.2185141425881, // AdV-Level 7 (1:136494,693366386)
    19.1092570712941, // AdV-Level 8 (1:68247,3466831931)
    9.55462853564703, // AdV-Level 9 (1:34123,6733415966)
    4.77731426782352, // AdV-Level 10 (1:17061,8366707983)
    2.38865713391176, // AdV-Level 11 (1:8530,91833539914)
    1.19432856695588, // AdV-Level 12 (1:4265,45916769957)
    0.59716428347794 // AdV-Level 13 (1:2132,72958384978)
];

/**
 * Extension resolutions for UTM32s.
 * They extend the defined resolutions by 30cm/Pixel and 15cm/Pixel
 * @type {number[]}
 * @constant BKGWebMap.RESOLUTIONS_EXTENDED
 */
BKGWebMap.RESOLUTIONS_EXTENDED = BKGWebMap.RESOLUTIONS.slice();
BKGWebMap.RESOLUTIONS_EXTENDED.push(0.298582141738970);
BKGWebMap.RESOLUTIONS_EXTENDED.push(0.149291070869485);

/**
 * Standard resolutions for WGS84.
 * These will be used in all coordinate system with degrees as unit
 * @type {number[]}
 * @constant BKGWebMap.RESOLUTIONS_DEGREE
 */
BKGWebMap.RESOLUTIONS_DEGREE = [
    0.0439453125, // AdV-Level 0 (1:17471320.7508974)
    0.02197265625, // AdV-Level 1 (1:8735660.37544872)
    0.010986328125, // AdV-Level 2 (1:4367830.18772436)
    0.0054931640625, // AdV-Level 3 (1:2183915.09386218)
    0.00274658203125, // AdV-Level 4 (1:1091957.54693109)
    0.001373291015625, // AdV-Level 5 (1:545978.773465545)
    0.0006866455078125, // AdV-Level 6 (1:272989,386732772)
    0.00034332275390625, // AdV-Level 7 (1:136494,693366386)
    0.000171661376953125, // AdV-Level 8 (1:68247,3466831931)
    0.0000858306884765625, // AdV-Level 9 (1:34123,6733415966)
    0.0000429153442382813, // AdV-Level 10 (1:17061,8366707983)
    0.0000214576721191406, // AdV-Level 11 (1:8530,91833539914)
    0.0000107288360595703, // AdV-Level 12 (1:4265,45916769957)
    0.00000536441802978516 // AdV-Level 13 (1:2132,72958384978)
];

/**
 * Extension resolutions for WGS84.
 * They extend the defined resolutions by 30cm/Pixel and 15cm/Pixel
 * @type {number[]}
 * @constant BKGWebMap.RESOLUTIONS_DEGREE_EXTENDED
 */
BKGWebMap.RESOLUTIONS_DEGREE_EXTENDED = BKGWebMap.RESOLUTIONS_DEGREE.slice();
BKGWebMap.RESOLUTIONS_DEGREE_EXTENDED.push(0.00000268220901489258);
BKGWebMap.RESOLUTIONS_DEGREE_EXTENDED.push(0.00000134110450744629);

/**
 * GetFeatureInfo supported formats. Priority have the first elements of this array.
 * @type {string[]}
 * @constant BKGWebMap.GETFEATUREINFO_FORMATS
 */
BKGWebMap.GETFEATUREINFO_FORMATS = [
    'application/json',
    'application/geojson',
    'text/html'
];

/**
 * Standard colors for map icons.
 * @type {string[]}
 * @constant BKGWebMap.MAP_ICONS_COLORS
 */
BKGWebMap.MAP_ICONS_COLORS = [
    '#407E40',
    '#0374ad',
    '#FF0000',
    '#FFCC00',
    '#6A33D6',
    '#808080',
    '#000000'
];

/**
 * Deafault style for vector layers. It will be used if no style is defined for vector layers.
 * @type {Object}
 * @constant BKGWebMap.DEFAULT_STYLE
 * @property {string} name - Name of style. This should be used as reference for a layer (/styles/items/symbol/name)
 * @property {string} type - Type of style: symbol (/styles/items/symbol/type)
 * @property {string} fillColor - Fill color for vector layers. A hexadecimal value (/styles/items/symbol/fillColor)
 * @property {string} strokeColor - Stroke color for vector layers. A hexadecimal value (/styles/items/symbol/strokeColor)
 * @property {string} symbol - Symbol for vector layers (points) (/styles/items/symbol/symbol)
 */
BKGWebMap.DEFAULT_STYLE = {
    name: 'bkgwebmap-defaultstyle',
    type: 'symbol',
    fillColor: '#407E40',
    strokeColor: '#1E481E',
    symbol: 'circle'
};

/**
 * Default values for layer properties
 * @type {Object}
 * @constant BKGWebMap.LAYERS
 * @property {Object} WMS - Default values for WMS layer
 * @property {Object} WMTS - Default values for WMTS layer
 * @property {Object} WFS - Default values for WFS layer
 * @property {Object} MARKER - Default values for MARKER layer
 * @property {Object} CSV - Default values for CSV layer
 * @property {Object} XLS - Default values for XLS layer
 * @property {Object} GPS - Default values for GPS layer
 * @property {Object} GROUP - Default values for GROUP layer
 * @property {Object} VECTOR - Default values for VECTOR layer
 * @property {Object} NONE - Default values for NONE layer
 */
BKGWebMap.LAYERS = {
    WMS: {
        VERSION: '1.1.1', // TODO: fix issue with axis order in 1.3.0
        VISIBLE: true,
        SELECT_STYLE: true
    },
    WMTS: {
        VISIBLE: true,
        DEFAULTSTYLE: 'default'
    },
    WFS: {
        VERSION: '1.1.0',
        VISIBLE: true,
        FORMAT: 'GML3',
        EDIT: false,
        TILES: true
    },
    MARKER: {
        PROJECTION: 'EPSG:4326',
        VISIBLE: true,
        EDIT: false
    },
    CSV: {
        PROJECTION: 'EPSG:4326',
        VISIBLE: true,
        HEADER: true,
        ENCODING: 'UTF-8',
        DELIMITER: ';',
        EDIT: false
    },
    XLS: {
        PROJECTION: 'EPSG:4326',
        VISIBLE: true,
        HEADER: true,
        EDIT: false
    },
    GPS: {
        VISIBLE: true,
        EDIT: false
    },
    GROUP: {
        VISIBLE: true
    },
    VECTOR: {
        VISIBLE: true,
        EDIT: false
    },
    NONE: {
        NAME: 'Keine Hintergrundkarte'
    }
};

/**
 * Default parameters for controls
 * @type {Object}
 * @constant BKGWebMap.CONTROLS
 * @property {string} panelPosition - Panel position (/options/panelPosition)
 * @property {string|null} initialize - Tool that should be shown, when starting the Application. If empty or null, then panel will be closed (/options/initialize)
 * @property {Object} tools - Tools in panel (/options/tools)
 */
BKGWebMap.CONTROLS = {
    panelPosition: 'left',
    initialize: null,
    tools: {
        layerSwitcher: {
            active: true,
            div: null,
            style: '',
            editStyle: true,
            changeVisibility: true,
            showWMSLayers: true,
            changeOrder: true,
            openLevel: 0
        },
        customLayers: {
            active: true,
            edit: true,
            changeVisibility: true,
            defaultStyle: '',
            dataTypes: ['BKG', 'WMS', 'WMTS', 'WFS', 'CSV', 'XLS', 'GPS']
        },
        showAttributes: {
            active: true,
            div: null,
            style: ''
        },
        legend: {
            active: false,
            div: null,
            style: ''
        },
        measure: {
            active: false,
            div: null,
            style: ''
        },
        edit: {
            active: false,
            div: null,
            style: '',
            export: {
                active: false,
                formats: ['GEOJSON', 'GML', 'GPX', 'KML', 'WKT']
            }
        },
        zoom: {
            active: true,
            showZoomLevel: false,
            zoomToFullExtent: true,
            history: true,
            position: 'top-left',
            div: null,
            style: ''
        },
        fullScreen: {
            active: true,
            position: 'top-right',
            div: null,
            style: ''
        },
        scalebar: {
            active: true,
            position: 'bottom-right',
            scalebarType: 'mapscaleDistance',
            div: null,
            style: ''
        },
        share: {
            active: false,
            div: null,
            print: {
                active: true,
                stylesheet: ''
            },
            permaLink: {
                active: true
            },
            jsonExport: {
                active: false,
                appName: 'BKG WebMap'
            }

        },
        showCoordinates: {
            active: true,
            position: 'bottom-right',
            div: null,
            style: ''
        },
        staticLinks: [{
            active: false,
            position: 'bottom-left',
            div: null,
            style: ''
        }],
        staticWindows:
            [{
                active: false,
                position: 'top:200px;left:350px;',
                div: null,
                style: '',
                size: [0, 0],
                title: '',
                content: ''
            }],
        copyright: {
            active: true,
            position: 'bottom-left',
            div: null,
            style: '',
            maxHeight: '150px',
            maxWidth: '700px'
        },
        searchCoordinates: {
            active: true,
            div: null,
            style: ''
        },
        geoSearch: {
            active: false,
            div: null,
            style: '',
            protocol: {
                ortssuche: 'http://sg.geodatenzentrum.de/gdz_ortssuche'
            },
            defaultProtocol: 'ortssuche',
            suggestCount: 20,
            resultsCount: 20,
            resultsMaxZoom: 13,
            reverseGeocoding: {
                active: true,
                maxResolution: null,
                minResolution: null,
                maxZoom: null,
                minZoom: null,
                defaultFilter: 'typ:Haus',
                count: 20
            }
        },
        copyCoordinates: {
            active: true,
            div: null,
            style: ''
        },
        cookieCheck: {
            active: false,
            doNotActivate: false,
            url: BKGWebMap.BASE_URL + 'web_bkg_webmap/cookietest/setcookie.php'
        },
        overviewMap: {
            active: false,
            position: 'bottom-right',
            div: null,
            collapsible: true,
            collapsed: false,
            layers: []
        },
        timeSlider: {
            active: false,
            div: null,
            position: 'bottom-right'
        }
    }
};

/**
 * Controls that could be positioned in panel
 * @type {string[]}
 * @constant BKGWebMap.CONTROLS_IN_PANEL
 */
BKGWebMap.CONTROLS_IN_PANEL = [
    'geoSearch',
    'searchCoordinates',
    'layerSwitcher',
    'legend',
    'showAttributes',
    'copyCoordinates',
    'measure',
    'edit',
    'share'
];

/**
 * Valid positions for icons in map
 * @type {string[]}
 * @constant BKGWebMap.STANDARD_POSITION
 */
BKGWebMap.STANDARD_POSITION = [
    'top-left',
    'top-right',
    'bottom-left',
    'bottom-right'
];

/**
 * Errors for debugging. They will be shown in browser console.
 * @type {Object}
 * @constant BKGWebMap.ERROR
 */
BKGWebMap.ERROR = {
    mapDiv: 'ERROR - The map div with the following ID was not found: ',
    wrongPersistenceVersion: 'ERROR IN PERSISTENCE - The version of persistence JSON is not the same as the actual BKG WebMap version. You might experience compatibility problems.',
    jsonFile: 'ERROR - The following JSON could not be loaded: ',
    missingLayersJson: 'ERROR IN CONFIG JSON - Key "layers" is not available.',
    missingTypeLayersJson: 'ERROR IN CONFIG - Key "type" in "layers" is not available.',
    wrongTypeLayersJson: 'ERROR IN CONFIG - Illegal value for key "type" in "layers": ',
    wrongUrl: 'ERROR IN CONFIG - Please verify the map service URL of layers: ',
    wmtsGetCapabilities: 'ERROR - The WMTS getCapabilities request could not be made. Please make sure that the URL is right and the server is online.',
    wmtsLayerName: 'ERROR IN CONFIG - Please provide a layer name for the WMTS service.',
    wmtsTileGrid: 'ERROR IN CONFIG - Tile grid of WMTS service missing.',
    wfsTypename: 'ERROR IN CONFIG - Please provide a typeName (namespace:featuretype) for the WFS layers.',
    markersMissing: 'ERROR IN CONFIG - Please verify that you have added coordinates for the markers.',
    csvExcelOptions: 'ERROR IN CONFIG - No options are defined: ',
    csvExcelCoordMissing: 'ERROR IN CONFIG - Please verify that you have added coordinates for layer:  ',
    missingLayersGroup: 'ERROR IN CONFIG - No layers for GROUP are defined.',
    missingRefInBkg: 'ERROR IN CONFIG - No ref for BGK layer is defined',
    missingStyleName: 'ERROR IN CONFIG - No name is defined in the following style configuration: ',
    wrongStyleType: 'ERROR IN CONFIG - Wrong type in the following style configuration: ',
    wrongStyleSymbol: 'ERROR IN CONFIG - Wrong symbol in the following style configuration: ',
    missingStyleSymbol: 'ERROR IN CONFIG - Missing symbol in the following style configuration: ',
    noPanelNoDivForControl: 'ERROR IN CONFIG: No panel available and no other div defined for control: ',
    noLayerSwitcherControl: 'ERROR IN CONFIG: Custom Layers Control could not be added. Please add also Layer Switcher Control',
    geoSearchWrongProtocol: 'ERROR IN GEOSEARCH: Wrong protocol',
    geoSearchUrlMissing: 'ERROR IN GEOSEARCH: Please define url for wfs protocol',
    geoSearchFeaturePrefixMissing: 'ERROR IN GEOSEARCH: Please define featurePrefix for wfs protocol',
    geoSearchFeatureTypeMissing: 'ERROR IN GEOSEARCH: Please define featureType for wfs protocol',
    geoSearchSearchAttributeMissing: 'ERROR IN GEOSEARCH: Please define searchAttribute for wfs protocol',
    xhrError: 'ERROR IN GEOSEARCH: Error in AJAX request',
    enableCookiesImport: 'Konfigurationsdatei importieren: Für diese Funktion werden Cookies benötigt. Bitte aktivieren Sie Cookies im Browser.'
};

/**
 * Standard SVG map icons
 * @type {Object}
 * @property {object} marker - Symbol "marker"
 * @property {object} star - Symbol "star"
 * @property {object} circle - Symbol "circle"
 * @property {object} dottedCircle - Symbol "dottedCircle"
 * @property {object} pentagon - Symbol "pentagon"
 */
BKGWebMap.MAP_ICONS = {
    marker: {
        a: '<svg width="17" height="25" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="matrix(0.04593055,0,0,0.04593055,-0.34447913,-0.3536654)"> <path d="m 182.9,551.7 c 0,0.1 0.2,0.3 0.2,0.3 0,0 175.2,-269 175.2,-357.4 C 358.3,64.5 269.5,7.9 182.9,7.7 96.3,7.9 7.5,64.5 7.5,194.6 7.5,283 182.8,552 182.8,552 c 0,0 0.1,-0.3 0.1,-0.3 z M 122.2,187.2 c 0,-33.6 27.2,-60.8 60.8,-60.8 33.6,0 60.8,27.2 60.8,60.8 0,33.6 -27.3,60.8 -60.9,60.8 -33.5,0 -60.7,-27.2 -60.7,-60.8 z" style="fill:',
        b: ';fill-opacity:1;fill-opacity:1;stroke:',
        c: ';stroke-width:3px" /></g></svg>'
    },
    star: {
        a: '<svg width="20.993916" height="20.104015" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-142.00093,-306.60999)"> <g transform="matrix(0.0665647,-0.00132667,0.00132667,0.0665647,139.2985,298.43689)"> <path d="m 282.85714,429.50507 -94.75021,-54.79723 -98.855978,46.98758 22.835828,-107.04608 -75.236018,-79.49766 108.863528,-11.3609 52.35756,-96.11983 44.44554,100.02466 107.59477,20.09234 -81.39468,73.17953 z" style="fill:',
        b: ';fill-opacity:1;stroke:',
        c: ';stroke-width:3px"/></g></g></svg>'
    },
    circle: {
        a: '<svg width="20" height="20" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="matrix(0.57100777,0,0,0.57100777,-203.16093,-270.14881)"> <path d="m 451.42858,452.36218 c 0,45.76074 -37.0964,82.85714 -82.85714,82.85714 -45.76073,0 -82.85714,-37.0964 -82.85714,-82.85714 0,-45.76073 37.09641,-82.85714 82.85714,-82.85714 45.76074,0 82.85714,37.09641 82.85714,82.85714 z"  transform="matrix(0.21136255,0,0,0.21136255,295.40433,395.00928)" style="fill:',
        b: ';fill-opacity:1;stroke:',
        c: ';stroke-width:3px"/></g></svg>'
    },
    dottedCircle: {
        a: '<svg width="19.999996" height="20.46479" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-324.73482,-386.84426)"> <g transform="matrix(0.92967066,0,0,0.95201149,62.952049,-40.873532)"> <path d="m 290.99428,449.27797 c -4.92775,0.61214 -8.82868,4.53398 -9.40771,9.47201 l 2.73313,0 c 0.54274,-3.43985 3.24507,-6.16203 6.67458,-6.73551 l 0,-2.7365 z m 2.70773,0.002 0,2.73651 c 3.42469,0.57714 6.12222,3.29736 6.66443,6.7338 l 2.73312,0 c -0.57863,-4.93461 -4.47461,-8.85403 -9.39755,-9.47031 z m -12.09682,12.17806 c 0.64253,4.8639 4.51357,8.71051 9.38909,9.31631 l 0,-2.73651 c -3.37773,-0.5647 -6.05026,-3.21399 -6.6492,-6.5798 l -2.73989,0 z m 18.73586,0 c -0.59834,3.36244 -3.2661,6.00981 -6.63904,6.57811 l 0,2.73651 c 4.87071,-0.60991 8.73686,-4.45412 9.37894,-9.31462 l -2.7399,0 z" style="fill:',
        b: ';fill-opacity:1;stroke:',
        c: ';stroke-width:1px"/></g></g></svg>'
    },
    pentagon: {
        a: '<svg width="20.295969" height="20" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-355.90466,-487.9462)"> <path d="m 12.626907,15.959162 -7.8085263,0.01464 -7.8085272,0.01464 -2.4268945,-7.4218244 -2.4268948,-7.4218254 6.3086228,-4.6015837 6.3086237,-4.6015842 6.3258373,4.5778892 6.325839,4.5778899 -2.39904,7.4308748 z" transform="matrix(0.80319882,0,0,0.83171088,362.2049,494.64843)" style="fill:',
        b: ';fill-opacity:1;stroke:',
        c: ';stroke-width:1px"/></g></svg>'
    }
};

/**
 * Standard SVG map icons URL encoded including SVG size
 * Because of IE11 the SVG tags should be URL encoded with the quotes ' '
 * @type {Object}
 * @property {object} marker - Symbol "marker"
 * @property {object} star - Symbol "star"
 * @property {object} circle - Symbol "circle"
 * @property {object} dottedCircle - Symbol "dottedCircle"
 * @property {object} pentagon - Symbol "pentagon"
 */
BKGWebMap.MAP_ICONS_ENCODED = {
    marker: {
        a: '%3Csvg%20width%3D%2717%27%20height%3D%2725%27%20version%3D%271.1%27%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%3E%20%3Cg%20transform%3D%27matrix(0.04593055%2C0%2C0%2C0.04593055%2C-0.34447913%2C-0.3536654)%27%3E%20%3Cpath%20d%3D%27m%20182.9%2C551.7%20c%200%2C0.1%200.2%2C0.3%200.2%2C0.3%200%2C0%20175.2%2C-269%20175.2%2C-357.4%20C%20358.3%2C64.5%20269.5%2C7.9%20182.9%2C7.7%2096.3%2C7.9%207.5%2C64.5%207.5%2C194.6%207.5%2C283%20182.8%2C552%20182.8%2C552%20c%200%2C0%200.1%2C-0.3%200.1%2C-0.3%20z%20M%20122.2%2C187.2%20c%200%2C-33.6%2027.2%2C-60.8%2060.8%2C-60.8%2033.6%2C0%2060.8%2C27.2%2060.8%2C60.8%200%2C33.6%20-27.3%2C60.8%20-60.9%2C60.8%20-33.5%2C0%20-60.7%2C-27.2%20-60.7%2C-60.8%20z%27%20style%3D%27fill%3A',
        b: '%3Bfill-opacity%3A1%3Bfill-opacity%3A1%3Bstroke%3A',
        c: '%3Bstroke-width%3A3px%27%20%2F%3E%3C%2Fg%3E%3C%2Fsvg%3E',
        size: [17, 25]
    },
    star: {
        a: '%3Csvg%20width%3D%2720.993916%27%20height%3D%2720.104015%27%20version%3D%271.1%27%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%3E%20%3Cg%20transform%3D%27translate(-142.00093%2C-306.60999)%27%3E%20%3Cg%20transform%3D%27matrix(0.0665647%2C-0.00132667%2C0.00132667%2C0.0665647%2C139.2985%2C298.43689)%27%3E%20%3Cpath%20d%3D%27m%20282.85714%2C429.50507%20-94.75021%2C-54.79723%20-98.855978%2C46.98758%2022.835828%2C-107.04608%20-75.236018%2C-79.49766%20108.863528%2C-11.3609%2052.35756%2C-96.11983%2044.44554%2C100.02466%20107.59477%2C20.09234%20-81.39468%2C73.17953%20z%27%20style%3D%27fill%3A',
        b: '%3Bfill-opacity%3A1%3Bstroke%3A',
        c: '%3Bstroke-width%3A3px%27%2F%3E%3C%2Fg%3E%3C%2Fg%3E%3C%2Fsvg%3E',
        size: [20, 20]
    },
    circle: {
        a: '%3Csvg%20width%3D%2220%22%20height%3D%2220%22%20version%3D%221.1%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%3E%20%3Cg%20transform%3D%22matrix(0.57100777%2C0%2C0%2C0.57100777%2C-203.16093%2C-270.14881)%22%3E%20%3Cpath%20d%3D%22m%20451.42858%2C452.36218%20c%200%2C45.76074%20-37.0964%2C82.85714%20-82.85714%2C82.85714%20-45.76073%2C0%20-82.85714%2C-37.0964%20-82.85714%2C-82.85714%200%2C-45.76073%2037.09641%2C-82.85714%2082.85714%2C-82.85714%2045.76074%2C0%2082.85714%2C37.09641%2082.85714%2C82.85714%20z%22%20%20transform%3D%22matrix(0.21136255%2C0%2C0%2C0.21136255%2C295.40433%2C395.00928)%22%20style%3D%22fill%3A',
        b: '%3Bfill-opacity%3A1%3Bstroke%3A',
        c: '%3Bstroke-width%3A3px%22%2F%3E%3C%2Fg%3E%3C%2Fsvg%3E',
        size: [20, 20]
    },
    dottedCircle: {
        a: '%3Csvg%20width%3D%2719.999996%27%20height%3D%2720.46479%27%20version%3D%271.1%27%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%3E%20%3Cg%20transform%3D%27translate(-324.73482%2C-386.84426)%27%3E%20%3Cg%20transform%3D%27matrix(0.92967066%2C0%2C0%2C0.95201149%2C62.952049%2C-40.873532)%27%3E%20%3Cpath%20d%3D%27m%20290.99428%2C449.27797%20c%20-4.92775%2C0.61214%20-8.82868%2C4.53398%20-9.40771%2C9.47201%20l%202.73313%2C0%20c%200.54274%2C-3.43985%203.24507%2C-6.16203%206.67458%2C-6.73551%20l%200%2C-2.7365%20z%20m%202.70773%2C0.002%200%2C2.73651%20c%203.42469%2C0.57714%206.12222%2C3.29736%206.66443%2C6.7338%20l%202.73312%2C0%20c%20-0.57863%2C-4.93461%20-4.47461%2C-8.85403%20-9.39755%2C-9.47031%20z%20m%20-12.09682%2C12.17806%20c%200.64253%2C4.8639%204.51357%2C8.71051%209.38909%2C9.31631%20l%200%2C-2.73651%20c%20-3.37773%2C-0.5647%20-6.05026%2C-3.21399%20-6.6492%2C-6.5798%20l%20-2.73989%2C0%20z%20m%2018.73586%2C0%20c%20-0.59834%2C3.36244%20-3.2661%2C6.00981%20-6.63904%2C6.57811%20l%200%2C2.73651%20c%204.87071%2C-0.60991%208.73686%2C-4.45412%209.37894%2C-9.31462%20l%20-2.7399%2C0%20z%27%20style%3D%27fill%3A',
        b: '%3Bfill-opacity%3A1%3Bstroke%3A',
        c: '%3Bstroke-width%3A1px%27%2F%3E%3C%2Fg%3E%3C%2Fg%3E%3C%2Fsvg%3E',
        size: [20, 20]
    },
    pentagon: {
        a: '%3Csvg%20width%3D%2720.295969%27%20height%3D%2720%27%20version%3D%271.1%27%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%3E%20%3Cg%20transform%3D%27translate(-355.90466%2C-487.9462)%27%3E%20%3Cpath%20d%3D%27m%2012.626907%2C15.959162%20-7.8085263%2C0.01464%20-7.8085272%2C0.01464%20-2.4268945%2C-7.4218244%20-2.4268948%2C-7.4218254%206.3086228%2C-4.6015837%206.3086237%2C-4.6015842%206.3258373%2C4.5778892%206.325839%2C4.5778899%20-2.39904%2C7.4308748%20z%27%20transform%3D%27matrix(0.80319882%2C0%2C0%2C0.83171088%2C362.2049%2C494.64843)%27%20style%3D%27fill%3A',
        b: '%3Bfill-opacity%3A1%3Bstroke%3A',
        c: '%3Bstroke-width%3A1px%27%2F%3E%3C%2Fg%3E%3C%2Fsvg%3E',
        size: [20, 20]
    }
};

/**
 * SVG icons used in BKG WebMap
 * @type {Object}
 * @property {object} ARROW_LEFT
 * @property {object} ARROW_RIGHT
 * @property {object} ARROW_UP
 * @property {object} ARROW_DOWN
 * @property {object} SEARCH
 * @property {object} LAYERSWITCHER
 * @property {object} LEGEND
 * @property {object} INFO
 * @property {object} SHARE
 * @property {object} MEASURE_DISTANCE
 * @property {object} MEASURE_AREA
 * @property {object} ZOOM_PREVIOUS
 * @property {object} ZOOM_NEXT
 * @property {object} MAXIMIZE
 * @property {object} MINIMIZE
 * @property {object} GEAR_WHEEL
 * @property {object} LAYER_HIDDEN
 * @property {object} LAYER_SHOWN
 * @property {object} ADD_LAYER
 * @property {object} FOLDER_CLOSED
 * @property {object} FOLDER_OPEN
 * @property {object} ZOOM_IN
 * @property {object} SHOW_COORDINATES
 * @property {object} ZOOM_TO_FULL_EXTENT
 * @property {object} COPYRIGHT
 * @property {object} EDIT
 * @property {object} EDIT_POINT
 * @property {object} EDIT_LINE
 * @property {object} EDIT_POLYGON
 * @property {object} DELETE
 * @property {object} ATTRIBUTES
 * @property {object} DELETE_SEARCH
 * @property {object} CHECKBOX_UNSELECTED
 * @property {object} CHECKBOX_SELECTED
 * @property {object} TIMESLIDER
 * @property {object} REVERSE_GEOCODING
 * @property {object} SEARCH_GEOCODING
 */
BKGWebMap.PANEL_ICONS = {
    ARROW_LEFT: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(423.81636,-848.45315)"> <path d="m -411.68067,861.37136 c -0.96971,-0.48888 -1.86193,-0.93788 -2.72759,-1.37268 -1.1778,-0.59154 -2.37548,-1.19263 -3.53374,-1.77394 l -1.37156,-0.68838 c -0.31195,-0.15659 -0.62394,-0.31322 -0.93591,-0.46985 -1.06117,-0.5328 -2.15844,-1.08374 -3.23836,-1.62405 -0.21798,-0.10906 -0.32853,-0.27135 -0.32853,-0.48238 l 0,-0.003 c 7.3e-4,-0.21454 0.11297,-0.37703 0.33353,-0.483 0.14084,-0.0677 0.28326,-0.14031 0.42098,-0.21052 0.0715,-0.0365 0.14548,-0.0742 0.21866,-0.11089 1.16402,-0.58436 2.32806,-1.16867 3.4921,-1.75298 l 2.97533,-1.49354 c 1.53416,-0.77017 3.12058,-1.56653 4.68131,-2.3491 0.0564,-0.0283 0.11232,-0.0491 0.16165,-0.0677 0.0187,-0.007 0.0365,-0.0137 0.0516,-0.0198 l 0.0407,-0.0164 0.0433,0.008 c 0.0188,0.003 0.0351,0.005 0.051,0.008 0.0334,0.005 0.0648,0.009 0.0983,0.0194 0.22335,0.0668 0.36209,0.25103 0.36209,0.48064 0,0.083 -0.0177,0.16985 -0.0524,0.25773 -0.72552,1.83372 -1.49766,3.78458 -2.25983,5.70357 -0.009,0.0242 -0.0104,0.038 -0.0104,0.0465 0,0.009 8.7e-4,0.0228 0.0117,0.0478 0.537,1.34482 1.08162,2.71263 1.60831,4.03543 l 0.24922,0.62591 c 0.0406,0.10192 0.0815,0.20383 0.12219,0.3057 0.0985,0.24608 0.20049,0.50054 0.29803,0.75238 0.0257,0.0664 0.0387,0.13467 0.0387,0.20271 -3e-5,0.23274 -0.15429,0.42986 -0.3839,0.49052 -0.16432,0.0434 -0.30232,-0.009 -0.41568,-0.0663 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    ARROW_RIGHT: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(249.53076,-888.45376)"> <path d="m -248.73104,888.53582 c 0.96976,0.48888 1.862,0.93791 2.7277,1.37272 1.17783,0.59156 2.37556,1.19268 3.53386,1.77401 l 1.37161,0.6884 c 0.31198,0.1566 0.62396,0.31323 0.93594,0.46987 1.0612,0.53282 2.15853,1.08377 3.23848,1.6241 0.218,0.10905 0.32854,0.27136 0.32854,0.48241 l 0,0.002 c -7.3e-4,0.21454 -0.11295,0.37705 -0.33354,0.48302 -0.14084,0.0677 -0.28327,0.1403 -0.42099,0.21053 -0.0715,0.0365 -0.14549,0.0742 -0.21868,0.11093 -1.16405,0.5844 -2.32814,1.16873 -3.49222,1.75305 l -2.97542,1.4936 c -1.53424,0.7702 -3.1207,1.5666 -4.6815,2.34919 -0.0564,0.0282 -0.11231,0.0492 -0.16164,0.0677 -0.0188,0.007 -0.0366,0.0137 -0.0517,0.0198 l -0.0407,0.0164 -0.0433,-0.007 c -0.0188,-0.003 -0.0351,-0.006 -0.0509,-0.008 -0.0334,-0.005 -0.0649,-0.009 -0.0983,-0.0194 -0.22335,-0.0669 -0.36211,-0.25104 -0.36211,-0.48065 0,-0.0831 0.0177,-0.16985 0.0524,-0.25774 0.72555,-1.83378 1.49771,-3.78472 2.25992,-5.70378 0.01,-0.0242 0.0107,-0.0381 0.0107,-0.0465 0,-0.009 -0.001,-0.0227 -0.0112,-0.0478 -0.53701,-1.34488 -1.08165,-2.71275 -1.60836,-4.03559 l -0.24923,-0.62593 c -0.0406,-0.10196 -0.0814,-0.20384 -0.12224,-0.30571 -0.0986,-0.24609 -0.20049,-0.50055 -0.29804,-0.7524 -0.0257,-0.0665 -0.0388,-0.13468 -0.0388,-0.20272 3e-5,-0.23275 0.1543,-0.42988 0.38392,-0.49055 0.16432,-0.0434 0.30233,0.009 0.41568,0.0663 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    ARROW_UP: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(249.53076,-888.45376)"> <path d="m -249.48067,900.62186 c 0.48888,-0.96976 0.93791,-1.862 1.37272,-2.7277 0.59156,-1.17783 1.19268,-2.37556 1.77401,-3.53386 l 0.6884,-1.37161 c 0.1566,-0.31198 0.31323,-0.62396 0.46987,-0.93594 0.53282,-1.0612 1.08377,-2.15853 1.6241,-3.23848 0.10905,-0.218 0.27136,-0.32854 0.48241,-0.32854 h 0.002 c 0.21454,7.3e-4 0.37705,0.11295 0.48302,0.33354 0.0677,0.14084 0.1403,0.28327 0.21053,0.42099 0.0365,0.0715 0.0742,0.14549 0.11093,0.21868 0.5844,1.16405 1.16873,2.32814 1.75305,3.49222 l 1.4936,2.97542 c 0.7702,1.53424 1.5666,3.1207 2.34919,4.6815 0.0282,0.0564 0.0492,0.11231 0.0677,0.16164 0.007,0.0188 0.0137,0.0366 0.0198,0.0517 l 0.0164,0.0407 -0.007,0.0433 c -0.003,0.0188 -0.006,0.0351 -0.008,0.0509 -0.005,0.0334 -0.009,0.0649 -0.0194,0.0983 -0.0669,0.22335 -0.25104,0.36211 -0.48065,0.36211 -0.0831,0 -0.16985,-0.0177 -0.25774,-0.0524 -1.83378,-0.72555 -3.78472,-1.49771 -5.70378,-2.25992 -0.0242,-0.01 -0.0381,-0.0107 -0.0465,-0.0107 -0.009,0 -0.0227,10e-4 -0.0478,0.0112 -1.34488,0.53701 -2.71275,1.08165 -4.03559,1.60836 l -0.62593,0.24923 c -0.10196,0.0406 -0.20384,0.0814 -0.30571,0.12224 -0.24609,0.0986 -0.50055,0.20049 -0.7524,0.29804 -0.0665,0.0257 -0.13468,0.0388 -0.20272,0.0388 -0.23275,-3e-5 -0.42988,-0.1543 -0.49055,-0.38392 -0.0434,-0.16432 0.009,-0.30233 0.0663,-0.41568 z" style="fill:#757D75;fill-opacity:1" /> </g> </svg>',
    ARROW_DOWN: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(249.53076,-888.45376)"> <path d="m -249.48067,889.28545 c 0.48888,0.96976 0.93791,1.862 1.37272,2.7277 0.59156,1.17783 1.19268,2.37556 1.77401,3.53386 l 0.6884,1.37161 c 0.1566,0.31198 0.31323,0.62396 0.46987,0.93594 0.53282,1.0612 1.08377,2.15853 1.6241,3.23848 0.10905,0.218 0.27136,0.32854 0.48241,0.32854 h 0.002 c 0.21454,-7.3e-4 0.37705,-0.11295 0.48302,-0.33354 0.0677,-0.14084 0.1403,-0.28327 0.21053,-0.42099 0.0365,-0.0715 0.0742,-0.14549 0.11093,-0.21868 0.5844,-1.16405 1.16873,-2.32814 1.75305,-3.49222 l 1.4936,-2.97542 c 0.7702,-1.53424 1.5666,-3.1207 2.34919,-4.6815 0.0282,-0.0564 0.0492,-0.11231 0.0677,-0.16164 0.007,-0.0188 0.0137,-0.0366 0.0198,-0.0517 l 0.0164,-0.0407 -0.007,-0.0433 c -0.003,-0.0188 -0.006,-0.0351 -0.008,-0.0509 -0.005,-0.0334 -0.009,-0.0649 -0.0194,-0.0983 -0.0669,-0.22335 -0.25104,-0.36211 -0.48065,-0.36211 -0.0831,0 -0.16985,0.0177 -0.25774,0.0524 -1.83378,0.72555 -3.78472,1.49771 -5.70378,2.25992 -0.0242,0.01 -0.0381,0.0107 -0.0465,0.0107 -0.009,0 -0.0227,-10e-4 -0.0478,-0.0112 -1.34488,-0.53701 -2.71275,-1.08165 -4.03559,-1.60836 l -0.62593,-0.24923 c -0.10196,-0.0406 -0.20384,-0.0814 -0.30571,-0.12224 -0.24609,-0.0986 -0.50055,-0.20049 -0.7524,-0.29804 -0.0665,-0.0257 -0.13468,-0.0388 -0.20272,-0.0388 -0.23275,3e-5 -0.42988,0.1543 -0.49055,0.38392 -0.0434,0.16432 0.009,0.30233 0.0663,0.41568 z" style="fill:#757D75;fill-opacity:1" /> </g> </svg>',
    SEARCH: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(55.48252,-252.61931)"> <path d="m -40.251769,261.92694 c 0,-1.63061 -0.579533,-3.02543 -1.738576,-4.1845 -1.159042,-1.15906 -2.553884,-1.73857 -4.184499,-1.73857 -1.630615,0 -3.025455,0.57953 -4.184499,1.73857 -1.159043,1.15905 -1.738576,2.55389 -1.738576,4.1845 0,1.63062 0.579533,3.02544 1.738576,4.1845 1.159044,1.15907 2.553884,1.73858 4.184499,1.73858 1.630615,0 3.025433,-0.57953 4.184499,-1.73858 1.159043,-1.15906 1.738576,-2.55388 1.738576,-4.1845 z m 6.769249,11.00003 c 0,0.45833 -0.167471,0.85496 -0.502415,1.18991 -0.334943,0.33494 -0.731572,0.50241 -1.189909,0.50241 -0.475968,0 -0.872596,-0.16747 -1.189909,-0.50241 l -4.534852,-4.52165 c -1.577745,1.09297 -3.33615,1.63944 -5.275239,1.63944 -1.260433,0 -2.465751,-0.24459 -3.615979,-0.73377 -1.150228,-0.48918 -2.141822,-1.15026 -2.974761,-1.98317 -0.832939,-0.83292 -1.493986,-1.82451 -1.983166,-2.97476 -0.48918,-1.15025 -0.73377,-2.35557 -0.73377,-3.61598 0,-1.26041 0.24459,-2.46575 0.73377,-3.61598 0.48918,-1.15023 1.150251,-2.14182 1.983166,-2.97476 0.832916,-0.83294 1.82451,-1.49399 2.974761,-1.98317 1.150251,-0.48918 2.35557,-0.73377 3.615979,-0.73377 1.26041,0 2.465753,0.24459 3.61598,0.73377 1.150227,0.48918 2.141822,1.15025 2.974761,1.98317 0.832938,0.83291 1.493986,1.82451 1.983166,2.97476 0.48918,1.15025 0.733769,2.35557 0.733769,3.61598 0,1.93911 -0.546492,3.69752 -1.63943,5.27524 l 4.534852,4.53485 c 0.326105,0.32613 0.48918,0.72276 0.48918,1.18991 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    LAYERSWITCHER: '<svg width="20" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-109.27289,-1012.6035)"> <path d="m 129.26009,1028.3052 c -0.008,-0.031 -0.0166,-0.061 -0.03,-0.089 -0.005,-0.013 -0.005,-0.026 -0.0132,-0.04 -0.008,-0.013 -0.0201,-0.021 -0.0292,-0.033 -0.0186,-0.026 -0.039,-0.048 -0.0618,-0.072 -0.0239,-0.021 -0.0469,-0.039 -0.073,-0.053 -0.0143,-0.011 -0.0233,-0.022 -0.0373,-0.029 l -2.47871,-1.2771 -6.12766,3.7511 c -0.10793,0.075 -0.24323,0.1234 -0.32188,0.1488 l -0.10057,0.034 c -0.16861,0.051 -0.34031,0.076 -0.51055,0.076 h -0.0995 l -0.0894,-0.011 c -0.0936,-0.011 -0.20429,-0.029 -0.31924,-0.064 l -0.0615,-0.011 -0.16305,-0.068 c -0.1076,-0.051 -3.83271,-1.9676 -6.67419,-3.4325 -1.3448,0.8234 -2.39938,1.4699 -2.55911,1.5687 -0.0741,0.041 -0.14123,0.094 -0.18472,0.1751 -0.0538,0.096 -0.0621,0.2017 -0.0439,0.3025 5e-4,0 5e-4,0.011 7.3e-4,0.013 0.01,0.048 0.0292,0.094 0.0538,0.1366 0.007,0.011 0.007,0.021 0.0134,0.032 0.002,0 0.006,0 0.007,0.011 0.0186,0.026 0.0422,0.045 0.0665,0.066 0.0244,0.024 0.0486,0.048 0.078,0.067 0.002,0 0.004,0 0.007,0 0.12771,0.07 9.62836,4.9645 9.75942,5.0273 0.011,0 0.0206,0 0.0308,0.011 0.0435,0.018 0.0868,0.03 0.13413,0.034 0.0115,0 0.0223,0 0.033,0 0.05,0 0.0977,-0.011 0.14718,-0.022 0.008,0 0.0152,-0.011 0.023,-0.011 0.0314,-0.011 0.0626,-0.017 0.0904,-0.035 l 9.31896,-5.7042 c 0.0152,-0.011 0.0229,-0.022 0.0358,-0.031 0.025,-0.018 0.0467,-0.037 0.0677,-0.059 0.0223,-0.023 0.041,-0.048 0.0578,-0.076 0.008,-0.013 0.0196,-0.022 0.0261,-0.035 0.007,-0.013 0.006,-0.026 0.011,-0.04 0.011,-0.03 0.0177,-0.059 0.023,-0.091 0.004,-0.03 0.008,-0.059 0.007,-0.087 -10e-4,-0.029 -0.006,-0.056 -0.0128,-0.086 z m -19.9771,-4.2755 c 0.01,0.049 0.0292,0.093 0.0536,0.1367 0.007,0.011 0.007,0.021 0.0136,0.031 0.002,0 0.005,0 0.007,0.011 0.0186,0.026 0.0422,0.046 0.0664,0.067 0.0244,0.023 0.0486,0.048 0.0781,0.066 0.002,0 0.004,0 0.007,0 0.12776,0.07 9.62842,4.9655 9.7594,5.0281 0.011,0 0.0207,0 0.0309,0.011 0.0434,0.018 0.0867,0.03 0.13402,0.034 0.0116,0 0.0224,0 0.0331,0 0.0498,0 0.0976,-0.011 0.14703,-0.021 0.008,0 0.0153,-0.011 0.0229,-0.011 0.0314,-0.011 0.0626,-0.017 0.0906,-0.036 l 9.31885,-5.7035 c 0.0152,-0.011 0.0228,-0.022 0.0358,-0.031 0.025,-0.018 0.0467,-0.037 0.0677,-0.059 0.0223,-0.024 0.041,-0.048 0.0578,-0.076 0.008,-0.013 0.0196,-0.022 0.0261,-0.037 0.007,-0.012 0.005,-0.026 0.011,-0.04 0.011,-0.029 0.0179,-0.059 0.023,-0.091 0.004,-0.029 0.008,-0.059 0.007,-0.086 -7.4e-4,-0.029 -0.005,-0.057 -0.0128,-0.086 -0.008,-0.031 -0.0166,-0.061 -0.03,-0.09 -0.005,-0.013 -0.005,-0.026 -0.0129,-0.04 -0.008,-0.013 -0.0204,-0.022 -0.0294,-0.033 -0.0186,-0.026 -0.039,-0.049 -0.0617,-0.072 -0.0237,-0.021 -0.047,-0.039 -0.0727,-0.055 -0.0143,-0.011 -0.0232,-0.021 -0.0373,-0.028 l -2.4785,-1.2768 -6.12835,3.751 c -0.11352,0.075 -0.24253,0.1224 -0.31724,0.1467 l -0.0952,0.033 c -0.16729,0.052 -0.34774,0.079 -0.53091,0.079 h -0.0727 l -0.10562,-0.011 c -0.10023,-0.011 -0.21958,-0.032 -0.34187,-0.07 l -0.0567,-0.013 -0.145,-0.06 c -0.11651,-0.056 -3.83625,-1.9698 -6.67399,-3.4325 -1.34505,0.824 -2.39957,1.4702 -2.55937,1.5695 -0.074,0.041 -0.14116,0.095 -0.18467,0.1742 -0.0536,0.096 -0.0621,0.2022 -0.0441,0.3035 5.1e-4,0 5.1e-4,0.011 10e-4,0.012 z m -5e-5,-5.1679 c 0.01,0.05 0.0292,0.093 0.0536,0.1368 0.007,0.011 0.007,0.022 0.0136,0.031 0.002,0 0.006,0 0.007,0.011 0.0186,0.025 0.0422,0.045 0.0664,0.067 0.0244,0.024 0.0486,0.048 0.0782,0.066 0.002,0 0.004,0 0.007,0.011 0.12775,0.07 9.62844,4.9636 9.75939,5.0271 0.011,0 0.0207,0 0.0309,0.011 0.0434,0.017 0.0867,0.03 0.13397,0.033 0.0116,0 0.0226,0 0.0331,0 0.0499,0 0.0976,-0.011 0.14705,-0.022 0.009,0 0.0153,-0.011 0.023,-0.011 0.0314,-0.011 0.0626,-0.018 0.0906,-0.036 l 9.31888,-5.7033 c 0.0152,-0.011 0.0228,-0.023 0.0357,-0.032 0.025,-0.018 0.0467,-0.037 0.0677,-0.059 0.0223,-0.024 0.041,-0.048 0.0578,-0.076 0.008,-0.013 0.0196,-0.022 0.0262,-0.037 0.007,-0.013 0.005,-0.026 0.011,-0.04 0.011,-0.031 0.018,-0.06 0.023,-0.092 0.004,-0.029 0.008,-0.059 0.007,-0.087 -0.001,-0.028 -0.006,-0.056 -0.0127,-0.085 -0.008,-0.032 -0.0166,-0.062 -0.03,-0.09 -0.005,-0.013 -0.005,-0.026 -0.013,-0.039 -0.008,-0.015 -0.0204,-0.022 -0.0294,-0.034 -0.0186,-0.025 -0.039,-0.048 -0.0618,-0.07 -0.0237,-0.022 -0.0469,-0.039 -0.0727,-0.055 -0.0142,-0.011 -0.0232,-0.022 -0.0373,-0.027 l -9.71434,-5.0039 c -0.0173,-0.011 -0.0358,-0.011 -0.0529,-0.017 -0.0267,-0.011 -0.0529,-0.02 -0.0811,-0.025 -0.0351,-0.011 -0.0683,-0.011 -0.10353,-0.011 -0.0224,6e-4 -0.0441,0 -0.0672,0.011 -0.0402,0.011 -0.0778,0.021 -0.11448,0.039 -0.01,0 -0.0229,0 -0.0338,0.011 -0.12314,0.072 -8.85347,5.4143 -9.33816,5.7153 -0.074,0.041 -0.14116,0.096 -0.18468,0.1743 -0.0538,0.096 -0.0621,0.2033 -0.0441,0.3035 5.3e-4,0 5.3e-4,0.011 7.3e-4,0.012 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    LEGEND: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-68.7325,-1100.7181)"> <path d="M 91.055911,1122.7178 H 71.913883 c -0.121414,0 -0.220738,-0.099 -0.220738,-0.2208 v -8.9686 H 68.7325 v -11.3049 c 0,-0.1214 0,-0.3201 0,-0.4415 v -0.6488 c 0,-0.1214 0,-0.2645 0,-0.3181 v -0.097 h 13.550411 v 2.4165 h 8.773 c 0.121414,0 0.220738,0.099 0.220738,0.2208 v 19.1419 c 0,0.1215 -0.09932,0.2208 -0.220716,0.2208 z m -1.322905,-18.223 H 73.197478 c -0.121415,0 -0.220738,0.099 -0.220738,0.2207 v 16.5355 c 0,0.1214 0.09934,0.2208 0.220738,0.2208 h 16.535506 c 0.121415,0 0.220738,-0.099 0.220738,-0.2208 l 2.2e-5,-16.5355 c 2.2e-5,-0.1214 -0.09934,-0.2207 -0.220738,-0.2207 z m -13.684238,5.2803 H 87.1133 v -2.213 H 76.048768 v 2.213 z m 0,4.4258 H 87.1133 v -2.2129 H 76.048768 v 2.2129 z m 0,4.4258 H 87.1133 v -2.2129 H 76.048768 v 2.2129 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    INFO: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(41.738476,-230.55979)"> <path d="m -21.213763,236.03827 c -0.983494,-1.68531 -2.317898,-3.01974 -4.003235,-4.00324 -1.685337,-0.98349 -3.525822,-1.47524 -5.521501,-1.47524 -1.995657,0 -3.836141,0.49175 -5.521501,1.47524 -1.685359,0.9835 -3.019718,2.31793 -4.003235,4.00324 -0.983517,1.68534 -1.475241,3.52582 -1.475241,5.52148 0,1.99565 0.491747,3.83614 1.475241,5.5215 0.98354,1.68531 2.317921,3.01974 4.003235,4.00323 1.685314,0.9835 3.525822,1.47529 5.521501,1.47529 1.995679,0 3.836164,-0.49175 5.521501,-1.47529 1.685337,-0.98349 3.019741,-2.31792 4.003257,-4.00323 0.98354,-1.68536 1.475265,-3.52585 1.475265,-5.5215 0,-1.99566 -0.491747,-3.83614 -1.475287,-5.52148 z m -11.358054,-2.72851 c 0,-0.13369 0.04298,-0.2435 0.128915,-0.32943 0.08594,-0.0859 0.195761,-0.12892 0.329409,-0.12892 h 2.750012 c 0.133669,0 0.243495,0.043 0.329408,0.12892 0.08591,0.086 0.128915,0.19574 0.128915,0.32943 v 2.29166 c 0,0.13367 -0.04298,0.2435 -0.128915,0.32941 -0.08594,0.0859 -0.195761,0.12892 -0.329408,0.12892 h -2.750012 c -0.133671,0 -0.243496,-0.043 -0.329409,-0.12892 -0.08591,-0.0859 -0.128915,-0.19576 -0.128915,-0.32941 l -2.3e-5,-2.29166 z m 5.5,15.125 c 0,0.13367 -0.04296,0.2435 -0.128915,0.32944 -0.08596,0.0859 -0.195762,0.12889 -0.329431,0.12889 h -6.416671 c -0.13367,0 -0.243496,-0.043 -0.329409,-0.12889 -0.08594,-0.086 -0.128915,-0.19579 -0.128915,-0.32944 v -2.29166 c 0,-0.13369 0.04298,-0.2435 0.128915,-0.32943 0.08591,-0.0859 0.195761,-0.12889 0.329409,-0.12889 h 1.374994 v -4.58333 h -1.374994 c -0.13367,0 -0.243496,-0.043 -0.329409,-0.12892 -0.08591,-0.0859 -0.128915,-0.19576 -0.128915,-0.32943 v -2.29166 c 0,-0.13368 0.04298,-0.2435 0.128915,-0.32941 0.08594,-0.0859 0.195761,-0.12892 0.329409,-0.12892 h 4.583353 c 0.133669,0 0.243495,0.043 0.329408,0.12892 0.08593,0.0859 0.128915,0.19576 0.128915,0.32941 v 7.33334 h 1.374995 c 0.133669,0 0.243495,0.043 0.329431,0.12889 0.08596,0.086 0.128915,0.19576 0.128915,0.32943 v 2.29169 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    SHARE: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-35.572381,-252.56856)"> <path d="M 57.356972,252.56857 H 38.676975 c -0.118484,0 -0.21541,0.0969 -0.21541,0.21543 v 8.75215 h -2.889184 v 11.03205 c 0,0.11848 0,0.31235 0,0.43084 v 0.6331 c 0,0.11849 0,0.25814 0,0.3104 v 0.095 h 13.223344 v -2.35819 h 8.561247 c 0.118484,0 0.215409,-0.097 0.215409,-0.21541 v -18.67995 c 0,-0.11849 -0.09692,-0.21543 -0.215388,-0.21543 z m -1.075565,17.56775 c 0,0.11848 -0.09697,0.21541 -0.215431,0.21541 h -16.13641 c -0.118484,0 -0.21541,-0.0969 -0.21541,-0.21541 v -16.13639 c 0,-0.11849 0.09695,-0.21543 0.21541,-0.21543 h 16.136388 c 0.118484,0 0.215432,0.0969 0.215432,0.21543 z m -2.431191,-9.93084 -3.180865,-3.18087 c -0.104929,-0.10493 -0.229158,-0.15738 -0.37275,-0.15738 -0.06629,0 -0.135287,0.0138 -0.207105,0.0414 -0.215367,0.0939 -0.323028,0.25678 -0.323028,0.48871 v 1.59045 h -1.325377 c -0.585363,0 -1.127953,0.0304 -1.627729,0.0911 -0.499776,0.0607 -0.940191,0.14497 -1.321225,0.25266 -0.381033,0.1077 -0.724802,0.24161 -1.031306,0.40175 -0.306506,0.16014 -0.56742,0.32996 -0.782787,0.50944 -0.215388,0.17947 -0.404507,0.38378 -0.567419,0.61296 -0.162913,0.22918 -0.292692,0.45421 -0.389317,0.6751 -0.09663,0.2209 -0.17395,0.46387 -0.231955,0.72896 -0.05801,0.26509 -0.09665,0.51359 -0.115966,0.74552 -0.01932,0.23193 -0.02898,0.48321 -0.02898,0.75381 0,0.30925 0.04832,0.64612 0.14497,1.01058 0.09664,0.36447 0.202952,0.67924 0.318918,0.94435 0.115968,0.26504 0.252654,0.53981 0.410036,0.8242 0.157384,0.28441 0.266466,0.47355 0.327181,0.56742 0.06076,0.0939 0.118743,0.1795 0.173951,0.25678 0.05523,0.0718 0.127025,0.10771 0.215366,0.10771 0.0221,0 0.05523,-0.006 0.0994,-0.0166 0.127003,-0.0607 0.182233,-0.15459 0.165666,-0.28161 -0.2485,-1.85551 -0.04417,-3.16155 0.612988,-3.91813 0.635085,-0.7234 1.844474,-1.08514 3.628188,-1.08514 h 1.325376 v 1.59045 c 0,0.23193 0.107683,0.39487 0.323028,0.48871 0.07182,0.0276 0.140817,0.0414 0.207105,0.0414 0.149101,0 0.273351,-0.0525 0.372751,-0.1574 l 3.180886,-3.18087 c 0.10493,-0.10493 0.157384,-0.22918 0.157384,-0.37275 0,-0.14357 -0.05243,-0.2678 -0.157384,-0.37275 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    MEASURE_DISTANCE: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-303.62478,-762.46601)"> <path d="m 308.23402,762.46621 -0.83733,0.8449 c -10e-5,1.1e-4 -2.2e-4,2e-4 -2.9e-4,3e-4 l -3.62163,3.62107 c -0.2,0.19995 -0.19994,0.52438 -1.3e-4,0.72428 l 1.19932,1.19946 -0.004,0.004 1.91441,1.91344 0.82458,-0.82459 c 0.18364,-0.18365 0.47744,-0.18365 0.64271,0 0.18365,0.18363 0.18365,0.47742 0,0.64271 l -0.82442,0.82441 0.78983,0.78943 1.65057,-1.65057 c 0.18364,-0.18364 0.47744,-0.18364 0.64271,0 0.18365,0.18364 0.18365,0.47743 0,0.6427 l -1.65042,1.65041 0.78982,0.78942 0.82385,-0.82385 c 0.18364,-0.18364 0.47744,-0.18364 0.64272,0 0.18363,0.18363 0.18363,0.47744 0,0.64272 l -0.82371,0.82371 0.78981,0.78942 1.64985,-1.64986 c 0.18362,-0.18364 0.47743,-0.18364 0.6427,0 0.18365,0.18363 0.18365,0.47743 0,0.64271 l -1.64969,1.64969 0.78982,0.78943 0.82315,-0.82315 c 0.18364,-0.18364 0.47743,-0.18364 0.64271,0 0.18364,0.18364 0.18364,0.47744 0,0.64271 l -0.82298,0.82298 0.78983,0.78942 1.64912,-1.64912 c 0.18364,-0.18365 0.47744,-0.18365 0.64271,0 0.18365,0.18363 0.18365,0.47744 0,0.64271 l -1.64895,1.64896 0.78983,0.78942 0.82242,-0.82243 c 0.18365,-0.18364 0.47744,-0.18364 0.64271,0 0.18365,0.18364 0.18365,0.47744 0,0.64271 l -0.82226,0.82227 0.78982,0.78942 1.64842,-1.64842 c 0.18365,-0.18363 0.47744,-0.18363 0.64271,0 0.18365,0.18365 0.18365,0.47745 0,0.64271 l -1.62287,1.6736 0.7917,0.79192 0.83117,-0.83117 c 0.18365,-0.18365 0.47744,-0.18365 0.64272,0 0.18364,0.18363 0.18364,0.47744 0,0.64271 l -0.83075,0.83074 0.32972,0.32954 -6.3e-4,6.4e-4 1.08631,1.08633 c 0.19921,0.19926 0.52435,0.20003 0.72427,1.3e-4 l 3.62164,-3.62108 c 0.008,-0.008 0.0158,-0.0164 0.0233,-0.025 l 0.89311,-0.90123 -17.45986,-17.30286 z m -0.83343,3.31797 c 0.43346,0 0.78487,0.35141 0.78487,0.78487 0,0.43347 -0.35139,0.78487 -0.78487,0.78487 -0.43347,0 -0.78488,-0.3514 -0.78488,-0.78487 0,-0.43346 0.35141,-0.78487 0.78488,-0.78487 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    MEASURE_AREA: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-21.268214,-869.09547)"> <path d="m 25.892517,873.71977 -4.624303,-4.6243 v 5.82107 h 2.05794 c 0.246642,0 0.443959,0.19732 0.431634,0.43163 0,0.24664 -0.197317,0.44396 -0.431634,0.43164 h -2.05794 v 1.06058 h 0.948032 c 0.246641,0 0.443959,0.19732 0.431634,0.43164 0,0.24664 -0.197318,0.44395 -0.431634,0.43163 h -0.948032 v 1.06058 h 2.05794 c 0.246642,0 0.443959,0.19732 0.431634,0.43164 0,0.24664 -0.197317,0.44396 -0.431634,0.43163 h -2.05794 v 1.06056 h 0.948032 c 0.246641,0 0.443959,0.19732 0.431634,0.43164 0,0.24664 -0.197318,0.44396 -0.431634,0.43163 h -0.948032 v 1.06056 h 2.05794 c 0.246642,0 0.443959,0.19732 0.431634,0.43164 0,0.24664 -0.197317,0.44396 -0.431634,0.43163 h -2.05794 v 1.06056 h 0.948032 c 0.246641,0 0.443959,0.19732 0.431634,0.43164 0,0.24664 -0.197318,0.44396 -0.431634,0.43163 h -0.948032 v 1.06059 h 2.05794 c 0.246642,0 0.443959,0.19731 0.431634,0.43163 0,0.24664 -0.197317,0.44396 -0.431634,0.43163 l -2.05794,0.0317 v 3.74087 h 4.462472 v -2.05794 c 0,-0.24664 0.197317,-0.44396 0.431634,-0.43163 0.246641,0 0.443959,0.19731 0.431633,0.43163 v 2.05794 h 1.060586 v -0.94803 c 0,-0.24664 0.197317,-0.44396 0.431634,-0.43164 0.246641,0 0.443958,0.19732 0.431633,0.43164 v 0.94803 h 1.060586 v -2.05794 c 0,-0.24664 0.197317,-0.44396 0.431634,-0.43163 0.246641,0 0.443958,0.19731 0.431633,0.43163 v 2.05794 h 1.060562 v -0.94803 c 0,-0.24664 0.197318,-0.44396 0.431634,-0.43164 0.246641,0 0.443959,0.1973 0.431634,0.43164 v 0.94803 h 1.060562 v -2.05794 c 0,-0.24664 0.197318,-0.44396 0.431634,-0.43163 0.246641,0 0.443959,0.19731 0.431634,0.43163 v 2.05794 h 1.060562 v -0.94803 c 0,-0.24664 0.197317,-0.44396 0.431634,-0.43164 0.246641,0 0.443959,0.1973 0.431633,0.43164 v 0.94803 h 1.060586 v -2.05794 c 0,-0.24664 0.197317,-0.44396 0.431634,-0.43163 0.246641,0 0.443958,0.19731 0.431633,0.43163 l 0.03167,2.05794 H 43.26814 L 25.892586,873.71984 z m 0.0089,13.3257 -0.005,-7.59079 7.590812,7.59079 h -7.585765 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    ZOOM_PREVIOUS: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(310.83877,-1059.6151)"> <path d="m -297.83877,1071.6151 c 0,0.2708 -0.099,0.5052 -0.29688,0.7031 -0.19792,0.1979 -0.43229,0.2969 -0.70313,0.2969 -0.28125,0 -0.51562,-0.099 -0.70313,-0.2969 l -2.67968,-2.6719 c -0.93231,0.6459 -1.97136,0.9688 -3.11719,0.9688 -0.7448,0 -1.45703,-0.1445 -2.13671,-0.4336 -0.67968,-0.2891 -1.26563,-0.6797 -1.75782,-1.1719 -0.49219,-0.4921 -0.88281,-1.0781 -1.17187,-1.7578 -0.28906,-0.6797 -0.43359,-1.3919 -0.43359,-2.1367 0,-0.7448 0.14453,-1.457 0.43359,-2.1367 0.28906,-0.6797 0.67969,-1.2656 1.17187,-1.7578 0.49218,-0.4922 1.07812,-0.8828 1.75782,-1.1719 0.67969,-0.2891 1.39192,-0.4336 2.13671,-0.4336 0.74479,0 1.45704,0.1445 2.13672,0.4336 0.67968,0.2891 1.26562,0.6797 1.75781,1.1719 0.49219,0.4922 0.88281,1.0781 1.17187,1.7578 0.28906,0.6797 0.43359,1.3919 0.43359,2.1367 0,1.1458 -0.32293,2.1849 -0.96875,3.1172 l 2.67968,2.6797 c 0.1927,0.1927 0.28906,0.4271 0.28906,0.7031 z m -11.5486,-6.0022 3.8069,3.6035 c 0.14819,0.1413 0.32556,0.2107 0.53217,0.2107 0.20272,0 0.37813,-0.069 0.5263,-0.2107 l 0.43858,-0.4148 c 0.14819,-0.1326 0.22224,-0.2992 0.22224,-0.4986 0,-0.1999 -0.0741,-0.3653 -0.22224,-0.4982 l -1.71339,-1.6276 h 4.11678 c 0.2027,0 0.36741,-0.069 0.4941,-0.2063 0.12669,-0.1391 0.19011,-0.3055 0.19011,-0.5009 v -0.7085 c 0,-0.1957 -0.0635,-0.3628 -0.19011,-0.5012 -0.12667,-0.1391 -0.2914,-0.2085 -0.4941,-0.2085 h -4.11683 l 1.71339,-1.6217 c 0.14817,-0.1393 0.22224,-0.3081 0.22224,-0.504 0,-0.1955 -0.0741,-0.3635 -0.22224,-0.5035 l -0.4386,-0.4152 c -0.15206,-0.137 -0.32745,-0.2043 -0.52627,-0.2043 -0.20272,0 -0.38016,0.067 -0.53218,0.2043 l -3.80694,3.6036 c -0.14425,0.137 -0.21638,0.3045 -0.21638,0.5037 0,0.2021 0.0721,0.3691 0.21638,0.4984 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg> ',
    ZOOM_NEXT: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(310.83877,-1059.6151)"> <path d="m -301.21229,1064.6173 -3.8069,-3.6035 c -0.14819,-0.1413 -0.32556,-0.2107 -0.53217,-0.2107 -0.20272,0 -0.37813,0.069 -0.5263,0.2107 l -0.43858,0.4148 c -0.14819,0.1326 -0.22224,0.2992 -0.22224,0.4986 0,0.1999 0.0741,0.3653 0.22224,0.4982 l 1.71339,1.6276 h -4.11678 c -0.2027,0 -0.36741,0.069 -0.4941,0.2063 -0.12669,0.1391 -0.19011,0.3055 -0.19011,0.5009 v 0.7085 c 0,0.1957 0.0635,0.3628 0.19011,0.5012 0.12667,0.1391 0.2914,0.2085 0.4941,0.2085 h 4.11683 l -1.71339,1.6217 c -0.14817,0.1393 -0.22224,0.3081 -0.22224,0.504 0,0.1955 0.0741,0.3635 0.22224,0.5035 l 0.4386,0.4152 c 0.15206,0.137 0.32745,0.2043 0.52627,0.2043 0.20272,0 0.38016,-0.067 0.53218,-0.2043 l 3.80694,-3.6036 c 0.14425,-0.137 0.21638,-0.3045 0.21638,-0.5037 0,-0.2021 -0.0721,-0.3691 -0.21638,-0.4984 z m 3.37352,6.9978 c 0,0.2708 -0.099,0.5052 -0.29688,0.7031 -0.19792,0.1979 -0.43229,0.2969 -0.70313,0.2969 -0.28125,0 -0.51562,-0.099 -0.70313,-0.2969 l -2.67968,-2.6719 c -0.93231,0.6459 -1.97136,0.9688 -3.11719,0.9688 -0.7448,0 -1.45703,-0.1445 -2.13671,-0.4336 -0.67968,-0.2891 -1.26563,-0.6797 -1.75782,-1.1719 -0.49219,-0.4921 -0.88281,-1.0781 -1.17187,-1.7578 -0.28906,-0.6797 -0.43359,-1.3919 -0.43359,-2.1367 0,-0.7448 0.14453,-1.457 0.43359,-2.1367 0.28906,-0.6797 0.67969,-1.2656 1.17187,-1.7578 0.49218,-0.4922 1.07812,-0.8828 1.75782,-1.1719 0.67969,-0.2891 1.39192,-0.4336 2.13671,-0.4336 0.74479,0 1.45704,0.1445 2.13672,0.4336 0.67968,0.2891 1.26562,0.6797 1.75781,1.1719 0.49219,0.4922 0.88281,1.0781 1.17187,1.7578 0.28906,0.6797 0.43359,1.3919 0.43359,2.1367 0,1.1458 -0.32293,2.1849 -0.96875,3.1172 l 2.67968,2.6797 c 0.1927,0.1927 0.28906,0.4271 0.28906,0.7031 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    MAXIMIZE: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(67.743472,-283.82536)"> <path d="m -54.906019,283.98105 c 0.104572,0.10419 0.157,0.23264 0.157253,0.38523 l 0.0052,3.08383 c 2.82e-4,0.15257 -0.05173,0.28116 -0.155956,0.38573 -0.104229,0.10454 -0.232638,0.157 -0.385225,0.15727 -0.152588,2.8e-4 -0.28116,-0.0517 -0.385732,-0.15596 l -0.772267,-0.76964 -2.69677,2.70595 -1.54254,-1.54131 2.694772,-2.70392 -0.772269,-0.76965 c -0.104572,-0.10421 -0.156985,-0.23263 -0.157253,-0.38522 -2.82e-4,-0.15259 0.05173,-0.28116 0.155956,-0.38573 0.104215,-0.10459 0.232638,-0.157 0.385225,-0.15727 l 3.083814,-0.005 c 0.152587,-3e-4 0.281145,0.0517 0.385747,0.15592 z m -6.899007,8.25992 -2.694772,2.70393 0.772269,0.76963 c 0.104572,0.10423 0.157,0.23264 0.157253,0.38522 2.54e-4,0.15259 -0.05173,0.28118 -0.155941,0.38575 -0.104215,0.10457 -0.232638,0.157 -0.385241,0.15725 l -3.083813,0.005 c -0.152588,2.8e-4 -0.28116,-0.0517 -0.385747,-0.15594 -0.104587,-0.10423 -0.157015,-0.23263 -0.157253,-0.38521 l -0.0052,-3.08383 c -2.54e-4,-0.15257 0.05173,-0.28118 0.155956,-0.38575 0.104229,-0.10457 0.232638,-0.157 0.38524,-0.15725 0.152573,-2.3e-4 0.281175,0.0517 0.385732,0.15595 l 0.772269,0.76964 2.6968,-2.70596 1.54251,1.54132 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    MINIMIZE: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-60.768341,-285.3372)"> <path d="m 66.544364,292.36799 c 0.104573,0.10421 0.157001,0.23263 0.157253,0.38522 l 0.0052,3.08383 c 2.25e-4,0.15256 -0.05173,0.28116 -0.155957,0.38572 -0.104229,0.10455 -0.232637,0.15701 -0.38524,0.15728 -0.152572,2.2e-4 -0.28116,-0.0517 -0.385732,-0.15597 l -0.772266,-0.76963 -2.696756,2.70595 -1.542525,-1.54129 2.694772,-2.70392 -0.772269,-0.76963 c -0.104572,-0.10423 -0.157014,-0.23264 -0.157268,-0.38524 -2.36e-4,-0.15259 0.05173,-0.28116 0.155972,-0.38574 0.104214,-0.10458 0.232622,-0.15701 0.38521,-0.15726 l 3.083829,-0.005 c 0.152587,-2.8e-4 0.281144,0.0517 0.385731,0.15593 z m 7.224023,-5.48919 -2.694772,2.70393 0.772269,0.76963 c 0.104572,0.10421 0.157014,0.23264 0.157253,0.38522 2.82e-4,0.15259 -0.05171,0.28118 -0.155941,0.38575 -0.10423,0.10457 -0.232638,0.15701 -0.385225,0.15725 l -3.083814,0.005 c -0.152588,2.8e-4 -0.28116,-0.0517 -0.385748,-0.15596 -0.104572,-0.10421 -0.156999,-0.23264 -0.157253,-0.38522 l -0.0053,-3.08383 c -2.26e-4,-0.15258 0.05174,-0.28118 0.155956,-0.38575 0.104215,-0.10457 0.232638,-0.157 0.38524,-0.15725 0.152573,-2.3e-4 0.28116,0.0517 0.385732,0.15595 l 0.77227,0.76963 2.696769,-2.70595 1.542511,1.54133 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    GEAR_WHEEL: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-25.800826,-231.74042)"> <path d="m 37.256026,238.24032 c 0,-0.15509 -0.0078,-0.30863 -0.02234,-0.46008 l 1.56714,-0.90219 c -0.09649,-0.44238 -0.238981,-0.86814 -0.422256,-1.27204 l -1.810109,0.17096 c -0.160397,-0.26532 -0.346045,-0.51439 -0.553524,-0.74411 l 0.725139,-1.62981 c -0.338897,-0.29783 -0.709408,-0.562 -1.10604,-0.78728 l -1.360862,1.17806 c -0.285455,-0.12142 -0.585109,-0.2171 -0.895678,-0.28444 l -0.392603,-1.73497 c -0.22503,-0.0225 -0.453193,-0.034 -0.68406,-0.034 -0.230895,0 -0.459044,0.0116 -0.68406,0.034 l -0.392741,1.73524 c -0.310569,0.0675 -0.610099,0.16314 -0.895705,0.28443 l -1.360711,-1.17822 c -0.396632,0.22517 -0.767143,0.48944 -1.106165,0.78727 l 0.725402,1.6298 c -0.207617,0.22973 -0.393113,0.47881 -0.553538,0.74412 l -1.810095,-0.17108 c -0.183551,0.40404 -0.325913,0.82966 -0.42238,1.27204 l 1.567154,0.90208 c -0.01456,0.15143 -0.02237,0.30498 -0.02237,0.46006 0,0.15509 0.0078,0.30864 0.02237,0.45996 l -1.567168,0.90242 c 0.09647,0.44226 0.238815,0.86814 0.42238,1.27218 l 1.809971,-0.17105 c 0.160411,0.26533 0.345921,0.51441 0.553524,0.74412 l -0.725388,1.62969 c 0.339036,0.29783 0.709547,0.56212 1.106151,0.78739 l 1.360724,-1.17805 c 0.285607,0.1213 0.58511,0.21697 0.895692,0.28432 l 0.392741,1.73536 c 0.225168,0.0222 0.453303,0.0338 0.684185,0.0338 0.230881,0 0.459029,-0.0116 0.684059,-0.0341 l 0.392727,-1.73536 c 0.310569,-0.0674 0.610099,-0.16303 0.89572,-0.28432 l 1.360821,1.17804 c 0.396618,-0.22516 0.767004,-0.48957 1.10604,-0.7874 l -0.725249,-1.62954 c 0.207478,-0.22971 0.392975,-0.47879 0.553524,-0.74411 l 1.810108,0.17108 c 0.183303,-0.40405 0.325789,-0.8299 0.422256,-1.27217 l -1.56714,-0.9022 c 0.01468,-0.15132 0.02235,-0.30486 0.02235,-0.45996 z m -4.955207,2.12603 c -1.200824,0 -2.174134,-0.95185 -2.174134,-2.12602 0,-1.17429 0.97331,-2.126 2.174134,-2.126 1.200687,0 2.174121,0.95171 2.174121,2.126 -1.4e-5,1.17417 -0.973434,2.12602 -2.174121,2.12602 z" style="fill:#757D75;fill-opacity:1" /> </g> </svg>',
    LAYER_HIDDEN: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(9.0288095,-228.84545)"> <path d="M 3.8439033,228.8455 H -7.1942766 c -0.070013,0 -0.1272876,0.0573 -0.1272876,0.1273 v 5.17173 h -1.7072453 v 6.51894 c 0,0.07 0,0.18457 0,0.25458 v 0.37411 c 0,0.07 0,0.15254 0,0.18342 v 0.0561 h 7.8138067 v -1.39348 h 5.0589061 c 0.070013,0 0.1272872,-0.0573 0.1272872,-0.1273 v -11.03815 c 0,-0.07 -0.057274,-0.1273 -0.1272747,-0.1273 z m -0.6355609,10.38095 c 0,0.07 -0.057287,0.1273 -0.1273001,0.1273 h -9.5351389 c -0.070013,0 -0.1272875,-0.0573 -0.1272875,-0.1273 v -9.53514 c 0,-0.07 0.057287,-0.1273 0.1272875,-0.1273 h 9.5351389 c 0.070013,0 0.1273001,0.0573 0.1273001,0.1273 z" style="fill:#000000;fill-opacity:1" /> </g> </svg>',
    LAYER_SHOWN: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-17.429524,-284.78581)"> <path d="m 21.648423,287.14497 h 6.380322 v 6.38032 h -6.380322 z m 8.653814,-2.35912 h -11.03818 c -0.07001,0 -0.127288,0.0573 -0.127288,0.1273 v 5.17173 h -1.707245 v 6.51894 c 0,0.07 0,0.18457 0,0.25458 v 0.37411 c 0,0.07 0,0.15254 0,0.18342 v 0.0561 h 7.813794 v -1.39348 h 5.058919 c 0.07001,0 0.127287,-0.0573 0.127287,-0.12728 v -11.03816 c 0,-0.07 -0.05727,-0.1273 -0.127275,-0.1273 z m -0.635561,10.38095 c 0,0.07 -0.0573,0.12728 -0.1273,0.12728 h -9.535152 c -0.07001,0 -0.127287,-0.0573 -0.127287,-0.12728 v -9.53514 c 0,-0.07 0.05729,-0.1273 0.127287,-0.1273 h 9.535139 c 0.07001,0 0.1273,0.0573 0.1273,0.1273 z" style="fill:#000000;fill-opacity:1" /> </g> </svg>',
    ADD_LAYER: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(64.969286,-246.23236)"> <path d="m -52.096573,246.23241 h -11.03818 c -0.07001,0 -0.127288,0.0573 -0.127288,0.1273 v 5.17173 h -1.707245 v 6.51894 c 0,0.07 0,0.18457 0,0.25458 v 0.37411 c 0,0.07 0,0.15254 0,0.18342 v 0.0561 h 7.813807 v -1.39348 h 5.058906 c 0.07001,0 0.127287,-0.0573 0.127287,-0.1273 v -11.03815 c 0,-0.07 -0.05727,-0.1273 -0.127275,-0.1273 z m -0.635561,10.38095 c 0,0.07 -0.05729,0.1273 -0.1273,0.1273 h -9.535139 c -0.07001,0 -0.127288,-0.0573 -0.127288,-0.1273 v -9.53514 c 0,-0.07 0.05729,-0.1273 0.127288,-0.1273 h 9.535139 c 0.07001,0 0.1273,0.0573 0.1273,0.1273 z m -4.067443,-8.0836 h -1.514038 v 2.59714 h -2.620431 v 1.5606 h 2.620431 v 2.59716 h 1.514038 v -2.59716 h 2.632076 v -1.5606 h -2.632076 z" style="fill:#000000;fill-opacity:1" /> </g> </svg>',
    FOLDER_CLOSED: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(38.099983,-285.84875)"> <path d="m -25.099983,289.59875 v 5.5 c 0,0.47916 -0.171869,0.89063 -0.515621,1.23438 -0.343752,0.34375 -0.755207,0.51562 -1.234379,0.51562 h -9.5 c -0.479158,0 -0.890627,-0.17187 -1.234379,-0.51562 -0.343752,-0.34375 -0.515621,-0.75521 -0.515621,-1.23438 v -7.49999 c 0,-0.47916 0.171869,-0.89063 0.515621,-1.23438 0.343752,-0.34376 0.755207,-0.51563 1.234379,-0.51563 h 2.499999 c 0.479171,0 0.890626,0.17187 1.234378,0.51563 0.343752,0.34375 0.515622,0.7552 0.515622,1.23438 v 0.25 h 5.250001 c 0.479172,0 0.890627,0.17187 1.234379,0.51562 0.343752,0.34375 0.515621,0.75521 0.515621,1.23438 z" style="fill:#000000;fill-opacity:1" /> </g> </svg>',
    FOLDER_OPEN: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(90.676505,-247.26362)"> <path d="m -77.676434,252.96455 c 0,0.14298 -0.07148,0.2952 -0.214469,0.45663 l -2.324633,2.73975 c -0.198336,0.23523 -0.476231,0.43472 -0.833697,0.59847 -0.357465,0.16374 -0.688399,0.2456 -0.992813,0.2456 h -7.527411 c -0.156816,0 -0.296342,-0.03 -0.418578,-0.0899 -0.122236,-0.06 -0.183347,-0.15913 -0.183347,-0.2975 0,-0.14299 0.0715,-0.2952 0.214469,-0.45663 l 2.324645,-2.73975 c 0.198337,-0.23523 0.476231,-0.43473 0.833684,-0.59846 0.357453,-0.16373 0.688399,-0.2456 0.992814,-0.2456 h 7.527411 c 0.156828,0 0.296341,0.03 0.418577,0.0899 0.122236,0.06 0.183348,0.15912 0.183348,0.2975 z m -2.373069,-2.37999 v 1.10698 h -5.756255 c -0.433553,0 -0.88788,0.10955 -1.362954,0.32863 -0.475074,0.21909 -0.853287,0.49468 -1.134652,0.82678 l -2.366141,2.78128 c 0,-0.0185 -0.0011,-0.0473 -0.0035,-0.0865 -0.0023,-0.0392 -0.0035,-0.068 -0.0035,-0.0865 v -6.64185 c 0,-0.42434 0.152213,-0.7887 0.456628,-1.09313 0.304414,-0.30443 0.668795,-0.45663 1.093131,-0.45663 h 2.213941 c 0.424336,0 0.788717,0.15221 1.093132,0.45663 0.304414,0.30441 0.456627,0.66879 0.456627,1.09313 v 0.2214 h 3.7637 c 0.424349,0 0.788717,0.15221 1.093144,0.45663 0.304427,0.30441 0.45664,0.66879 0.45664,1.09314 z" style="fill:#000000;fill-opacity:1" /> </g> </svg>',
    ZOOM_IN: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(53.214663,-282.78597)"> <path d="m -44.214674,288.28594 c 0,-0.96355 -0.342451,-1.78776 -1.02734,-2.47266 -0.684889,-0.6849 -1.509113,-1.02734 -2.472658,-1.02734 -0.963546,0 -1.78777,0.34245 -2.472659,1.02734 -0.684889,0.68489 -1.02734,1.50911 -1.02734,2.47266 0,0.96354 0.342451,1.78775 1.02734,2.47266 0.684889,0.6849 1.509113,1.02734 2.472659,1.02734 0.963545,0 1.787755,-0.34246 2.472658,-1.02734 0.684889,-0.68491 1.02734,-1.50912 1.02734,-2.47266 z m 4.000011,6.50001 c 0,0.27084 -0.09896,0.50521 -0.296881,0.70313 -0.197921,0.19792 -0.432293,0.29688 -0.703128,0.29688 -0.281254,0 -0.515626,-0.099 -0.703129,-0.29688 l -2.679685,-2.67188 c -0.932304,0.64584 -1.971361,0.96875 -3.117186,0.96875 -0.744802,0 -1.457036,-0.14453 -2.136716,-0.43359 -0.67968,-0.28906 -1.265622,-0.67969 -1.757813,-1.17187 -0.492191,-0.49217 -0.88281,-1.07812 -1.171871,-1.75781 -0.289061,-0.67969 -0.433591,-1.39193 -0.433591,-2.13672 0,-0.74478 0.14453,-1.45703 0.433591,-2.13671 0.289061,-0.67968 0.679694,-1.26562 1.171871,-1.75781 0.492178,-0.4922 1.07812,-0.88281 1.757813,-1.17187 0.679694,-0.28907 1.391928,-0.4336 2.136716,-0.4336 0.744787,0 1.457035,0.14453 2.136715,0.4336 0.67968,0.28906 1.265622,0.67969 1.757813,1.17187 0.492191,0.49217 0.88281,1.07812 1.171871,1.75781 0.289061,0.67969 0.433591,1.39193 0.433591,2.13671 0,1.14584 -0.322927,2.1849 -0.968754,3.11719 l 2.679685,2.67969 c 0.192698,0.19271 0.289061,0.42708 0.289061,0.70312 z m -5.487836,-7.16478 h -1.415143 v -1.41735 c 0,-0.0909 -0.03175,-0.16808 -0.09524,-0.23168 -0.06349,-0.0636 -0.140606,-0.0954 -0.231322,-0.0954 h -0.653156 c -0.09072,0 -0.167814,0.0318 -0.231322,0.0954 -0.06351,0.0636 -0.09524,0.14082 -0.09524,0.23168 v 1.41737 h -1.415156 c -0.0907,0 -0.167815,0.0318 -0.231309,0.0954 -0.06349,0.0636 -0.09524,0.14083 -0.09524,0.23168 v 0.65417 c 0,0.0908 0.03175,0.16807 0.09524,0.23168 0.06349,0.0636 0.140606,0.0954 0.231309,0.0954 h 1.415142 v 1.41737 c 0,0.0908 0.03175,0.16807 0.09524,0.23165 0.0635,0.0636 0.140607,0.0954 0.231323,0.0954 h 0.653155 c 0.09072,0 0.167815,-0.0318 0.231323,-0.0954 0.06349,-0.0636 0.09523,-0.14082 0.09523,-0.23165 v -1.41737 h 1.415157 c 0.09069,0 0.1678,-0.0318 0.231308,-0.0954 0.0635,-0.0636 0.09524,-0.14083 0.09524,-0.2317 v -0.65415 c 0,-0.0908 -0.03175,-0.16809 -0.09524,-0.23169 -0.06349,-0.0636 -0.140606,-0.0954 -0.231308,-0.0954 z" style="fill:#757D75;fill-opacity:1" /> </g> </svg>',
    SHOW_COORDINATES: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-62.142801,-221.11561)"> <path xmlns="http://www.w3.org/2000/svg" d="m 68.652763,221.11561 c -3.606049,0 -6.509962,2.88494 -6.509962,6.47012 0,3.62549 2.904386,6.50996 6.509962,6.50996 3.625503,0 6.490038,-2.88493 6.490038,-6.50996 0,-3.58518 -2.864535,-6.47012 -6.490038,-6.47012 z m -0.440732,1.22211 c 0.01992,0 0.03938,0 0.03938,0 v 3.7256 c -0.68079,-0.0199 -1.36158,-0.0602 -2.022445,-0.11996 0.320708,-1.84263 1.0812,-3.24502 1.983069,-3.60557 z m 0.03938,4.42678 v 2.82469 c -0.68079,-0.0199 -1.341655,-0.0802 -2.022445,-0.20068 -0.08065,-0.54083 -0.120028,-1.16138 -0.120028,-1.74253 0,-0.36055 0.01945,-0.66134 0.01945,-1.02189 0.681738,0.0802 1.402379,0.12049 2.123495,0.14004 z m -3.344648,-2.88445 c 0.540837,-0.58117 1.141926,-0.86155 1.822715,-1.18178 -0.600138,0.80129 -0.98157,1.86256 -1.201226,3.14445 -1.18225,-0.32023 -1.482556,-0.34063 -1.66236,-0.50099 0.240055,-0.52044 0.580212,-1.04134 1.041346,-1.46216 z m -1.521932,4.44672 c -0.04033,-0.2206 -0.04033,-0.48059 -0.04033,-0.74104 0,-0.52091 0.08065,-1.06175 0.220604,-1.54233 0.420334,0.18028 0.961171,0.32022 1.882015,0.50003 -0.03938,0.38096 -0.05978,0.70119 -0.05978,1.10208 0,0.54083 0.03938,1.1016 0.120029,1.60258 -1.202175,-0.22013 -1.86304,-0.62101 -2.12302,-0.92132 z m 1.521932,3.00497 c -0.581161,-0.54085 -0.961169,-1.20171 -1.26195,-1.94323 0.481058,0.26094 1.201226,0.48106 2.002992,0.66134 0.199729,0.96164 0.500511,1.78287 0.96117,2.42381 -0.620539,-0.26047 -1.221626,-0.62148 -1.702685,-1.14192 z m 3.345596,1.54233 c -0.54131,0 -1.001495,-0.58117 -1.302277,-1.30181 -0.241003,-0.4208 -0.420334,-0.88146 -0.540836,-1.40238 0.600139,0.0602 1.221626,0.10059 1.84264,0.12049 v 2.58368 z m 5.167835,-7.51193 c -0.160355,0.12049 -0.601088,0.30077 -1.682286,0.50098 -0.200679,-1.30181 -0.581162,-2.40388 -1.18225,-3.18477 1.241553,0.44074 2.303774,1.44223 2.864536,2.68425 z m -4.406868,-3.02442 c 0.13995,0 0.340633,0.1603 0.520437,0.28038 0.681738,0.62102 1.26195,1.88297 1.521932,3.32519 -0.68079,0.0597 -1.341655,0.10006 -2.042844,0.11996 v -3.7256 z m 0,4.42678 c 0.741041,-0.0199 1.44223,-0.0597 2.123495,-0.11995 0.01992,0.34064 0.01992,0.64095 0.01992,1.0015 0,0.60061 -0.01992,1.22211 -0.120028,1.76247 -0.661339,0.10005 -1.322204,0.1603 -2.023393,0.18027 v -2.82468 z m 0,6.10957 v -2.58368 c 0.621012,-0.0204 1.241551,-0.0602 1.86304,-0.1205 -0.260457,0.9014 -0.821218,2.7042 -1.86304,2.7042 z m 3.365046,-1.54233 c -0.480111,0.5209 -1.101598,0.88099 -1.723085,1.14192 0.481059,-0.66134 0.76144,-1.44223 0.982044,-2.40387 0.740567,-0.1603 1.421357,-0.36057 1.942742,-0.6011 -0.26093,0.70119 -0.641414,1.34214 -1.202175,1.86305 z m -0.600613,-2.06324 c 0.05978,-0.50099 0.100108,-1.08168 0.100108,-1.62252 0,-0.40088 0,-0.72112 -0.04033,-1.10208 0.800818,-0.0798 1.482556,-0.32022 1.863039,-0.48058 0.160355,0.48058 0.240056,1.02189 0.240056,1.52241 0,0.86154 -0.0797,1.34212 -2.162871,1.68277 z" style="fill:#ffffff;fill-opacity:1"/> </g> </svg>',
    ZOOM_TO_FULL_EXTENT: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(57.905912,-271.60234)"> <path xmlns="http://www.w3.org/2000/svg" d="m -51.405912,271.60234 c 1.179253,0 2.26681,0.29058 3.262701,0.87174 0.99589,0.58116 1.784394,1.36968 2.365556,2.36556 0.581162,0.99587 0.871743,2.08345 0.871743,3.2627 0,1.17925 -0.290581,2.26681 -0.871743,3.2627 -0.581162,0.99589 -1.369681,1.7844 -2.365556,2.36556 -0.995876,0.58116 -2.083448,0.87174 -3.262701,0.87174 -1.179253,0 -2.26681,-0.29058 -3.262701,-0.87174 -0.99589,-0.58116 -1.784394,-1.36968 -2.365556,-2.36556 -0.581162,-0.99588 -0.871743,-2.08345 -0.871743,-3.2627 0,-1.17925 0.290581,-2.26681 0.871743,-3.2627 0.581162,-0.99588 1.369681,-1.7844 2.365556,-2.36556 0.995876,-0.58116 2.083448,-0.87174 3.262701,-0.87174 z m 2.319005,4.4095 c -0.01129,0.006 -0.03808,0.0324 -0.08041,0.0804 -0.04233,0.048 -0.08041,0.0747 -0.114254,0.0804 0.01129,0 0.02398,-0.0141 0.03808,-0.0423 0.0141,-0.0282 0.02821,-0.0593 0.04232,-0.0931 0.0141,-0.0338 0.02398,-0.0536 0.02962,-0.0592 0.03386,-0.0395 0.09592,-0.0818 0.186192,-0.12695 0.07899,-0.0339 0.225693,-0.0677 0.4401,-0.10156 0.191849,-0.0451 0.335725,-0.0141 0.431643,0.0931 -0.01129,-0.0113 0.01551,-0.048 0.08041,-0.11004 0.0649,-0.0621 0.105796,-0.0959 0.122725,-0.10156 0.01693,-0.0113 0.05924,-0.024 0.126947,-0.0381 0.0677,-0.0141 0.110032,-0.0353 0.126947,-0.0635 l 0.01693,-0.18619 c -0.0677,0.006 -0.117083,-0.0141 -0.148112,-0.0592 -0.03103,-0.0451 -0.04937,-0.10438 -0.05501,-0.17774 0,0.0113 -0.01693,0.0339 -0.05079,0.0677 0,-0.0395 -0.01269,-0.0621 -0.03808,-0.0677 -0.02539,-0.006 -0.05784,-0.003 -0.09732,0.008 -0.03949,0.0113 -0.06489,0.0141 -0.07617,0.008 -0.05643,-0.0169 -0.09875,-0.0381 -0.126947,-0.0635 -0.0282,-0.0254 -0.05079,-0.0719 -0.0677,-0.13965 -0.01691,-0.0677 -0.02822,-0.11003 -0.03386,-0.12695 -0.01129,-0.0282 -0.03808,-0.0578 -0.08041,-0.0889 -0.04233,-0.031 -0.06912,-0.0607 -0.08041,-0.0889 -0.0056,-0.0113 -0.01269,-0.0268 -0.02117,-0.0465 -0.0085,-0.0198 -0.01693,-0.0381 -0.02539,-0.055 -0.0085,-0.0169 -0.01974,-0.0324 -0.03386,-0.0465 -0.01412,-0.0141 -0.02962,-0.0212 -0.04655,-0.0212 -0.01693,0 -0.03667,0.0141 -0.05924,0.0423 -0.02257,0.0282 -0.04374,0.0564 -0.06348,0.0846 -0.01974,0.0282 -0.03244,0.0423 -0.03808,0.0423 -0.01693,-0.0113 -0.03386,-0.0155 -0.05079,-0.0127 -0.01693,0.003 -0.02962,0.006 -0.03808,0.008 -0.0085,0.003 -0.02117,0.0113 -0.03808,0.0254 -0.01691,0.0141 -0.03103,0.024 -0.04232,0.0296 -0.01693,0.0113 -0.04091,0.0197 -0.07194,0.0254 -0.03103,0.006 -0.05501,0.0113 -0.07194,0.0169 0.08463,-0.0282 0.08182,-0.0592 -0.0085,-0.0931 -0.05643,-0.0226 -0.10156,-0.031 -0.135418,-0.0254 0.05079,-0.0226 0.07194,-0.0564 0.06348,-0.10156 -0.0085,-0.0451 -0.03244,-0.0846 -0.07194,-0.11849 h 0.04232 c -0.0056,-0.0226 -0.02962,-0.0465 -0.07194,-0.0719 -0.04232,-0.0254 -0.09168,-0.0494 -0.148113,-0.0719 -0.05643,-0.0226 -0.0931,-0.0395 -0.110032,-0.0508 -0.04513,-0.0282 -0.141062,-0.055 -0.287767,-0.0804 -0.146705,-0.0254 -0.239793,-0.0268 -0.279295,-0.004 -0.02821,0.0339 -0.04091,0.0635 -0.03808,0.0889 0.0028,0.0254 0.01412,0.0649 0.03386,0.11849 0.01974,0.0536 0.02962,0.0889 0.02962,0.10579 0.0056,0.0339 -0.0099,0.0705 -0.04655,0.11004 -0.03667,0.0395 -0.05501,0.0734 -0.05501,0.10156 0,0.0395 0.0395,0.0832 0.118489,0.13118 0.07899,0.048 0.107204,0.10861 0.08463,0.18197 -0.01693,0.0451 -0.06206,0.0903 -0.135419,0.13542 -0.07336,0.0451 -0.11849,0.079 -0.135419,0.10156 -0.02821,0.0451 -0.03244,0.0973 -0.01269,0.15657 0.01974,0.0592 0.04937,0.1058 0.08887,0.13965 0.01129,0.0113 0.01551,0.0226 0.01269,0.0339 -0.0028,0.0113 -0.01269,0.024 -0.02962,0.0381 -0.01693,0.0141 -0.03244,0.0254 -0.04655,0.0339 -0.01411,0.008 -0.03244,0.0183 -0.05501,0.0296 l -0.02539,0.0169 c -0.06206,0.0282 -0.119897,0.0113 -0.173499,-0.0508 -0.0536,-0.0621 -0.09168,-0.13541 -0.114253,-0.22005 -0.0395,-0.14106 -0.08463,-0.22569 -0.135419,-0.2539 -0.129776,-0.0451 -0.211593,-0.0423 -0.245436,0.008 -0.02822,-0.0734 -0.143876,-0.1467 -0.347012,-0.22005 -0.141062,-0.0508 -0.304681,-0.0621 -0.490888,-0.0339 0.03386,-0.006 0.03386,-0.048 0,-0.12694 -0.0395,-0.0846 -0.0931,-0.11849 -0.160805,-0.10156 0.01693,-0.0339 0.02822,-0.0832 0.03386,-0.14812 0.0056,-0.0649 0.0085,-0.10298 0.0085,-0.11425 0.01693,-0.0734 0.05079,-0.13823 0.10156,-0.19466 0.0056,-0.006 0.02539,-0.0296 0.05925,-0.0719 0.03386,-0.0423 0.06065,-0.0804 0.08041,-0.11425 0.01976,-0.0339 0.02116,-0.0508 0.0042,-0.0508 0.197477,0.0226 0.338539,-0.008 0.42317,-0.0931 0.02822,-0.0282 0.06065,-0.0762 0.09732,-0.14388 0.03667,-0.0677 0.06629,-0.11568 0.08887,-0.14388 0.05079,-0.0339 0.09027,-0.0494 0.11849,-0.0466 0.02821,0.003 0.06912,0.0183 0.122725,0.0466 0.0536,0.0282 0.09451,0.0423 0.122726,0.0423 0.07899,0.006 0.122726,-0.0254 0.131183,-0.0931 0.0085,-0.0677 -0.01269,-0.12414 -0.06348,-0.16928 0.0677,0.006 0.07617,-0.0423 0.02539,-0.14388 -0.02822,-0.0395 -0.05079,-0.0649 -0.0677,-0.0762 -0.0677,-0.0226 -0.143877,-0.008 -0.228523,0.0423 -0.04513,0.0226 -0.0395,0.0451 0.01693,0.0677 -0.0056,-0.006 -0.03244,0.024 -0.08041,0.0889 -0.04797,0.0649 -0.09451,0.11426 -0.139655,0.14812 -0.04514,0.0338 -0.09027,0.0197 -0.135419,-0.0423 -0.0056,-0.006 -0.02117,-0.0437 -0.04655,-0.11425 -0.02539,-0.0705 -0.05219,-0.10861 -0.08041,-0.11426 -0.04513,0 -0.09027,0.0423 -0.13542,0.12695 0.01693,-0.0451 -0.01411,-0.0875 -0.0931,-0.12695 -0.07899,-0.0395 -0.146705,-0.0621 -0.203121,-0.0677 0.107204,-0.0677 0.08463,-0.14388 -0.0677,-0.22852 -0.0395,-0.0226 -0.09732,-0.0367 -0.173498,-0.0423 -0.07617,-0.006 -0.131183,0.006 -0.165041,0.0339 -0.02822,0.0395 -0.04374,0.0719 -0.04655,0.0973 -0.0028,0.0254 0.01129,0.048 0.04232,0.0677 0.03103,0.0197 0.06065,0.0353 0.08887,0.0466 0.02821,0.0113 0.06065,0.0226 0.09732,0.0339 0.03667,0.0113 0.06065,0.0197 0.07194,0.0254 0.07899,0.0564 0.101561,0.0959 0.0677,0.11849 -0.01129,0.006 -0.03527,0.0155 -0.07194,0.0296 -0.03667,0.0141 -0.06912,0.0268 -0.09732,0.0381 -0.0282,0.0113 -0.04513,0.0226 -0.05079,0.0339 -0.01693,0.0226 -0.01693,0.0621 0,0.11849 0.01693,0.0564 0.01129,0.0959 -0.01693,0.11849 -0.02821,-0.0282 -0.0536,-0.0776 -0.07617,-0.14811 -0.02257,-0.0705 -0.04232,-0.11708 -0.05925,-0.13965 0.0395,0.0508 -0.03103,0.0677 -0.211593,0.0508 l -0.08463,-0.008 c -0.02257,0 -0.0677,0.006 -0.135419,0.0169 -0.06772,0.0113 -0.125539,0.0141 -0.173498,0.008 -0.04796,-0.006 -0.08605,-0.0282 -0.114254,-0.0677 -0.02257,-0.0451 -0.02257,-0.10156 0,-0.16928 0.0056,-0.0226 0.01693,-0.0282 0.03386,-0.0169 -0.02257,-0.0169 -0.0536,-0.0437 -0.0931,-0.0804 -0.0395,-0.0367 -0.0677,-0.0606 -0.08463,-0.0719 -0.259551,0.0846 -0.524746,0.2003 -0.795569,0.34701 0.03386,0.006 0.0677,0.003 0.101561,-0.008 0.02822,-0.0113 0.06489,-0.0296 0.110032,-0.055 0.04514,-0.0254 0.07336,-0.0409 0.08463,-0.0465 0.191849,-0.079 0.310338,-0.0987 0.355468,-0.0592 l 0.04232,-0.0423 c 0.07899,0.0903 0.135419,0.16081 0.169277,0.21159 -0.0395,-0.0226 -0.124133,-0.0254 -0.253909,-0.008 -0.112846,0.0339 -0.17492,0.0677 -0.186191,0.10156 0.0395,0.0677 0.0536,0.11849 0.04232,0.15234 -0.02257,-0.0169 -0.05501,-0.0451 -0.09733,-0.0846 -0.04231,-0.0395 -0.08322,-0.0705 -0.122725,-0.0931 -0.0395,-0.0226 -0.08182,-0.0367 -0.126947,-0.0423 -0.09027,0 -0.152348,0.003 -0.186192,0.008 -0.823784,0.45139 -1.486763,1.07769 -1.988937,1.87891 0.0395,0.0395 0.07336,0.0621 0.10156,0.0677 0.02257,0.006 0.03667,0.031 0.04232,0.0762 0.0056,0.0452 0.01269,0.0762 0.02116,0.0931 0.0085,0.0169 0.04091,0.008 0.09733,-0.0254 0.05079,0.0451 0.05924,0.0987 0.02539,0.1608 0.0056,-0.006 0.129776,0.0705 0.372398,0.22853 0.107204,0.0959 0.166448,0.15516 0.177735,0.17773 0.01693,0.0621 -0.01129,0.11285 -0.08463,0.15235 -0.0056,-0.0113 -0.03103,-0.0367 -0.07617,-0.0762 -0.04514,-0.0395 -0.07053,-0.0508 -0.07617,-0.0338 -0.01693,0.0282 -0.01551,0.0804 0.0042,0.15657 0.01974,0.0761 0.04937,0.11144 0.08887,0.10579 -0.0395,0 -0.0663,0.0451 -0.08041,0.13542 -0.01412,0.0903 -0.02117,0.19043 -0.02117,0.30046 0,0.11003 -0.0028,0.17633 -0.0085,0.1989 l 0.01693,0.008 c -0.01693,0.0677 -0.0014,0.16504 0.04655,0.29199 0.04796,0.12694 0.10861,0.18197 0.18197,0.16504 -0.07336,0.0169 -0.01693,0.13823 0.169278,0.36392 0.03386,0.0451 0.05643,0.0705 0.0677,0.0762 0.01693,0.0113 0.05079,0.0324 0.10156,0.0635 0.05077,0.031 0.0931,0.0592 0.126947,0.0846 0.03384,0.0254 0.06206,0.055 0.08463,0.0889 0.02257,0.0282 0.05079,0.0917 0.08463,0.19042 0.03384,0.0987 0.07336,0.16505 0.11849,0.1989 -0.01129,0.0339 0.01551,0.0903 0.08041,0.16928 0.0649,0.079 0.09451,0.14388 0.08887,0.19466 -0.0056,0 -0.01269,0.003 -0.02116,0.008 -0.0085,0.006 -0.01551,0.008 -0.02117,0.008 0.01693,0.0395 0.06065,0.079 0.131183,0.11849 0.07053,0.0395 0.114253,0.0762 0.131182,0.11003 0.0056,0.0169 0.01129,0.0451 0.01693,0.0846 0.0056,0.0395 0.01412,0.0705 0.02539,0.0931 0.01127,0.0226 0.03386,0.0282 0.0677,0.0169 0.01129,-0.11284 -0.05643,-0.28776 -0.203121,-0.52474 -0.08463,-0.14106 -0.132605,-0.22287 -0.143876,-0.24544 -0.01693,-0.0282 -0.03244,-0.0719 -0.04655,-0.13118 -0.01411,-0.0593 -0.02681,-0.10015 -0.03808,-0.12273 0.01129,0 0.02821,0.004 0.05079,0.0127 0.02257,0.008 0.04655,0.0183 0.07194,0.0296 0.02539,0.0113 0.04655,0.0226 0.06348,0.0339 0.01693,0.0113 0.02257,0.0197 0.01693,0.0254 -0.01693,0.0395 -0.01129,0.0889 0.01693,0.14812 0.02822,0.0592 0.06206,0.11144 0.10156,0.15657 0.0395,0.0451 0.08746,0.0987 0.143876,0.1608 0.05642,0.0621 0.09027,0.0987 0.101561,0.11003 0.03386,0.0339 0.07336,0.0889 0.118489,0.16504 0.04513,0.0762 0.04513,0.11426 0,0.11426 0.05079,0 0.107204,0.0282 0.169277,0.0846 0.06207,0.0564 0.110033,0.11285 0.143877,0.16928 0.02821,0.0451 0.05079,0.11849 0.0677,0.22005 0.01691,0.10156 0.03103,0.16927 0.04232,0.20312 0.01129,0.0395 0.03526,0.0776 0.07194,0.11425 0.03667,0.0367 0.07194,0.0635 0.105797,0.0804 l 0.135419,0.0677 0.110032,0.0593 c 0.02822,0.0113 0.08041,0.0409 0.156569,0.0889 0.07616,0.048 0.136826,0.0804 0.181971,0.0973 0.05643,0.0226 0.10156,0.0339 0.135418,0.0339 0.03386,0 0.07475,-0.007 0.122726,-0.0212 0.04797,-0.0141 0.08605,-0.024 0.114254,-0.0296 0.08463,-0.0113 0.166448,0.031 0.245436,0.12695 0.07899,0.0959 0.138233,0.15516 0.177735,0.17773 0.20312,0.1072 0.358283,0.13823 0.465501,0.0931 -0.01129,0.006 -0.0099,0.0268 0.0042,0.0635 0.01411,0.0367 0.03667,0.0804 0.0677,0.13118 0.03103,0.0508 0.05643,0.0917 0.07617,0.12272 0.01974,0.031 0.03526,0.055 0.04655,0.0719 0.02822,0.0339 0.07899,0.0762 0.152348,0.12695 0.07336,0.0508 0.124133,0.0931 0.152348,0.12695 0.03386,-0.0226 0.0536,-0.048 0.05924,-0.0762 -0.01693,0.0451 0.0028,0.10156 0.05924,0.16928 0.05643,0.0677 0.107203,0.0959 0.152348,0.0846 0.07899,-0.0169 0.118489,-0.1072 0.118489,-0.27084 -0.17492,0.0846 -0.313153,0.0339 -0.414713,-0.15235 0,-0.006 -0.007,-0.0212 -0.02116,-0.0466 -0.01412,-0.0254 -0.02539,-0.0494 -0.03386,-0.0719 -0.0085,-0.0226 -0.01551,-0.0465 -0.02117,-0.0719 -0.0057,-0.0254 -0.0056,-0.0466 0,-0.0635 0.0056,-0.0169 0.01974,-0.0254 0.04232,-0.0254 0.05079,0 0.07899,-0.01 0.08463,-0.0296 0.0056,-0.0197 0,-0.055 -0.01693,-0.1058 -0.01693,-0.0508 -0.02822,-0.0875 -0.03386,-0.11003 -0.0056,-0.0451 -0.03667,-0.10156 -0.0931,-0.16928 -0.05643,-0.0677 -0.09027,-0.11003 -0.10156,-0.12695 -0.02822,0.0508 -0.07336,0.0734 -0.13542,0.0677 -0.06206,-0.006 -0.107203,-0.031 -0.135418,-0.0762 0,0.006 -0.0042,0.0212 -0.01269,0.0465 -0.0085,0.0254 -0.01269,0.0437 -0.01269,0.055 -0.07336,0 -0.115675,-0.003 -0.126946,-0.008 0.0056,-0.0169 0.01269,-0.0663 0.02116,-0.14811 0.0085,-0.0818 0.01834,-0.14529 0.02962,-0.19042 0.0056,-0.0226 0.02116,-0.0564 0.04655,-0.10157 0.02539,-0.0451 0.04655,-0.0861 0.06348,-0.12272 0.01693,-0.0367 0.02822,-0.0719 0.03386,-0.1058 0.0056,-0.0339 -0.007,-0.0607 -0.03808,-0.0804 -0.03103,-0.0198 -0.08041,-0.0268 -0.148112,-0.0212 -0.107204,0.006 -0.180549,0.0621 -0.220051,0.16928 -0.0056,0.0169 -0.01411,0.0465 -0.02539,0.0889 -0.01127,0.0423 -0.02539,0.0747 -0.04232,0.0973 -0.01693,0.0226 -0.04232,0.0423 -0.07617,0.0592 -0.0395,0.0169 -0.107203,0.0226 -0.203121,0.0169 -0.09592,-0.006 -0.163619,-0.0197 -0.20312,-0.0423 -0.07336,-0.0451 -0.136826,-0.12694 -0.190428,-0.24543 -0.0536,-0.11849 -0.08041,-0.22287 -0.08041,-0.31315 0,-0.0564 0.007,-0.13119 0.02117,-0.22429 0.01411,-0.0931 0.02257,-0.16362 0.02539,-0.21159 0.0028,-0.048 -0.01269,-0.11709 -0.04655,-0.20736 0.01693,-0.0113 0.04232,-0.0381 0.07617,-0.0804 0.03386,-0.0423 0.06206,-0.0719 0.08463,-0.0889 0.01129,-0.006 0.02398,-0.01 0.03808,-0.0127 0.0141,-0.003 0.02681,-0.003 0.03808,0 0.01127,0.003 0.02257,-0.001 0.03386,-0.0127 0.01129,-0.0113 0.01974,-0.0282 0.02539,-0.0508 -0.0056,-0.006 -0.01693,-0.0141 -0.03386,-0.0254 -0.01693,-0.0169 -0.02822,-0.0254 -0.03386,-0.0254 0.0395,0.0169 0.119897,0.0127 0.241216,-0.0127 0.121318,-0.0254 0.1989,-0.0212 0.232743,0.0127 0.08463,0.062 0.146705,0.0564 0.186192,-0.0169 0,-0.006 -0.0071,-0.0324 -0.02117,-0.0804 -0.01412,-0.048 -0.01551,-0.0861 -0.0042,-0.11426 0.02822,0.15235 0.110032,0.17774 0.245436,0.0762 0.01693,0.0169 0.06065,0.031 0.131183,0.0423 0.07053,0.0113 0.119896,0.0254 0.148112,0.0423 0.01693,0.0113 0.03667,0.0268 0.05924,0.0466 0.02257,0.0197 0.03808,0.0324 0.04655,0.0381 0.0085,0.006 0.02257,0.004 0.04232,-0.004 0.01974,-0.008 0.04374,-0.0268 0.07194,-0.055 0.05643,0.079 0.09027,0.14671 0.101561,0.20312 0.06206,0.2257 0.115675,0.34983 0.160805,0.3724 0.0395,0.0169 0.07053,0.0226 0.0931,0.0169 0.02257,-0.006 0.03527,-0.0324 0.03808,-0.0804 0.0028,-0.048 0.0028,-0.0875 0,-0.11849 -0.0028,-0.031 -0.0071,-0.0663 -0.01269,-0.1058 l -0.0085,-0.0677 v -0.15235 l -0.0085,-0.0677 c -0.08463,-0.0169 -0.136826,-0.0508 -0.156569,-0.10156 -0.01974,-0.0508 -0.01551,-0.10298 0.01269,-0.15657 0.0282,-0.0536 0.07053,-0.10579 0.126947,-0.15657 0.0056,-0.006 0.02822,-0.0155 0.0677,-0.0296 0.03949,-0.0141 0.08322,-0.0324 0.131183,-0.055 0.04796,-0.0226 0.08322,-0.0451 0.105796,-0.0677 0.118489,-0.1072 0.160805,-0.20595 0.126947,-0.29622 0.0395,0 0.07053,-0.0254 0.0931,-0.0762 -0.0056,0 -0.01974,-0.008 -0.04232,-0.0254 -0.02257,-0.0169 -0.04374,-0.031 -0.06348,-0.0423 -0.01974,-0.0113 -0.03244,-0.0169 -0.03808,-0.0169 0.05079,-0.0282 0.05643,-0.0734 0.01693,-0.13542 0.02822,-0.0169 0.04937,-0.048 0.06348,-0.0931 0.01412,-0.0452 0.03527,-0.0734 0.06348,-0.0846 0.05079,0.0677 0.110032,0.0734 0.177734,0.0169 0.0395,-0.0451 0.04232,-0.0903 0.0085,-0.13542 0.02822,-0.0395 0.08605,-0.0691 0.173499,-0.0889 0.08745,-0.0197 0.139655,-0.0466 0.156569,-0.0804 0.0395,0.0113 0.06206,0.006 0.0677,-0.0169 0.0056,-0.0226 0.0085,-0.0564 0.0085,-0.10156 0,-0.0451 0.0085,-0.079 0.02539,-0.10156 0.02257,-0.0282 0.06489,-0.0536 0.126948,-0.0762 0.06206,-0.0226 0.09875,-0.0367 0.110032,-0.0423 l 0.143876,-0.0931 c 0.01693,-0.0226 0.01693,-0.0339 0,-0.0339 0.101561,0.0113 0.18902,-0.0197 0.262366,-0.0931 0.05643,-0.0621 0.0395,-0.11849 -0.05079,-0.16928 0.01693,-0.0339 0.0085,-0.0607 -0.02539,-0.0804 -0.03384,-0.0198 -0.07617,-0.0353 -0.126947,-0.0465 0.01693,-0.006 0.04937,-0.007 0.09732,-0.004 0.04796,0.003 0.07758,-10e-4 0.08887,-0.0127 0.08463,-0.0564 0.06489,-0.10156 -0.05924,-0.13542 -0.09592,-0.0282 -0.217236,0.006 -0.363926,0.10156 z m -1.379545,7.42253 c 1.162324,-0.20312 2.152556,-0.73632 2.970698,-1.59961 -0.01693,-0.0169 -0.0522,-0.0296 -0.105797,-0.0381 -0.0536,-0.008 -0.08887,-0.0183 -0.105796,-0.0296 -0.101561,-0.0395 -0.169277,-0.0621 -0.203121,-0.0677 0.0056,-0.0395 -0.0014,-0.0762 -0.02116,-0.11003 -0.01976,-0.0339 -0.04232,-0.0593 -0.0677,-0.0762 -0.02539,-0.0169 -0.06065,-0.0395 -0.105797,-0.0677 -0.04514,-0.0282 -0.07617,-0.048 -0.0931,-0.0592 -0.01129,-0.0113 -0.03103,-0.0282 -0.05925,-0.0508 -0.02821,-0.0226 -0.04796,-0.0381 -0.05924,-0.0466 -0.01129,-0.008 -0.03244,-0.0212 -0.06348,-0.0381 -0.03104,-0.0169 -0.05501,-0.0226 -0.07194,-0.0169 -0.01693,0.006 -0.04513,0.008 -0.08463,0.008 l -0.02539,0.008 c -0.01693,0.006 -0.03244,0.0127 -0.04655,0.0212 -0.01411,0.008 -0.02962,0.0169 -0.04655,0.0254 -0.01693,0.008 -0.02822,0.0169 -0.03386,0.0254 -0.0056,0.008 -0.0056,0.0155 0,0.0212 -0.11849,-0.0959 -0.220051,-0.158 -0.304682,-0.1862 -0.02822,-0.006 -0.05925,-0.0212 -0.0931,-0.0466 -0.03386,-0.0254 -0.06348,-0.0451 -0.08887,-0.0592 -0.02539,-0.0141 -0.0536,-0.0183 -0.08463,-0.0127 -0.03103,0.006 -0.06348,0.0254 -0.09732,0.0592 -0.02822,0.0282 -0.04513,0.0705 -0.05079,0.12695 -0.0057,0.0564 -0.01129,0.0931 -0.01693,0.11003 -0.0395,-0.0282 -0.0395,-0.0776 0,-0.14811 0.0395,-0.0705 0.04513,-0.12273 0.01693,-0.15657 -0.01693,-0.0339 -0.04655,-0.0465 -0.08887,-0.0381 -0.04232,0.008 -0.07617,0.0212 -0.10156,0.0381 -0.02539,0.0169 -0.05784,0.0409 -0.09732,0.0719 -0.03949,0.031 -0.06489,0.0494 -0.07617,0.055 -0.01129,0.006 -0.03527,0.0212 -0.07194,0.0466 -0.03667,0.0254 -0.06065,0.0465 -0.07194,0.0635 -0.01693,0.0226 -0.03386,0.0564 -0.05079,0.10156 -0.01693,0.0451 -0.03103,0.0762 -0.04232,0.0931 -0.01129,-0.0226 -0.04374,-0.0409 -0.09732,-0.055 -0.05359,-0.0141 -0.08041,-0.0296 -0.08041,-0.0466 0.01129,0.0564 0.02257,0.15516 0.03386,0.29622 0.01129,0.14107 0.02539,0.24827 0.04232,0.32161 0.0395,0.17492 0.0056,0.31034 -0.101561,0.40626 -0.152348,0.14106 -0.234165,0.25391 -0.245436,0.33854 -0.02257,0.12413 0.01129,0.19748 0.10156,0.22005 0,0.0395 -0.02257,0.0973 -0.0677,0.1735 -0.04513,0.0762 -0.06489,0.13682 -0.05924,0.18197 0,0.0339 0.0056,0.079 0.01693,0.13542 z" style="fill:#ffffff;fill-opacity:1"/> </g> </svg>',
    COPYRIGHT: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(0,-51)"> <path xmlns="http://www.w3.org/2000/svg" d="M 8.4514218,59.051672 8.2832344,58.94686 c -0.3942657,0.435296 -0.9624063,0.709312 -1.5959532,0.709312 -1.1907186,0 -2.1561718,-0.964844 -2.1561718,-2.155969 0,-1.190922 0.9654532,-2.156375 2.1561718,-2.156375 0.6335469,0 1.2016875,0.274422 1.5959532,0.709313 L 8.4514218,55.948328 9.6106563,55.229469 C 8.9322186,54.358063 7.8769844,53.795203 6.687078,53.795203 c -2.0454686,0 -3.7043904,1.658922 -3.7043904,3.704797 0,2.046078 1.6589218,3.704391 3.7043904,3.704391 1.1897032,0 2.245547,-0.562657 2.9235783,-1.434266 z M 6.4880156,51 c 1.8183751,0 3.3663905,0.634766 4.6430314,1.903688 0.611,0.611203 1.075547,1.309546 1.392422,2.095031 C 12.840953,55.784203 13,56.617828 13,57.5 c 0,0.889891 -0.157016,1.723719 -0.470031,2.501078 -0.313422,0.777563 -0.775938,1.464734 -1.386938,2.060703 C 10.508672,62.688219 9.789,63.168203 8.9840156,63.501125 8.1794375,63.833437 7.3474375,64 6.488422,64 5.6294061,64 4.8073592,63.835672 4.0218751,63.506406 3.2365936,63.177953 2.5323594,62.701828 1.909375,62.079047 1.2863906,61.456266 0.8125,60.754063 0.4875,59.972437 0.1625,59.190812 0,58.366938 0,57.5 0,56.640984 0.16432812,55.815078 0.49318751,55.021875 0.82204688,54.228875 1.3,53.51875 1.9266406,52.891906 3.1646876,51.630906 4.6850781,51 6.4880156,51 Z m 0.02336,1.172438 c -1.4854533,0 -2.7352812,0.518578 -3.7490783,1.555125 -0.5108593,0.518578 -0.9034999,1.100937 -1.1781249,1.746874 -0.2750313,0.646344 -0.4121406,1.321532 -0.4121406,2.025766 0,0.696516 0.1371093,1.367641 0.4121406,2.013578 0.2748281,0.64675 0.6672656,1.223016 1.1781249,1.729813 0.5106564,0.507 1.0869221,0.89375 1.7296096,1.160859 0.6420781,0.266906 1.3154374,0.400766 2.0194687,0.400766 0.6963124,0 1.3710936,-0.135282 2.0257656,-0.40625 0.6542656,-0.270969 1.2433282,-0.661781 1.7702338,-1.172235 1.013188,-0.990234 1.519782,-2.232343 1.519782,-3.726125 0,-0.719671 -0.131219,-1.40075 -0.394266,-2.043031 C 11.17025,54.8155 10.786547,54.243094 10.284422,53.73975 9.2389379,52.694875 7.9817975,52.172438 6.5113756,52.172438 Z" style="fill:#ffffff;fill-opacity:1"/> </g> </svg>',
    EDIT: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(97.895793,-210.36625)"> <path d="m -77.754542,227.095 -1.321454,-1.32145 -3.41255,3.41255 1.321454,1.32145 3.497376,0.0236 z m -5.823109,0.84222 c 0.06777,0.0678 0.150061,0.10165 0.246858,0.10165 0.212982,0 0.319461,-0.10648 0.319461,-0.31946 0,-0.0968 -0.03388,-0.17908 -0.101651,-0.24686 l -7.870622,-7.87062 c -0.06777,-0.0678 -0.150061,-0.10165 -0.246857,-0.10165 -0.212983,0 -0.319462,0.10648 -0.319462,0.31946 0,0.0968 0.03388,0.17909 0.101651,0.24686 z m -10.440924,-7.65278 6.040919,-6.04092 12.081863,12.08186 v 6.04092 h -6.040919 z m 1.394056,-9.91817 c 0.51308,0 0.948727,0.17909 1.306942,0.5373 l 2.410559,2.41056 -6.040919,6.04092 -2.396048,-2.41056 c -0.367872,-0.34851 -0.551808,-0.78415 -0.551808,-1.30694 0,-0.51308 0.183936,-0.95358 0.551808,-1.32145 l 3.398014,-3.41255 c 0.377554,-0.35819 0.81803,-0.5373 1.321452,-0.5373 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    EDIT_POINT: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-36.185718,-207.86684)"> <path d="m 36.185718,218.35523 c 0,1.16649 0.997189,2.11212 2.227265,2.11212 1.230075,0 2.227285,-0.94561 2.227285,-2.11212 0,-1.16654 -0.997188,-2.11217 -2.227285,-2.11217 -1.230098,0 -2.227265,0.94563 -2.227265,2.11217 z m 15.202036,-8.37625 c 0,-1.1665 -0.99721,-2.11214 -2.227329,-2.11214 -1.23012,0 -2.22733,0.94564 -2.22733,2.11214 0,1.16652 0.99721,2.11215 2.22733,2.11215 1.230119,0 2.227329,-0.94563 2.227329,-2.11215 z m -0.285152,17.77569 c 0,-1.16652 -0.99721,-2.11217 -2.227329,-2.11217 -1.230119,0 -2.22733,0.94565 -2.22733,2.11217 0,1.16651 0.997211,2.11217 2.22733,2.11217 1.230119,0 2.227329,-0.94566 2.227329,-2.11217 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    EDIT_LINE: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(29.3449,-267.58148)"> <path d="m -18.882576,287.46936 c 0,-0.3393 0.08446,-0.65981 0.23439,-0.9439 l -7.581761,-6.51797 c -0.27197,0.1122 -0.572129,0.17458 -0.887672,0.17458 -1.230073,0 -2.227281,-0.94562 -2.227281,-2.11218 0,-1.16652 0.997186,-2.11214 2.227281,-2.11214 0.465923,0 0.898329,0.13575 1.255877,0.36767 l 7.495517,-5.6939 c -0.147953,-0.2826 -0.231232,-0.60096 -0.231232,-0.93788 0,-1.16652 0.997207,-2.11216 2.227302,-2.11216 1.230094,0 2.227324,0.94564 2.227324,2.11216 0,1.16654 -0.997187,2.11216 -2.227324,2.11216 -0.493555,0 -0.949509,-0.15232 -1.318682,-0.40998 l -7.467369,5.67254 c 0.169589,0.29803 0.265889,0.63912 0.265889,1.00151 0,0.50118 -0.184156,0.96147 -0.491685,1.32364 l 7.411291,6.37137 c 0.368614,-0.25626 0.823321,-0.40772 1.315437,-0.40772 1.230116,0 2.227302,0.94567 2.227302,2.11218 0,1.16652 -0.997186,2.11214 -2.227302,2.11214 -1.230116,0 -2.227302,-0.94562 -2.227302,-2.11212 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    EDIT_POLYGON: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(14.225853,-276.65264)"> <path d="m -0.66455648,280.80275 v 13.79348 c 0.79691649,0.32171 1.35568274,1.07108 1.35568274,1.94427 0,1.16652 -0.99718852,2.11214 -2.22730646,2.11214 -1.2301188,0 -2.2273073,-0.94562 -2.2273073,-2.11212 0,-0.33931 0.084462,-0.65981 0.2343912,-0.9439 l -7.5817977,-6.51796 c -0.27197,0.1122 -0.57213,0.17457 -0.887674,0.17457 -1.230075,0 -2.227285,-0.94564 -2.227285,-2.11218 0,-1.16654 0.997188,-2.11214 2.227285,-2.11214 0.465925,0 0.898331,0.13577 1.25588,0.36766 l 7.495532,-5.6939 c -0.1479536,-0.28261 -0.231233,-0.60097 -0.231233,-0.93789 0,-1.16652 0.9972096,-2.11214 2.2273064,-2.11214 1.2300969,0 2.22732846,0.94564 2.22732846,2.11214 2.111e-5,0.97405 -0.69526638,1.79389 -1.64080234,2.03802 z m -9.37259452,5.33677 c 0.1695894,0.29803 0.2658898,0.63912 0.2658898,1.00151 0,0.50118 -0.1841568,0.96147 -0.4916868,1.32364 l 7.4113069,6.37138 c 0.3162527,-0.21986 0.6958892,-0.36246 1.1081206,-0.39856 V 280.8251 c -0.3035983,-0.065 -0.5836684,-0.18884 -0.8262461,-0.35813 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    DELETE: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-96.648512,-92.172911)"> <path d="m 107.64852,92.172911 c -6.06589,0 -11.000008,4.935301 -11.000008,11.000009 0,6.06465 4.934118,11 11.000008,11 6.06589,0 10.99999,-4.93535 10.99999,-11 0,-6.064708 -4.9341,-11.000009 -10.99999,-11.000009 z m 0,19.555549 c -4.71656,0 -8.555561,-3.83777 -8.555561,-8.55554 0,-4.717823 3.839001,-8.555595 8.555561,-8.555595 4.71656,0 8.55558,3.837772 8.55558,8.555595 0,4.71777 -3.83902,8.55554 -8.55558,8.55554 z m 0.86411,-8.55554 3.234,-3.234018 c 0.23711,-0.236976 0.23711,-0.625793 0,-0.864109 -0.23832,-0.236977 -0.627,-0.236977 -0.86411,0 l -3.234,3.234017 -3.23401,-3.235264 c -0.23831,-0.236977 -0.627,-0.236977 -0.86411,0 -0.23831,0.238362 -0.23831,0.62704 0,0.864109 l 3.23401,3.235265 -3.23401,3.23396 c -0.23831,0.23836 -0.23831,0.62704 0,0.86411 0.11858,0.11964 0.275,0.1797 0.43146,0.1797 0.15646,0 0.31287,-0.0601 0.43265,-0.17831 l 3.23401,-3.23522 3.234,3.23397 c 0.11978,0.11964 0.27624,0.1797 0.43265,0.1797 0.15646,0 0.31287,-0.0601 0.43266,-0.17831 0.23711,-0.23698 0.23711,-0.6258 0,-0.86411 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    ATTRIBUTES: '<svg width="22" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(10.946114,-218.38962)"> <path d="m -4.1769019,220.505 v 2.53847 c 0,0.12337 -0.039674,0.22474 -0.1189997,0.30407 -0.079326,0.0793 -0.180695,0.11902 -0.3040857,0.11902 h -4.2307878 c -0.1234129,0 -0.22476,-0.0397 -0.3040858,-0.11902 -0.079326,-0.0794 -0.1189997,-0.1807 -0.1189997,-0.30407 V 220.505 c 0,-0.12341 0.039674,-0.22473 0.1189997,-0.30408 0.079326,-0.0794 0.1806729,-0.119 0.3040858,-0.119 h 4.2307878 c 0.1233907,0 0.2247379,0.0397 0.3040857,0.119 0.079348,0.0793 0.1189997,0.18065 0.1189997,0.30408 z m 0,5.0769 v 2.53846 c 0,0.1234 -0.039674,0.22477 -0.1189997,0.30409 -0.079326,0.0793 -0.180695,0.11898 -0.3040857,0.11898 h -4.2307878 c -0.1234129,0 -0.22476,-0.0396 -0.3040858,-0.11898 -0.079326,-0.0793 -0.1189997,-0.18069 -0.1189997,-0.30409 v -2.53846 c 0,-0.12337 0.039674,-0.22474 0.1189997,-0.30407 0.079326,-0.0793 0.1806729,-0.119 0.3040858,-0.119 h 4.2307878 c 0.1233907,0 0.2247379,0.0396 0.3040857,0.119 0.079304,0.0793 0.1189997,0.18068 0.1189997,0.30404 z m 6.7692346,-5.0769 v 2.53847 c 0,0.12337 -0.039652,0.22474 -0.1189998,0.30407 -0.079348,0.0793 -0.1806506,0.11902 -0.3040855,0.11902 h -4.2307445 c -0.1233682,0 -0.2247378,-0.0397 -0.3040855,-0.11902 -0.079348,-0.0794 -0.1189998,-0.1807 -0.1189998,-0.30407 V 220.505 c 0,-0.12341 0.039674,-0.22473 0.1189998,-0.30408 0.079326,-0.0794 0.1806948,-0.119 0.3040855,-0.119 h 4.2307662 c 0.1234132,0 0.2247378,0.0397 0.3040855,0.119 0.079349,0.0793 0.1189781,0.18065 0.1189781,0.30408 z m -6.7692346,10.15383 v 2.53845 c 0,0.12339 -0.039674,0.22476 -0.1189997,0.30409 -0.079326,0.0793 -0.180695,0.11899 -0.3040857,0.11899 h -4.2307878 c -0.1234129,0 -0.22476,-0.0397 -0.3040858,-0.11899 -0.079326,-0.0793 -0.1189997,-0.1807 -0.1189997,-0.30409 v -2.53845 c 0,-0.12339 0.039674,-0.22476 0.1189997,-0.3041 0.079326,-0.0793 0.1806729,-0.11898 0.3040858,-0.11898 h 4.2307878 c 0.1233907,0 0.2247379,0.0396 0.3040857,0.11898 0.079304,0.0793 0.1189997,0.18069 0.1189997,0.3041 z m 6.7692346,-5.07693 v 2.53846 c 0,0.1234 -0.039652,0.22477 -0.1189998,0.30409 -0.079348,0.0793 -0.1806506,0.11898 -0.3040855,0.11898 h -4.2307445 c -0.1233682,0 -0.2247378,-0.0396 -0.3040855,-0.11898 -0.079348,-0.0793 -0.1189998,-0.18069 -0.1189998,-0.30409 v -2.53846 c 0,-0.12337 0.039674,-0.22474 0.1189998,-0.30407 0.079326,-0.0793 0.1806948,-0.119 0.3040855,-0.119 h 4.2307662 c 0.1234132,0 0.2247378,0.0396 0.3040855,0.119 0.079326,0.0793 0.1189781,0.18068 0.1189781,0.30404 z m 6.7692562,-5.0769 v 2.53847 c 0,0.12337 -0.039674,0.22474 -0.1189999,0.30407 -0.079326,0.0793 -0.1806948,0.11902 -0.304108,0.11902 H 4.7077377 c -0.123369,0 -0.2247378,-0.0397 -0.3040863,-0.11902 -0.079348,-0.0794 -0.1189773,-0.1807 -0.1189773,-0.30407 V 220.505 c 0,-0.12341 0.03963,-0.22473 0.1189773,-0.30408 0.079349,-0.0794 0.1807173,-0.119 0.3040863,-0.119 H 8.938481 c 0.1234349,0 0.2247603,0.0397 0.304108,0.119 0.079303,0.0793 0.1189999,0.18065 0.1189999,0.30408 z m -6.7692562,10.15383 v 2.53845 c 0,0.12339 -0.039652,0.22476 -0.1189998,0.30409 -0.079348,0.0793 -0.1806506,0.11899 -0.3040855,0.11899 h -4.2307445 c -0.1233682,0 -0.2247378,-0.0397 -0.3040855,-0.11899 -0.079348,-0.0793 -0.1189998,-0.1807 -0.1189998,-0.30409 v -2.53845 c 0,-0.12339 0.039674,-0.22476 0.1189998,-0.3041 0.079326,-0.0793 0.1806948,-0.11898 0.3040855,-0.11898 h 4.2307662 c 0.1234132,0 0.2247378,0.0396 0.3040855,0.11898 0.079349,0.0793 0.1189781,0.18069 0.1189781,0.3041 z m 6.7692562,-5.07693 v 2.53846 c 0,0.1234 -0.039674,0.22477 -0.1189999,0.30409 -0.079326,0.0793 -0.1806948,0.11898 -0.304108,0.11898 H 4.7077377 c -0.123369,0 -0.2247378,-0.0396 -0.3040863,-0.11898 -0.079348,-0.0793 -0.1189773,-0.18069 -0.1189773,-0.30409 v -2.53846 c 0,-0.12337 0.03963,-0.22474 0.1189773,-0.30407 0.079349,-0.0793 0.1807173,-0.119 0.3040863,-0.119 H 8.938481 c 0.1234349,0 0.2247603,0.0396 0.304108,0.119 0.079303,0.0793 0.1189999,0.18068 0.1189999,0.30404 z m 0,5.07693 v 2.53845 c 0,0.12339 -0.039674,0.22476 -0.1189999,0.30409 -0.079326,0.0793 -0.1806948,0.11899 -0.304108,0.11899 H 4.7077377 c -0.123369,0 -0.2247378,-0.0397 -0.3040863,-0.11899 -0.079348,-0.0793 -0.1189773,-0.1807 -0.1189773,-0.30409 v -2.53845 c 0,-0.12339 0.03963,-0.22476 0.1189773,-0.3041 0.079349,-0.0793 0.1807173,-0.11898 0.3040863,-0.11898 H 8.938481 c 0.1234349,0 0.2247603,0.0396 0.304108,0.11898 0.079303,0.0793 0.1189999,0.18069 0.1189999,0.3041 z m 1.6922971,4.23077 V 220.505 c 0,-0.58173 -0.207108,-1.07973 -0.62141,-1.49399 -0.41426,-0.41426 -0.9122577,-0.62139 -1.4939725,-0.62139 H -8.830731 c -0.581737,0 -1.079735,0.20713 -1.493994,0.62139 -0.414259,0.41426 -0.621389,0.91228 -0.621389,1.49399 v 14.3846 c 0,0.58171 0.20713,1.07973 0.621389,1.49397 0.414259,0.41424 0.912257,0.62139 1.493994,0.62139 H 8.938481 c 0.5817373,0 1.079757,-0.20713 1.493995,-0.62139 0.414281,-0.41426 0.62141,-0.91226 0.62141,-1.49397 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    DELETE_SEARCH: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(-73.57168,-152.98468)"> <path d="m 86.426439,154.54374 c 0.193654,0.19363 0.193654,0.51107 0,0.70474 l -3.883207,3.87948 c -0.193654,0.19293 -0.193654,0.51109 0,0.70538 l 3.881352,3.88073 c 0.193655,0.19364 0.193655,0.51107 0,0.70536 l -1.413819,1.40887 c -0.194286,0.19293 -0.512316,0.19293 -0.706599,0 l -3.880113,-3.88013 c -0.193654,-0.19363 -0.512316,-0.19363 -0.705982,0 l -3.883206,3.87765 c -0.193655,0.19364 -0.512316,0.19364 -0.705982,0 L 73.71692,164.4151 c -0.193654,-0.19363 -0.193654,-0.51109 0,-0.70538 l 3.884444,-3.87886 c 0.193654,-0.19293 0.193654,-0.51109 0,-0.70535 l -3.88135,-3.88137 c -0.194286,-0.19364 -0.194286,-0.5117 0,-0.70536 l 1.4132,-1.40948 c 0.194894,-0.19293 0.512315,-0.19293 0.706601,6.1e-4 l 3.879493,3.8795 c 0.194286,0.19433 0.512316,0.19433 0.705982,6e-4 l 3.883207,-3.87762 c 0.193046,-0.19317 0.511078,-0.19317 0.705979,0 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    CHECKBOX_UNSELECTED: {
        a: '<svg width="20" height="20" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(66.145833,-272.84226)"> <path d="m -48.645833,272.84226 h -15 c -1.375511,0 -2.5,1.12449 -2.5,2.5 v 15 c 0,1.37551 1.124489,2.5 2.5,2.5 h 15 c 1.375511,0 2.5,-1.12449 2.5,-2.5 v -15 c 0,-1.37551 -1.124489,-2.5 -2.5,-2.5 z" style="fill:',
        b: ';fill-opacity:1" /> </g> </svg>',
        c: ';fill-opacity:1;stroke:',
        d: ';stroke-width:2px"/></g></svg>'
    },
    CHECKBOX_SELECTED: {
        a: '<svg width="20" height="20" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(66.145833,-272.84226)"> <path d="m -48.645833,272.84226 h -15 c -1.375511,0 -2.5,1.12449 -2.5,2.5 v 15 c 0,1.37551 1.124489,2.5 2.5,2.5 h 15 c 1.375511,0 2.5,-1.12449 2.5,-2.5 v -15 c 0,-1.37551 -1.124489,-2.5 -2.5,-2.5 z m -8.982215,18.49212 -6.73382,-6.38395 1.417492,-1.70905 4.906123,4.7312 9.37376,-12.28921 1.825657,1.4758 z" style="fill:',
        b: ';fill-opacity:1" /> </g> </svg>',
        c: ';fill-opacity:1;stroke:',
        d: ';stroke-width:2px"/></g></svg>'
    },
    TIMESLIDER: '<svg width="13" height="13" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(114.60934,-1059.6692)"> <path d="m -108.11021,1059.6735 h -0.002 a 6.4998814,6.4998814 0 0 0 -4.78039,2.1076 l 0.0209,-1.0187 c 0,-0.1234 -0.0369,-0.2271 -0.12141,-0.3111 -0.0418,-0.043 -0.0904,-0.072 -0.14227,-0.093 v -0.01 c -0.0524,-0.019 -0.11056,-0.029 -0.17263,-0.028 l -0.36422,0.011 c -0.12315,0 -0.22826,0.05 -0.31489,0.1385 -0.0884,0.089 -0.13586,0.1947 -0.13848,0.3187 l -0.0626,2.8891 v 0.2048 0.091 c 6.8e-4,0.1237 0.0418,0.2268 0.1252,0.3092 0.0845,0.084 0.18848,0.1248 0.3092,0.1214 l 1.37911,-0.036 1.80972,-0.047 c 0.12412,-0.014 0.23006,-0.055 0.31679,-0.1422 0.0884,-0.089 0.13357,-0.1947 0.13659,-0.3149 v -0.1859 -0.184 c 0.01,-0.1207 -0.033,-0.2234 -0.11951,-0.3093 -0.0864,-0.085 -0.19228,-0.1258 -0.31301,-0.1195 l -1.02626,0.03 a 4.632251,4.6322348 0 0 1 3.46009,-1.5593 4.632251,4.6322348 0 0 1 4.63242,4.6324 4.632251,4.6322348 0 0 1 -4.63242,4.6324 4.632251,4.6322348 0 0 1 -4.63243,-4.6305 h -1.86663 a 6.4998814,6.4998814 0 0 0 6.49906,6.499 6.4998814,6.4998814 0 0 0 6.50094,-6.499 6.4998814,6.4998814 0 0 0 -6.50094,-6.501 z m -0.26368,2.2897 c -0.20383,0 -0.36797,0.1641 -0.36802,0.368 l 0.002,3.5644 c 2e-5,0.5434 0.002,0.5513 0.36042,0.9106 l 2.53057,2.5287 c 0.14414,0.1441 0.37569,0.1441 0.51977,0 l 0.39078,-0.3889 c 0.14415,-0.1442 0.14413,-0.3776 0,-0.5217 l -2.51539,-2.5135 v -3.5796 c -2e-4,-0.1019 -0.0416,-0.1933 -0.10813,-0.2599 -0.0663,-0.065 -0.15649,-0.1082 -0.25799,-0.1081 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    REVERSE_GEOCODING: '<svg width="15" height="15" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(34.255708,-313.67945)"> <path d="m -31.577795,318.53906 c 0.0025,-4e-4 0.0051,-5.8e-4 0.0077,-5.8e-4 z m 6.212276,-0.14991 c -0.0018,4e-4 -0.0036,7.9e-4 -0.0053,0.001 0.0017,2e-5 0.0035,-4.5e-4 0.0053,-0.001 z m -1.679411,-3.05059 c -5.66e-4,-2.3e-4 -9.91e-4,-4.5e-4 -0.0015,-6.4e-4 z m -1.835717,9.94263 c -0.258525,-0.60789 -0.389629,-1.25319 -0.389629,-1.91796 0,-0.30475 0.02763,-0.60538 0.08238,-0.90023 l -0.07168,-0.0358 c -0.03487,-0.0174 -0.0712,-0.0451 -0.108989,-0.0828 -0.03779,-0.0378 -0.0625,-0.077 -0.07412,-0.11772 -0.01162,-0.0349 -0.02616,-0.10463 -0.04359,-0.20925 -0.01743,-0.10462 -0.0407,-0.1802 -0.06974,-0.22669 -0.03487,-0.0581 -0.0843,-0.11625 -0.148219,-0.17438 -0.06392,-0.0581 -0.122075,-0.0872 -0.174376,-0.0872 0.04651,0 0.04651,-0.0392 0,-0.11772 -0.04651,-0.0785 -0.08719,-0.13514 -0.122076,-0.17002 -0.01162,-0.0116 -0.04651,-0.0494 -0.104632,-0.11334 -0.05813,-0.0639 -0.107537,-0.11916 -0.148219,-0.16567 -0.0407,-0.0465 -0.07557,-0.10027 -0.104632,-0.1613 -0.02906,-0.061 -0.03487,-0.11189 -0.01744,-0.15258 0.0058,-0.006 0,-0.0145 -0.01744,-0.0262 -0.01744,-0.0116 -0.03923,-0.0233 -0.06539,-0.0349 -0.02616,-0.0116 -0.05086,-0.0218 -0.07412,-0.0305 -0.02325,-0.009 -0.0407,-0.0131 -0.05232,-0.0131 0.01162,0.0233 0.02471,0.0654 0.03923,0.12642 0.01452,0.061 0.03051,0.10608 0.04796,0.13515 0.01162,0.0232 0.06103,0.10753 0.148219,0.25285 0.151138,0.24413 0.220883,0.42432 0.209264,0.54059 -0.03487,0.0116 -0.05813,0.006 -0.06974,-0.0174 -0.01162,-0.0233 -0.02033,-0.0552 -0.02616,-0.0959 -0.0058,-0.0407 -0.01162,-0.0697 -0.01744,-0.0872 -0.01744,-0.0349 -0.0625,-0.0727 -0.135147,-0.11335 -0.07265,-0.0407 -0.117703,-0.0814 -0.135147,-0.12208 0.0058,0 0.01309,-0.003 0.0218,-0.009 0.0087,-0.006 0.01598,-0.009 0.02179,-0.009 0.0058,-0.0523 -0.02471,-0.11916 -0.09155,-0.20054 -0.06684,-0.0814 -0.09445,-0.1395 -0.08283,-0.17438 -0.04651,-0.0349 -0.08719,-0.10317 -0.122076,-0.2049 -0.03489,-0.10173 -0.06394,-0.16712 -0.08719,-0.19618 -0.02325,-0.0349 -0.05232,-0.0654 -0.08719,-0.0915 -0.03487,-0.0262 -0.07847,-0.0552 -0.13079,-0.0872 -0.05232,-0.032 -0.08719,-0.0538 -0.104632,-0.0654 -0.01162,-0.006 -0.03487,-0.032 -0.06975,-0.0785 -0.19182,-0.23251 -0.249946,-0.35748 -0.174376,-0.37491 -0.07557,0.0174 -0.138052,-0.0392 -0.187464,-0.17002 -0.04941,-0.13077 -0.06539,-0.23105 -0.04796,-0.30081 l -0.01744,-0.009 c 0.0058,-0.0233 0.0087,-0.0915 0.0087,-0.20491 0,-0.11336 0.0073,-0.21652 0.02179,-0.30953 0.01361,-0.087 0.03866,-0.13334 0.07516,-0.13893 -0.03688,4e-4 -0.06485,-0.0361 -0.08388,-0.10957 -0.02033,-0.0785 -0.02179,-0.13224 -0.0044,-0.1613 0.0058,-0.0174 0.03197,-0.006 0.07847,0.0349 0.04651,0.0407 0.07266,0.0668 0.07847,0.0785 0.07557,-0.0407 0.104632,-0.093 0.08719,-0.15695 -0.01162,-0.0233 -0.07266,-0.0843 -0.183106,-0.1831 -0.249946,-0.16276 -0.377831,-0.24123 -0.38364,-0.23542 0.03487,-0.0639 0.02616,-0.11916 -0.02616,-0.16567 -0.05813,0.0349 -0.09155,0.0436 -0.100275,0.0262 -0.0087,-0.0174 -0.01598,-0.0494 -0.02179,-0.0959 -0.0058,-0.0465 -0.02033,-0.0727 -0.04359,-0.0785 -0.02906,-0.006 -0.06393,-0.0291 -0.104632,-0.0697 0.517336,-0.82541 1.200333,-1.47062 2.048993,-1.93564 0.03487,-0.006 0.09881,-0.009 0.191821,-0.009 0.04651,0.006 0.09009,0.0204 0.13079,0.0436 0.0407,0.0232 0.08283,0.0552 0.126417,0.0959 0.04359,0.0407 0.07701,0.0697 0.100275,0.0872 0.01162,-0.0349 -0.0029,-0.0872 -0.04359,-0.15695 0.01162,-0.0349 0.07557,-0.0697 0.19182,-0.10463 0.133695,-0.0174 0.220868,-0.0145 0.261565,0.009 -0.03487,-0.0523 -0.093,-0.12498 -0.174377,-0.21798 l -0.04359,0.0436 c -0.04651,-0.0407 -0.168568,-0.0204 -0.366197,0.061 -0.01162,0.006 -0.0407,0.0218 -0.08719,0.048 -0.04649,0.0262 -0.0843,0.0451 -0.113346,0.0567 -0.03487,0.0116 -0.06975,0.0145 -0.104632,0.009 0.279009,-0.15114 0.552208,-0.2703 0.819597,-0.35749 0.01744,0.0116 0.04651,0.0363 0.08719,0.0741 0.04068,0.0378 0.07267,0.0654 0.09592,0.0828 -0.01744,-0.0116 -0.02906,-0.006 -0.03487,0.0174 -0.02325,0.0697 -0.02325,0.12788 0,0.17437 0.02906,0.0407 0.06829,0.0639 0.117703,0.0697 0.04941,0.006 0.108989,0.003 0.178749,-0.009 0.06976,-0.0116 0.116251,-0.0174 0.139504,-0.0174 l 0.08719,0.009 c 0.177027,0.0166 0.251324,0.002 0.222994,-0.045 0.01629,0.0253 0.03495,0.0707 0.05602,0.13656 0.02325,0.0727 0.04941,0.12353 0.07847,0.15259 0.02906,-0.0233 0.03487,-0.064 0.01744,-0.12208 -0.01743,-0.0581 -0.01744,-0.0988 0,-0.12207 0.0058,-0.0116 0.02325,-0.0233 0.05232,-0.0349 0.02906,-0.0116 0.0625,-0.0247 0.100275,-0.0393 0.03778,-0.0145 0.0625,-0.0247 0.07412,-0.0305 0.03487,-0.0233 0.01162,-0.0639 -0.06976,-0.12208 -0.01162,-0.006 -0.03632,-0.0145 -0.07412,-0.0262 -0.03779,-0.0116 -0.07121,-0.0233 -0.100275,-0.0349 -0.02906,-0.0116 -0.05958,-0.0276 -0.09154,-0.048 -0.03197,-0.0204 -0.04651,-0.0436 -0.04359,-0.0697 0.0029,-0.0262 0.0189,-0.0596 0.04796,-0.10028 0.03487,-0.0291 0.09154,-0.0407 0.170019,-0.0349 0.07847,0.006 0.138052,0.0203 0.178749,0.0436 0.156948,0.0872 0.180201,0.16566 0.06974,0.23542 0.05813,0.006 0.127885,0.0291 0.209249,0.0697 0.08136,0.0407 0.113346,0.0843 0.09592,0.13079 0.04651,-0.0872 0.093,-0.13079 0.139504,-0.13079 0.02906,0.006 0.05667,0.0451 0.08283,0.1177 0.02616,0.0727 0.04213,0.1119 0.04794,0.11771 0.04651,0.0639 0.09301,0.0785 0.139505,0.0436 0.04649,-0.0349 0.09445,-0.0857 0.143861,-0.15257 0.04603,-0.0623 0.0731,-0.093 0.0813,-0.0922 -0.05663,-0.023 -0.06197,-0.0461 -0.01592,-0.0691 0.08719,-0.0523 0.165662,-0.0668 0.235422,-0.0436 0.01744,0.0116 0.0407,0.0378 0.06974,0.0785 0.05232,0.10464 0.0436,0.15403 -0.02616,0.14822 0.05232,0.0465 0.07412,0.10463 0.06539,0.17438 -0.0087,0.0697 -0.05377,0.10173 -0.135147,0.0959 -0.02906,0 -0.07121,-0.0145 -0.126418,-0.0436 -0.05521,-0.0291 -0.09737,-0.0451 -0.126418,-0.0479 -0.02905,-0.003 -0.06974,0.0131 -0.122075,0.0479 -0.02325,0.0291 -0.05377,0.0785 -0.09155,0.14821 -0.03778,0.0697 -0.07121,0.11916 -0.100275,0.14822 -0.08719,0.0872 -0.232517,0.11916 -0.435956,0.0959 0.01744,0 0.01598,0.0174 -0.0044,0.0523 -0.02033,0.0349 -0.04796,0.0741 -0.08283,0.1177 -0.03487,0.0436 -0.05522,0.0683 -0.06103,0.0741 -0.05232,0.0581 -0.08719,0.12497 -0.104632,0.20054 0,0.0116 -0.0029,0.0509 -0.0087,0.1177 -0.0058,0.0668 -0.01744,0.1177 -0.03487,0.15258 0.06976,-0.0174 0.124965,0.0174 0.165662,0.10463 0.03487,0.0814 0.03487,0.12496 0,0.13079 0.19182,-0.0291 0.360387,-0.0174 0.505701,0.0349 0.209264,0.0756 0.32842,0.15112 0.357483,0.22671 0.03487,-0.0523 0.119156,-0.0552 0.252851,-0.009 0.05232,0.0291 0.09881,0.11625 0.139504,0.26157 0.02325,0.0872 0.06248,0.16276 0.117703,0.22671 0.05522,0.0639 0.114799,0.0814 0.178749,0.0523 l 0.02616,-0.0174 c 0.02327,-0.0116 0.04215,-0.0218 0.05667,-0.0305 0.01452,-0.009 0.03052,-0.0203 0.04796,-0.0349 0.01744,-0.0145 0.02763,-0.0276 0.03052,-0.0392 0.0029,-0.0116 -0.0015,-0.0233 -0.01307,-0.0349 -0.0407,-0.0349 -0.07121,-0.0828 -0.09155,-0.14386 -0.02033,-0.061 -0.01598,-0.1148 0.01307,-0.16131 0.01744,-0.0232 0.06394,-0.0581 0.139504,-0.10463 0.07557,-0.0465 0.122076,-0.093 0.139504,-0.1395 0.02327,-0.0756 -0.0058,-0.13806 -0.08719,-0.18747 -0.08136,-0.0494 -0.122076,-0.0945 -0.122076,-0.13514 0,-0.0291 0.0189,-0.0639 0.05667,-0.10464 0.03778,-0.0407 0.05377,-0.0785 0.04794,-0.11334 0,-0.0174 -0.01017,-0.0538 -0.03052,-0.10899 -0.02035,-0.0552 -0.03197,-0.0959 -0.03487,-0.12208 -0.0029,-0.0262 0.01017,-0.0567 0.03924,-0.0915 0.0407,-0.0233 0.1366,-0.0218 0.287738,0.004 0.151139,0.0262 0.249946,0.0538 0.296438,0.0828 0.01744,0.0116 0.05522,0.0291 0.113346,0.0523 0.05813,0.0233 0.108989,0.048 0.152576,0.0741 0.0436,0.0262 0.06829,0.0509 0.07412,0.0741 h -0.0436 c 0.0407,0.0349 0.0654,0.0756 0.07412,0.12208 0.0087,0.0465 -0.01307,0.0814 -0.06539,0.10463 0.03487,-0.006 0.08138,0.003 0.139505,0.0262 0.093,0.0349 0.09592,0.0669 0.0087,0.0959 0.01744,-0.006 0.04213,-0.0116 0.07412,-0.0174 0.03198,-0.006 0.05667,-0.0145 0.0741,-0.0262 0.01162,-0.006 0.02616,-0.016 0.0436,-0.0305 0.01744,-0.0145 0.03052,-0.0233 0.03925,-0.0262 0.0087,-0.003 0.0218,-0.006 0.03923,-0.009 0.01744,-0.003 0.03489,10e-4 0.05232,0.0131 0.0058,0 0.0189,-0.0145 0.03923,-0.0436 0.02033,-0.029 0.04215,-0.0581 0.0654,-0.0872 0.02325,-0.0291 0.04359,-0.0436 0.06103,-0.0436 0.01744,0 0.03342,0.007 0.04796,0.0218 0.01452,0.0145 0.02616,0.0305 0.03487,0.048 0.0087,0.0174 0.01744,0.0363 0.02616,0.0567 0.0087,0.0203 0.01598,0.0363 0.0218,0.0479 0.01162,0.0291 0.03924,0.0596 0.08283,0.0916 0.04359,0.032 0.07121,0.0625 0.08285,0.0915 0.0058,0.0174 0.01744,0.061 0.03487,0.13079 0.01743,0.0698 0.0407,0.1177 0.06975,0.14386 0.02905,0.0262 0.07266,0.048 0.130775,0.0654 0.01163,0.006 0.03778,0.003 0.07847,-0.009 0.0407,-0.0116 0.07412,-0.0145 0.100274,-0.009 0.02616,0.006 0.03925,0.0291 0.03925,0.0697 0.03487,-0.0349 0.05232,-0.0581 0.05232,-0.0697 0.0058,0.0756 0.02471,0.1366 0.05667,0.18311 0.03197,0.0465 0.08285,0.0668 0.152591,0.061 l -0.01744,0.19182 c -0.01744,0.0291 -0.06105,0.0509 -0.130791,0.0654 -0.06974,0.0145 -0.113346,0.0276 -0.130789,0.0392 -0.01744,0.006 -0.05958,0.0407 -0.126418,0.10463 -0.06684,0.0639 -0.09445,0.10172 -0.08283,0.11334 -0.09881,-0.11045 -0.247041,-0.14241 -0.44467,-0.0959 -0.220869,0.0349 -0.372022,0.0698 -0.453401,0.10463 -0.093,0.0465 -0.156948,0.0901 -0.19182,0.13079 -0.0058,0.006 -0.01598,0.0262 -0.03052,0.061 -0.01454,0.0349 -0.02906,0.0668 -0.0436,0.0959 -0.01235,0.0247 -0.02364,0.0388 -0.03388,0.0425 0.03353,-0.008 0.07099,-0.0348 0.112373,-0.0817 0.04359,-0.0494 0.0712,-0.077 0.08283,-0.0828 0.151124,-0.0988 0.276119,-0.13369 0.374912,-0.10463 0.127884,0.0349 0.148218,0.0814 0.06105,0.1395 -0.01162,0.0116 -0.04213,0.016 -0.09155,0.0131 -0.04941,-0.003 -0.08285,-0.001 -0.100274,0.004 0.05232,0.0116 0.0959,0.0276 0.130775,0.048 0.03487,0.0203 0.0436,0.0479 0.02616,0.0828 0.02375,0.0134 0.04249,0.0271 0.05639,0.0412 0.122794,-0.009 0.246383,-0.0137 0.370644,-0.0137 0.664775,0 1.310071,0.13109 1.917978,0.38963 0.587635,0.24991 1.105958,0.59349 1.541376,1.02143 -0.07536,-1.01167 -0.368009,-1.9548 -0.878307,-2.82924 -0.598714,-1.02594 -1.411034,-1.83828 -2.436976,-2.43699 -1.025971,-0.59864 -2.146363,-0.898 -3.361219,-0.898 -1.214858,0 -2.335264,0.29936 -3.361205,0.89806 -1.025941,0.59871 -1.838262,1.41105 -2.436991,2.43699 -0.598699,1.02594 -0.898056,2.14635 -0.898056,3.3612 0,1.21486 0.299357,2.33527 0.898056,3.36121 0.598714,1.02594 1.411035,1.83826 2.436991,2.43698 1.016763,0.59335 2.126344,0.8925 3.328653,0.89781 -0.08213,-0.0715 -0.161739,-0.14569 -0.238656,-0.2226 -0.441301,-0.4413 -0.794607,-0.96967 -1.050078,-1.57041 z m 9.429037,2.01361 -1.81742,-1.81742 c 0.438023,-0.6323 0.657035,-1.33701 0.657035,-2.11414 0,-0.50512 -0.09801,-0.98819 -0.294072,-1.44917 -0.0276,-0.0649 -0.05673,-0.12841 -0.08705,-0.19079 -0.185113,-0.38069 -0.420909,-0.71459 -0.707733,-1.0014 -0.333826,-0.33381 -0.731212,-0.59874 -1.192188,-0.79478 -0.460977,-0.19605 -0.944039,-0.29408 -1.449171,-0.29408 -0.505118,0 -0.988179,0.098 -1.449171,0.29408 -0.112089,0.0476 -0.220329,0.0995 -0.324901,0.15528 -0.325501,0.17373 -0.614645,0.38685 -0.867287,0.6395 -0.03838,0.0384 -0.07575,0.0777 -0.112313,0.11778 -0.281404,0.30837 -0.50898,0.66644 -0.682488,1.07442 -0.07389,0.17377 -0.133845,0.35066 -0.179887,0.5307 -0.03369,0.13173 -0.05992,0.26517 -0.0787,0.40027 -0.02363,0.17007 -0.03549,0.3428 -0.03549,0.51818 0,0.50511 0.09803,0.98817 0.294072,1.44915 0.196042,0.46098 0.460976,0.85838 0.794787,1.19219 0.33381,0.33382 0.731195,0.59874 1.192187,0.7948 0.02219,0.009 0.04444,0.0186 0.06674,0.0276 0.440823,0.17762 0.901635,0.2665 1.382436,0.2665 0.777133,0 1.481842,-0.21899 2.114141,-0.65702 l 1.817419,1.81212 c 0.127166,0.13424 0.286121,0.20136 0.476878,0.20136 0.183675,0 0.342644,-0.0671 0.476863,-0.20136 0.134219,-0.13423 0.201343,-0.29319 0.201343,-0.47685 1.5e-5,-0.18722 -0.06533,-0.34616 -0.196027,-0.47687 z m -2.753268,-2.88611 c -0.112972,0.22698 -0.266312,0.43755 -0.460318,0.63155 -0.145224,0.14521 -0.299672,0.26774 -0.463357,0.36755 -0.359908,0.21947 -0.764451,0.32921 -1.213659,0.32921 -0.371363,0 -0.712165,-0.0751 -1.022498,-0.22511 -0.235766,-0.11396 -0.453969,-0.27111 -0.654519,-0.47165 -0.09727,-0.0973 -0.184198,-0.19874 -0.2611,-0.30428 -0.170304,-0.23376 -0.290643,-0.48787 -0.361062,-0.76228 -0.02014,-0.0785 -0.03624,-0.15858 -0.0482,-0.24038 -0.01752,-0.11981 -0.0264,-0.24313 -0.0264,-0.37007 0,-0.6535 0.232247,-1.21251 0.696757,-1.67702 0.464511,-0.46451 1.023516,-0.69676 1.677017,-0.69676 0.6535,0 1.212491,0.23225 1.677016,0.69676 0.46451,0.46451 0.696773,1.02352 0.696773,1.67702 0,0.38055 -0.07892,0.72899 -0.23644,1.04546 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    SEARCH_GEOCODING: '<svg width="15" height="15" version="1.1" xmlns="http://www.w3.org/2000/svg"> <g transform="translate(19.95276,-264.91098)"> <path d="m -5.2863233,277.94582 -3.0919443,-3.09195 c 0.7451847,-1.0757 1.1177935,-2.27463 1.1177935,-3.59675 0,-0.85937 -0.1667659,-1.6812 -0.5002976,-2.46544 -0.3335317,-0.78425 -0.7842618,-1.46033 -1.3521592,-2.02825 -0.5678968,-0.56791 -1.2439841,-1.01862 -2.0282461,-1.35216 -0.784261,-0.33353 -1.606086,-0.50029 -2.46544,-0.50029 -0.859386,0 -1.681195,0.16676 -2.465441,0.50029 -0.784246,0.33354 -1.460333,0.78427 -2.028246,1.35216 -0.567912,0.5679 -1.018627,1.24399 -1.352158,2.02825 -0.333532,0.78426 -0.500298,1.60608 -0.500298,2.46544 0,0.85939 0.166766,1.68119 0.500298,2.46544 0.333531,0.78425 0.784262,1.46033 1.352158,2.02825 0.567897,0.56791 1.243985,1.01862 2.028246,1.35215 0.784262,0.33354 1.60607,0.5003 2.465441,0.5003 1.322122,0 2.521034,-0.37258 3.596754,-1.11779 l 3.0919442,3.08293 c 0.2163494,0.22838 0.4867776,0.34256 0.8113017,0.34256 0.3124865,0 0.5829313,-0.11417 0.8113012,-0.34256 0.2283549,-0.22835 0.3425559,-0.49878 0.3425559,-0.8113 0,-0.31849 -0.1111882,-0.58892 -0.3335317,-0.8113 z m -5.4672427,-3.83563 c -0.790288,0.79027 -1.7413,1.18539 -2.853067,1.18539 -1.111767,0 -2.062811,-0.39512 -2.853067,-1.18539 -0.790289,-0.79026 -1.185393,-1.74129 -1.185393,-2.85307 0,-1.11178 0.395104,-2.0628 1.185393,-2.85307 0.790256,-0.79025 1.741284,-1.18539 2.853067,-1.18539 1.111783,0 2.062795,0.39515 2.853067,1.18539 0.7902569,0.79027 1.1853932,1.7413 1.1853932,2.85307 0,1.11177 -0.3951363,2.06281 -1.1853932,2.85307 z m -5.101953,-5.1578 h 4.384345 v 4.50613 h -4.384345 z" style="fill:#ffffff;fill-opacity:1" /> </g> </svg>',
    TRASH: '<svg width="20" height="22" version="1.1" xmlns="http://www.w3.org/2000/svg"> <path d="m 12.014242,9.9999999 v 6.0000011 m -4,-6.0000011 v 6.0000011 m 9,-11.0000009 V 19 a 2,2 0 0 1 -2,2 H 5.0142424 a 2,2 0 0 1 -2,-2 V 5.0000001 m 3,0 v -2 A 2,2 0 0 1 8.014242,1 h 4 a 2,2 0 0 1 2,2.0000001 v 2 m -12.9999995,0 h 2 15.9999995" style="fill:none;stroke:#ffffff;stroke-width:2;stroke-linecap:round;stroke-linejoin:round" /></svg>'
};

/**
 * @namespace BKGWebMap.Util
 * @type {object}
 */
BKGWebMap.Util = BKGWebMap.Util || {};

/**
 * Iterates over arrays
 * @param {array} elements - Array that this method is being applied to
 * @param {function} method - Function to be executed for each element
 */
BKGWebMap.Util.each = function (elements, method) {
    if (!elements || !elements.length) {
        return;
    }

    for (var i = 0; i < elements.length; i++) {
        method(i, elements[i]);
    }
};

/**
 * Iterates reverse over arrays
 * @param {array} elements - Array that this method is being applied to
 * @param {function} method - Function to be executed for each element
 */
BKGWebMap.Util.reverseEach = function (elements, method) {
    if (!elements || !elements.length) {
        return;
    }

    for (var i = elements.length - 1; i >= 0; i--) {
        method(i, elements[i]);
    }
};

/**
 * Maps elements of array. It creates a new array with the results of calling a method for every array element. You can pass further static arguments to the method.
 * @param {function} method - Function to be run for each element in the array
 * @param {array} elements - Array that this method is being applied to
 * @return {array}
 */
BKGWebMap.Util.map = function (method, elements) {
    if (!elements || !elements.length) {
        return [];
    }

    // pass further optional arguments
    var staticArgs = (arguments.length === 2) ? [] : Array.prototype.slice.call(arguments, 2, arguments.length);

    var result = [];
    for (var i = 0; i < elements.length; i++) {
        var args = [elements[i]];
        args = args.concat(staticArgs);
        result.push(method.apply(this, args));
    }
    return result;
};

/**
 * Creates a deep copy of an object
 * @param {object} obj - Object to copy
 * @returns {object}
 */
BKGWebMap.Util.deepCopy = function (obj) {
    var newObj = obj;
    if (obj && typeof obj === 'object') {
        newObj = Object.prototype.toString.call(obj) === '[object Array]' ? [] : {};
        for (var i in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, i)) {
                newObj[i] = BKGWebMap.Util.deepCopy(obj[i]);
            }
        }
    }
    return newObj;
};

/**
 * Extends an object using properties of a second object. Common properties will be overwritten.
 * @param {object} obj1 - Object to extend.
 * @param {object} obj2 - Object to get new properties.
 * @returns {object}
 */
BKGWebMap.Util.extend = function (obj1, obj2) {
    for (var p in obj2) {
        if (Object.prototype.hasOwnProperty.call(obj2, p)) {
            try {
                // Property in destination object set: update its value.
                if (obj2[p].constructor === Object && (Object.keys(obj2[p]).length > 0)) {
                    obj1[p] = BKGWebMap.Util.extend(obj1[p], obj2[p]);
                } else {
                    obj1[p] = obj2[p];
                }
            } catch (e) {
                // Property in destination object not set: create it and set its value.
                obj1[p] = obj2[p];
            }
        }
    }
    return obj1;
};

/**
 * Checks if an object has a nested property
 * @param {object} obj - The object to test
 * @param {string} propertyPath - Path of property. Syntax: 'prop1.prop2.prop3...'
 * @returns {boolean}
 */
BKGWebMap.Util.hasNestedProperty = function (obj, propertyPath) {
    if (!propertyPath) { return false; }

    var properties = propertyPath.split('.');

    for (var i = 0; i < properties.length; i++) {
        var prop = properties[i];

        if (!obj || !Object.prototype.hasOwnProperty.call(obj, prop)) {
            return false;
        }
        obj = obj[prop];
    }

    return true;
};

/**
 * Get a value from an object using a string path in dot notation
 * @param {object} obj - Object to search.
 * @param {string} propertyPath - String path in dot notation.
 * @returns {object}
 */
BKGWebMap.Util.getObjValueFromStringPath = function (obj, propertyPath) {
    function index(_obj, i) {
        return _obj[i];
    }
    return propertyPath.split('.').reduce(index, obj);
};

/**
 * Generate object with css properties from a string
 * @param {string} cssString - String to parse
 * @returns {object}
 */
BKGWebMap.Util.cssParser = function (cssString) {
    var obj = {};
    var propArray = cssString.split(';').filter(function (prop) {
        return (!!prop);
    });
    for (var prop in propArray) {
        propArray[prop] = propArray[prop].split(':');
        obj[propArray[prop][0]] = propArray[prop][1];
    }
    return obj;
};

/**
 * Generate a unique BKG WebMap ID that can be used in DOM elements
 * @returns {string}
 */
BKGWebMap.Util.uniqueId = function () {
    return 'bkgwebmap-' + Math.random().toString(36).substr(2, 16);
};

/**
 * Converts XML to JSON format
 * @param {object} xml - XML as JavaScript object
 * @returns {object}
 */
BKGWebMap.Util.xmlToJson = function (xml) {
    var obj = {};

    if (xml.nodeType === 1) { // element
        // do attributes
        if (xml.attributes.length > 0) {
            obj['@attributes'] = {};
            for (var j = 0; j < xml.attributes.length; j++) {
                var attribute = xml.attributes.item(j);
                obj['@attributes'][attribute.nodeName] = attribute.nodeValue;
            }
        }
    } else if (xml.nodeType === 3) { // text
        obj = xml.nodeValue;
    }

    if (xml.hasChildNodes()) {
        for (var i = 0; i < xml.childNodes.length; i++) {
            var item = xml.childNodes.item(i);
            var nodeName = item.nodeName;
            if (typeof (obj[nodeName]) === 'undefined') {
                obj[nodeName] = BKGWebMap.Util.xmlToJson(item);
            } else {
                if (typeof (obj[nodeName].push) === 'undefined') {
                    var old = obj[nodeName];
                    obj[nodeName] = [];
                    obj[nodeName].push(old);
                }
                obj[nodeName].push(BKGWebMap.Util.xmlToJson(item));
            }
        }
    }
    return obj;
};

/**
 * Generate a Session-Token for secure BKG services
 * @param {string} appID
 * @param {string} appDomain
 * @param {function} callback - Callback function
 * @returns {function}
 */
BKGWebMap.Util.getSessionToken = function (appID, appDomain, callback) {
    var baseURL = BKGWebMap.BASE_URL.replace('http://', 'https://');
    var url = baseURL + 'gdz_getSession?bkg_appid=' + appID + '&domain=' + appDomain;
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url);

    xhr.onload = function () {
        if (xhr.status === 200) {
            return callback(xhr.responseText);
        }
    };

    xhr.onerror = function () {
        return callback('');
    };

    xhr.send();
};

/**
 * Determine if we need to create a panel
 * @param {object} controls - Object with controls configuration
 * @returns {boolean}
 */
BKGWebMap.Util.shouldCreatePanel = function (controls) {
    var createPanel = false;
    BKGWebMap.Util.onlyPermaLink = false;
    if (!controls) {
        return createPanel;
    }
    if (typeof controls.tools !== 'object' || controls.tools.constructor !== Object) {
        return createPanel;
    }
    for (var i = 0; i < BKGWebMap.CONTROLS_IN_PANEL.length; i++) {
        if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]]) {
            if (BKGWebMap.CONTROLS_IN_PANEL[i] === 'share') {
                if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].active && !controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].div && ((controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport.active) || (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print.active))) {
                    createPanel = true;
                } else if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].active && !controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].div && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport.active === false && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print.active === false && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].permaLink && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].permaLink.active === true) {
                    BKGWebMap.Util.onlyPermaLink = true;
                }
            } else if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].active && !controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].div) {
                createPanel = true;
            }
        }
    }
    return createPanel;
};

/**
 * Find geometry type of features
 * @param {array} features - Array with OpenLayers features
 * @returns {object}
 */
BKGWebMap.Util.findGeometryType = function (features) {
    var stringsToSearch = [
        {
            string: 'POLYGON',
            name: 'Polygon'
        },
        {
            string: 'POINT',
            name: 'Point'
        },
        {
            string: 'LINE',
            name: 'LineString'
        }
    ];
    var types = [];
    var format = new ol.format.WKT();
    var geometry;
    var wkt;
    var tempType;
    for (var i = 0; i < features.length; i++) {
        geometry = features[i].getGeometry();

        wkt = format.writeGeometry(geometry);
        for (var k = 0; k < stringsToSearch.length; k++) {
            if (wkt.indexOf(stringsToSearch[k].string) !== -1) {
                tempType = stringsToSearch[k].name;
                if (types.indexOf(tempType) === -1) {
                    types.push(tempType);
                }
            }
        }
    }
    return types;
};

/**
 * Counter for layer IDs
 * @type {number}
 */
BKGWebMap.Util.layerId = 0;

/**
 * Generate ID for layers to use in permalink
 * @returns {string}
 */
BKGWebMap.Util.generateLayerId = function () {
    BKGWebMap.Util.layerId++;
    return 'layer_' + BKGWebMap.Util.layerId;
};

// Add remove() if method not exists
if (!('remove' in Element.prototype)) {
    Element.prototype.remove = function () {
        if (this.parentNode) {
            this.parentNode.removeChild(this);
        }
    };
}

/**
 * @namespace BKGWebMap.Util
 * @type {object}
 */
BKGWebMap.Util = BKGWebMap.Util || {};

/**
 * Iterates over arrays
 * @param {array} elements - Array that this method is being applied to
 * @param {function} method - Function to be executed for each element
 */
BKGWebMap.Util.each = function (elements, method) {
    if (!elements || !elements.length) {
        return;
    }

    for (var i = 0; i < elements.length; i++) {
        method(i, elements[i]);
    }
};

/**
 * Iterates reverse over arrays
 * @param {array} elements - Array that this method is being applied to
 * @param {function} method - Function to be executed for each element
 */
BKGWebMap.Util.reverseEach = function (elements, method) {
    if (!elements || !elements.length) {
        return;
    }

    for (var i = elements.length - 1; i >= 0; i--) {
        method(i, elements[i]);
    }
};

/**
 * Maps elements of array. It creates a new array with the results of calling a method for every array element. You can pass further static arguments to the method.
 * @param {function} method - Function to be run for each element in the array
 * @param {array} elements - Array that this method is being applied to
 * @return {array}
 */
BKGWebMap.Util.map = function (method, elements) {
    if (!elements || !elements.length) {
        return [];
    }

    // pass further optional arguments
    var staticArgs = (arguments.length === 2) ? [] : Array.prototype.slice.call(arguments, 2, arguments.length);

    var result = [];
    for (var i = 0; i < elements.length; i++) {
        var args = [elements[i]];
        args = args.concat(staticArgs);
        result.push(method.apply(this, args));
    }
    return result;
};

/**
 * Creates a deep copy of an object
 * @param {object} obj - Object to copy
 * @returns {object}
 */
BKGWebMap.Util.deepCopy = function (obj) {
    var newObj = obj;
    if (obj && typeof obj === 'object') {
        newObj = Object.prototype.toString.call(obj) === '[object Array]' ? [] : {};
        for (var i in obj) {
            if (Object.prototype.hasOwnProperty.call(obj, i)) {
                newObj[i] = BKGWebMap.Util.deepCopy(obj[i]);
            }
        }
    }
    return newObj;
};

/**
 * Extends an object using properties of a second object. Common properties will be overwritten.
 * @param {object} obj1 - Object to extend.
 * @param {object} obj2 - Object to get new properties.
 * @returns {object}
 */
BKGWebMap.Util.extend = function (obj1, obj2) {
    for (var p in obj2) {
        if (Object.prototype.hasOwnProperty.call(obj2, p)) {
            try {
                // Property in destination object set: update its value.
                if (obj2[p].constructor === Object && (Object.keys(obj2[p]).length > 0)) {
                    obj1[p] = BKGWebMap.Util.extend(obj1[p], obj2[p]);
                } else {
                    obj1[p] = obj2[p];
                }
            } catch (e) {
                // Property in destination object not set: create it and set its value.
                obj1[p] = obj2[p];
            }
        }
    }
    return obj1;
};

/**
 * Checks if an object has a nested property
 * @param {object} obj - The object to test
 * @param {string} propertyPath - Path of property. Syntax: 'prop1.prop2.prop3...'
 * @returns {boolean}
 */
BKGWebMap.Util.hasNestedProperty = function (obj, propertyPath) {
    if (!propertyPath) { return false; }

    var properties = propertyPath.split('.');

    for (var i = 0; i < properties.length; i++) {
        var prop = properties[i];

        if (!obj || !Object.prototype.hasOwnProperty.call(obj, prop)) {
            return false;
        }
        obj = obj[prop];
    }

    return true;
};

/**
 * Get a value from an object using a string path in dot notation
 * @param {object} obj - Object to search.
 * @param {string} propertyPath - String path in dot notation.
 * @returns {object}
 */
BKGWebMap.Util.getObjValueFromStringPath = function (obj, propertyPath) {
    function index(_obj, i) {
        return _obj[i];
    }
    return propertyPath.split('.').reduce(index, obj);
};

/**
 * Generate object with css properties from a string
 * @param {string} cssString - String to parse
 * @returns {object}
 */
BKGWebMap.Util.cssParser = function (cssString) {
    var obj = {};
    var propArray = cssString.split(';').filter(function (prop) {
        return (!!prop);
    });
    for (var prop in propArray) {
        propArray[prop] = propArray[prop].split(':');
        obj[propArray[prop][0]] = propArray[prop][1];
    }
    return obj;
};

/**
 * Generate a unique BKG WebMap ID that can be used in DOM elements
 * @returns {string}
 */
BKGWebMap.Util.uniqueId = function () {
    return 'bkgwebmap-' + Math.random().toString(36).substr(2, 16);
};

/**
 * Converts XML to JSON format
 * @param {object} xml - XML as JavaScript object
 * @returns {object}
 */
BKGWebMap.Util.xmlToJson = function (xml) {
    var obj = {};

    if (xml.nodeType === 1) { // element
        // do attributes
        if (xml.attributes.length > 0) {
            obj['@attributes'] = {};
            for (var j = 0; j < xml.attributes.length; j++) {
                var attribute = xml.attributes.item(j);
                obj['@attributes'][attribute.nodeName] = attribute.nodeValue;
            }
        }
    } else if (xml.nodeType === 3) { // text
        obj = xml.nodeValue;
    }

    if (xml.hasChildNodes()) {
        for (var i = 0; i < xml.childNodes.length; i++) {
            var item = xml.childNodes.item(i);
            var nodeName = item.nodeName;
            if (typeof (obj[nodeName]) === 'undefined') {
                obj[nodeName] = BKGWebMap.Util.xmlToJson(item);
            } else {
                if (typeof (obj[nodeName].push) === 'undefined') {
                    var old = obj[nodeName];
                    obj[nodeName] = [];
                    obj[nodeName].push(old);
                }
                obj[nodeName].push(BKGWebMap.Util.xmlToJson(item));
            }
        }
    }
    return obj;
};

/**
 * Generate a Session-Token for secure BKG services
 * @param {string} appID
 * @param {string} appDomain
 * @param {function} callback - Callback function
 * @returns {function}
 */
BKGWebMap.Util.getSessionToken = function (appID, appDomain, callback) {
    var baseURL = BKGWebMap.BASE_URL.replace('http://', 'https://');
    var url = baseURL + 'gdz_getSession?bkg_appid=' + appID + '&domain=' + appDomain;
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url);

    xhr.onload = function () {
        if (xhr.status === 200) {
            return callback(xhr.responseText);
        }
    };

    xhr.onerror = function () {
        return callback('');
    };

    xhr.send();
};

/**
 * Determine if we need to create a panel
 * @param {object} controls - Object with controls configuration
 * @returns {boolean}
 */
BKGWebMap.Util.shouldCreatePanel = function (controls) {
    var createPanel = false;
    BKGWebMap.Util.onlyPermaLink = false;
    if (!controls) {
        return createPanel;
    }
    if (typeof controls.tools !== 'object' || controls.tools.constructor !== Object) {
        return createPanel;
    }
    for (var i = 0; i < BKGWebMap.CONTROLS_IN_PANEL.length; i++) {
        if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]]) {
            if (BKGWebMap.CONTROLS_IN_PANEL[i] === 'share') {
                if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].active && !controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].div && ((controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport.active) || (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print.active))) {
                    createPanel = true;
                } else if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].active && !controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].div && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].jsonExport.active === false && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].print.active === false && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].permaLink && controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].permaLink.active === true) {
                    BKGWebMap.Util.onlyPermaLink = true;
                }
            } else if (controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].active && !controls.tools[BKGWebMap.CONTROLS_IN_PANEL[i]].div) {
                createPanel = true;
            }
        }
    }
    return createPanel;
};

/**
 * Find geometry type of features
 * @param {array} features - Array with OpenLayers features
 * @returns {object}
 */
BKGWebMap.Util.findGeometryType = function (features) {
    var stringsToSearch = [
        {
            string: 'POLYGON',
            name: 'Polygon'
        },
        {
            string: 'POINT',
            name: 'Point'
        },
        {
            string: 'LINE',
            name: 'LineString'
        }
    ];
    var types = [];
    var format = new ol.format.WKT();
    var geometry;
    var wkt;
    var tempType;
    for (var i = 0; i < features.length; i++) {
        geometry = features[i].getGeometry();

        wkt = format.writeGeometry(geometry);
        for (var k = 0; k < stringsToSearch.length; k++) {
            if (wkt.indexOf(stringsToSearch[k].string) !== -1) {
                tempType = stringsToSearch[k].name;
                if (types.indexOf(tempType) === -1) {
                    types.push(tempType);
                }
            }
        }
    }
    return types;
};

/**
 * Counter for layer IDs
 * @type {number}
 */
BKGWebMap.Util.layerId = 0;

/**
 * Generate ID for layers to use in permalink
 * @returns {string}
 */
BKGWebMap.Util.generateLayerId = function () {
    BKGWebMap.Util.layerId++;
    return 'layer_' + BKGWebMap.Util.layerId;
};

// Add remove() if method not exists
if (!('remove' in Element.prototype)) {
    Element.prototype.remove = function () {
        if (this.parentNode) {
            this.parentNode.removeChild(this);
        }
    };
}

// Polyfill CustomEvent() in IE
(function () {
    if (typeof window.CustomEvent === 'function') return false;

    function CustomEvent(event, params) {
        params = params || { bubbles: false, cancelable: false, detail: undefined };
        var evt = document.createEvent('CustomEvent');
        evt.initCustomEvent(event, params.bubbles, params.cancelable, params.detail);
        return evt;
    }

    CustomEvent.prototype = window.Event.prototype;

    window.CustomEvent = CustomEvent;
}());


/**
 * Returns the extent of the given layer. Depending on the layer type the
 * access to the extent may vary.
 *
 * @param {ol.layer.Layer} layer - the layer from which to retrieve the extent
 * @param {ol.proj.Projection} projection - optional target projection for layer
 * @returns {ol.Extent}
 */
BKGWebMap.Util.getLayerExtent = function (layer, projection) {
    var extent;
    if (layer instanceof ol.layer.Group) {
        extent = ol.extent.createEmpty();
        layer.getLayers().forEach(function (subLayer) {
            var subLayerExtent = BKGWebMap.Util.getLayerExtent(subLayer, projection);
            ol.extent.extend(extent, subLayerExtent);
        });
        return extent;
    }

    // layer has no source. e.g. EMPTY
    if (layer.getSource() == null) { return ol.extent.createEmpty(); }

    if (layer instanceof ol.layer.Vector) {
        extent = layer.getSource().getExtent();
    } else if (layer.extent && layer.extent instanceof Array) {
        extent = layer.extent;
    }

    var srcProjection = layer.getSource().getProjection();
    if (projection && srcProjection != null) {
        extent = ol.proj.transformExtent(extent, srcProjection, projection);
    }

    return extent;
};

/**
 * @namespace BKGWebMap.Control
 * @type {object}
 */
BKGWebMap.Control = BKGWebMap.Control || {};
/**
 * Create four standard positions for map controls (top-left, top-right, bottom-left, bottom-right)
 * @typedef {function} CONTROL_FACTORIES_standardPosition
 * @param {object} map - Map object
 * @param {string} position - Position of control (top-left, top-right, bottom-left, bottom-right)
 * @returns {object}
 */
/**
 * Create panel Control
 * @typedef {function} CONTROL_FACTORIES_panel
 * @param {object} map - Map object
 * @param {string} panelPosition - Panel position (Values: "left", "right") (/options/panelPosition)
 * @param {object} initialize - Tool that should be shown, when starting the Application. If empty or null, then panel will be closed. (Values: "geoSearch", "searchCoordinates", "layerSwitcher", "legend", "showAttributes", "copyCoordinates", "measure", "edit", "share") (/options/initialize)
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} layerSwitcher_options
 * @property {boolean} active - Activate tool. (/options/tools/layerSwitcher/active)
 * @property {string|null} div - DIV ID. (/options/tools/layerSwitcher/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/layerSwitcher/style)
 * @property {boolean} editStyle - User can change style of vector layers. (/options/tools/layerSwitcher/editStyle)
 * @property {boolean} changeVisibility - User can change visibility of layers. (/options/tools/layerSwitcher/changeVisibility)
 * @property {boolean} changeOrder - User can change layer order. (/options/tools/layerSwitcher/changeOrder)
 * @property {boolean} showWMSLayers - Show layers of WMS Services in menu. (/options/tools/layerSwitcher/showWMSLayers)
 * @property {integer} openLevel - Define which level of layerswitcher should be open. 0: Menu is closed, 1: Basemaps/Overlays menu is open, 2: Group layers are open. (/options/tools/layerSwitcher/openLevel)
 */
/**
 * Create layerSwitcher Control
 * @typedef {function} CONTROL_FACTORIES_layerSwitcher
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (layerSwitcher)
 * @param {object} options - Control options. See properties in {@link layerSwitcher_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} showAttributes_options
 * @property {boolean} active - Activate tool. (/options/tools/showAttributes/active)
 * @property {string|null} div - DIV ID. (/options/tools/showAttributes/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/showAttributes/style)
 */
/**
 * Create showAttributes Control
 * @typedef {function} CONTROL_FACTORIES_showAttributes
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (showAttributes)
 * @param {object} options - Control options. See properties in {@link showAttributes_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} legend_options
 * @property {boolean} active - Activate tool. (/options/tools/legend/active)
 * @property {string|null} div - DIV ID. (/options/tools/legend/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/legend/style)
 */
/**
 * Create legend Control
 * @typedef {function} CONTROL_FACTORIES_legend
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (legend)
 * @param {object} options - Control options. See properties in {@link legend_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} zoom_options
 * @property {boolean} active - Activate tool. (/options/tools/zoom/active)
 * @property {boolean} showZoomLevel - Show zoom level as text under the zoom buttons. (/options/tools/zoom/showZoomLevel)
 * @property {boolean} zoomToFullExtent - Zoom to full extent button. (/options/tools/zoom/zoomToFullExtent)
 * @property {boolean} history - Navigation history buttons. (/options/tools/zoom/history)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/zoom/position)
 * @property {string|null} div - DIV ID. (/options/tools/zoom/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/zoom/style)
 * @property {boolean} onlyFullScreen - Tool available only in full screen mode. (/options/tools/zoom/onlyFullScreen)
 */
/**
 * Create zoom Control
 * @typedef {function} CONTROL_FACTORIES_zoom
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (zoom)
 * @param {object} options - Control options. See properties in {@link zoom_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} fullScreen_options
 * @property {boolean} active - Activate tool. (/options/tools/fullScreen/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/fullScreen/position)
 * @property {string|null} div - DIV ID. (/options/tools/fullScreen/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/fullScreen/style)
 */
/**
 * Create fullScreen Control
 * @typedef {function} CONTROL_FACTORIES_fullScreen
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (fullScreen)
 * @param {object} options - Control options. See properties in {@link fullScreen_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} measure_options
 * @property {boolean} active - Activate tool. (/options/tools/measure/active)
 * @property {string|null} div - DIV ID. (/options/tools/measure/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/measure/style)
 */
/**
 * Create measure Control
 * @typedef {function} CONTROL_FACTORIES_measure
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (measure)
 * @param {object} options - Control options. See properties in {@link measure_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} edit_options
 * @property {boolean} active - Activate tool. (/options/tools/edit/active)
 * @property {string|null} div - DIV ID. (/options/tools/edit/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/edit/style)
 * @property {boolean} emptyLayer - If edit is active and there is no vector layer, add an empty vector layer. (/options/tools/edit/emptyLayer)
 * @property {object} export - Export editable layers. (/options/tools/edit/export)
 * @property {boolean} export.active - Activate tool. (/options/tools/edit/export/active)
 * @property {array} export.formats - Export formats. (Array values: "KML", "GML", "GEOJSON", "GPX", "WKT") (/options/tools/edit/export/formats)
 */
/**
 * Create edit Control
 * @typedef {function} CONTROL_FACTORIES_edit
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (edit)
 * @param {object} options - Control options. See properties in {@link edit_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} scalebar_options
 * @property {boolean} active - Activate tool. (/options/tools/scalebar/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/scalebar/position)
 * @property {string} scalebarType - Type of scalebar. (Values: "mapscale", "resolution", "distance", "mapscaleDistance", "resolutionDistance") (/options/tools/scalebar/scalebarType)
 * @property {string|null} div - DIV ID. (/options/tools/scalebar/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/scalebar/style)
 * @property {boolean} onlyFullScreen - Tool available only in full screen mode. (/options/tools/scalebar/onlyFullScreen)
 */
/**
 * Create scalebar Control
 * @typedef {function} CONTROL_FACTORIES_scalebar
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (scalebar)
 * @param {object} options - Control options. See properties in {@link scalebar_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} showCoordinates_options
 * @property {boolean} active - Activate tool. (/options/tools/showCoordinates/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/showCoordinates/position)
 * @property {object[]} coordinateSystems - Coordinate systems for dropdown menu. (/options/tools/showCoordinates/coordinateSystems) <br> <b>Below are properties of each Object in Array:</b>
 * @property {string} coordinateSystems.epsg -EPSG code. (/options/tools/searchCoordinates/showCoordinates/items/epsg)
 * @property {string} coordinateSystems.name - Name of coordinate system. (/options/tools/showCoordinates/coordinateSystems/items/name)
 * @property {string|null} div - DIV ID. (/options/tools/showCoordinates/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/showCoordinates/style)
 */
/**
 * Create showCoordinates Control
 * @typedef {function} CONTROL_FACTORIES_showCoordinates
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (showCoordinates)
 * @param {object} options - Control options. See properties in {@link showCoordinates_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} staticLinks_options
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/staticLinks/items/position)
 * @property {string|null} div - DIV ID. (/options/tools/staticLinks/items/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/staticLinks/items/style)
 * @property {string} url - URL for link. (/options/tools/staticLinks/items/url)
 * @property {string} title - Title for link shown on hover. (/options/tools/staticLinks/items/title)
 * @property {string} content - Content for link. Markup is allowed. (/options/tools/staticLinks/items/content)
 * @property {boolean} onlyFullScreen - Link available only in full screen mode. (/options/tools/staticLinks/items/onlyFullScreen)
 */
/**
 * Create staticLinks Control
 * @typedef {function} CONTROL_FACTORIES_staticLinks
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (staticLinks)
 * @param {object} options - Control options. See properties in {@link staticLinks_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} staticWindows_options
 * @property {boolean} active - Should window be initially open or close. (/options/tools/staticWindows/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/staticWindows/items/position)
 * @property {string|null} div - DIV ID. (/options/tools/staticWindows/items/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/staticWindows/items/style)
 * @property {integer[]} size - Size of window in pixel [width, height]. (/options/tools/staticWindows/items/size)
 * @property {string} title - Title for link shown on hover. (/options/tools/staticWindows/items/title)
 * @property {string} content - Content for link. Markup is allowed. (/options/tools/staticWindows/items/content)
 * @property {boolean} onlyFullScreen - Link available only in full screen mode. (/options/tools/staticWindows/items/onlyFullScreen)
 */
/**
 * Create staticWindows Control
 * @typedef {function} CONTROL_FACTORIES_staticWindows
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (staticWindows)
 * @param {object} options - Control options. See properties in {@link staticWindows_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} copyright_options
 * @property {boolean} active - Activate tool. (/options/tools/copyright/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/copyright/position)
 * @property {string|null} div - DIV ID. (/options/tools/copyright/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/copyright/style)
 * @property {string} maxWidth - Maximum width of copyright div (e.g. '200px'). (/options/tools/copyright/maxWidth)
 * @property {string} maxHeight - Maximum height of copyright div (e.g. '100px'). (/options/tools/copyright/maxHeight)
 * @property {boolean} onlyFullScreen - Tool available only in full screen mode. (/options/tools/copyright/onlyFullScreen)
 */
/**
 * Create copyright Control
 * @typedef {function} CONTROL_FACTORIES_copyright
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (copyright)
 * @param {object} options - Control options. See properties in {@link copyright_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * Method to create searchPanel Control
 * @typedef {function} CONTROL_FACTORIES_searchPanel
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (searchpanel)
 * @param {boolean} geoSearch - Is there a geoSearch control available
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * Create infoPanel Control
 * @typedef {function} CONTROL_FACTORIES_infoPanel
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (infoPanel)
 * @param {null} options - InfoPlanel options. Currently not used.
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} geoSearch_options
 * @property {boolean} active - Activate tool. (/options/tools/geoSearch/active)
 * @property {string|null} div - DIV ID. (/options/tools/geoSearch/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/geoSearch/style)
 * @property {integer|null} resultsMaxZoom - Max value for zooming to result features. (/options/tools/geoSearch/resultsMaxZoom)
 * @property {integer|null} suggestCount - Suggestion results that will be fetched. (/options/tools/geoSearch/suggestCount)
 * @property {integer|null} resultsCount - Results that will be fetched. (/options/tools/geoSearch/resultsCount)
 * @property {string|null} templatePopup - Template for popups (e.g. "< b>$text< /b>< br/>$typ< br/>($geometry.x $geometry.y)"). (/options/tools/geoSearch/templatePopup)
 * @property {string|null} templateList - Template for results list. (e.g. "< b>$text< /b>< br/>$typ< br/>($geometry.x $geometry.y)"). (/options/tools/geoSearch/templateList)
 * @property {object} protocol - Protocol used for geoSearch control. (/options/tools/geoSearch/protocol)
 */
/**
 * Create geoSearch Control
 * @typedef {function} CONTROL_FACTORIES_geoSearch
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (geoSearch)
 * @param {object} options - Control options. See properties in {@link geoSearch_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} searchCoordinates_options
 * @property {boolean} active - Activate tool. (/options/tools/searchCoordinates/active)
 * @property {string|null} div - DIV ID. (/options/tools/searchCoordinates/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/searchCoordinates/style)
 * @property {object[]} coordinateSystems - Coordinate systems for dropdown menu. (/options/tools/searchCoordinates/coordinateSystems) <br> <b>Below are properties of each Object in Array:</b>
 * @property {string} coordinateSystems.epsg -EPSG code. (/options/tools/searchCoordinates/coordinateSystems/items/epsg)
 * @property {string} coordinateSystems.name - Name of coordinate system. (/options/tools/searchCoordinates/coordinateSystems/items/name)
 */
/**
 * Create searchCoordinates Control
 * @typedef {function} CONTROL_FACTORIES_searchCoordinates
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (searchCoordinates)
 * @param {object} options - Control options. See properties in {@link searchCoordinates_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} copyCoordinates_options
 * @property {boolean} active - Activate tool. (/options/tools/copyCoordinates/active)
 * @property {string|null} div - DIV ID. (/options/tools/copyCoordinates/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/copyCoordinates/style)
 * @property {object[]} coordinateSystems - Coordinate systems for dropdown menu. (/options/tools/copyCoordinates/coordinateSystems) <br> <b>Below are properties of each Object in Array:</b>
 * @property {string} coordinateSystems.epsg -EPSG code. (/options/tools/searchCoordinates/copyCoordinates/items/epsg)
 * @property {string} coordinateSystems.name - Name of coordinate system. (/options/tools/copyCoordinates/coordinateSystems/items/name)
 */
/**
 * Create copyCoordinates Control
 * @typedef {function} CONTROL_FACTORIES_copyCoordinates
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (copyCoordinates)
 * @param {object} options - Control options. See properties in {@link copyCoordinates_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} share_options
 * @property {boolean} active - Activate tool. (/options/tools/share/active)
 * @property {string|null} div - DIV ID. (/options/tools/share/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/share/style)
 * @property {object} print - Print map. (/options/tools/share/print)
 * @property {boolean} print.active - Activate tool. (/options/tools/share/print/active)
 * @property {string} print.stylesheet - URL of stylesheet file that can be used when printing. (/options/tools/share/print/stylesheet)
 * @property {object} permaLink - Use URL paramaters for exporting-importing map status. (/options/tools/share/permaLink)
 * @property {boolean} permaLink.active - Activate tool. (/options/tools/share/permaLink/active)
 * @property {object} jsonExport - Export-Import JSON with current status of application. (/options/tools/share/jsonExport)
 * @property {boolean} jsonExport.active - Activate tool. (/options/tools/share/jsonExport/active)
 * @property {string} jsonExport.appName - Name of BKG Webmap implementation that will be used in exported JSON. (/options/tools/share/jsonExport/appName)
 */
/**
 * Create share Control
 * @typedef {function} CONTROL_FACTORIES_share
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (share)
 * @param {object} options - Control options. See properties in {@link share_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * Create print Control
 * @typedef {function} CONTROL_FACTORIES_print
 * @param {object} map - Map object
 * @param {object} options - Control options.
 * @param {boolean} options.active - Activate tool. (/options/tools/share/print/active)
 * @param {string} options.stylesheet - URL of stylesheet file that can be used when printing. (/options/tools/share/print/stylesheet)
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * @typedef {object} customLayers_options
 * @property {boolean} active - Activate tool. (/options/tools/customLayers/active)
 * @property {boolean} edit - Enable editing for custom layer. (/options/tools/customLayers/edit)
 * @property {boolean} changeVisibility - User can change visibility of custom layers. (/options/tools/customLayers/changeVisibility)
 * @property {string} defaultStyle - Default style of custom vector layers. Use /styles/items/name. (/options/tools/customLayers/defaultStyle)
 * @property {string[]} dataTypes - Layer types. (Values in array: "BKG", "WMS", "WMTS", "WFS", "CSV", "XLS", "GPS") (/options/tools/customLayers/dataTypes)
 */
/**
 * Create customLayers Control
 * @typedef {function} CONTROL_FACTORIES_customLayers
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (customLayers)
 * @param {object} options - Control options. See properties in {@link customLayers_options}
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * Create permaLink Control
 * @typedef {function} CONTROL_FACTORIES_permaLink
 * @param {object} map - Map object
 * @returns {object}
 */
/**
 * Create jsonExport Control
 * @typedef {function} CONTROL_FACTORIES_jsonExport
 * @param {object} map - Map object
 * @param {object} options - Control options.
 * @param {boolean} options.active - Activate tool. (/options/tools/share/jsonExport/active)
 * @param {string} options.appName - Name of BKG Webmap implementation that will be used in exported JSON. (/options/tools/share/jsonExport/appName)
 * @param {object} panel - Panel object
 * @returns {object}
 */
/**
 * Create cookieCheck Control
 * @typedef {function} CONTROL_FACTORIES_cookieCheck
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (cookieCheck)
 * @param {object} options - Control options.
 * @returns {object}
 */
/**
 * @typedef {object} overviewMap_options
 * @property {boolean} active - Activate tool. (/options/tools/overviewMap/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/overviewMap/position)
 * @property {string|null} div - DIV ID. (/options/tools/overviewMap/div)
 * @property {boolean} collapsible - Overview map can be collapsed. (/options/tools/overviewMap/collapsible)
 * @property {boolean} collapsed - Overview map should start collapsed. (/options/tools/overviewMap/collapsed)
 * @property {array|null} layers - Array with layer IDs that should be shown in overview map. If empty or null, all layers will be used.. (/options/tools/overviewMap/layers)
 * @property {boolean} onlyFullScreen - Link available only in full screen mode. (/options/tools/overviewMap/items/onlyFullScreen)
 */
/**
 * Create overviewMap Control
 * @typedef {function} CONTROL_FACTORIES_overviewMap
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (overviewMap)
 * @param {object} options - Control options. See properties in {@link overviewMap_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * @typedef {object} timeSlider_options
 * @property {boolean} active - Activate tool. (/options/tools/timeSlider/active)
 * @property {string} position - Position of control. It will be used only if div is null. Values: 'top-left', 'top-right', 'bottom-left', 'bottom-right' or CSS properties (e.g. 'left: 5px; top: 10px;'). (/options/tools/timeSlider/position)
 * @property {string|null} div - DIV ID. (/options/tools/timeSlider/div)
 * @property {string} style - CSS Class used for styling. (/options/tools/timeSlider/style)
 */
/**
 * Create timeSlider Control
 * @typedef {function} CONTROL_FACTORIES_timeSlider
 * @param {object} map - Map object
 * @param {string} controlName - Name of control (timeSlider)
 * @param {object} options - Control options. See properties in {@link timeSlider_options}
 * @param {object} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {object}
 */
/**
 * Create marker Control
 * @typedef {function} CONTROL_FACTORIES_marker
 * @param {object} map - Map object
 * @returns {object}
 */
/**
 * Factory functions to generate controls
 * @type {object}
 * @memberof BKGWebMap.Control
 * @property {function} standardPosition - Method to create four standard positions for map controls (top-left, top-right, bottom-left, bottom-right). See {@link CONTROL_FACTORIES_standardPosition}
 * @property {function} geoSearch - Method to create geoSearch Control. See {@link CONTROL_FACTORIES_geoSearch}
 * @property {function} searchCoordinates - Method to create searchCoordinates Control. See {@link CONTROL_FACTORIES_searchCoordinates}
 * @property {function} layerSwitcher - Method to create layerSwitcher Control. See {@link CONTROL_FACTORIES_layerSwitcher}
 * @property {function} customLayers - Method to create customLayers Control. See {@link CONTROL_FACTORIES_customLayers}
 * @property {function} legend - Method to create legend Control. See {@link CONTROL_FACTORIES_legend}
 * @property {function} showAttributes - Method to create showAttributes Control. See {@link CONTROL_FACTORIES_showAttributes}
 * @property {function} copyCoordinates - Method to create copyCoordinates Control. See {@link CONTROL_FACTORIES_copyCoordinates}
 * @property {function} measure - Method to create measure Control. See {@link CONTROL_FACTORIES_measure}
 * @property {function} edit - Method to create measure Control. See {@link CONTROL_FACTORIES_edit}
 * @property {function} share - Method to create share Control. See {@link CONTROL_FACTORIES_share}
 * @property {function} zoom - Method to create zoom Control. See {@link CONTROL_FACTORIES_zoom}
 * @property {function} scalebar - Method to create scalebar Control. See {@link CONTROL_FACTORIES_scalebar}
 * @property {function} copyright - Method to create copyright Control. See {@link CONTROL_FACTORIES_copyright}
 * @property {function} showCoordinates - Method to create showCoordinates Control. See {@link CONTROL_FACTORIES_showCoordinates}
 * @property {function} staticLinks - Method to create staticLinks Control. See {@link CONTROL_FACTORIES_staticLinks}
 * @property {function} staticWindows - Method to create staticWindows Control. See {@link CONTROL_FACTORIES_staticWindows}
 * @property {function} fullScreen - Method to create fullScreen Control. See {@link CONTROL_FACTORIES_fullScreen}
 * @property {function} overviewMap - Method to create overviewMap Control. See {@link CONTROL_FACTORIES_overviewMap}
 * @property {function} timeSlider - Method to create timeSlider Control. See {@link CONTROL_FACTORIES_timeSlider}
 * @property {function} panel - Method to create panel Control. See {@link CONTROL_FACTORIES_panel}
 * @property {function} searchPanel - Method to create searchPanel Control. See {@link CONTROL_FACTORIES_searchPanel}
 * @property {function} infoPanel - Method to create infoPanel Control. See {@link CONTROL_FACTORIES_infoPanel}
 * @property {function} print - Method to create print Control. See {@link CONTROL_FACTORIES_print}
 * @property {function} permaLink - Method to create permaLink Control. See {@link CONTROL_FACTORIES_permaLink}
 * @property {function} jsonExport - Method to create jsonExport Control. See {@link CONTROL_FACTORIES_jsonExport}
 * @property {function} cookieCheck - Method to create cookieCheck Control. See {@link CONTROL_FACTORIES_cookieCheck}
 * @property {function} marker - Method to create marker Control. See {@link CONTROL_FACTORIES_marker}
 */
BKGWebMap.Control.FACTORIES = {
    standardPosition: function () {
        var standardPositionControls = {};
        for (var i = 0; i < BKGWebMap.STANDARD_POSITION.length; i++) {
            standardPositionControls[BKGWebMap.STANDARD_POSITION[i]] = BKGWebMap.Control.createStandardPosition(BKGWebMap.STANDARD_POSITION[i]);
            ol.inherits(standardPositionControls[BKGWebMap.STANDARD_POSITION[i]], ol.control.Control);
        }
        return standardPositionControls;
    },
    panel: function () {
        BKGWebMap.Control.Panel = BKGWebMap.Control.createPanel();
        ol.inherits(BKGWebMap.Control.Panel, ol.control.Control);
        return BKGWebMap.Control.Panel;
    },
    layerSwitcher: function () {
        BKGWebMap.Control.LayerSwitcher = BKGWebMap.Control.createLayerSwitcher();
        ol.inherits(BKGWebMap.Control.LayerSwitcher, ol.control.Control);
        return BKGWebMap.Control.LayerSwitcher;
    },
    showAttributes: function () {
        BKGWebMap.Control.ShowAttributes = BKGWebMap.Control.createShowAttributes();
        ol.inherits(BKGWebMap.Control.ShowAttributes, ol.control.Control);
        return BKGWebMap.Control.ShowAttributes;
    },
    legend: function () {
        BKGWebMap.Control.Legend = BKGWebMap.Control.createLegend();
        ol.inherits(BKGWebMap.Control.Legend, ol.control.Control);
        return BKGWebMap.Control.Legend;
    },
    zoom: function () {
        BKGWebMap.Control.Zoom = BKGWebMap.Control.createZoom();
        ol.inherits(BKGWebMap.Control.Zoom, ol.control.Control);
        return BKGWebMap.Control.Zoom;
    },
    fullScreen: function () {
        BKGWebMap.Control.FullScreen = BKGWebMap.Control.createFullScreen();
        ol.inherits(BKGWebMap.Control.FullScreen, ol.control.FullScreen);
        return BKGWebMap.Control.FullScreen;
    },
    measure: function () {
        BKGWebMap.Control.Measure = BKGWebMap.Control.createMeasure();
        ol.inherits(BKGWebMap.Control.Measure, ol.control.Control);
        return BKGWebMap.Control.Measure;
    },
    edit: function () {
        BKGWebMap.Control.Edit = BKGWebMap.Control.createEdit();
        ol.inherits(BKGWebMap.Control.Edit, ol.control.Control);
        return BKGWebMap.Control.Edit;
    },
    scalebar: function () {
        BKGWebMap.Control.Scalebar = BKGWebMap.Control.createScalebar();
        ol.inherits(BKGWebMap.Control.Scalebar, ol.control.Control);
        return BKGWebMap.Control.Scalebar;
    },
    showCoordinates: function () {
        BKGWebMap.Control.ShowCoordinates = BKGWebMap.Control.createShowCoordinates();
        ol.inherits(BKGWebMap.Control.ShowCoordinates, ol.control.Control);
        return BKGWebMap.Control.ShowCoordinates;
    },
    staticLinks: function (i) {
        BKGWebMap.Control['StaticLinks' + i] = BKGWebMap.Control.createStaticLinks();
        ol.inherits(BKGWebMap.Control['StaticLinks' + i], ol.control.Control);
        return BKGWebMap.Control['StaticLinks' + i];
    },
    staticWindows: function (i) {
        BKGWebMap.Control['StaticWindows' + i] = BKGWebMap.Control.createStaticWindows();
        ol.inherits(BKGWebMap.Control['StaticWindows' + i], ol.control.Control);
        return BKGWebMap.Control['StaticWindows' + i];
    },
    copyright: function () {
        BKGWebMap.Control.Copyright = BKGWebMap.Control.createCopyright();
        ol.inherits(BKGWebMap.Control.Copyright, ol.control.Control);
        return BKGWebMap.Control.Copyright;
    },
    searchPanel: function () {
        BKGWebMap.Control.SearchPanel = BKGWebMap.Control.createSearchPanel();
        ol.inherits(BKGWebMap.Control.SearchPanel, ol.control.Control);
        return BKGWebMap.Control.SearchPanel;
    },
    infoPanel: function () {
        BKGWebMap.Control.InfoPanel = BKGWebMap.Control.createInfoPanel();
        ol.inherits(BKGWebMap.Control.InfoPanel, ol.control.Control);
        return BKGWebMap.Control.InfoPanel;
    },

    geoSearch: function () {
        BKGWebMap.Control.GeoSearch = BKGWebMap.Control.createGeoSearch();
        ol.inherits(BKGWebMap.Control.GeoSearch, ol.control.Control);
        return BKGWebMap.Control.GeoSearch;
    },
    searchCoordinates: function () {
        BKGWebMap.Control.SearchCoordinates = BKGWebMap.Control.createSearchCoordinates();
        ol.inherits(BKGWebMap.Control.SearchCoordinates, ol.control.Control);
        return BKGWebMap.Control.SearchCoordinates;
    },
    copyCoordinates: function () {
        BKGWebMap.Control.CopyCoordinates = BKGWebMap.Control.createCopyCoordinates();
        ol.inherits(BKGWebMap.Control.CopyCoordinates, ol.control.Control);
        return BKGWebMap.Control.CopyCoordinates;
    },
    share: function () {
        BKGWebMap.Control.Share = BKGWebMap.Control.createShare();
        ol.inherits(BKGWebMap.Control.Share, ol.control.Control);
        return BKGWebMap.Control.Share;
    },
    print: function () {
        BKGWebMap.Control.Print = BKGWebMap.Control.createPrint();
        ol.inherits(BKGWebMap.Control.Print, ol.control.Control);
        return BKGWebMap.Control.Print;
    },
    customLayers: function () {
        BKGWebMap.Control.CustomLayers = BKGWebMap.Control.createCustomLayers();
        ol.inherits(BKGWebMap.Control.CustomLayers, ol.control.Control);
        return BKGWebMap.Control.CustomLayers;
    },
    permaLink: function () {
        BKGWebMap.Control.PermaLink = BKGWebMap.Control.createPermaLink();
        return BKGWebMap.Control.PermaLink;
    },
    jsonExport: function () {
        BKGWebMap.Control.JsonExport = BKGWebMap.Control.createJsonExport();
        ol.inherits(BKGWebMap.Control.JsonExport, ol.control.Control);
        return BKGWebMap.Control.JsonExport;
    },
    cookieCheck: function () {
        BKGWebMap.Control.CookieCheck = BKGWebMap.Control.createCookieCheck();
        ol.inherits(BKGWebMap.Control.CookieCheck, ol.control.Control);
        return BKGWebMap.Control.CookieCheck;
    },
    overviewMap: function () {
        BKGWebMap.Control.OverviewMap = BKGWebMap.Control.createOverviewMap();
        ol.inherits(BKGWebMap.Control.OverviewMap, ol.control.Control);
        return BKGWebMap.Control.OverviewMap;
    },
    timeSlider: function () {
        BKGWebMap.Control.TimeSlider = BKGWebMap.Control.createTimeSlider();
        ol.inherits(BKGWebMap.Control.TimeSlider, ol.control.Control);
        return BKGWebMap.Control.TimeSlider;
    },
    marker: function () {
        BKGWebMap.Control.Marker = BKGWebMap.Control.createMarker();
        ol.inherits(BKGWebMap.Control.Marker, ol.control.Control);
        return BKGWebMap.Control.Marker;
    }
};

/**
 * Object with all BKG Webmap Controls used in application
 * @type {object}
 */
BKGWebMap.Controls = BKGWebMap.Controls || {};

/**
 * Create CookieCheck Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_cookieCheck}
 */
BKGWebMap.Control.createCookieCheck = function () {
    return function (map, controlName, options) {
        options = options || {};

        var _this = this;

        // Check if control should be created
        this.activate = BKGWebMap.CONTROLS.tools.cookieCheck.active;

        // Use property 'active' to check later if control is activated.
        this.active = false;

        if (typeof options.active === 'boolean') {
            this.activate = options.active;
        }

        // Get URL
        var url = BKGWebMap.CONTROLS.tools.cookieCheck.url;
        if (typeof options.url === 'string' && options.url !== '') {
            url = options.url;
        }
        url = url.replace('https://', '');
        url = url.replace('http://', '');
        url = window.location.protocol + '//' + url;
        // Generate token
        var token = Math.random().toString(36).substring(2, 10);

        // Name of callback to evaluate cookie test result
        var callbackName = 'BKGWebMap.Controls.cookieCheck.callback';

        // Message to show if cookies are disabled
        var message = 'Für eine korrekte Darstellung <b>aktivieren Sie Cookies für sg.geodatenzentrum.de</b> und laden Sie die Webseite noch einmal vollständig neu (Strg + F5). Weitere Informationen dazu finden sie <a href="http://sg.geodatenzentrum.de/web_bkg_webmap/cookietest/enable.html" target="_blank">hier</a>';

        // Add DOM
        var cookieCheck = document.createElement('div');
        cookieCheck.className = 'bkgwebmap-cookiecheck ol-unselectable ol-control';
        var messageDiv = document.createElement('div');
        messageDiv.className = 'bkgwebmap-cookiemessage';
        messageDiv.innerHTML = message;
        cookieCheck.appendChild(messageDiv);

        var closeDiv = document.createElement('div');
        closeDiv.className = 'bkgwebmap-cookieclosemessage';
        closeDiv.innerHTML = 'X';
        cookieCheck.appendChild(closeDiv);

        // How many milliseconds to wait before message is shown
        var delay = 10000;

        // Activate cookie test
        this.activateCookieTest = function () {
            _this.active = true;
            _this.showTimer = setTimeout(function () {
                cookieCheck.style.display = 'table';
            }, delay);

            var urlWithParams = url + '?callback=' + callbackName + '&token=' + token;
            var script = document.createElement('script');
            script.src = urlWithParams;
            document.head.appendChild(script);
        };

        // Callback to evaluate cookie test result
        this.callback = function (tokenReceived) {
            if (tokenReceived === token) {
                clearTimeout(_this.showTimer);
            } else {
                cookieCheck.style.display = 'table';
            }
        };

        // Close message
        closeDiv.addEventListener('click', function () {
            cookieCheck.style.display = 'none';
        }, true);

        // Finalize control
        ol.control.Control.call(this, {
            element: cookieCheck
        });
    };
};

/**
 * Create StandardPosition Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_standardPosition}
 */
BKGWebMap.Control.createStandardPosition = function () {
    return function (map, position) {
        // Create DOM
        var positionElement = document.createElement('div');
        var positionClass = 'bkgwebmap-position-' + position;
        positionElement.className = 'bkgwebmap-standardposition ' + positionClass + ' ol-unselectable ol-control';

        switch (position) {
        case 'top-left':
            positionElement.style.top = '1.375em';
            positionElement.style.left = '1.375em';
            break;
        case 'top-right':
            positionElement.style.top = '1.375em';
            positionElement.style.right = '1.375em';
            break;
        case 'bottom-left':
            positionElement.style.bottom = '1.375em';
            positionElement.style.left = '1.375em';
            break;
        case 'bottom-right':
            positionElement.style.bottom = '1.375em';
            positionElement.style.right = '1.375em';
            break;
        default:
            return undefined;
        }

        this.getClass = function () {
            return positionClass;
        };

        this.changePosition = function (newPositions) {
            for (var newPosition in newPositions) {
                positionElement.style[newPosition] = newPositions[newPosition];
            }
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: positionElement
        });
    };
};

/**
 * Create Panel Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_panel}
 */
BKGWebMap.Control.createPanel = function () {
    return function (map, panelPosition, initialize, standardPositionControls) {
        var _this = this;

        var mapDivId = map.getTarget();

        // Panel size
        var panelSize = 300;

        // Panel position
        var position = BKGWebMap.CONTROLS.panelPosition;
        if (panelPosition === 'left' || panelPosition === 'right') {
            position = panelPosition;
        }
        var arrowSvg = BKGWebMap.PANEL_ICONS.ARROW_LEFT;
        var panelContentWrapperLeft = '-' + panelSize + 'px';
        if (position === 'right') {
            arrowSvg = BKGWebMap.PANEL_ICONS.ARROW_RIGHT;
            panelContentWrapperLeft = '';
        }

        // Initialize open panel with specific control in it
        var initialControl = BKGWebMap.CONTROLS.initialize;
        if ((typeof initialize === 'string' || initialize instanceof String) && initialize !== '') {
            initialControl = initialize;
        }

        if (BKGWebMap.CONTROLS_IN_PANEL.indexOf(initialControl) === -1) {
            initialControl = null;
        }

        // Create DOM
        var panelBar = document.createElement('div');
        panelBar.className = 'bkgwebmap-panelbar';

        var title = document.createElement('span');
        title.className = 'bkgwebmap-paneltitletext';
        title.innerHTML = 'Title';

        var panelTitle = document.createElement('div');
        panelTitle.className = 'bkgwebmap-paneltitle';
        panelTitle.appendChild(title);

        var parser = new DOMParser();
        var arrow = parser.parseFromString(arrowSvg, 'text/xml');
        arrow.documentElement.setAttribute('class', 'bkgwebmap-panelicons');

        var panelTitleButton = document.createElement('div');
        panelTitleButton.className = 'bkgwebmap-paneltitlebutton';
        panelTitleButton.appendChild(arrow.documentElement);

        var panelTitleWrapper = document.createElement('div');
        panelTitleWrapper.className = 'bkgwebmap-paneltitlewrapper';

        if (position === 'right') {
            panelTitleWrapper.appendChild(panelTitleButton);
            panelTitleWrapper.appendChild(panelTitle);
        } else {
            panelTitleWrapper.appendChild(panelTitle);
            panelTitleWrapper.appendChild(panelTitleButton);
        }

        var panelContent = document.createElement('div');
        panelContent.className = 'bkgwebmap-panelcontent';
        if (position === 'left') {
            panelContent.style.marginLeft = '40px';
        } else {
            panelContent.style.marginRight = '40px';
        }
        panelContent.setAttribute('data-bkg-webmap-activecontent', '');

        var panelContentWrapper = document.createElement('div');
        panelContentWrapper.className = 'bkgwebmap-panelcontentwrapper';
        panelContentWrapper.style.width = panelSize + 'px';
        panelContentWrapper.style.left = panelContentWrapperLeft;
        panelContentWrapper.appendChild(panelTitleWrapper);
        panelContentWrapper.appendChild(panelContent);

        var panel = document.createElement('div');
        panel.className = 'bkgwebmap-panel ol-unselectable ol-control';

        var moveControls;
        var controlMarginSize = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left')[0].offsetTop;
        var moveControlsWidth = controlMarginSize + 40; // +40 for size of panelBar

        // disable transition at beginning
        if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left').length) {
            document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left')[0].style.transition = 'none';
        }
        if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-right').length) {
            document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-right')[0].style.transition = 'none';
        }
        if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-left').length) {
            document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-left')[0].style.transition = 'none';
        }
        if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-right').length) {
            document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-right')[0].style.transition = 'none';
        }

        if (position === 'left') {
            panel.style.left = '0';
            moveControls = {
                left: moveControlsWidth + 'px'
            };
            standardPositionControls['top-left'].changePosition(moveControls);
            standardPositionControls['bottom-left'].changePosition(moveControls);
        } else {
            panelBar.style.right = '0';
            panel.style.right = '0';
            panelContentWrapper.style.right = '-' + panelSize + 'px';
            moveControls = {
                right: moveControlsWidth + 'px'
            };
            standardPositionControls['top-right'].changePosition(moveControls);
            standardPositionControls['bottom-right'].changePosition(moveControls);
        }
        panel.appendChild(panelBar);
        panel.appendChild(panelContentWrapper);

        /**
         * Get panel position (left/right)
         * @returns {string}
         */
        this.getPanelPosition = function () {
            return position;
        };

        /**
         * Add new content to panel
         * @param {Element} newContent - Content that should be added to panel
         */
        this.addPanelContent = function (newContent) {
            panelContent.appendChild(newContent);
        };

        /**
         * Show different content in panel
         * @param {string} title - Content title
         * @param {string} contentClass - Content class
         * @param {boolean} geoSearch - Whether content is geoSearch control
         */
        this.changePanelContent = function (title, contentClass, geoSearch) {
            for (var i = 0; i < panelContent.childNodes.length; i++) {
                panelContent.childNodes[i].style.display = 'none';
            }

            // geoSearch has an input tag instead of a title
            if (geoSearch) {
                if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-paneltitle').length) {
                    document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-paneltitle')[0].style.display = 'none';
                }
                if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-geosearchformdiv').length) {
                    document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-geosearchformdiv')[0].style.display = 'table-cell';
                }
            } else {
                if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-geosearchformdiv').length) {
                    document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-geosearchformdiv')[0].style.display = 'none';
                }
                if (document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-paneltitle').length) {
                    document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-paneltitle')[0].style.display = 'table-cell';
                }
            }

            document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-paneltitletext')[0].innerHTML = title;
            document.getElementById(mapDivId).getElementsByClassName(contentClass)[0].style.display = 'block';
            panelContent.setAttribute('data-bkg-webmap-activecontent', contentClass);

            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.Edit && control instanceof BKGWebMap.Control.Edit) {
                    control.removeEditInteractions();
                    control.addAttributeListener();
                    if (contentClass === 'bkgwebmap-editpanelcontent') {
                        control.adaptLayerMenu();
                    }
                }
            });
            deactivateIcons();
        };

        /**
         * Get content that is currently shown
         * @returns {string}
         */
        this.getActiveContent = function () {
            var activeContent = panelContent.getAttribute('data-bkg-webmap-activecontent');
            return activeContent;
        };

        /**
         * Close panel
         */
        this.closePanel = function () {
            var panelContentWrapper = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-panelcontentwrapper')[0];
            var panelBarWidth = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-panelbar')[0].getBoundingClientRect().width;
            var controlsMargin = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left')[0].offsetTop;

            var moveControls;
            var moveControlsWidth;
            if (position === 'left') {
                panelContentWrapper.style.left = '-' + panelSize + 'px';
                if (panelContentWrapper.style.width === '100%') {
                    panelContentWrapper.style.width = panelSize + 'px';
                    // timeout for optical reasons with css transition
                    setTimeout(function () {
                        panel.style.backgroundColor = '';
                        panel.style.width = '';
                    }, 500);
                } else {
                    moveControlsWidth = panelBarWidth + controlsMargin;
                    moveControls = {
                        left: moveControlsWidth + 'px'
                    };
                    standardPositionControls['top-left'].changePosition(moveControls);
                    standardPositionControls['bottom-left'].changePosition(moveControls);
                }
            } else {
                panelContentWrapper.style.left = '';
                panelContentWrapper.style.right = '-' + panelSize + 'px';
                if (panelContentWrapper.style.width === '100%') {
                    panelContentWrapper.style.width = panelSize + 'px';
                    // timeout for optical reasons with css transition
                    setTimeout(function () {
                        panel.style.backgroundColor = '';
                        panel.style.width = '';
                    }, 500);
                } else {
                    moveControlsWidth = panelBarWidth + controlsMargin;
                    moveControls = {
                        right: moveControlsWidth + 'px'
                    };
                    standardPositionControls['top-right'].changePosition(moveControls);
                    standardPositionControls['bottom-right'].changePosition(moveControls);
                }
            }
            panelContent.setAttribute('data-bkg-webmap-activecontent', '');
            deactivateIcons();
        };

        /**
         * Open panel
         */
        this.openPanel = function (print) {
            var controlsTopLeft = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left')[0];
            var controlsTopRight = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-right')[0];
            var controlsBottomLeft = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-left')[0];
            var controlsBottomRight = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-right')[0];

            controlsTopLeft.style.transition = '';
            controlsTopRight.style.transition = '';
            controlsBottomLeft.style.transition = '';
            controlsBottomRight.style.transition = '';

            var widthOfTopControls = controlsTopLeft.getBoundingClientRect().width + controlsTopRight.getBoundingClientRect().width;
            var widthOfBottomControls = controlsBottomLeft.getBoundingClientRect().width + controlsBottomRight.getBoundingClientRect().width;

            var panelBarWidth = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-panelbar')[0].getBoundingClientRect().width;
            var panelWidth = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-panelcontentwrapper')[0].getBoundingClientRect().width;
            var controlsMargin = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left')[0].offsetTop;

            var controlsWidth;
            if (widthOfTopControls >= widthOfBottomControls) {
                controlsWidth = widthOfTopControls;
            } else if (widthOfTopControls < widthOfBottomControls) {
                controlsWidth = widthOfBottomControls;
            }
            var sumOfWidths = panelWidth + controlsWidth;
            var mapWidth = document.getElementById(mapDivId).getBoundingClientRect().width;

            var panelContentWrapper = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-panelcontentwrapper')[0];

            var moveControls;
            var moveControlsWidth = panelWidth + controlsMargin;

            if (position === 'left') {
                panelContentWrapper.style.left = '0';
                panelContentWrapper.style.paddingLeft = panelBarWidth + 'px';

                if ((sumOfWidths + (2 * controlsMargin)) >= mapWidth) {
                    panel.style.backgroundColor = 'transparent';
                    panel.style.width = '100%';
                    panelContentWrapper.style.width = '100%';
                } else {
                    moveControls = {
                        left: moveControlsWidth + 'px'
                    };

                    standardPositionControls['top-left'].changePosition(moveControls);
                    standardPositionControls['bottom-left'].changePosition(moveControls);
                }
            } else {
                panelContentWrapper.style.left = '';
                panelContentWrapper.style.right = '0';
                panelContentWrapper.style.paddingRight = panelBarWidth + 'px';

                if ((sumOfWidths + (2 * controlsMargin)) >= mapWidth) {
                    panel.style.backgroundColor = 'transparent';
                    panel.style.width = '100%';
                    panelContentWrapper.style.width = '100%';
                } else {
                    moveControls = {
                        right: moveControlsWidth + 'px'
                    };

                    standardPositionControls['top-right'].changePosition(moveControls);
                    standardPositionControls['bottom-right'].changePosition(moveControls);
                }
            }
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.Measure && control instanceof BKGWebMap.Control.Measure) {
                    if (print) {
                        control.closeSidePanel(print);
                    } else {
                        control.closeSidePanel();
                    }
                }
            });
        };

        /**
         * Initialize panel (open control that is defined in property 'initialize')
         */
        this.initialize = function () {
            if (initialControl) {
                if (initialControl === 'geoSearch' || initialControl === 'searchCoordinates') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.SearchPanel && control instanceof BKGWebMap.Control.SearchPanel) {
                            _this.changePanelContent('Suche', 'bkgwebmap-searchpanelcontent', true);
                            _this.openPanel();
                            control.activeIcon();
                        }
                    });
                } else if (initialControl === 'layerSwitcher') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.LayerSwitcher && control instanceof BKGWebMap.Control.LayerSwitcher) {
                            _this.openPanel();
                            _this.changePanelContent('Layer', 'bkgwebmap-layerswitchercontent', false);
                            control.activeIcon();
                        }
                    });
                } else if (initialControl === 'legend') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.Legend && control instanceof BKGWebMap.Control.Legend) {
                            _this.changePanelContent('Legende', 'bkgwebmap-legendcontent', false);
                            _this.openPanel();
                            control.activeIcon();
                        }
                    });
                } else if (initialControl === 'showAttributes' || initialControl === 'copyCoordinates') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.InfoPanel && control instanceof BKGWebMap.Control.InfoPanel) {
                            _this.changePanelContent('Info', 'bkgwebmap-infopanelcontent', false);
                            _this.openPanel();
                            control.activeIcon();
                        }
                    });
                } else if (initialControl === 'share') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.Share && control instanceof BKGWebMap.Control.Share) {
                            _this.changePanelContent('Teilen', 'bkgwebmap-sharepanelcontent', false);
                            _this.openPanel();
                            control.activeIcon();
                        }
                    });
                } else if (initialControl === 'measure') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.Measure && control instanceof BKGWebMap.Control.Measure) {
                            control.toggleSidePanels();
                        }
                    });
                } else if (initialControl === 'edit') {
                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.Edit && control instanceof BKGWebMap.Control.Edit) {
                            _this.changePanelContent('Editieren', 'bkgwebmap-editpanelcontent', false);
                            _this.openPanel();
                            control.activeIcon();
                            var editableLayerAvailable = control.editableLayerAvailable();
                            if (editableLayerAvailable === false) {
                                control.addEmptyLayer();
                            }
                        }
                    });
                }
            }
        };

        function deactivateIcons() {
            var panelIcons = document.getElementsByClassName('bkgwebmap-paneltooltip');
            for (var i = 0; i < panelIcons.length; i++) {
                var element = panelIcons[i];
                if (element.classList.contains('bkgwebmap-panelactive')) {
                    element.classList.remove('bkgwebmap-panelactive');
                }
            }
        }

        // Event listeners
        panelTitleButton.addEventListener('click', this.closePanel, { passive: true });

        // Finalize control
        ol.control.Control.call(this, {
            element: panel
        });
    };
};

/**
 * Create SearchPanel Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_searchPanel}
 */
BKGWebMap.Control.createSearchPanel = function () {
    return function (map, controlName, geoSearch, panel) {
        var mapId = map.getTarget();
        var _this = this;
        var target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];

        // If no panel exists, do not create this control
        if (!panel) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        // Control title for panel
        var title = 'Suche';

        // Tooltip position
        var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
        var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
        if (panel.getPanelPosition() === 'right') {
            tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
            tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
        }

        // Create DOM
        var searchPanel = document.createElement('div');
        searchPanel.className = 'bkgwebmap-searchpanel ' + tooltipClass;

        var parser = new DOMParser();
        var searchPanelIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.SEARCH, 'text/xml');
        searchPanelIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons bkgwebmap-paneliconsopen');
        searchPanel.appendChild(searchPanelIcon.documentElement);

        var searchPanelTooltip = document.createElement('span');
        searchPanelTooltip.className = tooltipTextClass;
        searchPanelTooltip.innerHTML = title;
        searchPanel.appendChild(searchPanelTooltip);

        var searchPanelContent = document.createElement('div');
        var searchPanelContentClass = 'bkgwebmap-searchpanelcontent';
        searchPanelContent.className = searchPanelContentClass + ' bkgwebmap-panelsinglecontent';
        panel.addPanelContent(searchPanelContent);

        function clickControl() {
            var activeContent = panel.getActiveContent();
            if (activeContent === '') {
                panel.openPanel();
                panel.changePanelContent(title, searchPanelContentClass, geoSearch);
                _this.activeIcon();
            } else if (activeContent === searchPanelContentClass) {
                panel.closePanel();
            } else {
                panel.changePanelContent(title, searchPanelContentClass, geoSearch);
                _this.activeIcon();
            }
        }

        this.activeIcon = function () {
            searchPanel.classList.add('bkgwebmap-panelactive');
        };

        // Event listeners
        searchPanel.addEventListener('click', clickControl, { passive: true });
        searchPanel.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            searchPanelTooltip.style.visibility = 'visible';
            setTimeout(function () {
                searchPanelTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: searchPanel,
            target: target
        });
    };
};

/**
 * Create InfoPanel Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_infoPanel}
 */
BKGWebMap.Control.createInfoPanel = function () {
    return function (map, controlName, options, panel) {
        var mapId = map.getTarget();
        var _this = this;
        var target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];

        // Control title for panel
        var title = 'Info';

        // Tooltip position
        var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
        var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
        if (panel.getPanelPosition() === 'right') {
            tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
            tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
        }

        // Create DOM
        var infoPanel = document.createElement('div');
        infoPanel.className = 'bkgwebmap-infopanel ' + tooltipClass;

        var parser = new DOMParser();
        var infoPanelIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.INFO, 'text/xml');
        infoPanelIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons bkgwebmap-paneliconsopen');
        infoPanel.appendChild(infoPanelIcon.documentElement);

        var infoPanelTooltip = document.createElement('span');
        infoPanelTooltip.className = tooltipTextClass;
        infoPanelTooltip.innerHTML = title;
        infoPanel.appendChild(infoPanelTooltip);

        var infoPanelContent = document.createElement('div');
        var infoPanelContentClass = 'bkgwebmap-infopanelcontent';
        infoPanelContent.className = infoPanelContentClass + ' bkgwebmap-panelsinglecontent';

        panel.addPanelContent(infoPanelContent);

        function clickControl() {
            var activeContent = panel.getActiveContent();
            if (activeContent === '') {
                panel.openPanel();
                panel.changePanelContent(title, infoPanelContentClass);
                _this.activeIcon();
            } else if (activeContent === infoPanelContentClass) {
                panel.closePanel();
            } else {
                panel.changePanelContent(title, infoPanelContentClass);
                _this.activeIcon();
            }
        }

        this.activeIcon = function () {
            infoPanel.classList.add('bkgwebmap-panelactive');
        };

        // Event listeners
        infoPanel.addEventListener('click', clickControl, { passive: true });
        infoPanel.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            infoPanelTooltip.style.visibility = 'visible';
            setTimeout(function () {
                infoPanelTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: infoPanel,
            target: target
        });
    };
};

/**
 * Create LayerSwitcher Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_layerSwitcher}
 */
BKGWebMap.Control.createLayerSwitcher = function () {
    return function (map, controlName, options, panel) {
        var _this = this;

        var mapId = map.getTarget();
        var elementId = mapId;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        this.permaLinkActivated = false;

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
            elementId = target;
        } else {
            target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];
        }

        var changeOrder = BKGWebMap.CONTROLS.tools.layerSwitcher.changeOrder;
        if (typeof options.changeOrder === 'boolean') {
            changeOrder = options.changeOrder;
        }

        var changeVisibility = BKGWebMap.CONTROLS.tools.layerSwitcher.changeVisibility;
        if (typeof options.changeVisibility === 'boolean') {
            changeVisibility = options.changeVisibility;
        }

        var editStyle = BKGWebMap.CONTROLS.tools.layerSwitcher.editStyle;
        if (typeof options.editStyle === 'boolean') {
            editStyle = options.editStyle;
        }

        var showWMSLayers = BKGWebMap.CONTROLS.tools.layerSwitcher.showWMSLayers;
        if (typeof options.showWMSLayers === 'boolean') {
            showWMSLayers = options.showWMSLayers;
        }

        var openLevel = BKGWebMap.CONTROLS.tools.layerSwitcher.openLevel;
        if (typeof options.openLevel === 'number' && (options.openLevel === 0 || options.openLevel === 1 || options.openLevel === 2)) {
            openLevel = options.openLevel;
        }

        // Control title for panel
        var title = 'Layer';

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        // Tooltip position
        var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
        var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
        if (inPanel && panel.getPanelPosition() === 'right') {
            tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
            tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
        }

        // Create DOM
        var layerSwitcher = document.createElement('div');
        layerSwitcher.className = 'bkgwebmap-layerswitcher ' + tooltipClass + customClass;

        var parser = new DOMParser();
        var layerSwitcherIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.LAYERSWITCHER, 'text/xml');
        // layerSwitcherIcon.documentElement.id = 'bkgwebmap-layerswitchericon';
        if (inPanel) {
            layerSwitcherIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons bkgwebmap-paneliconsopen');
        } else {
            layerSwitcherIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons');
        }

        layerSwitcher.appendChild(layerSwitcherIcon.documentElement);

        var layerSwitcherTooltip = document.createElement('span');
        layerSwitcherTooltip.className = tooltipTextClass;
        layerSwitcherTooltip.innerHTML = title;
        layerSwitcher.appendChild(layerSwitcherTooltip);

        var layerSwitcherContent = document.createElement('div');
        var layerSwitcherContentClass = 'bkgwebmap-layerswitchercontent';
        layerSwitcherContent.className = layerSwitcherContentClass + ' bkgwebmap-panelsinglecontent';
        if (inPanel) {
            panel.addPanelContent(layerSwitcherContent);
        } else {
            layerSwitcher.appendChild(layerSwitcherContent);
            layerSwitcherContent.style.display = 'none';
        }

        // Update permalink
        function updatePermaLink() {
            if (!_this.permaLinkActivated) {
                return;
            }
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.Share && control instanceof BKGWebMap.Control.Share) {
                    if (Object.prototype.hasOwnProperty.call(control, 'permaLink') && Object.prototype.hasOwnProperty.call(control.permaLink, 'active')) {
                        control.permaLink.changeLayersInPermalink();
                    }
                }
            });
        }

        // Open or close layer menu
        function openCloseMain() {
            if (this.nextSibling.classList.contains('bkgwebmap-layercontentactive')) {
                this.nextSibling.classList.remove('bkgwebmap-layercontentactive');
                if (this.childNodes[1]) {
                    this.childNodes[1].innerHTML = '+';
                }
            } else {
                this.nextSibling.classList.add('bkgwebmap-layercontentactive');
                if (this.childNodes[1]) {
                    this.childNodes[1].innerHTML = '\u2212';
                }
            }
        }

        // Open or close layer div
        function openCloseLayer() {
            if (this.parentNode.parentNode.nextSibling.classList.contains('bkgwebmap-layercontentactive')) {
                this.parentNode.parentNode.nextSibling.classList.remove('bkgwebmap-layercontentactive');
            } else {
                this.parentNode.parentNode.nextSibling.classList.add('bkgwebmap-layercontentactive');
            }
        }

        // Open or close group div
        function openCloseGroup(headerwrapper, iconOpen, iconClosed, nodePosition, activeClass, sibling) {
            var parserGroupIconOpen = new DOMParser();
            var groupIconOpen = parserGroupIconOpen.parseFromString(BKGWebMap.PANEL_ICONS[iconOpen], 'text/xml');
            var parserGroupIconClosed = new DOMParser();
            var groupIconClosed = parserGroupIconClosed.parseFromString(BKGWebMap.PANEL_ICONS[iconClosed], 'text/xml');
            if (sibling.classList.contains(activeClass)) {
                sibling.classList.remove(activeClass);
                headerwrapper.childNodes[nodePosition].innerHTML = '';
                headerwrapper.childNodes[nodePosition].appendChild(groupIconClosed.documentElement);
            } else {
                sibling.classList.add(activeClass);
                headerwrapper.childNodes[nodePosition].innerHTML = '';
                headerwrapper.childNodes[nodePosition].appendChild(groupIconOpen.documentElement);
            }
        }

        // Set layer visibility (also update originalConfig, used for persistence json)
        function setVisible(layer, visible, newParamsWMS) {
            // Find if layer is part of a group
            var inGroup = false;
            var groupVisible = false;
            var element = document.getElementById(layer.getProperties().uniqueId);
            if (element && element.parentNode && element.parentNode.previousSibling && element.parentNode.previousSibling.classList.contains('bkgwebmap-layerswitchergroupheader')) {
                var groupElement = element.parentNode.previousSibling;
                if (groupElement.getElementsByClassName('bkgwebmap-layerheaderinput').length) {
                    inGroup = true;
                    groupVisible = groupElement.getElementsByClassName('bkgwebmap-layerheaderinput')[0].checked;
                }
            }
            layer.setVisible(visible);
            if (!newParamsWMS && layer.getProperties().originalConfig) {
                layer.getProperties().originalConfig.visibility = visible;
            }
            var definedVisibility;
            if ((typeof layer.getSource === 'function' && (layer.getSource() instanceof ol.source.ImageWMS || layer.getSource() instanceof ol.source.TileWMS)) && layer.getLayers().length && BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'originalConfig.layers')) {
                if (!visible && newParamsWMS != null) {
                    layer.getSource().updateParams({
                        LAYERS: newParamsWMS.LAYERS.join(),
                        STYLES: newParamsWMS.STYLES.join()
                    });
                }
                for (var i = 0; i < layer.getProperties().originalConfig.layers.length; i++) {
                    definedVisibility = false;
                    var k;
                    if (newParamsWMS === null && visible && (layer.getProperties().originalConfig.layers[i].visibility || layer.getProperties().originalConfig.layers[i].visibility === undefined)) {
                        var subLayerName = layer.getProperties().originalConfig.layers[i].layer;
                        if (document.getElementById(layer.get('uniqueId'))) {
                            var inputsSublayers = document.getElementById(layer.get('uniqueId')).querySelectorAll('[data-bkgwebmap-wmssublayer]');
                            for (k = 0; k < inputsSublayers.length; k++) {
                                if (inputsSublayers[k].getAttribute('data-bkgwebmap-wmssublayer') === subLayerName) {
                                    inputsSublayers[k].checked = true;
                                    var event = document.createEvent('HTMLEvents');
                                    event.initEvent('change', true, true);
                                    inputsSublayers[k].dispatchEvent(event);
                                }
                            }
                        }
                    } else if (newParamsWMS) {
                        for (k = 0; k < newParamsWMS.LAYERS.length; k++) {
                            if (layer.getProperties().originalConfig.layers[i].layer && layer.getProperties().originalConfig.layers[i].layer === newParamsWMS.LAYERS[k]) {
                                layer.getProperties().originalConfig.layers[i].visibility = true;
                                definedVisibility = true;
                                if (newParamsWMS.STYLES && newParamsWMS.STYLES[k] !== undefined) {
                                    layer.getProperties().originalConfig.layers[i].style = newParamsWMS.STYLES[k];
                                }
                            }
                            if (!definedVisibility) {
                                layer.getProperties().originalConfig.layers[i].visibility = false;
                            }
                        }
                    }
                }
            } else if (BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'originalConfig')) {
                layer.getProperties().originalConfig.visibility = visible;
            }

            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.Legend && control instanceof BKGWebMap.Control.Legend) {
                    control.changeLegend(layer, visible, newParamsWMS, inGroup, groupVisible);
                }
            });
            updatePermaLink();
        }

        // Add a new baselayer and remove the old one
        function addRemoveBaselayer(_this, layer) {
            var baselayerDivs = document.getElementById(elementId).getElementsByClassName('bkgwebmap-baselayerdivselected');
            var id;
            for (var i = 0; i < baselayerDivs.length; i++) {
                map.getLayers().forEach(function (singleLayer) {
                    id = singleLayer.get('uniqueId');
                    if (id === baselayerDivs[i].id) {
                        setVisible(singleLayer, false, null);
                    }
                });
                baselayerDivs[i].classList.remove('bkgwebmap-baselayerdivselected');
            }
            _this.classList.add('bkgwebmap-baselayerdivselected');
            setVisible(layer, true, null);
        }

        // Change icons color on hover
        function mouseEnterLayerIcons(_this) {
            _this.getElementsByTagName('path')[0].style.fill = '#000000';
        }

        function mouseLeaveLayerIcons(_this) {
            _this.getElementsByTagName('path')[0].style.fill = '#757D75';
        }

        // Zoom map to extent
        function zoomToExtent(layer) {
            if (layer.getVisible()) {
                if (layer.getSource() instanceof ol.source.Vector) {
                    if (layer.getSource().getExtent().indexOf(Infinity) !== -1 && layer.fullExtent) {
                        map.getView().fit(layer.fullExtent, { size: map.getSize() });
                        zoomToResolutionLimits(layer, layer.getSource().getExtent());
                    } else {
                        zoomToResolutionLimits(layer, layer.getSource().getExtent());
                    }
                } else if (layer.extent && layer.extent instanceof Array) {
                    zoomToResolutionLimits(layer, layer.extent);
                }
            }
        }

        function zoomToResolutionLimits(layer, extent) {
            var zoom;
            if (layer.getMaxResolution() && typeof layer.getMaxResolution() === 'number' && layer.getMaxResolution() !== Infinity) {
                zoom = Math.ceil(map.getView().getZoomForResolution(layer.getMaxResolution()) * 10) / 10;
                map.getView().fit(extent, { size: map.getSize() });
                map.getView().setZoom(zoom);
            } else {
                map.getView().fit(extent, { size: map.getSize() });
            }
        }


        // Create div for opacity control
        function createOpacityDiv(layer) {
            // Opacity
            var opacityDiv = document.createElement('div');
            opacityDiv.className = 'bkgwebmap-opacitysliderdiv';
            var opacityTitle = document.createTextNode('Transparenz: ');
            var opacityValue = document.createElement('span');
            var opacityBreak = document.createElement('br');
            var opacityInput = document.createElement('input');
            opacityInput.className = 'bkgwebmap-opacityslider';
            opacityInput.setAttribute('type', 'range');
            opacityInput.setAttribute('min', '0');
            opacityInput.setAttribute('max', '1');
            opacityInput.setAttribute('step', '0.1');

            opacityDiv.appendChild(opacityTitle);
            opacityDiv.appendChild(opacityValue);
            opacityDiv.appendChild(opacityBreak);
            opacityDiv.appendChild(opacityInput);

            var currentOpacity = layer.getOpacity();
            opacityInput.value = currentOpacity;
            opacityValue.innerHTML = currentOpacity;

            opacityInput.addEventListener('input', function () {
                currentOpacity = opacityInput.value;
                layer.setOpacity(currentOpacity);
                opacityValue.innerHTML = currentOpacity;
            }, { passive: true });
            // For IE
            opacityInput.addEventListener('change', function () {
                currentOpacity = opacityInput.value;
                layer.setOpacity(currentOpacity);
                opacityValue.innerHTML = currentOpacity;
            }, { passive: true });

            return opacityDiv;
        }

        // Show tooltip on hover and hide all other
        function showHideTooltips(tooltip) {
            var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-layertooltip');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }

            tooltip.style.visibility = 'visible';
            setTimeout(function () {
                tooltip.style.visibility = '';
            }, 1200);
        }

        // Create div for change style control
        function createChangeStyleDiv(layer) {
            var changeStyleDiv = document.createElement('div');
            changeStyleDiv.className = 'bkgwebmap-changestylediv';

            var changeStyleTitleDiv = document.createElement('div');
            changeStyleTitleDiv.innerHTML = 'Symbolisierung:';
            changeStyleDiv.appendChild(changeStyleTitleDiv);

            var changeStyleColorsDiv = document.createElement('div');
            changeStyleColorsDiv.className = 'bkgwebmap-changestylecolorsdiv';
            changeStyleDiv.appendChild(changeStyleColorsDiv);

            var colorsArray = BKGWebMap.MAP_ICONS_COLORS;
            var strokeColor = layer.getStyle().getStroke().getColor();
            var geometryType = BKGWebMap.Util.findGeometryType(layer.getSource().getFeatures());
            for (var i = 0; i < colorsArray.length; i++) {
                var colorDiv = document.createElement('div');
                colorDiv.className = 'bkgwebmap-changestylecolorcheckbox';
                colorDiv.setAttribute('data-bkgwebmap-colorcheckbox', colorsArray[i]);
                colorDiv.setAttribute('data-bkgwebmap-bordercolorcheckbox', strokeColor);

                var iconSvgString;
                if (geometryType.indexOf('Polygon') !== -1) {
                    iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.a + colorsArray[i] + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.c + strokeColor + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.d;
                } else {
                    iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.a + colorsArray[i] + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.b;
                }
                var parserIconColorNotSelected = new DOMParser();
                var iconColorNotSelected = parserIconColorNotSelected.parseFromString(iconSvgString, 'text/xml');
                colorDiv.appendChild(iconColorNotSelected.documentElement);
                changeStyleColorsDiv.appendChild(colorDiv);

                // Change color
                colorDiv.querySelector('svg').addEventListener('click', function () {
                    changeColor(this, layer, changeStyleColorsDiv);
                });
            }

            var changeStyleSymbolDiv = document.createElement('div');
            changeStyleSymbolDiv.className = 'bkgwebmap-changestylesymboldiv';

            if (geometryType.indexOf('Point') !== -1) {
                changeStyleDiv.appendChild(changeStyleSymbolDiv);
            }

            layer.getSource().on('change', function () {
                var styleCheckboxes;
                var i;
                if (layer.getSource().getState() === 'ready') {
                    geometryType = BKGWebMap.Util.findGeometryType(layer.getSource().getFeatures());

                    if (geometryType.indexOf('Point') !== -1) {
                        changeStyleDiv.appendChild(changeStyleSymbolDiv);
                    } else if (geometryType.indexOf('Polygon') !== -1) {
                        styleCheckboxes = changeStyleDiv.getElementsByClassName('bkgwebmap-changestylecolorcheckbox');
                        for (i = 0; i < styleCheckboxes.length; i++) {
                            styleCheckboxes[i].innerHTML = '';
                            var strokeColor = styleCheckboxes[i].getAttribute('data-bkgwebmap-bordercolorcheckbox');
                            var fillColor = styleCheckboxes[i].getAttribute('data-bkgwebmap-colorcheckbox');
                            var iconSvgString;
                            if (styleCheckboxes[i].classList.contains('selected')) {
                                iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.a + fillColor + BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.c + strokeColor + BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.d;
                            } else {
                                iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.a + fillColor + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.c + strokeColor + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.d;
                            }
                            var parserIconColorNotSelected = new DOMParser();
                            var iconColorNotSelected = parserIconColorNotSelected.parseFromString(iconSvgString, 'text/xml');
                            styleCheckboxes[i].appendChild(iconColorNotSelected.documentElement);
                            // Change color
                            styleCheckboxes[i].querySelector('svg').addEventListener('click', function () {
                                changeColor(this, layer, changeStyleColorsDiv);
                            });
                        }
                    } else if (geometryType.indexOf('LineString') !== -1) {
                        styleCheckboxes = changeStyleDiv.getElementsByClassName('bkgwebmap-changestylecolorcheckbox');
                        for (i = 0; i < styleCheckboxes.length; i++) {
                            if (styleCheckboxes[i].classList.contains('selected')) {
                                changeColor(styleCheckboxes[i].getElementsByTagName('svg')[0], layer, styleCheckboxes[i].parentNode);
                            }
                        }
                    }
                }
            });

            var symbols = BKGWebMap.MAP_ICONS;
            for (var symbol in symbols) {
                var symbolDiv = document.createElement('div');
                symbolDiv.className = 'bkgwebmap-changestylesymbol';
                symbolDiv.setAttribute('data-bkgwebmap-stylesymbol', symbol);
                var symbolSvgString = BKGWebMap.MAP_ICONS[symbol].a + colorsArray[0] + BKGWebMap.MAP_ICONS[symbol].b + colorsArray[0] + BKGWebMap.MAP_ICONS[symbol].c;
                var parserSymbolSvg = new DOMParser();
                var symbolSvg = parserSymbolSvg.parseFromString(symbolSvgString, 'text/xml');
                symbolDiv.appendChild(symbolSvg.documentElement);
                changeStyleSymbolDiv.appendChild(symbolDiv);

                // Change symbol
                symbolDiv.querySelector('svg').addEventListener('click', function () {
                    changeSymbol(this, layer, changeStyleSymbolDiv);
                });
            }

            return changeStyleDiv;
        }

        // Change color of vector layer
        function changeColor(svg, layer, changeStyleColorsDiv) {
            var newStyle;
            var color = svg.parentNode.getAttribute('data-bkgwebmap-colorcheckbox');
            var strokeColorDefault = svg.parentNode.getAttribute('data-bkgwebmap-bordercolorcheckbox');
            var style = layer.getStyle();
            var strokeColor;
            var anchor;
            var geometryType = BKGWebMap.Util.findGeometryType(layer.getSource().getFeatures());
            svg.parentNode.classList.add('selected');
            if (typeof style === 'function') {
                if (geometryType.indexOf('LineString') !== -1) {
                    strokeColor = color;
                } else {
                    strokeColor = strokeColorDefault;
                }
                anchor = [0.5, 1];
                var svgColor = BKGWebMap.Style.svgColor(color);
                var newSymbol = BKGWebMap.MAP_ICONS_ENCODED.circle.a + svgColor + BKGWebMap.MAP_ICONS_ENCODED.circle.b + '%23FFFFFF' + BKGWebMap.MAP_ICONS_ENCODED.circle.c;
                newStyle = new ol.style.Style({
                    fill: new ol.style.Fill({
                        color: color
                    }),
                    stroke: new ol.style.Stroke({
                        color: strokeColor,
                        width: 1
                    }),
                    image: new ol.style.Icon(({
                        anchor: anchor,
                        anchorXUnits: 'fraction',
                        anchorYUnits: 'fraction',
                        imgSize: BKGWebMap.MAP_ICONS_ENCODED.circle.size,
                        src: 'data:image/svg+xml;charset=utf8,' + newSymbol
                    }))
                });
                newStyle.getImage().anchor = anchor;
                layer.setStyle(newStyle);
            } else {
                strokeColor = color;
                // Fill
                if (typeof style.getFill === 'function' && style.getFill() !== null && typeof style.getFill().setColor === 'function') {
                    style.getFill().setColor(color);
                    if (geometryType.indexOf('LineString') !== -1) {
                        style.getStroke().setColor(color);
                    } else {
                        style.getStroke().setColor(strokeColorDefault);
                    }
                }

                // Stroke (only for lines)
                if ((geometryType.indexOf('LineString') !== -1) && (typeof style.getStroke === 'function' && style.getStroke() !== null && typeof style.getStroke().setColor === 'function')) {
                    style.getStroke().setColor(color);
                } else {
                    style.getStroke().setColor(strokeColorDefault);
                }

                // Circle
                if (typeof style.getImage === 'function' && style.getImage() && typeof style.getImage().getFill === 'function') {
                    style.getImage().getFill().setColor(color);
                    var radius = style.getImage().getRadius();
                    style.getImage().setRadius(radius + 1);
                    style.getImage().setRadius(radius);
                }

                // Icon
                if (typeof style.getImage === 'function' && style.getImage() instanceof ol.style.Icon) {
                    var src = style.getImage().getSrc();
                    var size = layer.getStyle().getImage().getSize();

                    anchor = layer.getStyle().getImage().getAnchor();
                    var units = 'pixels';
                    if (!anchor) {
                        anchor = layer.getStyle().getImage().anchor;
                        units = 'fraction';
                    }

                    var oldColor = src.substring(src.indexOf('fill%3A') + 7, src.indexOf('%3Bfill-opacity%3A'));
                    src = src.replace('fill%3A' + oldColor, 'fill%3A' + BKGWebMap.Style.svgColor(color));

                    if (geometryType.indexOf('LineString') !== -1) {
                        strokeColor = color;
                    } else {
                        strokeColor = strokeColorDefault;
                    }

                    newStyle = new ol.style.Style({
                        fill: new ol.style.Fill({
                            color: color
                        }),
                        stroke: new ol.style.Stroke({
                            color: strokeColor,
                            width: 1
                        }),
                        image: new ol.style.Icon(({
                            anchor: anchor,
                            anchorXUnits: units,
                            anchorYUnits: units,
                            imgSize: size,
                            src: src
                        }))
                    });
                    if (units === 'fraction') {
                        newStyle.getImage().anchor = anchor;
                    }
                    layer.setStyle(newStyle);
                }
            }
            layer.changed();

            showColorSelection(svg, layer, changeStyleColorsDiv);
        }

        // Change color icons in menu when selecting a new color
        function showColorSelection(selectedColorIcon, layer, changeStyleColorsDiv) {
            var selectedColor = selectedColorIcon.parentNode.getAttribute('data-bkgwebmap-colorcheckbox');
            var colorDivs = changeStyleColorsDiv.getElementsByClassName('bkgwebmap-changestylecolorcheckbox');
            var strokeColor = selectedColorIcon.parentNode.getAttribute('data-bkgwebmap-bordercolorcheckbox');
            var geometryType = BKGWebMap.Util.findGeometryType(layer.getSource().getFeatures());
            var color;
            var iconSvgString;
            var parserIcon;
            var icon;
            for (var i = 0; i < colorDivs.length; i++) {
                color = colorDivs[i].getAttribute('data-bkgwebmap-colorcheckbox');
                colorDivs[i].innerHTML = '';
                if (color === selectedColor) {
                    if (geometryType.indexOf('Polygon') !== -1) {
                        iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.a + color + BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.c + strokeColor + BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.d;
                    } else {
                        iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.a + color + BKGWebMap.PANEL_ICONS.CHECKBOX_SELECTED.b;
                    }
                } else if (geometryType.indexOf('Polygon') !== -1) {
                    iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.a + color + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.c + strokeColor + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.d;
                } else {
                    iconSvgString = BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.a + color + BKGWebMap.PANEL_ICONS.CHECKBOX_UNSELECTED.b;
                }
                parserIcon = new DOMParser();
                icon = parserIcon.parseFromString(iconSvgString, 'text/xml');
                colorDivs[i].appendChild(icon.documentElement);

                colorDivs[i].querySelector('svg').addEventListener('click', function () {
                    changeColor(this, layer, changeStyleColorsDiv);
                });
            }
        }

        // Change symbol icon when selecting a new symbol
        function changeSymbol(svg, layer, changeStyleSymbolDiv) {
            var style = layer.getStyle();
            var symbolName = svg.parentNode.getAttribute('data-bkgwebmap-stylesymbol');
            var colorFill;
            var colorStroke;
            var anchor;
            var newSymbol;
            var newStyle;

            if (typeof style === 'function') {
                colorFill = style.call()[0].getFill().getColor();
                colorStroke = style.call()[0].getStroke().getColor();

                anchor = [0.5, 0.5];
                if (symbolName === 'marker') {
                    anchor = [0.5, 1];
                }

                var svgColorFill = BKGWebMap.Style.svgColor(colorFill);
                var svgColorStroke = BKGWebMap.Style.svgColor(colorStroke);
                newSymbol = BKGWebMap.MAP_ICONS_ENCODED[symbolName].a + svgColorFill + BKGWebMap.MAP_ICONS_ENCODED[symbolName].b + svgColorStroke + BKGWebMap.MAP_ICONS_ENCODED[symbolName].c;

                newStyle = new ol.style.Style({
                    fill: new ol.style.Fill({
                        color: colorFill
                    }),
                    stroke: new ol.style.Stroke({
                        color: colorStroke,
                        width: 1
                    }),
                    image: new ol.style.Icon(({
                        anchor: anchor,
                        anchorXUnits: 'fraction',
                        anchorYUnits: 'fraction',
                        imgSize: BKGWebMap.MAP_ICONS_ENCODED[symbolName].size,
                        src: 'data:image/svg+xml;charset=utf8,' + newSymbol
                    }))
                });
                newStyle.getImage().anchor = anchor;
                layer.setStyle(newStyle);
            }
            // Fill
            if (typeof style.getFill === 'function' && style.getFill() !== null && typeof style.getFill().setColor === 'function') {
                colorFill = style.getFill().getColor();
            }

            // Stroke
            if (typeof style.getStroke === 'function' && style.getStroke() !== null && typeof style.getStroke().setColor === 'function') {
                colorStroke = style.getStroke().getColor();
            }

            // Icon
            if (typeof style.getImage === 'function' && style.getImage() instanceof ol.style.Icon) {
                var src = style.getImage().getSrc();
                anchor = [0.5, 0.5];
                if (symbolName === 'marker') {
                    anchor = [0.5, 1];
                }
                var svgColor = src.substring(src.indexOf('fill%3A') + 7, src.indexOf('%3Bfill-opacity%3A'));
                var svgStrokeColor = src.substring(src.indexOf('stroke%3A') + 9, src.indexOf('%3Bstroke-width%3A'));

                newSymbol = BKGWebMap.MAP_ICONS_ENCODED[symbolName].a + svgColor + BKGWebMap.MAP_ICONS_ENCODED[symbolName].b + svgStrokeColor + BKGWebMap.MAP_ICONS_ENCODED[symbolName].c;

                newStyle = new ol.style.Style({
                    fill: new ol.style.Fill({
                        color: colorFill
                    }),
                    stroke: new ol.style.Stroke({
                        color: colorStroke,
                        width: 1
                    }),
                    image: new ol.style.Icon(({
                        anchor: anchor,
                        anchorXUnits: 'fraction',
                        anchorYUnits: 'fraction',
                        imgSize: BKGWebMap.MAP_ICONS_ENCODED[symbolName].size,
                        src: 'data:image/svg+xml;charset=utf8,' + newSymbol
                    }))
                });
                newStyle.getImage().anchor = anchor;
                layer.setStyle(newStyle);
            }
            layer.changed();

            showSymbolSelection(svg, layer, changeStyleSymbolDiv);
        }


        function showSymbolSelection(selectedSymbolIcon, layer, changeStyleSymbolDiv) {
            var selectedSymbol = selectedSymbolIcon.parentNode.getAttribute('data-bkgwebmap-stylesymbol');
            var symbolDivs = changeStyleSymbolDiv.getElementsByClassName('bkgwebmap-changestylesymbol');
            var symbol;
            var colorDefault = '#407E40';
            var colorSelect = '#FF0000';
            var iconSvgString;
            var parserIcon;
            var icon;
            for (var i = 0; i < symbolDivs.length; i++) {
                symbol = symbolDivs[i].getAttribute('data-bkgwebmap-stylesymbol');
                symbolDivs[i].innerHTML = '';
                if (symbol === selectedSymbol) {
                    iconSvgString = BKGWebMap.MAP_ICONS[symbol].a + colorSelect + BKGWebMap.MAP_ICONS[symbol].b + colorSelect + BKGWebMap.MAP_ICONS[symbol].c;
                } else {
                    iconSvgString = BKGWebMap.MAP_ICONS[symbol].a + colorDefault + BKGWebMap.MAP_ICONS[symbol].b + colorDefault + BKGWebMap.MAP_ICONS[symbol].c;
                }
                parserIcon = new DOMParser();
                icon = parserIcon.parseFromString(iconSvgString, 'text/xml');
                symbolDivs[i].appendChild(icon.documentElement);

                symbolDivs[i].querySelector('svg').addEventListener('click', function () {
                    changeSymbol(this, layer, changeStyleSymbolDiv);
                });
            }
        }

        // Reload WMS after selecting a layer or changing style
        function reloadWms(layerId) {
            var subLayerNodes = document.getElementById(layerId).querySelectorAll('[data-bkgwebmap-wmssublayer]');
            var inputLayerVisibility = document.getElementById(layerId + 'title').getElementsByClassName('bkgwebmap-layerheaderinput')[0];
            var subLayersToLoad = [];
            var subLayersToSetVisible = [];
            var subLayerName;
            var stylesToLoad = [];
            var stylesToSetVisible = [];
            var id;
            var resolutionLimitsWMS;
            var mapResolution;
            var checkLayerMinResolution;
            var checkLayerMaxResolution;
            var event;
            var newParams;
            for (var i = 0; i < subLayerNodes.length; i++) {
                subLayerName = subLayerNodes[i].getAttribute('data-bkgwebmap-wmssublayer');
                resolutionLimitsWMS = false;
                mapResolution = map.getView().getResolution();
                map.getLayers().forEach(function (layer) {
                    if (layer instanceof ol.layer.Group) {
                        layer.getLayers().forEach(function (grouplayer) {
                            if ((grouplayer.getSource() instanceof ol.source.ImageWMS || grouplayer.getSource() instanceof ol.source.TileWMS) && grouplayer.get('uniqueId') === layerId) {
                                grouplayer.getLayers().forEach(function (singleLayer) {
                                    if (singleLayer.layer === subLayerName) {
                                        checkLayerMinResolution = !((singleLayer.minResolution && mapResolution < singleLayer.minResolution));
                                        checkLayerMaxResolution = !((singleLayer.maxResolution && mapResolution > singleLayer.maxResolution));
                                        resolutionLimitsWMS = !((checkLayerMinResolution && checkLayerMaxResolution));
                                    }
                                });
                            }
                        });
                    } else if ((layer.getSource() instanceof ol.source.ImageWMS || layer.getSource() instanceof ol.source.TileWMS) && layer.get('uniqueId') === layerId) {
                        layer.getLayers().forEach(function (singleLayer) {
                            if (singleLayer.layer === subLayerName) {
                                checkLayerMinResolution = !((singleLayer.minResolution && mapResolution < singleLayer.minResolution));
                                checkLayerMaxResolution = !((singleLayer.maxResolution && mapResolution > singleLayer.maxResolution));
                                resolutionLimitsWMS = !((checkLayerMinResolution && checkLayerMaxResolution));
                            }
                        });
                    }
                });
                if (subLayerNodes[i].checked && !resolutionLimitsWMS && inputLayerVisibility.checked) {
                    subLayersToLoad.push(subLayerName);
                    if (subLayerNodes[i].parentNode.parentNode.parentNode.querySelectorAll('[data-bkgwebmap-wmssublayerstyle]').length) {
                        stylesToLoad.push(subLayerNodes[i].parentNode.parentNode.parentNode.querySelectorAll('[data-bkgwebmap-wmssublayerstyle]')[0].value);
                    } else if (subLayerNodes[i].getAttribute('data-bkgwebmap-defaultstyle')) {
                        stylesToLoad.push(subLayerNodes[i].getAttribute('data-bkgwebmap-defaultstyle'));
                    } else {
                        stylesToLoad.push('');
                    }
                    // If the sublayer not visible on this resolution, just change visibility in original config
                } else if (subLayerNodes[i].checked) {
                    subLayersToSetVisible.push(subLayerName);
                    if (subLayerNodes[i].parentNode.parentNode.parentNode.querySelectorAll('[data-bkgwebmap-wmssublayerstyle]').length) {
                        stylesToSetVisible.push(subLayerNodes[i].parentNode.parentNode.parentNode.querySelectorAll('[data-bkgwebmap-wmssublayerstyle]')[0].value);
                    } else if (subLayerNodes[i].getAttribute('data-bkgwebmap-defaultstyle')) {
                        stylesToSetVisible.push(subLayerNodes[i].getAttribute('data-bkgwebmap-defaultstyle'));
                    } else {
                        stylesToSetVisible.push('');
                    }
                }
            }
            if (!subLayersToLoad.length && !subLayersToSetVisible.length) {
                inputLayerVisibility.checked = false;
                event = document.createEvent('HTMLEvents');
                event.initEvent('change', false, true);
                inputLayerVisibility.dispatchEvent(event);
            }
            map.getLayers().forEach(function (singleLayer) {
                if (singleLayer instanceof ol.layer.Group) {
                    singleLayer.getLayers().forEach(function (singleLayerInGroup) {
                        id = singleLayerInGroup.get('uniqueId');
                        if (id === layerId) {
                            _this.ajaxLoader(singleLayer);
                            if (subLayersToLoad.length) {
                                newParams = { LAYERS: subLayersToLoad, STYLES: stylesToLoad };
                                singleLayerInGroup.getSource().updateParams({
                                    LAYERS: subLayersToLoad.join(),
                                    STYLES: stylesToLoad.join()
                                });
                                if (subLayersToSetVisible.length) {
                                    newParams.LAYERS = subLayersToLoad.concat(subLayersToSetVisible);
                                    newParams.STYLES = stylesToLoad.concat(stylesToSetVisible);
                                }
                                setVisible(singleLayerInGroup, true, newParams);
                            } else if (subLayersToSetVisible.length) {
                                newParams = {};
                                singleLayerInGroup.getSource().updateParams({
                                    LAYERS: '',
                                    STYLES: ''
                                });
                                if (subLayersToSetVisible.length) {
                                    newParams.LAYERS = subLayersToSetVisible;
                                    newParams.STYLES = stylesToSetVisible;
                                }
                                setVisible(singleLayerInGroup, false, newParams);
                            } else {
                                setVisible(singleLayerInGroup, false, null);
                            }
                        }
                    });
                } else {
                    id = singleLayer.get('uniqueId');
                    if (id === layerId) {
                        if (subLayersToLoad.length) {
                            newParams = { LAYERS: subLayersToLoad, STYLES: stylesToLoad };
                            singleLayer.getSource().updateParams({
                                LAYERS: subLayersToLoad.join(),
                                STYLES: stylesToLoad.join()
                            });
                            if (subLayersToSetVisible.length) {
                                newParams.LAYERS = subLayersToLoad.concat(subLayersToSetVisible);
                                newParams.STYLES = stylesToLoad.concat(stylesToSetVisible);
                            }
                            setVisible(singleLayer, true, newParams);
                        } else if (subLayersToSetVisible.length) {
                            newParams = {};
                            singleLayer.getSource().updateParams({
                                LAYERS: '',
                                STYLES: ''
                            });
                            if (subLayersToSetVisible.length) {
                                newParams.LAYERS = subLayersToLoad.concat(subLayersToSetVisible);
                                newParams.STYLES = stylesToLoad.concat(stylesToSetVisible);
                            }
                            setVisible(singleLayer, false, newParams);
                        } else {
                            setVisible(singleLayer, false, null);
                        }
                    }
                }
            });
        }

        // Create dropdown menu for selecting WMS style
        function createStyleDropdown(layerUniqueId, subLayer, subLayerStyles) {
            var dropdownDiv = document.createElement('div');
            var styleTitle = document.createTextNode('Stil: ');
            var dropdown = document.createElement('select');
            dropdown.setAttribute('data-bkgwebmap-wmslayerid', layerUniqueId);
            dropdown.setAttribute('data-bkgwebmap-wmssublayerstyle', subLayer.layer);
            var createDom = false;
            for (var layerName in subLayerStyles) {
                if (Object.prototype.hasOwnProperty.call(subLayerStyles, layerName) && layerName === subLayer.layer) {
                    if (subLayerStyles[layerName].length <= 1) {
                        return undefined;
                    }
                    for (var i = 0; i < subLayerStyles[layerName].length; i++) {
                        var option = document.createElement('option');
                        option.setAttribute('value', subLayerStyles[layerName][i].Name);
                        if (subLayer.style && subLayer.style === subLayerStyles[layerName][i].Name) {
                            option.setAttribute('selected', 'selected');
                        }
                        if (subLayerStyles[layerName][i].Title === '' || subLayerStyles[layerName][i].Title === undefined) {
                            option.innerHTML = subLayerStyles[layerName][i].Name;
                        } else {
                            option.innerHTML = subLayerStyles[layerName][i].Title;
                        }
                        dropdown.appendChild(option);
                        createDom = true;
                    }
                }
            }
            dropdown.onchange = function () {
                var layerId = this.getAttribute('data-bkgwebmap-wmslayerid');
                reloadWms(layerId);
            };
            if (!createDom) {
                return undefined;
            }

            dropdownDiv.appendChild(styleTitle);
            dropdownDiv.appendChild(dropdown);
            return dropdownDiv;
        }

        // Remove a layer from the layer switcher
        function removeLayer() {
            var layerId = this.getAttribute('data-bkgwebmap-layer-unique-id');
            var currentLayerId;
            map.getLayers().forEach(function (layer) {
                currentLayerId = layer.getProperties().uniqueId;
                if (layer.getProperties().customLayer && currentLayerId === layerId) {
                    map.removeLayer(layer);
                    document.getElementById(currentLayerId).remove();

                    map.getControls().forEach(function (control) {
                        if (BKGWebMap.Control.Legend && control instanceof BKGWebMap.Control.Legend) {
                            control.removeLayerFromLegend(layer);
                        }
                        if (BKGWebMap.Control.Copyright && control instanceof BKGWebMap.Control.Copyright) {
                            control.removeLayerFromCopyright();
                        }
                    });
                }
            });
        }

        // Create div to remove a layer
        function createRemoveLayerDiv(layer) {
            var removeLayerDiv = document.createElement('div');
            removeLayerDiv.className = 'bkgwebmap-removelayer bkgwebmap-paneltooltip';
            var parserRemoveLayerDivIcon = new DOMParser();
            var removeLayerDivIcon = parserRemoveLayerDivIcon.parseFromString(BKGWebMap.PANEL_ICONS.TRASH, 'text/xml');
            removeLayerDiv.appendChild(removeLayerDivIcon.documentElement);
            var removeLayerDivTooltip = document.createElement('span');
            removeLayerDivTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-removelayertooltip';
            removeLayerDivTooltip.innerHTML = 'Layer entfernen';
            removeLayerDiv.appendChild(removeLayerDivTooltip);
            var layerId = layer.getProperties().uniqueId;

            removeLayerDiv.setAttribute('data-bkgwebmap-layer-unique-id', layerId);
            removeLayerDiv.addEventListener('click', removeLayer);
            removeLayerDiv.addEventListener('mouseenter', function () {
                showHideTooltips(removeLayerDivTooltip);
            });

            return removeLayerDiv;
        }

        // Create divs for WMS layers
        function createWmsSubLayerDiv(layer, subLayer) {
            var subLayerStyles = layer.getStyleInfo();
            var layerUniqueId = layer.getProperties().uniqueId;
            var defaultStyle = '';
            if (subLayer.style !== undefined && subLayer.style !== null) {
                defaultStyle = subLayer.style;
            }
            var wmsSubLayerDiv = document.createElement('div');
            wmsSubLayerDiv.className = 'bkgwebmap-wmssublayerdiv';

            var inputDiv = document.createElement('div');
            inputDiv.className = 'bkgwebmap-layerheaderwmsinputdiv';
            wmsSubLayerDiv.appendChild(inputDiv);

            var inputLabel = document.createElement('label');
            var parserIconEmpty = new DOMParser();
            var clickIconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
            var parserIconFull = new DOMParser();
            var clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
            inputDiv.appendChild(inputLabel);

            var input = document.createElement('input');
            input.setAttribute('type', 'checkbox');
            input.setAttribute('data-bkgwebmap-wmssublayer', subLayer.layer);
            input.setAttribute('data-bkgwebmap-wmslayerid', layerUniqueId);
            input.setAttribute('data-bkgwebmap-defaultstyle', defaultStyle);
            inputLabel.appendChild(input);

            var visible = BKGWebMap.LAYERS.WMS.VISIBLE;
            if (Object.prototype.hasOwnProperty.call(subLayer, 'visibility')) {
                visible = subLayer.visibility;
            }

            var clickIcon = clickIconEmpty;
            if (visible) {
                clickIcon = clickIconFull;
            }
            inputLabel.appendChild(clickIcon.documentElement);

            input.checked = visible;
            input.onchange = function () {
                var label = this.parentNode;
                label.removeChild(label.childNodes[1]);
                parserIconEmpty = new DOMParser();
                clickIconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                parserIconFull = new DOMParser();
                clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                if (this.checked) {
                    label.appendChild(clickIconFull.documentElement);
                } else {
                    label.appendChild(clickIconEmpty.documentElement);
                }
                var layerId = this.getAttribute('data-bkgwebmap-wmslayerid');
                reloadWms(layerId);
            };

            var layerTitle = document.createElement('div');
            layerTitle.className = 'bkgwebmap-layerheaderwmstitle';
            if (subLayer.name) {
                layerTitle.innerHTML = subLayer.name;
            } else {
                layerTitle.innerHTML = subLayer.layer;
            }
            wmsSubLayerDiv.appendChild(layerTitle);

            if (subLayer.selectStyle && subLayerStyles) {
                var dropdownDom = createStyleDropdown(layerUniqueId, subLayer, subLayerStyles);
                if (dropdownDom) {
                    wmsSubLayerDiv.appendChild(dropdownDom);
                }
            }
            return wmsSubLayerDiv;
        }

        // Create divs for WMS service
        function createWmsLayersDiv(layer, subLayers) {
            var wmsLayersDiv = document.createElement('div');
            wmsLayersDiv.className = 'bkgwebmap-wmslayersdiv';

            for (var i = 0; i < subLayers.length; i++) {
                wmsLayersDiv.appendChild(createWmsSubLayerDiv(layer, subLayers[i]));
            }

            return wmsLayersDiv;
        }

        // Change layer order using arrows
        function changeLayerOrder(_this, delta) {
            var div = _this.parentNode.parentNode.parentNode;
            var parentDiv = div.parentNode;
            var divToOverpass;
            if (delta === 1) {
                divToOverpass = div.previousSibling;
                parentDiv.insertBefore(div, divToOverpass);
            } else if (delta === -1) {
                divToOverpass = div.nextSibling.nextSibling;
                parentDiv.insertBefore(div, divToOverpass);
            }
            var layer;
            var id = div.id;
            var index;
            var i;
            var layersArray = map.getLayers().getArray();
            if (_this.hasAttribute('data-bkgwebmap-group')) {
                var groupId = _this.getAttribute('data-bkgwebmap-group');
                for (i = 0; i < layersArray.length; i++) {
                    if (groupId === layersArray[i].getProperties().uniqueId) {
                        var groupLayer = layersArray[i];
                        var groupLayerArray = groupLayer.getLayers().getArray();
                        for (var k = 0; k < groupLayerArray.length; k++) {
                            if (id === groupLayerArray[k].getProperties().uniqueId) {
                                index = k;
                            }
                        }
                        layer = groupLayer.getLayers().removeAt(index);
                        groupLayer.getLayers().insertAt(index + delta, layer);
                    }
                }
            } else {
                for (i = 0; i < layersArray.length; i++) {
                    if (id === layersArray[i].getProperties().uniqueId) {
                        index = i;
                    }
                }
                layer = map.getLayers().removeAt(index);
                map.getLayers().insertAt(index + delta, layer);
            }
            showHideArrows();

            // Update permalink
            updatePermaLink();
        }

        // Show or hide arrows to change layer order
        function showHideArrows() {
            var i;
            // Show all arrows
            var arrowsDown = document.getElementById(elementId).getElementsByClassName('bkgwebmap-layerheaderdownwrapper');
            for (i = 0; i < arrowsDown.length; i++) {
                arrowsDown[i].style.display = 'table-cell';
            }
            var arrowsUp = document.getElementById(elementId).getElementsByClassName('bkgwebmap-layerheaderupwrapper');
            for (i = 0; i < arrowsUp.length; i++) {
                arrowsUp[i].style.display = 'table-cell';
            }

            // Hide first-last of layers
            var layers = document.getElementById(elementId).getElementsByClassName('bkgwebmap-overlayscontent')[0];
            if (layers && layers.childElementCount) {
                layers.childNodes[0].getElementsByClassName('bkgwebmap-layerheaderupwrapper')[0].style.display = 'none';
                layers.childNodes[layers.childElementCount - 1].getElementsByClassName('bkgwebmap-layerheaderdownwrapper')[0].style.display = 'none';
            }

            // Hide first-last in groups
            var groups = document.getElementById(elementId).getElementsByClassName('bkgwebmap-layerswitchergroupheader');
            for (i = 0; i < groups.length; i++) {
                var layersCount = groups[i].parentNode.childNodes[1].childElementCount;
                if (layersCount) {
                    groups[i].parentNode.childNodes[1].getElementsByClassName('bkgwebmap-layerheaderupwrapper')[0].style.display = 'none';
                    groups[i].parentNode.childNodes[1].getElementsByClassName('bkgwebmap-layerheaderdownwrapper')[layersCount - 1].style.display = 'none';
                }
            }
        }

        // Create arrows to change layer order
        function createLayerUpDownDom(layerDivHeader, groupLayerId) {
            var layerDown = document.createElement('div');
            layerDown.className = 'bkgwebmap-layerheaderdown';
            if (groupLayerId) {
                layerDown.setAttribute('data-bkgwebmap-group', groupLayerId);
            }
            var parserLayerDown = new DOMParser();
            var layerDownIcon = parserLayerDown.parseFromString(BKGWebMap.PANEL_ICONS.ARROW_DOWN, 'text/xml');
            layerDown.appendChild(layerDownIcon.documentElement);
            var layerDownWrapper = document.createElement('div');
            layerDownWrapper.className = 'bkgwebmap-layerheaderdownwrapper';
            layerDownWrapper.appendChild(layerDown);
            layerDivHeader.appendChild(layerDownWrapper);

            var layerUp = document.createElement('div');
            layerUp.className = 'bkgwebmap-layerheaderup';
            if (groupLayerId) {
                layerUp.setAttribute('data-bkgwebmap-group', groupLayerId);
            }
            var parserLayerUp = new DOMParser();
            var layerUpIcon = parserLayerUp.parseFromString(BKGWebMap.PANEL_ICONS.ARROW_UP, 'text/xml');
            layerUp.appendChild(layerUpIcon.documentElement);
            var layerUpWrapper = document.createElement('div');
            layerUpWrapper.className = 'bkgwebmap-layerheaderupwrapper';
            layerUpWrapper.appendChild(layerUp);
            layerDivHeader.appendChild(layerUpWrapper);

            layerDown.addEventListener('click', function () {
                changeLayerOrder(this, -1);
            });
            layerUp.addEventListener('click', function () {
                changeLayerOrder(this, 1);
            });
            layerDown.addEventListener('mouseenter', function () {
                mouseEnterLayerIcons(this);
            });
            layerDown.addEventListener('mouseleave', function () {
                mouseLeaveLayerIcons(this);
            });
            layerUp.addEventListener('mouseenter', function () {
                mouseEnterLayerIcons(this);
            });
            layerUp.addEventListener('mouseleave', function () {
                mouseLeaveLayerIcons(this);
            });
        }

        // Create layer selection menu
        function createLayerMenu(changeVisibilityControl, level, name, id, layer, groupLayerId) {
            // level: main - group - layer - baselayer
            var classToAdd = '';
            var extraClass = '';
            var layerDiv = document.createElement('div');
            var layerDivHeader = document.createElement('div');
            if (level === 'layer') {
                extraClass = ' bkgwebmap-layerswitcherlayerheader ' + id + 'ajax';
                layerDiv.id = id;
                layerDivHeader.id = id + 'title';
            } else if (level === 'group') {
                extraClass = ' bkgwebmap-layerswitchergroupheader';
                layerDiv.id = id;
                layerDivHeader.id = id + 'title';
            } else if (level === 'main') {
                classToAdd = id;
                extraClass = ' bkgwebmap-layerswitchermainheader';
            } else if (level === 'baselayer') {
                extraClass = ' bkgwebmap-layerswitcherbaselayerheader';
                classToAdd = ' ' + id + 'ajax';
                layerDiv.id = id;
                layerDivHeader.id = id + 'title';
            }

            if (classToAdd) {
                layerDiv.className = classToAdd;
            }
            layerDivHeader.className = 'bkgwebmap-layerheader' + extraClass;
            extraClass = '';
            var layerTitle;
            var visible;
            var subLayers;
            var subLayersWMS = false;
            if (level === 'layer') {
                if ((layer.getSource() instanceof ol.source.ImageWMS || layer.getSource() instanceof ol.source.TileWMS) && showWMSLayers) {
                    subLayersWMS = true;
                    subLayers = layer.getLayers();
                }
                extraClass = ' bkgwebmap-layerheaderinputdivlayer';
                layerTitle = document.createElement('div');
                layerTitle.className = 'bkgwebmap-layerheadertitlediv' + extraClass;
                layerTitle.innerHTML = name;

                var subInputDiv = document.createElement('div');
                subInputDiv.className = 'bkgwebmap-layerheaderinputdiv';

                var subInputLabel = document.createElement('label');
                var subParserIconEmpty = new DOMParser();
                var subClickIconEmpty = subParserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                var subParserIconFull = new DOMParser();
                var subClickIconFull = subParserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                subInputDiv.appendChild(subInputLabel);

                var subInput = document.createElement('input');
                subInput.setAttribute('type', 'checkbox');
                subInput.className = 'bkgwebmap-layerheaderinput';
                subInputLabel.appendChild(subInput);

                layerDivHeader.appendChild(subInputDiv);
                if (subLayersWMS) {
                    visible = layer.getProperties().visible;
                } else {
                    visible = layer.get('visible');
                }
                var subClickIcon = subClickIconEmpty;
                if (visible) {
                    subClickIcon = subClickIconFull;
                }
                subInputLabel.appendChild(subClickIcon.documentElement);
                subInput.checked = visible;
                subInput.onchange = function (e) {
                    var label = this.parentNode;
                    label.removeChild(label.childNodes[1]);
                    subParserIconEmpty = new DOMParser();
                    subClickIconEmpty = subParserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                    subParserIconFull = new DOMParser();
                    subClickIconFull = subParserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                    if (this.checked) {
                        label.appendChild(subClickIconFull.documentElement);
                    } else {
                        label.appendChild(subClickIconEmpty.documentElement);
                    }
                    setVisible(layer, e.target.checked, null);
                };
                layerDivHeader.appendChild(layerTitle);

                if (layer.getSource() instanceof ol.source.Vector || (typeof layer.extent && layer.extent instanceof Array)) {
                    var zoomToLayer = document.createElement('div');
                    zoomToLayer.className = 'bkgwebmap-layerheaderzoom bkgwebmap-paneltooltip';
                    var parserZoomToLayer = new DOMParser();
                    var zoomToLayerIcon = parserZoomToLayer.parseFromString(BKGWebMap.PANEL_ICONS.ZOOM_IN, 'text/xml');
                    zoomToLayer.appendChild(zoomToLayerIcon.documentElement);
                    var zoomToLayerWrapper = document.createElement('div');
                    zoomToLayerWrapper.className = 'bkgwebmap-layerheaderzoomwrapper';
                    zoomToLayerWrapper.appendChild(zoomToLayer);
                    layerDivHeader.appendChild(zoomToLayerWrapper);

                    var zoomToLayerTooltip = document.createElement('span');
                    zoomToLayerTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-layertooltip';
                    zoomToLayerTooltip.innerHTML = 'Auf die Layer-Ausdehnung zoomen';
                    zoomToLayer.appendChild(zoomToLayerTooltip);

                    zoomToLayer.addEventListener('click', function () {
                        zoomToExtent(layer);
                    });
                    zoomToLayer.addEventListener('mouseenter', function () {
                        mouseEnterLayerIcons(this);
                        showHideTooltips(zoomToLayerTooltip);
                    });
                    zoomToLayer.addEventListener('mouseleave', function () {
                        mouseLeaveLayerIcons(this);
                    });
                }

                if (layer instanceof ol.layer.Vector || changeVisibilityControl) {
                    var adjust = document.createElement('div');
                    adjust.className = 'bkgwebmap-layerheaderadjust bkgwebmap-paneltooltip';
                    var parserAdjustIcon = new DOMParser();
                    var adjustIcon = parserAdjustIcon.parseFromString(BKGWebMap.PANEL_ICONS.GEAR_WHEEL, 'text/xml');
                    adjust.appendChild(adjustIcon.documentElement);
                    var adjustWrapper = document.createElement('div');
                    adjustWrapper.className = 'bkgwebmap-layerheaderadjustwrapper';
                    adjustWrapper.appendChild(adjust);
                    layerDivHeader.appendChild(adjustWrapper);

                    var adjustTooltip = document.createElement('span');
                    adjustTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-layertooltip';
                    adjustTooltip.innerHTML = 'Einstellungen';
                    adjust.appendChild(adjustTooltip);

                    adjust.addEventListener('click', openCloseLayer);
                    adjust.addEventListener('mouseenter', function () {
                        mouseEnterLayerIcons(this);
                        showHideTooltips(adjustTooltip);
                    });
                    adjust.addEventListener('mouseleave', function () {
                        mouseLeaveLayerIcons(this);
                    });
                }

                if (changeOrder) {
                    createLayerUpDownDom(layerDivHeader, groupLayerId);
                }
            } else if (level === 'group') {
                var groupHeaderWrapper = document.createElement('div');

                var inputDiv = document.createElement('div');
                inputDiv.className = 'bkgwebmap-layerheaderinputdiv';

                var inputLabel = document.createElement('label');
                var parserIconEmpty = new DOMParser();
                var clickIconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                var parserIconFull = new DOMParser();
                var clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                inputDiv.appendChild(inputLabel);

                var input = document.createElement('input');
                input.setAttribute('type', 'checkbox');
                input.className = 'bkgwebmap-layerheaderinput';
                inputLabel.appendChild(input);
                groupHeaderWrapper.appendChild(inputDiv);

                var clickIcon = clickIconEmpty;
                visible = layer.get('visible');
                if (visible) {
                    clickIcon = clickIconFull;
                }
                inputLabel.appendChild(clickIcon.documentElement);

                input.checked = visible;
                input.onchange = function (e) {
                    var label = this.parentNode;
                    label.removeChild(label.childNodes[1]);
                    parserIconEmpty = new DOMParser();
                    clickIconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                    parserIconFull = new DOMParser();
                    clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                    if (this.checked) {
                        label.appendChild(clickIconFull.documentElement);
                    } else {
                        label.appendChild(clickIconEmpty.documentElement);
                    }
                    setVisible(layer, e.target.checked, null);
                };
                var groupIcon = document.createElement('div');
                groupIcon.className = 'bkgwebmap-layerheadergroupicon';
                var parsergroupIconClosed = new DOMParser();
                var groupIconClosed = parsergroupIconClosed.parseFromString(BKGWebMap.PANEL_ICONS.FOLDER_CLOSED, 'text/xml');
                var parsergroupIconOpen = new DOMParser();
                var groupIconOpen = parsergroupIconOpen.parseFromString(BKGWebMap.PANEL_ICONS.FOLDER_OPEN, 'text/xml');
                if (openLevel === 2) {
                    groupIcon.appendChild(groupIconOpen.documentElement);
                } else {
                    groupIcon.appendChild(groupIconClosed.documentElement);
                }
                groupHeaderWrapper.appendChild(groupIcon);

                layerTitle = document.createElement('div');
                layerTitle.className = 'bkgwebmap-layerheadergrouptext';
                layerTitle.innerHTML = name;
                groupHeaderWrapper.appendChild(layerTitle);

                layerDivHeader.appendChild(groupHeaderWrapper);

                if (changeOrder) {
                    createLayerUpDownDom(layerDivHeader, groupLayerId);
                }

                groupHeaderWrapper.addEventListener('click', function () {
                    openCloseGroup(this, 'FOLDER_OPEN', 'FOLDER_CLOSED', 1, 'bkgwebmap-layercontentactive', this.parentNode.nextSibling);
                });
            } else if (level === 'main') {
                layerTitle = document.createElement('div');
                layerTitle.className = 'bkgwebmap-layerheadermaintext';
                layerTitle.innerHTML = name;
                layerDivHeader.appendChild(layerTitle);

                var plusMinus = document.createElement('div');
                plusMinus.className = 'bkgwebmap-layerheaderplusminus';
                if (openLevel === 1 || openLevel === 2) {
                    plusMinus.innerHTML = '\u2212';
                } else {
                    plusMinus.innerHTML = '+';
                }
                layerDivHeader.appendChild(plusMinus);

                layerDivHeader.addEventListener('click', openCloseMain);
            } else if (level === 'baselayer') {
                layerDiv.className = 'bkgwebmap-baselayerdiv' + classToAdd;
                layerTitle = document.createElement('div');
                layerTitle.className = 'bkgwebmap-layerheadertitlediv bkgwebmap-baselayertitlediv';
                layerTitle.innerHTML = name;
                layerDivHeader.appendChild(layerTitle);

                visible = layer.get('visible');
                if (visible) {
                    addRemoveBaselayer(layerDiv, layer);
                }

                layerDiv.addEventListener('click', function () {
                    addRemoveBaselayer(this, layer);
                });
            } else {
                return undefined;
            }
            layerDiv.appendChild(layerDivHeader);

            if (level !== 'baselayer') {
                var layerContent = document.createElement('div');
                if (level !== 'main') {
                    layerContent.id = id + 'content';
                }
                layerContent.className = 'bkgwebmap-layercontent ' + id + 'content';
                if (level === 'layer') {
                    if (changeVisibilityControl) {
                        layerContent.appendChild(createOpacityDiv(layer));
                    }
                    if (layer instanceof ol.layer.Vector && editStyle) {
                        layerContent.appendChild(createChangeStyleDiv(layer));
                    }
                    if (subLayersWMS) {
                        layerContent.appendChild(createWmsLayersDiv(layer, subLayers));
                    }
                    if (layer.getProperties().customLayer) {
                        layerContent.appendChild(createRemoveLayerDiv(layer));
                    }
                } else if (level === 'main' && (openLevel === 1 || openLevel === 2)) {
                    layerContent.classList.add('bkgwebmap-layercontentactive');
                } else if (level === 'group' && (openLevel === 2)) {
                    layerContent.classList.add('bkgwebmap-layercontentactive');
                }
                layerDiv.appendChild(layerContent);
            }
            return layerDiv;
        }

        function clickControl() {
            if (inPanel) {
                var activeContent = panel.getActiveContent();
                if (activeContent === '') {
                    panel.openPanel();
                    panel.changePanelContent(title, layerSwitcherContentClass);
                    _this.activeIcon();
                } else if (activeContent === layerSwitcherContentClass) {
                    panel.closePanel();
                } else {
                    panel.changePanelContent(title, layerSwitcherContentClass);
                    _this.activeIcon();
                }
            } else if (layerSwitcherContent.style.display === 'none') {
                layerSwitcherContent.style.display = 'block';
            } else {
                layerSwitcherContent.style.display = 'none';
            }
        }

        this.activeIcon = function () {
            layerSwitcher.classList.add('bkgwebmap-panelactive');
        };

        function addLayersInDom(changeVisibilityControl, layer, name, id, baseLayer, group, groupLayerId) {
            var mainDiv;
            if (baseLayer) {
                if (!document.getElementById(elementId).getElementsByClassName('bkgwebmap-baselayers').length) {
                    mainDiv = createLayerMenu(false, 'main', 'Hintergrundkarte', 'bkgwebmap-baselayers', layer, groupLayerId);
                    if (mainDiv) {
                        layerSwitcherContent.insertBefore(mainDiv, layerSwitcherContent.childNodes[0]);
                    }
                }
                var baseLayerDiv = createLayerMenu(false, 'baselayer', name, id, layer);
                if (baseLayerDiv) {
                    document.getElementById(elementId).getElementsByClassName('bkgwebmap-baselayerscontent')[0].insertBefore(baseLayerDiv, document.getElementById(elementId).getElementsByClassName('bkgwebmap-baselayerscontent')[0].childNodes[0]);
                }
            } else {
                if (!document.getElementById(elementId).getElementsByClassName('bkgwebmap-overlays').length) {
                    mainDiv = createLayerMenu(false, 'main', 'Overlays', 'bkgwebmap-overlays', layer, groupLayerId);
                    if (mainDiv) {
                        layerSwitcherContent.appendChild(mainDiv);
                    }
                }
                if (group) {
                    var groupDiv = createLayerMenu(false, 'group', name, id, layer, groupLayerId);
                    if (groupDiv) {
                        document.getElementById(elementId).getElementsByClassName('bkgwebmap-overlayscontent')[0].insertBefore(groupDiv, document.getElementById(elementId).getElementsByClassName('bkgwebmap-overlayscontent')[0].childNodes[0]);
                    }
                } else {
                    var element = createLayerMenu(changeVisibilityControl, 'layer', name, id, layer, groupLayerId);
                    var parent;
                    if (groupLayerId) {
                        parent = groupLayerId + 'content';
                        if (element.getElementsByClassName('bkgwebmap-layerheaderinputdiv').length) {
                            element.getElementsByClassName('bkgwebmap-layerheaderinputdiv')[0].classList.add('bkgwebmap-layerheaderinputdivgroup');
                        }
                        document.getElementById(parent).insertBefore(element, document.getElementById(parent).childNodes[0]);
                    } else {
                        parent = 'bkgwebmap-overlayscontent';
                        document.getElementById(elementId).getElementsByClassName(parent)[0].insertBefore(element, document.getElementById(elementId).getElementsByClassName(parent)[0].childNodes[0]);
                    }
                }
                if (changeOrder) {
                    showHideArrows();
                }
            }
        }

        // Show or hide ajax loader icon
        function showHideAjaxLoader(id, show) {
            if (show) {
                if (document.getElementsByClassName(id + 'ajax').length) {
                    document.getElementsByClassName(id + 'ajax')[0].classList.add('bkgwebmap-ajaxloader');
                }
            } else if (document.getElementById(id + 'title')) {
                if (document.getElementsByClassName(id + 'ajax').length) {
                    document.getElementsByClassName(id + 'ajax')[0].classList.remove('bkgwebmap-ajaxloader');
                }
            }
        }

        /**
         * Add container for Custom Layers Control
         * @returns {HTMLDivElement}
         */
        this.addCustomLayersContainer = function (customLayersContainer) {
            // Add overlays div if it doesn't exist
            if (!document.getElementById(elementId).getElementsByClassName('bkgwebmap-overlays').length) {
                var overlaysDiv = createLayerMenu(false, 'main', 'Overlays', 'bkgwebmap-overlays', '', '');
                if (overlaysDiv) {
                    layerSwitcherContent.appendChild(overlaysDiv);
                }
            }
            layerSwitcherContent.appendChild(customLayersContainer);
        };

        /**
         * Add layers in layer switcher
         * @param {object} layer - layer that should be added
         * @param {boolean} baseLayer - Is it a baselayer
         * @param {string|boolean} groupLayerId - ID of group that layer belongs to.
         */
        /**
         * Add layers in layer switcher
         * @param {object} layer - layer that should be added
         * @param {boolean} baseLayer - Is it a baselayer
         * @param {string|boolean} groupLayerId - ID of group that layer belongs to.
         * @param {boolean} useDefaultChangeVisibility - Should the default value of changeVisibility used
         * @param {boolean|null} customChangeVisibility - Custom value of changeVisibility
         */
        this.addInLayerSwitcher = function (layer, baseLayer, groupLayerId, useDefaultChangeVisibility, customChangeVisibility) {
            var group = false;
            var name = layer.getProperties().name;
            var id = layer.getProperties().uniqueId;
            var changeVisibilityControl = customChangeVisibility;

            if (useDefaultChangeVisibility) {
                changeVisibilityControl = changeVisibility;
            }

            if (layer instanceof ol.layer.Group) {
                group = true;
                addLayersInDom(changeVisibilityControl, layer, name, id, baseLayer, group, groupLayerId);
                layer.getLayers().forEach(function (sublayer) {
                    _this.addInLayerSwitcher(sublayer, baseLayer, id, useDefaultChangeVisibility, customChangeVisibility);
                });
            } else {
                addLayersInDom(changeVisibilityControl, layer, name, id, baseLayer, group, groupLayerId);
            }
        };

        /**
         * Show in layer switcher if a layer is displayed in actual resolution
         * @param {object} layer - Layer that should be used
         */
        this.resolutionLimits = function (layer) {
            if (layer instanceof ol.layer.Group) {
                layer.getLayers().forEach(function (sublayer) {
                    _this.resolutionLimits(sublayer);
                });
            } else {
                var id = layer.getProperties().uniqueId;
                var layerMinResolution = layer.getMinResolution();
                var layerMaxResolution = layer.getMaxResolution();
                var mapResolution = map.getView().getResolution();
                var opacityChanged;
                var elementDOM = document.getElementById(id);
                if (elementDOM && (layerMinResolution > mapResolution || layerMaxResolution < mapResolution)) {
                    elementDOM.style.opacity = 0.5;
                    opacityChanged = true;
                    adjustSelect(elementDOM, true);
                } else if (elementDOM) {
                    elementDOM.style.opacity = 1;
                    adjustSelect(elementDOM, false);
                }
                if ((layer.getSource() instanceof ol.source.ImageWMS || layer.getSource() instanceof ol.source.TileWMS) && layer.getLayers()) {
                    layer.getLayers().forEach(function (sublayer) {
                        var subLayerName = sublayer.layer;
                        var subLayerNodes = document.getElementById(id).querySelectorAll('[data-bkgwebmap-wmssublayer]');
                        for (var i = 0; i < subLayerNodes.length; i++) {
                            if (subLayerName === subLayerNodes[i].getAttribute('data-bkgwebmap-wmssublayer')) {
                                var sublayerDiv = subLayerNodes[i].parentNode.parentNode.parentNode;
                                if (!opacityChanged && ((sublayer.minResolution && sublayer.minResolution > mapResolution) || (sublayer.maxResolution && sublayer.maxResolution < mapResolution))) {
                                    sublayerDiv.style.opacity = 0.5;
                                    adjustSelect(sublayerDiv, true);
                                } else if (!opacityChanged) {
                                    sublayerDiv.style.opacity = 1;
                                    adjustSelect(sublayerDiv, false);
                                } else {
                                    sublayerDiv.style.opacity = 1;
                                    adjustSelect(sublayerDiv, true);
                                }
                            }
                        }
                    });
                }
            }
        };

        function adjustSelect(el, disabled) {
            var selects = el.getElementsByTagName('select');
            if (selects.length) {
                for (var i = 0; i < selects.length; i++) {
                    selects[i].disabled = disabled;
                }
            }
        }

        function checkAjaxLoaded(id, tilesLoaded, tilesPending) {
            if (tilesLoaded === tilesPending) {
                showHideAjaxLoader(id, false);
            }
        }

        /**
         * Add an ajax loader for specific layer
         * @param {object} layer - Layer that should be used
         */
        this.ajaxLoader = function (layer) {
            var id = layer.get('uniqueId');
            if (layer instanceof ol.layer.Group) {
                layer.getLayers().forEach(function (sublayer) {
                    _this.ajaxLoader(sublayer);
                });
            } else if (layer instanceof ol.layer.Tile) {
                var tilesLoaded = 0;
                var tilesPending = 0;
                layer.getSource().on('tileloadstart', function () {
                    showHideAjaxLoader(id, true);
                    tilesPending++;
                });
                layer.getSource().on('tileloadend', function () {
                    tilesLoaded++;
                    checkAjaxLoaded(id, tilesLoaded, tilesPending);
                });
                layer.getSource().on('tileloaderror', function () {
                    tilesLoaded++;
                    checkAjaxLoaded(id, tilesLoaded, tilesPending);
                });
            } else if (layer instanceof ol.layer.Image && !(layer instanceof BKGWebMap.Layer.NONE)) {
                layer.getSource().on('imageloadstart', function () {
                    showHideAjaxLoader(id, true);
                });
                layer.getSource().on('imageloadend', function () {
                    showHideAjaxLoader(id, false);
                });
                layer.getSource().on('imageloaderror', function () {
                    showHideAjaxLoader(id, false);
                });
            } else if (layer instanceof ol.layer.Vector) {
                layer.on('precompose', function () {
                    showHideAjaxLoader(id, true);
                });
                layer.on('postcompose', function () {
                    showHideAjaxLoader(id, false);
                });
            }
        };

        // Event listeners
        var elementForEvent = layerSwitcher;
        if (!inPanel) {
            elementForEvent = layerSwitcher.querySelector('svg');
        }
        elementForEvent.addEventListener('click', clickControl, { passive: true });
        elementForEvent.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementById(elementId).getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            layerSwitcherTooltip.style.visibility = 'visible';
            setTimeout(function () {
                layerSwitcherTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: layerSwitcher,
            target: target
        });
    };
};

/**
 * Create CustomLayers Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_customLayers}
 */
BKGWebMap.Control.createCustomLayers = function () {
    return function (map, controlName, options, panel) {
        var _this = this;

        var mapId = map.getTarget();

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists, do not create this control
        if (!panel) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        this.styles = null;

        this.changeVisibility = BKGWebMap.CONTROLS.tools.customLayers.changeVisibility;
        if (typeof options.changeVisibility === 'boolean') {
            this.changeVisibility = options.changeVisibility;
        }

        var style;
        var styleName;
        if (options.defaultStyle && typeof options.defaultStyle === 'string' && options.defaultStyle !== '') {
            style = options.defaultStyle;
            styleName = options.defaultStyle;
        }

        var edit = BKGWebMap.CONTROLS.tools.customLayers.edit;
        if (typeof options.edit === 'boolean') {
            edit = options.edit;
        }

        var dataTypes = BKGWebMap.CONTROLS.tools.customLayers.dataTypes;
        if (options.dataTypes instanceof Array && options.dataTypes.length) {
            dataTypes = options.dataTypes;
        }

        // Create DOM
        var customLayersContainer = document.createElement('div');
        customLayersContainer.className = 'bkgwebmap-customlayerscontainer';

        var customLayers = document.createElement('div');
        customLayers.className = 'bkgwebmap-customlayers';

        var customLayersHeader = document.createElement('div');
        customLayersHeader.className = 'bkgwebmap-customlayersheader bkgwebmap-layerheader bkgwebmap-layerswitchermainheader';
        customLayers.appendChild(customLayersHeader);

        var customLayersIconDiv = document.createElement('div');
        customLayersIconDiv.className = 'bkgwebmap-layerheaderinputdiv';

        var parserCustomLayersIcon = new DOMParser();
        var customLayersIcon = parserCustomLayersIcon.parseFromString(BKGWebMap.PANEL_ICONS.ADD_LAYER, 'text/xml');
        customLayersIconDiv.appendChild(customLayersIcon.documentElement);
        customLayersHeader.appendChild(customLayersIconDiv);

        var customLayersTitle = document.createElement('div');
        customLayersTitle.className = 'bkgwebmap-layerheaderinputdivlayer';
        customLayersTitle.innerHTML = 'Layer hinzufügen';
        customLayersHeader.appendChild(customLayersTitle);

        var plusMinus = document.createElement('div');
        plusMinus.className = 'bkgwebmap-layerheaderplusminus';
        plusMinus.innerHTML = '+';
        customLayersHeader.appendChild(plusMinus);

        customLayersHeader.addEventListener('click', openCloseHeader);
        customLayers.appendChild(createContent());

        var messageDiv = document.createElement('div');
        messageDiv.className = 'bkgwebmap-messagediv';
        messageDiv.innerHTML = 'fehlerhafte URL';


        function fillTypeDropdown(dataType) {
            var selectItem = document.createElement('option');
            selectItem.setAttribute('value', dataType);
            if (dataType === 'BKG') {
                selectItem.innerHTML = 'vorkonfigurierte Dienste';
            } else {
                selectItem.innerHTML = dataType;
            }
            return selectItem;
        }

        // Get info about available BKG services
        function getBkgServiceIds(callback) {
            var registryUrl = BKGWebMap.SERVICE_REGISTRY;
            var params = '';

            var xhr = new XMLHttpRequest();
            xhr.open('GET', registryUrl + params);
            var onError = function () {
                return callback(undefined);
            };
            xhr.onerror = onError;
            xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var jsonConfig = JSON.parse(xhr.responseText);
                    return callback(jsonConfig);
                }
                onError();
            };
            xhr.send();
        }

        // Get Info about WMS through a GetCapabilities request
        function getWmsInfo(callback) {
            var url = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmsinput')[0].value;
            if (url === '') {
                callback(undefined);
                return;
            }
            var title = '';
            var wmsInfo = [];
            var xhr = new XMLHttpRequest();
            var requestUrl = url;
            // Add parameters if not available
            if (requestUrl.indexOf('?') === -1) {
                requestUrl += '?SERVICE=WMS&VERSION=1.3.0&REQUEST=GetCapabilities';
            } else if (requestUrl[requestUrl.length - 1] === '?') {
                requestUrl += 'SERVICE=WMS&VERSION=1.3.0&REQUEST=GetCapabilities';
            }
            xhr.open('GET', requestUrl);
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var parser = new ol.format.WMSCapabilities();
                    var result = parser.read(xhr.responseText);
                    // Parse title
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Service.Title')) {
                        title = result.Service.Title;
                    }
                    // Parse info
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Capability.Layer.Layer')) {
                        if (result.Capability.Layer.Layer && result.Capability.Layer.Layer instanceof Array && result.Capability.Layer.Layer.length) {
                            parseLayersInfoWMS(result.Capability.Layer.Layer, wmsInfo);
                        }
                    }
                    // GetMap URL
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Capability.Request.GetMap.DCPType')) {
                        if (result.Capability.Request.GetMap.DCPType && result.Capability.Request.GetMap.DCPType instanceof Array && result.Capability.Request.GetMap.DCPType.length) {
                            var dcpType = result.Capability.Request.GetMap.DCPType[0];
                            if (dcpType && BKGWebMap.Util.hasNestedProperty(dcpType, 'HTTP.Get.OnlineResource')) {
                                url = dcpType.HTTP.Get.OnlineResource;
                            }
                        }
                    }
                    if (url.indexOf('?') !== -1) {
                        url = url.substring(0, url.indexOf('?'));
                    }
                    callback(title, wmsInfo, url);
                } else {
                    showMessage('bkgwebmap-customlayerdivwms', 'WMS-URL aufrufen');
                    callback(undefined);
                }
            };
            xhr.onerror = function () {
                showMessage('bkgwebmap-customlayerdivwms', 'WMS-URL aufrufen');
                callback(undefined);
            };
            xhr.send();
        }

        function showMessage(div, defaultButton) {
            var messageDivs = document.getElementById(mapId).getElementsByClassName(div)[0].getElementsByClassName('bkgwebmap-messagediv');
            document.getElementById(mapId).getElementsByClassName(div)[0].getElementsByClassName('bkgwebmap-customlayerinputbutton')[0].innerHTML = defaultButton;
            if (!messageDivs.length) {
                var cloneMessage = messageDiv.cloneNode(true);
                document.getElementById(mapId).getElementsByClassName(div)[0].appendChild(cloneMessage);
            }
            setTimeout(function () {
                if (messageDivs.length) {
                    document.getElementById(mapId).getElementsByClassName(div)[0].removeChild(messageDivs[0]);
                }
            }, 10000);
        }

        function parseLayersInfoWMS(arrayLayers, wmsInfo) {
            for (var i = 0; i < arrayLayers.length; i++) {
                if (arrayLayers[i].Layer && arrayLayers[i].Layer instanceof Array && arrayLayers[i].Layer.length) {
                    var layersGroup = {};
                    layersGroup.layers = [];
                    if (arrayLayers[i].Title) {
                        layersGroup.title = arrayLayers[i].Title;
                    }
                    wmsInfo.push(layersGroup);
                    parseLayersInfoWMS(arrayLayers[i].Layer, layersGroup.layers);
                } else if (!arrayLayers[i].Layer && arrayLayers[i].Name) {
                    var singleLayer = {};
                    singleLayer.styles = [];
                    singleLayer.name = arrayLayers[i].Name;
                    // Layer title
                    if (arrayLayers[i].Title) {
                        singleLayer.title = arrayLayers[i].Title;
                    } else {
                        singleLayer.title = singleLayer.name;
                    }
                    // Layer styles
                    if (arrayLayers[i].Style && arrayLayers[i].Style instanceof Array) {
                        for (var j = 0; j < arrayLayers[i].Style.length; j++) {
                            var singleStyle = {};
                            if (arrayLayers[i].Style[j].Name) {
                                singleStyle.name = arrayLayers[i].Style[j].Name;
                                if (arrayLayers[i].Style[j].Title) {
                                    singleStyle.title = arrayLayers[i].Style[j].Title;
                                } else {
                                    singleStyle.title = singleStyle.name;
                                }
                            }
                            singleLayer.styles.push(singleStyle);
                        }
                    }
                    wmsInfo.push(singleLayer);
                }
            }
        }

        function getWmtsInfo(callback) {
            var url = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmtsinput')[0].value;
            if (url === '' || url.slice(url.length - 4, url.length) !== '.xml') {
                callback(undefined);
                return;
            }
            var title = '';
            var wmtsInfo = {
                layers: [],
                matrixSets: []
            };
            var singleLayer;
            var xhr = new XMLHttpRequest();
            xhr.open('GET', url);
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var i;
                    var parser = new ol.format.WMTSCapabilities();
                    var result = parser.read(xhr.responseText);
                    // Parse title
                    if (BKGWebMap.Util.hasNestedProperty(result, 'ServiceIdentification.Title')) {
                        title = result.ServiceIdentification.Title;
                    }
                    // Parse info
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Contents.Layer') && result.Contents.Layer instanceof Array && result.Contents.Layer.length) {
                        for (i = 0; i < result.Contents.Layer.length; i++) {
                            singleLayer = {};
                            if (result.Contents.Layer[i].Identifier) {
                                singleLayer.layer = result.Contents.Layer[i].Identifier;

                                if (result.Contents.Layer[i].Title) {
                                    singleLayer.title = result.Contents.Layer[i].Title;
                                } else {
                                    singleLayer.title = singleLayer.layer;
                                }
                            }
                            wmtsInfo.layers.push(singleLayer);
                        }

                        if (BKGWebMap.Util.hasNestedProperty(result, 'Contents.TileMatrixSet') && result.Contents.TileMatrixSet instanceof Array && result.Contents.TileMatrixSet.length) {
                            for (i = 0; i < result.Contents.TileMatrixSet.length; i++) {
                                if (result.Contents.TileMatrixSet[i].Identifier) {
                                    wmtsInfo.matrixSets.push(result.Contents.TileMatrixSet[i].Identifier);
                                }
                            }
                        }
                    }

                    if (wmtsInfo.layers.length && wmtsInfo.matrixSets.length) {
                        callback(title, wmtsInfo, url);
                    } else {
                        showMessage('bkgwebmap-customlayerdivwmts', 'WMTS-URL aufrufen');
                        callback(undefined);
                    }
                } else {
                    showMessage('bkgwebmap-customlayerdivwmts', 'WMTS-URL aufrufen');
                    callback(undefined);
                }
            };
            xhr.onerror = function () {
                showMessage('bkgwebmap-customlayerdivwmts', 'WMTS-URL aufrufen');
                callback(undefined);
            };
            xhr.send();
        }

        function getWfsLayerNames(wfsNamesArray) {
            var layers = [];
            var singleLayer;
            for (var i = 0; i < wfsNamesArray.length; i++) {
                singleLayer = {};
                if (BKGWebMap.Util.hasNestedProperty(wfsNamesArray[i], 'Name.#text') && wfsNamesArray[i].Name['#text'] !== '') {
                    singleLayer.name = wfsNamesArray[i].Name['#text'];
                    if (BKGWebMap.Util.hasNestedProperty(wfsNamesArray[i], 'Title.#text') && wfsNamesArray[i].Title['#text'] !== '') {
                        singleLayer.title = wfsNamesArray[i].Title['#text'];
                    } else {
                        singleLayer.title = singleLayer.name;
                    }
                    layers.push(singleLayer);
                } else if (BKGWebMap.Util.hasNestedProperty(wfsNamesArray[i], 'wfs:Name.#text') && wfsNamesArray[i]['wfs:Name']['#text'] !== '') {
                    singleLayer.name = wfsNamesArray[i]['wfs:Name']['#text'];
                    if (BKGWebMap.Util.hasNestedProperty(wfsNamesArray[i], 'wfs:Title.#text') && wfsNamesArray[i]['wfs:Title']['#text'] !== '') {
                        singleLayer.title = wfsNamesArray[i]['wfs:Title']['#text'];
                    } else {
                        singleLayer.title = singleLayer.name;
                    }
                    layers.push(singleLayer);
                }
            }
            return layers;
        }

        // Create an array with available WFS formats
        function createFormatsArray(formatsTemp) {
            var formats = [];
            for (var i = 0; i < formatsTemp.length; i++) {
                var formatTemp = formatsTemp[i].toLowerCase();
                formatTemp = formatTemp.replace(/\s+/g, '');
                // GEOJSON
                if ((formatTemp.indexOf('json') !== -1 || formatTemp.indexOf('geojson') !== -1) && formats.indexOf('GEOJSON') === -1) {
                    formats.push('GEOJSON');
                }
                // GML3
                if ((formatTemp.indexOf('gml3') !== -1 || formatTemp.indexOf('gml/3') !== -1 || formatTemp.indexOf('gml+xml;version=3') !== -1) && formats.indexOf('GML3') === -1) {
                    formats.push('GML3');
                }
                // GML2
                if ((formatTemp.indexOf('gml2') !== -1 || formatTemp.indexOf('gml/2') !== -1 || formatTemp.indexOf('gml+xml;version=2') !== -1) && formats.indexOf('GML2') === -1) {
                    formats.push('GML2');
                }
            }
            return formats;
        }

        // Search in GetCapabilities object for various types of wfs formats
        function wfsFormatsOperation(operations) {
            var formatsTemp = [];
            for (var i = 0; i < operations.length; i++) {
                if (operations[i]['@attributes'] && operations[i]['@attributes'].name && operations[i]['@attributes'].name === 'GetFeature') {
                    var getFeatureOperation = operations[i];
                    if (getFeatureOperation['ows:Parameter'] instanceof Array) {
                        var parameter = getFeatureOperation['ows:Parameter'];
                        for (var k = 0; k < parameter.length; k++) {
                            if (BKGWebMap.Util.hasNestedProperty(parameter[k], '@attributes.name') && parameter[k]['@attributes'].name === 'outputFormat' && parameter[k]['ows:Value'] instanceof Array) {
                                var arrayFormats = parameter[k]['ows:Value'];
                                for (var j = 0; j < arrayFormats.length; j++) {
                                    if (arrayFormats[j]['#text']) {
                                        formatsTemp.push(arrayFormats[j]['#text']);
                                    }
                                }
                            } else if (BKGWebMap.Util.hasNestedProperty(parameter[k], '@attributes.name') && parameter[k]['@attributes'].name === 'outputFormat' && BKGWebMap.Util.hasNestedProperty(parameter[k], 'ows:Value.#text')) {
                                formatsTemp.push(parameter[k]['ows:Value']['#text']);
                            }
                        }
                    } else if (BKGWebMap.Util.hasNestedProperty(getFeatureOperation, 'ows:Parameter.@attributes.name') && getFeatureOperation['ows:Parameter']['@attributes'].name === 'outputFormat') {
                        if (BKGWebMap.Util.hasNestedProperty(getFeatureOperation, 'ows:Parameter.ows:AllowedValues.ows:Value.#text')) {
                            var singleFormat = getFeatureOperation['ows:Parameter']['ows:AllowedValues']['ows:Value']['#text'];
                            formatsTemp.push(singleFormat);
                        }
                    }
                }
            }
            return formatsTemp;
        }

        // Get available wfs formats  from GetCapabilities
        function getWfsFormats(result) {
            var formatsTemp;
            var operations;
            if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.ows:OperationsMetadata.ows:Operation') && result['wfs:WFS_Capabilities']['ows:OperationsMetadata']['ows:Operation'] instanceof Array) {
                operations = result['wfs:WFS_Capabilities']['ows:OperationsMetadata']['ows:Operation'];
                formatsTemp = wfsFormatsOperation(operations);
            } else if (BKGWebMap.Util.hasNestedProperty(result, 'WFS_Capabilities.ows:OperationsMetadata.ows:Operation') && result.WFS_Capabilities['ows:OperationsMetadata']['ows:Operation'] instanceof Array) {
                operations = result.WFS_Capabilities['ows:OperationsMetadata']['ows:Operation'];
                formatsTemp = wfsFormatsOperation(operations);
            }
            return createFormatsArray(formatsTemp);
        }

        function getWfsInfo(callback) {
            var url = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwfsinput')[0].value;
            if (url === '') {
                callback(undefined);
                return;
            }
            var title = '';
            var wfsInfo = {
                layers: []
            };
            var xhr = new XMLHttpRequest();
            var requestUrl = url;
            // Add parameters if not available
            if (requestUrl.indexOf('?') === -1) {
                requestUrl += '?REQUEST=GetCapabilities&VERSION=1.3.0&SERVICE=wfs';
            } else if (requestUrl[requestUrl.length - 1] === '?') {
                requestUrl += 'REQUEST=GetCapabilities&VERSION=1.3.0&SERVICE=wfs';
            }
            xhr.open('GET', requestUrl);


            // xhr.open('GET', url + '?REQUEST=GetCapabilities&VERSION=1.3.0&SERVICE=wfs');

            xhr.onload = function () {
                if (xhr.status === 200) {
                    var parser = new DOMParser();
                    var resultXml = parser.parseFromString(xhr.responseText, 'text/xml');
                    var result = BKGWebMap.Util.xmlToJson(resultXml);
                    if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.ows:ServiceIdentification.ows:Title.#text')) {
                        title = result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:Title']['#text'];
                    } else if (BKGWebMap.Util.hasNestedProperty(result, 'WFS_Capabilities.ows:ServiceIdentification.ows:Title.#text')) {
                        title = result.WFS_Capabilities['ows:ServiceIdentification']['ows:Title']['#text'];
                    }
                    if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.FeatureTypeList.FeatureType')) {
                        if (result['wfs:WFS_Capabilities'].FeatureTypeList.FeatureType.length) {
                            wfsInfo.layers = getWfsLayerNames(result['wfs:WFS_Capabilities'].FeatureTypeList.FeatureType);
                        } else {
                            wfsInfo.layers = getWfsLayerNames([result['wfs:WFS_Capabilities'].FeatureTypeList.FeatureType]);
                        }
                    } else if (BKGWebMap.Util.hasNestedProperty(result, 'WFS_Capabilities.FeatureTypeList.FeatureType') && result.WFS_Capabilities.FeatureTypeList.FeatureType.length) {
                        wfsInfo.layers = getWfsLayerNames(result.WFS_Capabilities.FeatureTypeList.FeatureType);
                    } else if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.wfs:FeatureTypeList.wfs:FeatureType')) {
                        if (result['wfs:WFS_Capabilities']['wfs:FeatureTypeList']['wfs:FeatureType'].length) {
                            wfsInfo.layers = getWfsLayerNames(result['wfs:WFS_Capabilities']['wfs:FeatureTypeList']['wfs:FeatureType']);
                        }
                    }

                    wfsInfo.formats = getWfsFormats(result);

                    // GetFeature URL
                    var operationArray;
                    if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.ows:OperationsMetadata.ows:Operation')) {
                        if (result['wfs:WFS_Capabilities']['ows:OperationsMetadata']['ows:Operation'].length) {
                            operationArray = result['wfs:WFS_Capabilities']['ows:OperationsMetadata']['ows:Operation'];
                        }
                    } else if (BKGWebMap.Util.hasNestedProperty(result, 'WFS_Capabilities.ows:OperationsMetadata.ows:Operation') && result.WFS_Capabilities['ows:OperationsMetadata']['ows:Operation'].length) {
                        operationArray = result.WFS_Capabilities['ows:OperationsMetadata']['ows:Operation'];
                    }
                    if (operationArray) {
                        for (var i = 0; i < operationArray.length; i++) {
                            if (BKGWebMap.Util.hasNestedProperty(operationArray[i], '@attributes.name')) {
                                if (operationArray[i]['@attributes'].name === 'GetFeature' && BKGWebMap.Util.hasNestedProperty(operationArray[i], 'ows:DCP.ows:HTTP.ows:Get.@attributes.xlink:href')) {
                                    url = operationArray[i]['ows:DCP']['ows:HTTP']['ows:Get']['@attributes']['xlink:href'];
                                }
                            }
                        }
                    }

                    if (url.indexOf('?') !== -1) {
                        url = url.substring(0, url.indexOf('?'));
                    }
                    return callback(title, wfsInfo, url);
                }
                showMessage('bkgwebmap-customlayerdivwfs', 'WFS-URL aufrufen');
            };
            xhr.onerror = function () {
                showMessage('bkgwebmap-customlayerdivwfs', 'WFS-URL aufrufen');
                return callback(undefined);
            };
            xhr.send();
        }

        function createWmsStyleDropdown(styleInfo) {
            var option = document.createElement('option');
            option.setAttribute('value', styleInfo.name);
            option.innerHTML = styleInfo.title;
            return option;
        }

        // Create menu with wms layer and style names
        function createWmsInfoMenu(singleLayerInfo) {
            var wmsSingleInfoContainer = document.createElement('div');
            wmsSingleInfoContainer.className = 'bkgwebmap-customlayerwmscontainer';

            var inputDiv = document.createElement('div');
            inputDiv.className = 'bkgwebmap-customlayerwmsinputdiv';

            var inputDivLabel = document.createElement('label');
            var parserIconEmpty = new DOMParser();
            var iconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');

            var input = document.createElement('input');
            input.setAttribute('type', 'checkbox');
            input.setAttribute('data-bkgwebmap-customwmslayer', singleLayerInfo.name);
            input.checked = false;
            inputDivLabel.appendChild(input);

            inputDivLabel.appendChild(iconEmpty.documentElement);
            inputDiv.appendChild(inputDivLabel);
            wmsSingleInfoContainer.appendChild(inputDiv);

            var titleDiv = document.createElement('div');
            titleDiv.className = 'bkgwebmap-customlayerwmstitlediv';
            titleDiv.innerHTML = singleLayerInfo.title;
            wmsSingleInfoContainer.appendChild(titleDiv);

            if (singleLayerInfo.styles.length > 1) {
                var dropdownDiv = document.createElement('div');
                dropdownDiv.className = 'bkgwebmap-customlayerwmsdropdowndiv';
                var styleTitle = document.createTextNode('Stil: ');
                var dropdown = document.createElement('select');
                dropdownDiv.appendChild(styleTitle);
                dropdownDiv.appendChild(dropdown);
                for (var i = 0; i < singleLayerInfo.styles.length; i++) {
                    dropdown.appendChild(createWmsStyleDropdown(singleLayerInfo.styles[i]));
                }
                wmsSingleInfoContainer.appendChild(dropdownDiv);
            }

            input.onchange = function () {
                var label = this.parentNode;
                label.removeChild(label.childNodes[1]);
                parserIconEmpty = new DOMParser();
                var clickIconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                var parserIconFull = new DOMParser();
                var clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                if (this.checked) {
                    label.appendChild(clickIconFull.documentElement);
                } else {
                    label.appendChild(clickIconEmpty.documentElement);
                }
            };

            return wmsSingleInfoContainer;
        }

        // Create menu with wmts layer name and matrix
        function createWmtsInfoMenu(wmtsInfo) {
            var i;
            var wmtsInfoContainer = document.createElement('div');
            wmtsInfoContainer.className = 'bkgwebmap-customlayerwmtscontainer';

            if (wmtsInfo.layers.length > 1) {
                var layerDivContainer = document.createElement('div');
                wmtsInfoContainer.appendChild(layerDivContainer);
                var layerTitle = document.createTextNode('Layer: ');
                layerDivContainer.appendChild(layerTitle);
                var dropdownLayers = document.createElement('select');
                dropdownLayers.className = 'bkgwebmap-customlayerwmtsdropdownlayers';
                layerDivContainer.appendChild(dropdownLayers);
                var optionLayers;
                for (i = 0; i < wmtsInfo.layers.length; i++) {
                    optionLayers = document.createElement('option');
                    optionLayers.setAttribute('value', wmtsInfo.layers[i].layer);
                    optionLayers.innerHTML = wmtsInfo.layers[i].title;
                    dropdownLayers.appendChild(optionLayers);
                }
            } else {
                var layerDivTitle = document.createElement('div');
                layerDivTitle.className = 'bkgwebmap-customlayerwmtsdivlayers';
                layerDivTitle.setAttribute('data-bkgwebmap-customlayerwmtsname', wmtsInfo.layers[0].layer);
                layerDivTitle.innerHTML = 'Layer: ' + wmtsInfo.layers[0].title;
                wmtsInfoContainer.appendChild(layerDivTitle);
            }

            if (wmtsInfo.matrixSets.length > 1) {
                var matrixSetDivContainer = document.createElement('div');
                wmtsInfoContainer.appendChild(matrixSetDivContainer);
                var matrixSetTitle = document.createTextNode('Matrix Set: ');
                matrixSetDivContainer.appendChild(matrixSetTitle);
                var dropdownMatrixSet = document.createElement('select');
                dropdownMatrixSet.className = 'bkgwebmap-customlayerwmtsdropdownmatrix';
                matrixSetDivContainer.appendChild(dropdownMatrixSet);
                var optionMatrixSet;
                var currentEPSG = parseFloat(map.getView().getProjection().getCode().replace(/[^\d.]/g, ''));
                for (i = 0; i < wmtsInfo.matrixSets.length; i++) {
                    optionMatrixSet = document.createElement('option');
                    optionMatrixSet.setAttribute('value', wmtsInfo.matrixSets[i]);
                    if (wmtsInfo.matrixSets[i].indexOf(currentEPSG) > -1) {
                        optionMatrixSet.selected = 'selected';
                    }
                    optionMatrixSet.innerHTML = wmtsInfo.matrixSets[i];
                    dropdownMatrixSet.appendChild(optionMatrixSet);
                }
            } else {
                var layerDivMatrixSet = document.createElement('div');
                layerDivMatrixSet.className = 'bkgwebmap-customlayerwmtsdivmatrix';
                layerDivMatrixSet.setAttribute('data-bkgwebmap-customlayerwmtsmatrixset', wmtsInfo.matrixSets[0]);
                layerDivMatrixSet.innerHTML = 'Matrix Set: ' + wmtsInfo.matrixSets[0];
                wmtsInfoContainer.appendChild(layerDivMatrixSet);
            }
            return wmtsInfoContainer;
        }

        // Create menu for wfs layer
        function createWfsInfoMenu(wfsInfo) {
            var i;
            var wfsInfoContainer = document.createElement('div');
            wfsInfoContainer.className = 'bkgwebmap-customlayerwfscontainer';

            if (wfsInfo.layers.length > 1) {
                var layerDivContainer = document.createElement('div');
                layerDivContainer.className = 'bkgwebmap-customlayerwfsdivlayers';
                wfsInfoContainer.appendChild(layerDivContainer);
                var layerTitle = document.createTextNode('Layer: ');
                layerDivContainer.appendChild(layerTitle);
                var dropdownLayers = document.createElement('select');
                dropdownLayers.className = 'bkgwebmap-customlayerwfsdropdownlayers';
                layerDivContainer.appendChild(dropdownLayers);
                var optionLayers;
                for (i = 0; i < wfsInfo.layers.length; i++) {
                    optionLayers = document.createElement('option');
                    optionLayers.setAttribute('value', wfsInfo.layers[i].name);
                    optionLayers.innerHTML = wfsInfo.layers[i].title;
                    dropdownLayers.appendChild(optionLayers);
                }
            } else {
                var layerDivTitle = document.createElement('div');
                layerDivTitle.className = 'bkgwebmap-customlayerwfsdivlayers bkgwebmap-customlayerwfsdivname';
                layerDivTitle.setAttribute('data-bkgwebmap-customlayerwfsname', wfsInfo.layers[0].name);
                layerDivTitle.innerHTML = 'Layer: ' + wfsInfo.layers[0].title;
                wfsInfoContainer.appendChild(layerDivTitle);
            }

            var inputDiv = document.createElement('div');
            inputDiv.className = 'bkgwebmap-customlayerwfsdivlayers';

            var epsgTitle = document.createTextNode('EPSG:');
            inputDiv.appendChild(epsgTitle);

            var input = document.createElement('input');
            input.className = 'bkgwebmap-customlayerwfsepsginput';
            input.value = '25832';
            inputDiv.appendChild(input);
            var epsgExample = document.createElement('span');
            epsgExample.innerHTML = 'Default: 25832';
            epsgExample.className = 'bkgwebmap-customlayerinputexample bkgwebmap-customlayerinputexamplewfs';
            inputDiv.appendChild(epsgExample);

            wfsInfoContainer.appendChild(inputDiv);

            var formatDivContainer = document.createElement('div');
            formatDivContainer.className = 'bkgwebmap-customlayerwfsdivlayers';
            wfsInfoContainer.appendChild(formatDivContainer);
            var formatTitle = document.createTextNode('Format: ');
            formatDivContainer.appendChild(formatTitle);
            var dropdownFormat = document.createElement('select');
            dropdownFormat.className = 'bkgwebmap-customlayerwfsdropdownformat';
            formatDivContainer.appendChild(dropdownFormat);
            var formats = ['GEOJSON', 'GML3', 'GML2'];
            if (wfsInfo.formats instanceof Array && wfsInfo.formats.length) {
                formats = wfsInfo.formats;
            }
            var geojsonIndex = formats.indexOf('GEOJSON');
            if (geojsonIndex !== -1) {
                formats.splice(geojsonIndex, 1);
                formats.splice(0, 0, 'GEOJSON');
            }
            var optionFormat;
            for (i = 0; i < formats.length; i++) {
                optionFormat = document.createElement('option');
                optionFormat.setAttribute('value', formats[i]);
                optionFormat.innerHTML = formats[i];
                dropdownFormat.appendChild(optionFormat);
            }

            var versionDivContainer = document.createElement('div');
            versionDivContainer.className = 'bkgwebmap-customlayerwfsdivlayers';
            wfsInfoContainer.appendChild(versionDivContainer);
            var versionTitle = document.createTextNode('Version: ');
            versionDivContainer.appendChild(versionTitle);
            var dropdownVersion = document.createElement('select');
            dropdownVersion.className = 'bkgwebmap-customlayerwfsdropdownversion';
            versionDivContainer.appendChild(dropdownVersion);
            var versions = ['1.0.0', '1.1.0', '2.0.0'];
            var optionVersion;
            for (i = 0; i < versions.length; i++) {
                optionVersion = document.createElement('option');
                optionVersion.setAttribute('value', versions[i]);
                optionVersion.innerHTML = versions[i];
                dropdownVersion.appendChild(optionVersion);
            }

            return wfsInfoContainer;
        }

        // Load WMS
        function loadWmsLayer(wmsInfoContainer, url) {
            var name = wmsInfoContainer.getElementsByClassName('bkgwebmap-customlayerwmsinfonameinput')[0].value;
            if (name === '') {
                name = 'WMS';
            }
            var layerOptions = {
                type: 'WMS',
                name: name,
                url: url,
                visibility: true,
                tiles: false,
                layers: []
            };

            var tilesInput = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmstilesinput')[0];
            if (tilesInput.checked) {
                layerOptions.tiles = true;
            }

            var layersMenu = wmsInfoContainer.getElementsByClassName('bkgwebmap-customlayerwmscontainer');
            var input;
            var singleLayer;
            for (var i = 0; i < layersMenu.length; i++) {
                singleLayer = {};
                input = layersMenu[i].getElementsByTagName('input')[0];
                if (input.checked) {
                    singleLayer.layer = input.getAttribute('data-bkgwebmap-customwmslayer');
                    singleLayer.name = input.parentNode.parentNode.nextSibling.innerHTML;

                    var styleContainer = input.parentNode.parentNode.nextSibling.nextSibling;
                    if (styleContainer && styleContainer.getElementsByTagName('select').length) {
                        singleLayer.style = styleContainer.getElementsByTagName('select')[0].value;
                    }
                    layerOptions.layers.push(singleLayer);
                }
            }
            if (layerOptions.layers.length) {
                _this.createLayer(_this, map, layerOptions, 'overlays', null, false, function (layer) {
                    addLayerToMap(layer);
                });
            }
        }

        // Load WMTS
        function loadWmtsLayer(wmtsInfoContainer, url) {
            var name = wmtsInfoContainer.getElementsByClassName('bkgwebmap-customlayerwmtsinfonameinput')[0].value;
            if (name === '') {
                name = 'WMTS';
            }
            var layerOptions = {
                type: 'WMTS',
                name: name,
                url: url,
                visibility: true,
                layer: '',
                matrixSet: ''
            };
            var layersMenu = wmtsInfoContainer.getElementsByClassName('bkgwebmap-customlayerwmtscontainer')[0];

            if (layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdropdownlayers').length) {
                layerOptions.layer = layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdropdownlayers')[0].value;
            } else if (layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdivlayers').length) {
                layerOptions.layer = layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdivlayers')[0].getAttribute('data-bkgwebmap-customlayerwmtsname');
            }

            if (layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdropdownmatrix').length) {
                layerOptions.matrixSet = layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdropdownmatrix')[0].value;
            } else if (layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdivmatrix').length) {
                layerOptions.matrixSet = layersMenu.getElementsByClassName('bkgwebmap-customlayerwmtsdivmatrix')[0].getAttribute('data-bkgwebmap-customlayerwmtsmatrixset');
            }

            _this.createLayer(_this, map, layerOptions, 'overlays', null, false, function (layer) {
                addLayerToMap(layer);
            });
        }

        // Load WFS
        function loadWfsLayer(wfsInfoContainer, url) {
            var name = wfsInfoContainer.getElementsByClassName('bkgwebmap-customlayerwfsinfonameinput')[0].value;
            if (name === '') {
                name = 'WFS';
            }

            var layerOptions = {
                type: 'WFS',
                name: name,
                url: url,
                visibility: true,
                version: '',
                typename: '',
                srsName: '',
                format: '',
                edit: edit
            };

            if (style) {
                layerOptions.style = style;
            }

            if (styleName) {
                layerOptions.styleName = style;
            }

            var layersMenu = wfsInfoContainer.getElementsByClassName('bkgwebmap-customlayerwfscontainer')[0];

            if (layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsdropdownlayers').length) {
                layerOptions.typename = layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsdropdownlayers')[0].value;
            } else if (layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsdivname').length) {
                layerOptions.typename = layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsdivname')[0].getAttribute('data-bkgwebmap-customlayerwfsname');
            }

            layerOptions.srsName = 'EPSG:' + layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsepsginput')[0].value;

            layerOptions.format = layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsdropdownformat')[0].value;

            layerOptions.version = layersMenu.getElementsByClassName('bkgwebmap-customlayerwfsdropdownversion')[0].value;

            _this.createLayer(_this, map, layerOptions, 'overlays', _this.styles, false, function (layer) {
                addLayerToMap(layer);
            });
        }

        // Load CSV / XLS
        function loadCsvEcxelData(format, json, csvExcelInfoContainer) {
            var i;
            var layerOptions = {
                name: '',
                type: '',
                url: json,
                visibility: true,
                srsName: '',
                edit: edit
            };

            if (style) {
                layerOptions.style = style;
            }

            if (styleName) {
                layerOptions.styleName = style;
            }

            var options = '';

            if (!json.length) {
                return;
            }

            if (format === 'csv') {
                options = 'csvOptions';
                layerOptions[options] = {};
                layerOptions.type = 'CSV';
                layerOptions.srsName = BKGWebMap.LAYERS.CSV.PROJECTION;
                layerOptions.encoding = BKGWebMap.LAYERS.CSV.ENCODING;
                var encoding = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvencinput')[0].value;
                if (encoding) {
                    layerOptions.encoding = encoding;
                }
            } else if (format === 'excel') {
                options = 'excelOptions';
                layerOptions[options] = {};
                layerOptions.type = 'XLS';
                layerOptions.srsName = BKGWebMap.LAYERS.XLS.PROJECTION;
            }

            layerOptions.name = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvinfonameinput')[0].value;
            if (layerOptions.name === '') {
                layerOptions.name = layerOptions.type;
            }

            layerOptions[options].header = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvheader')[0].checked;

            var latColumn = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvlat')[0].value;
            if (latColumn && !isNaN(latColumn)) {
                layerOptions[options].LatColumn = parseInt(latColumn, 10);
            } else if (latColumn) {
                layerOptions[options].LatColumn = latColumn;
            }

            var lonColumn = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvlon')[0].value;
            if (lonColumn && !isNaN(lonColumn)) {
                layerOptions[options].LonColumn = parseInt(lonColumn, 10);
            } else if (lonColumn) {
                layerOptions[options].LonColumn = lonColumn;
            }

            // Find columns to parse
            var index;
            layerOptions[options].columnsToParse = [];
            for (i = 0; i < json[0].length; i++) {
                index = i + 1;

                if (layerOptions[options].header) {
                    if (layerOptions[options].LatColumn === json[0][i] || layerOptions[options].LonColumn === json[0][i]) {
                        continue;
                    }
                    layerOptions[options].columnsToParse.push(json[0][i]);
                } else {
                    if (layerOptions[options].LatColumn === index || layerOptions[options].LonColumn === index) {
                        continue;
                    }
                    layerOptions[options].columnsToParse.push(index);
                }
            }

            // Fill column names with empty strings (used if no header)
            layerOptions[options].columnNames = [];
            for (i = 0; i < layerOptions[options].columnsToParse.length; i++) {
                layerOptions[options].columnNames.push('');
            }

            var epsg = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvepsginput')[0].value;
            if (epsg) {
                layerOptions.srsName = 'EPSG:' + epsg;
            }
            _this.createLayer(_this, map, layerOptions, 'overlays', _this.styles, false, function (layer) {
                addLayerToMap(layer);
                clearForms('CSV');
            });
        }

        function openCsvExcelFile(container, filename, format, json, csvExcelInfoContainer) {
            var i;
            var optionFormat;
            var header = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvheader')[0].checked;
            var csvInfoName = document.createElement('div');
            csvInfoName.innerHTML = 'Titel eingeben:';
            csvInfoName.className = 'bkgwebmap-customlayerexcelinfoname';
            container.appendChild(csvInfoName);

            var inputDiv = document.createElement('input');
            inputDiv.value = filename;
            inputDiv.className = 'bkgwebmap-customlayerinput bkgwebmap-customlayercsvinfonameinput';
            container.appendChild(inputDiv);

            // Latitude
            var latDiv = document.createElement('div');
            latDiv.className = 'bkgwebmap-customlayercsvexcelmenu';
            container.appendChild(latDiv);
            var latTitle = document.createElement('div');
            latTitle.className = 'bkgwebmap-customlayercsvexcelitem';
            latTitle.innerHTML = 'Lat-Spalte:';
            latDiv.appendChild(latTitle);
            var latInputDiv = document.createElement('div');
            latInputDiv.className = 'bkgwebmap-customlayercsvexcelitem bkgwebmap-customlayercsvcoordinputdiv';
            latDiv.appendChild(latInputDiv);

            var latInput = document.createElement('select');
            latInput.className = 'bkgwebmap-customlayercsvinput bkgwebmap-customlayercsvcoordinput bkgwebmap-customlayercsvlat';
            latInputDiv.appendChild(latInput);
            if (json[0] instanceof Array) {
                optionFormat = document.createElement('option');
                optionFormat.setAttribute('disabled', '');
                optionFormat.setAttribute('selected', '');
                optionFormat.innerHTML = 'Spalte auswählen';
                latInput.appendChild(optionFormat);
                for (i = 0; i < json[0].length; i++) {
                    optionFormat = document.createElement('option');
                    if (header) {
                        optionFormat.setAttribute('value', json[0][i]);
                        optionFormat.innerHTML = json[0][i];
                    } else {
                        optionFormat.setAttribute('value', i + 1);
                        optionFormat.innerHTML = i + 1;
                    }
                    latInput.appendChild(optionFormat);
                }
            }

            // Longitude
            var lonDiv = document.createElement('div');
            lonDiv.className = 'bkgwebmap-customlayercsvexcelmenu';
            container.appendChild(lonDiv);
            var lonTitle = document.createElement('span');
            lonTitle.innerHTML = 'Lon-Spalte:';
            lonDiv.appendChild(lonTitle);
            var lonInputDiv = document.createElement('div');
            lonInputDiv.className = 'bkgwebmap-customlayercsvexcelitem bkgwebmap-customlayercsvcoordinputdiv';
            lonDiv.appendChild(lonInputDiv);

            var lonInput = document.createElement('select');
            lonInput.className = 'bkgwebmap-customlayercsvinput bkgwebmap-customlayercsvcoordinput bkgwebmap-customlayercsvlon';
            lonInputDiv.appendChild(lonInput);

            if (json[0] instanceof Array) {
                optionFormat = document.createElement('option');
                optionFormat.setAttribute('disabled', '');
                optionFormat.setAttribute('selected', '');
                optionFormat.innerHTML = 'Spalte auswählen';
                lonInput.appendChild(optionFormat);
                for (i = 0; i < json[0].length; i++) {
                    optionFormat = document.createElement('option');
                    if (header) {
                        optionFormat.setAttribute('value', json[0][i]);
                        optionFormat.innerHTML = json[0][i];
                    } else {
                        optionFormat.setAttribute('value', i + 1);
                        optionFormat.innerHTML = i + 1;
                    }
                    lonInput.appendChild(optionFormat);
                }
            }

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'Daten laden';
            container.appendChild(inputButton);

            container.style.display = 'block';

            inputButton.addEventListener('click', function () {
                loadCsvEcxelData(format, json, csvExcelInfoContainer);
            }, true);
        }

        function loadGpsLayer(container, gpx, gpsInfoContainer) {
            var layerOptions = {
                type: 'GPS',
                name: '',
                url: [gpx],
                visibility: true,
                edit: edit
            };

            if (style) {
                layerOptions.style = style;
            }

            if (styleName) {
                layerOptions.styleName = style;
            }

            layerOptions.name = gpsInfoContainer.getElementsByClassName('bkgwebmap-customlayergpsinfonameinput')[0].value;
            if (layerOptions.name === '') {
                layerOptions.name = layerOptions.type;
            }
            _this.createLayer(_this, map, layerOptions, 'overlays', _this.styles, false, function (layer) {
                addLayerToMap(layer);
                container.innerHTML = '';
                clearForms('GPS');
            });
        }

        function openGpsFile(container, filename, gpx, gpsInfoContainer) {
            var gpsInfoName = document.createElement('div');
            gpsInfoName.innerHTML = 'Titel eingeben:';
            gpsInfoName.className = 'bkgwebmap-customlayergpsinfoname';
            container.appendChild(gpsInfoName);

            var inputDiv = document.createElement('input');
            inputDiv.value = filename;
            inputDiv.className = 'bkgwebmap-customlayerinput bkgwebmap-customlayergpsinfonameinput';
            container.appendChild(inputDiv);

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'Daten laden';
            container.appendChild(inputButton);

            container.style.display = 'block';

            inputButton.addEventListener('click', function () {
                loadGpsLayer(container, gpx, gpsInfoContainer);
            }, true);
        }

        // Create container for menu with wms layer and style names
        function addWmsInfoToDom(title, wmsInfo, url) {
            var wmsInfoContainer = document.createElement('div');
            wmsInfoContainer.className = 'bkgwebmap-customlayerwmsinfodiv';

            var wmsInfoName = document.createElement('div');
            wmsInfoName.innerHTML = 'Titel eingeben:';
            wmsInfoName.className = 'bkgwebmap-customlayerwmsinfoname';
            wmsInfoContainer.appendChild(wmsInfoName);

            var inputDiv = document.createElement('input');
            inputDiv.value = title;
            inputDiv.className = 'bkgwebmap-customlayerinput bkgwebmap-customlayerwmsinfonameinput';
            wmsInfoContainer.appendChild(inputDiv);

            var inputTilesDiv = document.createElement('div');
            inputTilesDiv.className = 'bkgwebmap-customlayerwmsinputdiv';
            wmsInfoContainer.appendChild(inputTilesDiv);

            var inputTilesLabel = document.createElement('label');

            var inputTiles = document.createElement('input');
            inputTiles.className = 'bkgwebmap-customlayerwmstilesinput';
            inputTiles.setAttribute('type', 'checkbox');
            inputTilesLabel.appendChild(inputTiles);


            var parserIconFull = new DOMParser();
            var clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
            inputTilesLabel.appendChild(clickIconFull.documentElement);
            inputTilesDiv.appendChild(inputTilesLabel);

            inputTiles.checked = true;

            inputTiles.onchange = function () {
                var label = this.parentNode;
                label.removeChild(label.childNodes[1]);
                var parserIconEmpty = new DOMParser();
                var clickIconEmpty = parserIconEmpty.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_HIDDEN, 'text/xml');
                var parserIconFull = new DOMParser();
                var clickIconFull = parserIconFull.parseFromString(BKGWebMap.PANEL_ICONS.LAYER_SHOWN, 'text/xml');
                if (this.checked) {
                    label.appendChild(clickIconFull.documentElement);
                } else {
                    label.appendChild(clickIconEmpty.documentElement);
                }
            };

            var inputTilesTitle = document.createElement('span');
            inputTilesTitle.className = 'bkgwebmap-customlayerwmstitlediv';
            inputTilesTitle.innerHTML = 'Gekachelt einbinden';
            inputTilesDiv.appendChild(inputTilesTitle);


            wmsInfoContainer.appendChild(inputTilesDiv);

            var wmsInfoContainerText = document.createElement('div');
            wmsInfoContainerText.className = 'bkgwebmap-customlayerwmsstyle';
            wmsInfoContainerText.innerHTML = 'Layer und Stil auswählen:';
            wmsInfoContainer.appendChild(wmsInfoContainerText);
            createWmsInfoContainer(wmsInfoContainer, wmsInfo);

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'Dienst laden';
            wmsInfoContainer.appendChild(inputButton);

            inputButton.addEventListener('click', function () {
                loadWmsLayer(wmsInfoContainer, url);
            }, true);

            return wmsInfoContainer;
        }

        function createWmsInfoContainer(wmsInfoContainer, wmsInfo) {
            for (var i = 0; i < wmsInfo.length; i++) {
                if (Object.prototype.hasOwnProperty.call(wmsInfo[i], 'layers')) {
                    var wmsSublayersWrapper = document.createElement('div');
                    var wmsLayersHeader = document.createElement('div');
                    wmsLayersHeader.className = 'bkgwebmap-customlayerwmsheader';

                    var wmsLevelTitle = document.createElement('div');
                    wmsLevelTitle.innerHTML = wmsInfo[i].title;
                    wmsLevelTitle.className = 'bkgwebmap-customlayerwmsheadertext';

                    var wmsMinusDiv = document.createElement('div');
                    wmsMinusDiv.className = 'bkgwebmap-customlayerwmsheaderplusminus';
                    wmsMinusDiv.innerHTML = '+';

                    wmsLayersHeader.appendChild(wmsLevelTitle);
                    wmsLayersHeader.appendChild(wmsMinusDiv);

                    var wmsSubLayersContainer = document.createElement('div');
                    wmsSubLayersContainer.className = 'bkgwebmap-wmssublayersgroupcontainer';

                    wmsSublayersWrapper.appendChild(wmsLayersHeader);
                    wmsSublayersWrapper.appendChild(wmsSubLayersContainer);
                    wmsSubLayersContainer.style.display = 'none';
                    wmsLayersHeader.addEventListener('click', function () {
                        var parent = this.parentNode;
                        var container = parent.getElementsByClassName('bkgwebmap-wmssublayersgroupcontainer')[0];
                        var minusPlus = parent.getElementsByClassName('bkgwebmap-customlayerwmsheaderplusminus')[0];
                        container.style.display = container.style.display === 'none' ? 'block' : 'none';
                        minusPlus.innerHTML = minusPlus.innerHTML === '+' ? '-' : '+';
                    });
                    wmsInfoContainer.appendChild(wmsSublayersWrapper);
                    createWmsInfoContainer(wmsSubLayersContainer, wmsInfo[i].layers);
                } else {
                    wmsInfoContainer.appendChild(createWmsInfoMenu(wmsInfo[i]));
                }
            }
        }

        // Create container for WMTS
        function addWmtsInfoToDom(title, wmtsInfo, url) {
            var wmtsInfoContainer = document.createElement('div');
            wmtsInfoContainer.className = 'bkgwebmap-customlayerwmtsinfodiv';

            var wmtsInfoName = document.createElement('div');
            wmtsInfoName.innerHTML = 'Titel eingeben:';
            wmtsInfoName.className = 'bkgwebmap-customlayerwmtsinfoname';
            wmtsInfoContainer.appendChild(wmtsInfoName);

            var inputDiv = document.createElement('input');
            inputDiv.value = title;
            inputDiv.className = 'bkgwebmap-customlayerinput bkgwebmap-customlayerwmtsinfonameinput';
            wmtsInfoContainer.appendChild(inputDiv);

            wmtsInfoContainer.appendChild(createWmtsInfoMenu(wmtsInfo));

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'Dienst laden';
            wmtsInfoContainer.appendChild(inputButton);

            inputButton.addEventListener('click', function () {
                loadWmtsLayer(wmtsInfoContainer, url);
            }, true);

            return wmtsInfoContainer;
        }

        function addWfsInfoToDom(title, wfsInfo, url) {
            var wfsInfoContainer = document.createElement('div');
            wfsInfoContainer.className = 'bkgwebmap-customlayerwfsinfodiv';

            var wfsInfoName = document.createElement('div');
            wfsInfoName.innerHTML = 'Titel eingeben:';
            wfsInfoName.className = 'bkgwebmap-customlayerfinfoname';
            wfsInfoContainer.appendChild(wfsInfoName);

            var inputDiv = document.createElement('input');
            inputDiv.value = title;
            inputDiv.className = 'bkgwebmap-customlayerinput bkgwebmap-customlayerwfsinfonameinput';
            wfsInfoContainer.appendChild(inputDiv);

            wfsInfoContainer.appendChild(createWfsInfoMenu(wfsInfo));

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'Dienst laden';
            wfsInfoContainer.appendChild(inputButton);

            inputButton.addEventListener('click', function () {
                loadWfsLayer(wfsInfoContainer, url);
            }, true);

            return wfsInfoContainer;
        }

        function addCsvExcelMenu(format) {
            var fileButtonText = 'Excel-Datei auswählen';
            var acceptFiles = '.xlsx,.xls,.ods';

            var csvExcelInfoContainer = document.createElement('div');
            csvExcelInfoContainer.className = 'bkgwebmap-customlayercsvexcelinfodiv';

            // Header
            var headerDiv = document.createElement('div');
            headerDiv.className = 'bkgwebmap-customlayercsvexcelmenu';
            csvExcelInfoContainer.appendChild(headerDiv);
            var headerTitle = document.createElement('div');
            headerTitle.className = 'bkgwebmap-customlayercsvexcelitem';
            headerTitle.innerHTML = 'Erste Zeile als Header:';
            headerDiv.appendChild(headerTitle);
            var headerInputDiv = document.createElement('div');
            headerInputDiv.className = 'bkgwebmap-customlayercsvexcelitem';
            headerDiv.appendChild(headerInputDiv);
            var headerInput = document.createElement('input');
            headerInput.className = 'bkgwebmap-customlayercsvheader';
            headerInput.setAttribute('type', 'checkbox');
            headerInput.setAttribute('name', 'header');
            headerInput.setAttribute('checked', '');
            headerInputDiv.appendChild(headerInput);

            // EPSG
            var epsgDiv = document.createElement('div');
            epsgDiv.className = 'bkgwebmap-customlayercsvexcelmenu';
            csvExcelInfoContainer.appendChild(epsgDiv);
            var epsgTitle = document.createElement('span');
            epsgTitle.innerHTML = 'EPSG:';
            epsgDiv.appendChild(epsgTitle);
            var epsgInputDiv = document.createElement('div');
            epsgInputDiv.className = 'bkgwebmap-customlayercsvexcelitem bkgwebmap-customlayercsvepsginputdiv';
            epsgDiv.appendChild(epsgInputDiv);
            var epsgInput = document.createElement('input');
            epsgInput.value = '4326';
            epsgInput.setAttribute('type', 'text');
            epsgInput.className = 'bkgwebmap-customlayercsvinput bkgwebmap-customlayercsvepsginput';
            epsgInputDiv.appendChild(epsgInput);

            if (format === 'csv') {
                fileButtonText = 'CSV-Datei auswählen';
                acceptFiles = '.csv';

                // Delimiter
                var delimiterDiv = document.createElement('div');
                delimiterDiv.className = 'bkgwebmap-customlayercsvexcelmenu';
                csvExcelInfoContainer.appendChild(delimiterDiv);
                var delimiterTitle = document.createElement('span');
                delimiterTitle.innerHTML = 'Trennzeichen:';
                delimiterDiv.appendChild(delimiterTitle);
                var delimiterInputDiv = document.createElement('div');
                delimiterInputDiv.className = 'bkgwebmap-customlayercsvexcelitem bkgwebmap-customlayercsvdelinputdiv';
                delimiterDiv.appendChild(delimiterInputDiv);
                var delimiterInput = document.createElement('input');
                delimiterInput.value = ';';
                delimiterInput.setAttribute('type', 'text');
                delimiterInput.className = 'bkgwebmap-customlayercsvinput bkgwebmap-customlayercsvdelinput';
                delimiterInputDiv.appendChild(delimiterInput);

                // Encoding
                var encodingDiv = document.createElement('div');
                encodingDiv.className = 'bkgwebmap-customlayercsvexcelmenu';
                csvExcelInfoContainer.appendChild(encodingDiv);
                var encodingTitle = document.createElement('span');
                encodingTitle.innerHTML = 'Kodierung:';
                encodingDiv.appendChild(encodingTitle);
                var encodingInputDiv = document.createElement('div');
                encodingInputDiv.className = 'bkgwebmap-customlayercsvexcelitem bkgwebmap-customlayercsvencinputdiv';
                encodingDiv.appendChild(encodingInputDiv);
                var encodingInput = document.createElement('input');
                encodingInput.setAttribute('type', 'text');
                encodingInput.value = 'UTF-8';
                encodingInput.className = 'bkgwebmap-customlayercsvinput bkgwebmap-customlayercsvencinput';
                encodingDiv.appendChild(encodingInput);
            }

            // Select file
            var selectFileDiv = document.createElement('div');
            selectFileDiv.className = 'bkgwebmap-customlayercsvexcelfilediv';
            csvExcelInfoContainer.appendChild(selectFileDiv);

            var fileButtonLabel = document.createElement('label');
            fileButtonLabel.className = 'bkgwebmap-customlayercsvexcelfilelabel';
            fileButtonLabel.innerHTML = fileButtonText;
            csvExcelInfoContainer.appendChild(fileButtonLabel);


            var fileButton = document.createElement('input');
            fileButton.className = 'bkgwebmap-customlayerinputbutton bkgwebmap-customlayercsvexcelfilebutton';
            fileButton.setAttribute('type', 'file');
            fileButton.setAttribute('accept', acceptFiles);

            fileButtonLabel.appendChild(fileButton);

            var container = document.createElement('div');
            container.className = 'bkgwebmap-customlayeremptycontainer';
            container.style.display = 'none';
            csvExcelInfoContainer.appendChild(container);

            // CSV
            if (format === 'csv') {
                fileButton.onchange = function (evt) {
                    var input = evt.target;

                    var filename = '';
                    if (input.files[0] && input.files[0].name) {
                        filename = input.files[0].name;
                    }
                    filename = filename.replace('.csv', '');
                    filename = filename.replace('.CSV', '');

                    var reader = new FileReader();
                    reader.readAsText(input.files[0]);
                    reader.onload = function (event) {
                        var delimiter = BKGWebMap.LAYERS.CSV.DELIMITER;
                        var customDelimiter = csvExcelInfoContainer.getElementsByClassName('bkgwebmap-customlayercsvdelinput')[0].value;
                        if (customDelimiter) {
                            delimiter = customDelimiter;
                        }
                        var result = 'sep=' + delimiter + '\n' + event.target.result;
                        var workbook = XLSX.read(result, { type: 'binary' });
                        var sheet = workbook.Sheets[workbook.SheetNames[0]];
                        var json = XLSX.utils.sheet_to_json(sheet, { header: 1 });
                        clearForms('CSV');
                        openCsvExcelFile(container, filename, format, json, csvExcelInfoContainer);
                    };
                    fileButton.value = '';
                };
            } else if (format === 'excel') {
                // EXCEL
                fileButton.onchange = function (evt) {
                    var file = evt.target.files[0];

                    var filename = '';
                    if (file && file.name) {
                        filename = file.name;
                    }
                    filename = filename.replace('.xlsx', '');
                    filename = filename.replace('.XLSX', '');
                    filename = filename.replace('.xls', '');
                    filename = filename.replace('.XLS', '');

                    var reader = new FileReader();

                    reader.onload = function (event) {
                        var binary = '';
                        var bytes = new Uint8Array(event.target.result);
                        for (var i = 0; i < bytes.byteLength; i++) {
                            binary += String.fromCharCode(bytes[i]);
                        }
                        var workbook = XLSX.read(binary, { type: 'binary' });
                        var sheet = workbook.Sheets[workbook.SheetNames[0]];
                        var json = XLSX.utils.sheet_to_json(sheet, { header: 1 });
                        clearForms('XLS');
                        openCsvExcelFile(container, filename, format, json, csvExcelInfoContainer);
                    };
                    reader.readAsArrayBuffer(file);
                    fileButton.value = '';
                };
            }

            return csvExcelInfoContainer;
        }

        // Create a custom layer
        this.createLayer = function (_this, map, config, layerGroup, styles, bkg, createLayerCallback) {
            config.isBaseLayer = false;
            BKGWebMap.Layer.FACTORIES[config.type](_this, map, config, styles, bkg, function (layer) {
                return createLayerCallback(layer);
            });
        };

        // Add layer in layer switcher control
        function addLayerToMap(layer) {
            if (layer === undefined) {
                return;
            }
            layer.setProperties({ customLayer: true });
            map.addLayer(layer);
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.LayerSwitcher && control instanceof BKGWebMap.Control.LayerSwitcher) {
                    control.addInLayerSwitcher(layer, false, false, false, _this.changeVisibility);
                    control.resolutionLimits(layer);
                    control.ajaxLoader(layer);
                }
                if (BKGWebMap.Control.Legend && control instanceof BKGWebMap.Control.Legend) {
                    control.addLayerToLegend(layer);
                }
                if (BKGWebMap.Control.Copyright && control instanceof BKGWebMap.Control.Copyright) {
                    control.addLayerInCopyright(layer);
                }
            });

            return true;
        }

        // Add BKG Layer
        function createCustomBKG() {
            var layerOptions = {
                type: 'BKG',
                visibility: true
            };

            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'BKG');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivbkg';

            var bkgServiceTypeTitle = document.createElement('div');
            bkgServiceTypeTitle.innerHTML = 'BKG-Dienst auswählen:';
            typeDiv.appendChild(bkgServiceTypeTitle);

            var bkgServiceDropdownDiv = document.createElement('div');
            bkgServiceDropdownDiv.className = 'bkgwebmap-customlayertypedropdownbkg';
            typeDiv.appendChild(bkgServiceDropdownDiv);

            var bkgServiceDropdownInput = document.createElement('input');
            bkgServiceDropdownInput.setAttribute('placeholder', 'Suchen...');
            bkgServiceDropdownInput.className = 'bkgwebmap-customlayertypeinputbkg';
            bkgServiceDropdownDiv.appendChild(bkgServiceDropdownInput);

            var bkgServiceDropdownList = document.createElement('ul');
            bkgServiceDropdownList.className = 'bkgwebmap-customlayertypelistbkg';
            bkgServiceDropdownDiv.appendChild(bkgServiceDropdownList);

            bkgServiceDropdownInput.onkeyup = function (event) {
                var i;
                if (event.key && event.keyCode === 40) {
                    event.preventDefault();
                    var list = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayertypelistbkg')[0];
                    var allItems = list.childNodes;
                    if (allItems && allItems.length) {
                        for (i = 0; i < allItems.length; i++) {
                            allItems[i].classList.remove('bkgwebmap-customlayertypeliactivebkg');
                        }
                        i = 0;
                        var focus;
                        do {
                            if (allItems[i].style.display !== 'none') {
                                allItems[i].childNodes[0].focus();
                                allItems[i].classList.add('bkgwebmap-customlayertypeliactivebkg');
                                focus = true;
                            }
                            i++;
                        } while (!focus && i < allItems.length);
                    }
                }
                var filter;
                var li;
                var a;
                filter = bkgServiceDropdownInput.value.toUpperCase();
                li = bkgServiceDropdownList.getElementsByTagName('li');
                for (i = 0; i < li.length; i++) {
                    a = li[i].getElementsByTagName('a')[0];
                    if (a.innerHTML.toUpperCase().indexOf(filter) > -1) {
                        li[i].style.display = '';
                    } else {
                        li[i].style.display = 'none';
                    }
                }
            };

            function pressArrows(event) {
                if (event.key && event.keyCode === 40) {
                    event.preventDefault();
                    var nextSibling = event.target.parentNode.nextSibling;
                    hightlightBkgListItem(nextSibling, true);
                } else if (event.key && event.keyCode === 38) {
                    var previousSibling = event.target.parentNode.previousSibling;
                    hightlightBkgListItem(previousSibling, false);
                }
            }

            getBkgServiceIds(function (ids) {
                if (ids.length) {
                    var listItem;
                    var a;
                    for (var i = 0; i < ids.length; i++) {
                        listItem = document.createElement('li');
                        listItem.className = 'bkgwebmap-customlayertypelibkg';
                        a = document.createElement('a');
                        a.setAttribute('href', 'javascript:void(0)');
                        a.innerHTML = ids[i];
                        listItem.appendChild(a);
                        listItem.setAttribute('data-bkgdienstid', ids[i]);
                        bkgServiceDropdownList.appendChild(listItem);
                        listItem.onclick = function () {
                            bkgServiceDropdownInput.innerHTML = this.firstChild.innerHTML;
                            var selectedId = this.getAttribute('data-bkgdienstid');
                            layerOptions.ref = selectedId;

                            _this.createLayer(_this, map, layerOptions, 'overlays', null, false, function (layer) {
                                addLayerToMap(layer);
                            });
                        };
                        a.onfocus = function () {
                            this.parentNode.addEventListener('keydown', pressArrows);
                        };
                        listItem.addEventListener('mouseenter', function () {
                            this.firstChild.focus();
                            var allItems = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayertypelibkg');
                            for (var i = 0; i < allItems.length; i++) {
                                allItems[i].classList.remove('bkgwebmap-customlayertypeliactivebkg');
                            }
                            this.classList.add('bkgwebmap-customlayertypeliactivebkg');
                        });
                    }
                }
            });
            return typeDiv;
        }

        function hightlightBkgListItem(nextSibling, arrowdown) {
            var newSibling;
            var allItems = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayertypelibkg');
            if (arrowdown && nextSibling && nextSibling.style.display === 'none') {
                newSibling = nextSibling.nextSibling;
                hightlightBkgListItem(newSibling, true);
            } else if (!arrowdown && nextSibling && nextSibling.style.display === 'none') {
                newSibling = nextSibling.previousSibling;
                hightlightBkgListItem(newSibling, false);
            } else if (nextSibling && nextSibling.style.display !== 'none') {
                for (var i = 0; i < allItems.length; i++) {
                    allItems[i].classList.remove('bkgwebmap-customlayertypeliactivebkg');
                }
                nextSibling.classList.add('bkgwebmap-customlayertypeliactivebkg');
                nextSibling.childNodes[0].focus();
            }
        }

        // WMS
        function createCustomWMS() {
            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'WMS');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivwms';

            var inputDivTitle = document.createElement('div');
            inputDivTitle.innerHTML = 'WMS-URL eingeben:';
            typeDiv.appendChild(inputDivTitle);

            var inputDiv = document.createElement('input');
            inputDiv.className = 'bkgwebmap-customlayerwmsinput';
            typeDiv.appendChild(inputDiv);

            var inputExampleDiv = document.createElement('div');
            inputExampleDiv.className = 'bkgwebmap-customlayerinputexample';
            inputExampleDiv.innerHTML = 'z.B. https://sg.geodatenzentrum.de/wms_webatlasde';
            typeDiv.appendChild(inputExampleDiv);

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'WMS-URL aufrufen';
            typeDiv.appendChild(inputButton);

            inputButton.addEventListener('click', function () {
                var button = this;
                button.innerHTML = '...parsing...';
                if (typeDiv.lastChild.classList.contains('bkgwebmap-customlayerwmsinfodiv')) {
                    typeDiv.removeChild(typeDiv.lastChild);
                }
                getWmsInfo(function (title, wmsInfo, url) {
                    if (wmsInfo) {
                        typeDiv.appendChild(addWmsInfoToDom(title, wmsInfo, url));
                        button.innerHTML = 'WMS-URL aufrufen';
                        if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerdivwms')[0].getElementsByClassName('bkgwebmap-messagediv').length) {
                            document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerdivwms')[0].getElementsByClassName('bkgwebmap-messagediv')[0].remove();
                        }
                    } else {
                        showMessage('bkgwebmap-customlayerdivwms', 'WMS-URL aufrufen');
                    }
                });
            }, true);

            return typeDiv;
        }

        // WMTS
        function createCustomWMTS() {
            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'WMTS');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivwmts';

            var inputDivTitle = document.createElement('div');
            inputDivTitle.innerHTML = 'WMTS GetCapabilities URL:';
            typeDiv.appendChild(inputDivTitle);

            var inputDiv = document.createElement('input');
            inputDiv.className = 'bkgwebmap-customlayerwmtsinput';
            typeDiv.appendChild(inputDiv);

            var inputExampleDiv = document.createElement('div');
            inputExampleDiv.className = 'bkgwebmap-customlayerinputexample';
            inputExampleDiv.innerHTML = 'z.B. https://sg.geodatenzentrum.de/wmts_webatlasde/1.0.0/WMTSCapabilities.xml';
            typeDiv.appendChild(inputExampleDiv);

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'WMTS-URL aufrufen';
            typeDiv.appendChild(inputButton);

            inputButton.addEventListener('click', function () {
                var button = this;
                button.innerHTML = '...parsing...';
                if (typeDiv.lastChild.classList.contains('bkgwebmap-customlayerwmtsinfodiv')) {
                    typeDiv.removeChild(typeDiv.lastChild);
                }
                getWmtsInfo(function (title, wmtsInfo, url) {
                    if (wmtsInfo) {
                        typeDiv.appendChild(addWmtsInfoToDom(title, wmtsInfo, url));
                        button.innerHTML = 'WMTS-URL aufrufen';
                        if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerdivwmts')[0].getElementsByClassName('bkgwebmap-messagediv').length) {
                            document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerdivwmts')[0].getElementsByClassName('bkgwebmap-messagediv')[0].remove();
                        }
                    } else {
                        showMessage('bkgwebmap-customlayerdivwmts', 'WMTS-URL aufrufen');
                    }
                });
            }, true);

            return typeDiv;
        }

        function createCustomWFS() {
            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'WFS');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivwfs';

            var inputDivTitle = document.createElement('div');
            inputDivTitle.innerHTML = 'WFS-URL eingeben:';
            typeDiv.appendChild(inputDivTitle);

            var inputDiv = document.createElement('input');
            inputDiv.className = 'bkgwebmap-customlayerwfsinput';
            typeDiv.appendChild(inputDiv);

            var inputExampleDiv = document.createElement('div');
            inputExampleDiv.className = 'bkgwebmap-customlayerinputexample';
            inputExampleDiv.innerHTML = 'z.B. https://sg.geodatenzentrum.de/wfs_vg1000';
            typeDiv.appendChild(inputExampleDiv);

            var inputButton = document.createElement('button');
            inputButton.className = 'bkgwebmap-customlayerinputbutton';
            inputButton.innerHTML = 'WFS-URL aufrufen';
            typeDiv.appendChild(inputButton);

            inputButton.addEventListener('click', function () {
                var button = this;
                button.innerHTML = '...parsing...';
                if (typeDiv.lastChild.classList.contains('bkgwebmap-customlayerwfsinfodiv')) {
                    typeDiv.removeChild(typeDiv.lastChild);
                }
                getWfsInfo(function (title, wfsInfo, url) {
                    if (wfsInfo) {
                        button.innerHTML = 'WFS-URL aufrufen';
                        if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerdivwfs')[0].getElementsByClassName('bkgwebmap-messagediv').length) {
                            document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerdivwfs')[0].getElementsByClassName('bkgwebmap-messagediv')[0].remove();
                        }
                        typeDiv.appendChild(addWfsInfoToDom(title, wfsInfo, url));
                    } else {
                        showMessage('bkgwebmap-customlayerdivwfs', 'WFS-URL aufrufen');
                    }
                });
            }, true);

            return typeDiv;
        }

        // CSV
        function createCustomCSV() {
            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'CSV');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivcsv';

            typeDiv.appendChild(addCsvExcelMenu('csv'));

            return typeDiv;
        }

        // XLS
        function createCustomXLS() {
            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'XLS');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivxls';

            typeDiv.appendChild(addCsvExcelMenu('excel'));

            return typeDiv;
        }

        // GPS
        function createCustomGPS() {
            var typeDiv = document.createElement('div');
            typeDiv.setAttribute('data-bkgwebmap-customlayertype', 'GPS');
            typeDiv.className = 'bkgwebmap-customlayertypediv bkgwebmap-customlayerdivgps';

            var gpsInfoContainer = document.createElement('div');
            gpsInfoContainer.className = 'bkgwebmap-customlayergpsinfodiv';
            typeDiv.appendChild(gpsInfoContainer);

            // Select file
            var selectFileDiv = document.createElement('div');
            selectFileDiv.className = 'bkgwebmap-customlayergpsfilediv';
            gpsInfoContainer.appendChild(selectFileDiv);

            var fileButtonLabel = document.createElement('label');
            fileButtonLabel.className = 'bkgwebmap-customlayergpsfilelabel';
            fileButtonLabel.innerHTML = 'GPX-Datei auswählen';
            gpsInfoContainer.appendChild(fileButtonLabel);

            var fileButton = document.createElement('input');
            fileButton.className = 'bkgwebmap-customlayerinputbutton bkgwebmap-customlayergpsfilebutton';
            fileButton.setAttribute('type', 'file');
            fileButton.setAttribute('accept', '.gpx');

            fileButtonLabel.appendChild(fileButton);

            var container = document.createElement('div');
            container.className = 'bkgwebmap-customlayeremptycontainer';
            container.style.display = 'none';
            gpsInfoContainer.appendChild(container);

            fileButton.onchange = function (evt) {
                var input = evt.target;
                var filename = '';
                if (input.files[0] && input.files[0].name) {
                    filename = input.files[0].name;
                }
                filename = filename.replace('.gpx', '');
                filename = filename.replace('.GPX', '');
                var reader = new FileReader();
                reader.readAsText(input.files[0]);
                reader.onload = function (event) {
                    var gpx = event.target.result;
                    clearForms('GPS');
                    openGpsFile(container, filename, gpx, gpsInfoContainer);
                };
                fileButton.value = '';
            };

            return typeDiv;
        }

        // Clear forms when changing data type
        function clearForms(type) {
            var i;
            var containerToEmpty = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayeremptycontainer');
            if (containerToEmpty.length) {
                for (i = 0; i < containerToEmpty.length; i++) {
                    containerToEmpty[i].innerHTML = '';
                }
            }
            switch (type) {
            case 'WMS':
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmsinput').length) {
                    document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmsinput')[0].value = '';
                }
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmsinfodiv').length) {
                    var wmsMenu = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmsinfodiv')[0];
                    wmsMenu.parentNode.removeChild(wmsMenu);
                }
                break;
            case 'WMTS':
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmtsinput').length) {
                    document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmtsinput')[0].value = '';
                }
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmtsinfodiv').length) {
                    var wmtsMenu = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayerwmtsinfodiv')[0];
                    wmtsMenu.parentNode.removeChild(wmtsMenu);
                }
                break;
            case 'CSV':
            case 'XLS':
                var titleInput = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayercsvinfonameinput');
                for (i = 0; i < titleInput.length; i++) {
                    titleInput[i].value = '';
                }
                break;
            case 'GPS':
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayergpsinfonameinput').length) {
                    document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayergpsinfonameinput')[0].value = '';
                }
                break;
                // no default
            }
        }

        // Create content for custom layer dropdown menu
        function createContent() {
            var i;
            var customLayersContent = document.createElement('div');
            customLayersContent.className = 'bkgwebmap-customlayerscontent';

            var selectType = document.createElement('select');
            selectType.className = 'bkgwebmap-customlayertypeselect';

            var selectItem = document.createElement('option');
            selectItem.setAttribute('disabled', '');
            selectItem.setAttribute('selected', '');
            selectItem.innerHTML = 'Geodatentyp auswählen';
            selectType.appendChild(selectItem);
            customLayersContent.appendChild(selectType);

            for (i = 0; i < dataTypes.length; i++) {
                selectType.appendChild(fillTypeDropdown(dataTypes[i]));
                var dataTypeContent;
                switch (dataTypes[i]) {
                case 'BKG':
                    dataTypeContent = createCustomBKG();
                    break;
                case 'WMS':
                    dataTypeContent = createCustomWMS();
                    break;
                case 'WMTS':
                    dataTypeContent = createCustomWMTS();
                    break;
                case 'WFS':
                    dataTypeContent = createCustomWFS();
                    break;
                case 'CSV':
                    dataTypeContent = createCustomCSV();
                    break;
                case 'XLS':
                    dataTypeContent = createCustomXLS();
                    break;
                case 'GPS':
                    dataTypeContent = createCustomGPS();
                    break;
                    // no default
                }
                customLayersContent.appendChild(dataTypeContent);
            }

            selectType.onchange = function () {
                var selectedType = this.value;
                var dataTypeDivs = document.getElementById(mapId).getElementsByClassName('bkgwebmap-customlayertypediv');
                var type;
                for (i = 0; i < dataTypeDivs.length; i++) {
                    dataTypeDivs[i].classList.remove('bkgwebmap-customlayertypeactive');
                    type = dataTypeDivs[i].getAttribute('data-bkgwebmap-customlayertype');
                    if (selectedType === type) {
                        clearForms(selectedType);
                        dataTypeDivs[i].classList.add('bkgwebmap-customlayertypeactive');
                    }
                }
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-messagediv').length) {
                    document.getElementById(mapId).getElementsByClassName('bkgwebmap-messagediv')[0].remove();
                }
            };
            return customLayersContent;
        }

        function openCloseHeader() {
            if (this.nextSibling.classList.contains('bkgwebmap-customlayercontentactive')) {
                this.nextSibling.classList.remove('bkgwebmap-customlayercontentactive');
                if (this.childNodes[2]) {
                    this.childNodes[2].innerHTML = '+';
                }
            } else {
                this.nextSibling.classList.add('bkgwebmap-customlayercontentactive');
                if (this.childNodes[2]) {
                    this.childNodes[2].innerHTML = '\u2212';
                }
            }
        }

        /**
         * Initialize custom layers control if layers switcher is available
         * @param {object} - layerSwitcher
         */
        this.initializeControl = function (layerSwitcher, styles) {
            if (layerSwitcher === undefined) {
                // If no layerswitcher exists, do not create this control
                window.console.log(BKGWebMap.ERROR.noLayerSwitcherControl);
            } else {
                layerSwitcher.addCustomLayersContainer(customLayersContainer);
            }
            _this.styles = styles;
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: customLayers,
            target: customLayersContainer
        });
    };
};

/**
 * Create ShowAttributes Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_showAttributes}
 */
BKGWebMap.Control.createShowAttributes = function () {
    return function (map, controlName, options, panel) {
        var mapId = map.getTarget();
        var _this = this;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }


        var markerControl;
        var copyCoordinates;
        map.getControls().forEach(function (control) {
            if (BKGWebMap.Control.Marker && control instanceof BKGWebMap.Control.Marker) {
                markerControl = control;
            }
            if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                copyCoordinates = control;
            }
        });

        if (!markerControl) {
            var Marker = BKGWebMap.Control.FACTORIES.marker();
            markerControl = new Marker(map);
            map.addControl(markerControl);
        }

        map.once('postrender', function () {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    copyCoordinates = control;
                }
            });
        });

        // Select feature interaction
        var selectStyle = new ol.style.Style({
            fill: new ol.style.Fill({
                color: '#FFFF00'
            }),
            stroke: new ol.style.Stroke({
                color: '#FFFF00',
                width: 2
            }),
            image: new ol.style.Circle({
                fill: new ol.style.Fill({
                    color: '#FFFF00'
                }),
                stroke: new ol.style.Stroke({
                    color: '#FF0000',
                    width: 1
                }),
                radius: 7
            })
        });

        var interactionSelect = new ol.interaction.Select({
            condition: ol.events.condition.singleClick,
            style: selectStyle,
            multi: true,
            filter: function (feature, layer) {
                if (feature && feature.getProperties().id === 'measurefeature') {
                    return false;
                }

                if (layer && (layer.getProperties().uniqueId === 'geosearchlayer' || layer.getProperties().uniqueId === 'measurelayer')) {
                    return false;
                }
                return true;
            }
        });

        map.addInteraction(interactionSelect);

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
        }
        var startMessage = 'Mit einem Klick können Sie Attributinformationen abfragen. Die abgefragten Informationen werden dann hier angezeigt.';
        var noResultsMessage = 'Die Abfrage an der gesuchten Position ergab kein Ergebnis.';

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        // Control in panel
        var infoPanel = getInfoPanel();
        if (inPanel) {
            if (!infoPanel) {
                infoPanel = createInfopanel();
            }
            target = panel.element.getElementsByClassName('bkgwebmap-infopanelcontent')[0];
        }

        var showAttributes = document.createElement('div');
        showAttributes.className = 'bkgwebmap-showattributes' + customClass;

        var standardInfo = document.createElement('div');
        standardInfo.className = 'bkgwebmap-showattributestandard';
        standardInfo.innerHTML = startMessage;

        var infoDiv = document.createElement('div');
        infoDiv.className = 'bkgwebmap-showattributesdiv';

        var markerButton = document.createElement('button');
        markerButton.className = 'bkgwebmap-deletemarker';
        markerButton.innerHTML = 'Marker löschen';

        showAttributes.appendChild(standardInfo);
        showAttributes.appendChild(infoDiv);

        function clickControl() {
            if (inPanel) {
                var activeContent = panel.getActiveContent();
                if (activeContent === '') {
                    panel.openPanel();
                    panel.changePanelContent('Info', 'bkgwebmap-infopanelcontent');
                    infoPanel.activeIcon();
                } else if (activeContent === 'bkgwebmap-infopanelcontent') {
                    panel.closePanel();
                } else {
                    panel.changePanelContent('Info', 'bkgwebmap-infopanelcontent');
                    infoPanel.activeIcon();
                }
            } else if (showAttributes.style.display === 'none') {
                showAttributes.style.display = 'block';
            } else {
                showAttributes.style.display = 'none';
            }
        }

        function addToDom(infoToShow) {
            var i;
            var html = '';
            for (var layer in infoToShow) {
                if (Object.prototype.hasOwnProperty.call(infoToShow, layer)) {
                    html += '<div class="bkgwebmap-showattributestitle">';
                    html += '<div class="bkgwebmap-layerheadermaintext">';
                    html += layer;
                    html += '</div>';
                    html += '<div class="bkgwebmap-layerheaderplusminus">';
                    html += '+';
                    html += '</div>';
                    html += '</div>';
                    html += '<table class="bkgwebmap-showattributestable bkgwebmap-selectable bkgwebmap-showattributestablehidden">';

                    var properties = infoToShow[layer];
                    for (i = 0; i < properties.length; i++) {
                        for (var key in properties[i]) {
                            html += '<tr><td class="bkgwebmap-showattributeshighlight">' + key + ':</td> <td>' + properties[i][key] + '</td></tr>';
                        }
                        if (properties.length > 1 && i < properties.length - 1) {
                            html += '<tr><td class="bkgwebmap-showattributesblock"></td></tr>';
                        }
                    }
                    html += '</table>';
                }
            }

            if (html) {
                infoDiv.innerHTML += html;
                standardInfo.style.display = 'none';
                infoDiv.style.display = 'block';
            } else if (infoDiv.innerHTML === '') {
                infoDiv.style.display = 'none';
                standardInfo.style.display = 'block';
            }

            var titleDivs = document.getElementById(mapId).getElementsByClassName('bkgwebmap-showattributestitle');
            for (i = 0; i < titleDivs.length; i++) {
                titleDivs[i].onclick = function () {
                    if (this.nextSibling.classList.contains('bkgwebmap-showattributestablehidden')) {
                        this.nextSibling.classList.remove('bkgwebmap-showattributestablehidden');
                        if (this.childNodes[1]) {
                            this.childNodes[1].innerHTML = '\u2212';
                        }
                    } else {
                        this.nextSibling.classList.add('bkgwebmap-showattributestablehidden');
                        if (this.childNodes[1]) {
                            this.childNodes[1].innerHTML = '+';
                        }
                    }
                };
            }
        }

        function addHtmlToDom(name, htmlToShow) {
            var html = '';
            if (name) {
                html += '<div class="bkgwebmap-showattributestitle">' + name + '</div>';
            }
            if (htmlToShow) {
                html += '<div class="bkgwebmap-showattributestable bkgwebmap-showattributestablehidden">';
                html += htmlToShow;
                html += '</div>';
                infoDiv.innerHTML += html;
                standardInfo.style.display = 'none';
                infoDiv.style.display = 'block';
            } else if (infoDiv.innerHTML === '') {
                infoDiv.style.display = 'none';
                standardInfo.style.display = 'block';
            }

            var titleDivs = document.getElementById(mapId).getElementsByClassName('bkgwebmap-showattributestitle');
            for (var i = 0; i < titleDivs.length; i++) {
                titleDivs[i].onclick = function () {
                    if (this.nextSibling.classList.contains('bkgwebmap-showattributestablehidden')) {
                        this.nextSibling.classList.remove('bkgwebmap-showattributestablehidden');
                    } else {
                        this.nextSibling.classList.add('bkgwebmap-showattributestablehidden');
                    }
                };
            }
        }

        function getVectorInfo(pixel) {
            interactionSelect.getFeatures().clear();
            var selectActive = false;
            map.getInteractions().forEach(function (interaction) {
                if (interaction === interactionSelect) {
                    selectActive = true;
                }
                if (!selectActive) {
                    map.addInteraction(interactionSelect);
                }
            });

            var layers = {};
            map.forEachFeatureAtPixel(pixel, function (feature, featureLayer) {
                interactionSelect.getFeatures().push(feature);

                if (!featureLayer) {
                    return;
                }
                if (feature.getGeometry() instanceof ol.geom.Point) {
                    var newMarkerCoord = feature.getGeometry().getCoordinates();
                    markerControl.setMarker(_this, newMarkerCoord);
                }
                var name = featureLayer.get('name');
                var properties = feature.getProperties();
                var object = {};
                for (var key in properties) {
                    if (Object.prototype.hasOwnProperty.call(properties, key) && properties[key] && typeof properties[key] !== 'object') {
                        object[key] = properties[key];
                    }
                }
                if (BKGWebMap.Util.hasNestedProperty(layers, name)) {
                    layers[name].push(object);
                } else {
                    layers[name] = [object];
                }
            });
            return layers;
        }

        function showRasterInfo(name, json) {
            if (json.features && json.features.length) {
                var layers = {};
                layers[name] = [];
                for (var i = 0; i < json.features.length; i++) {
                    var object = {};
                    if (!json.features[i].properties) {
                        continue;
                    }
                    for (var key in json.features[i].properties) {
                        if (Object.prototype.hasOwnProperty.call(json.features[i].properties, key) && json.features[i].properties[key] && typeof json.features[i].properties[key] !== 'object') {
                            object[key] = json.features[i].properties[key];
                        }
                    }
                    layers[name].push(object);
                }
                return layers;
            }
            return undefined;
        }

        function getRasterInfo(coordinates, layer, callback) {
            var viewResolution = map.getView().getResolution();
            var mapProjection = map.getView().getProjection();
            var infoFormat = BKGWebMap.GETFEATUREINFO_FORMATS[0];
            if (layer.getProperties().GetFeatureInfoFormat) {
                infoFormat = layer.getProperties().GetFeatureInfoFormat;
            }
            var url = layer.getSource().getGetFeatureInfoUrl(coordinates, viewResolution, mapProjection, { INFO_FORMAT: infoFormat });

            if (url) {
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url);
                xhr.setRequestHeader('Content-Type', infoFormat);
                xhr.onload = function () {
                    var json;
                    if (xhr.status === 200) {
                        if (infoFormat.indexOf('json') !== -1) {
                            try {
                                json = JSON.parse(xhr.responseText);
                                return callback(json);
                            } catch (e) {
                                json = undefined;
                            }
                        } else {
                            return callback(xhr.responseText);
                        }
                    } else if (xhr.status !== 200) {
                        json = undefined;
                    }

                    if (json) {
                        return callback(json);
                    }
                };
                xhr.send();
            }
        }

        function createInfopanel() {
            var InfoPanelClass = BKGWebMap.Control.FACTORIES.infoPanel();
            var infoPanel = new InfoPanelClass(map, 'infoPanel', null, panel);
            map.addControl(infoPanel);
            return infoPanel;
        }

        function getInfoPanel() {
            var theControl = false;
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.InfoPanel && control instanceof BKGWebMap.Control.InfoPanel) {
                    theControl = control;
                }
            });
            return theControl;
        }

        /**
         * Activate click event to request layer attributes
         * @param evt
         */
        this.clickAttributesActivate = function (evt) {
            // Show marker when clicking
            if (!copyCoordinates) {
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-deletemarker').length) {
                    document.getElementById(mapId).getElementsByClassName('bkgwebmap-deletemarker')[0].remove();
                }
                markerControl.setMarker(_this, evt.coordinate);
                var markerButtonClone = markerButton.cloneNode(true);
                showAttributes.prepend(markerButtonClone);
                markerButtonClone.onclick = function () {
                    markerControl.deleteMarker();
                    markerButtonClone.remove();
                };
            }

            standardInfo.innerHTML = noResultsMessage;
            infoDiv.innerHTML = '';

            // Open info panel
            if (inPanel) {
                panel.openPanel();
                var activeContent = panel.getActiveContent();
                if (activeContent !== 'bkgwebmap-infopanelcontent') {
                    clickControl();
                }
            }

            // Vector layers
            var vectorInfo = getVectorInfo(evt.pixel);
            addToDom(vectorInfo);

            // Raster layers
            var coordinates = map.getCoordinateFromPixel(evt.pixel);
            map.getLayers().forEach(function (layer) {
                if (layer instanceof ol.layer.Group) {
                    if (layer.getVisible()) {
                        layer.getLayers().forEach(function (sublayer) {
                            if ((sublayer.getSource() instanceof ol.source.ImageWMS || sublayer.getSource() instanceof ol.source.TileWMS) && sublayer.getVisible()) {
                                getRasterInfo(coordinates, sublayer, function (json) {
                                    var name = sublayer.get('name');
                                    if (typeof json === 'object') {
                                        addToDom(showRasterInfo(name, json));
                                    } else if (typeof json === 'string') {
                                        addHtmlToDom(name, json);
                                    }
                                });
                            }
                        });
                    }
                } else if ((layer.getSource() instanceof ol.source.ImageWMS || layer.getSource() instanceof ol.source.TileWMS) && layer.getVisible()) {
                    getRasterInfo(coordinates, layer, function (json) {
                        var name = layer.get('name');
                        if (typeof json === 'object') {
                            addToDom(showRasterInfo(name, json));
                        } else if (typeof json === 'string') {
                            addHtmlToDom(name, json);
                        }
                    });
                }
            });
        };

        map.on('click', this.clickAttributesActivate);

        // Finalize control
        ol.control.Control.call(this, {
            element: showAttributes,
            target: target
        });
    };
};

/**
 * Create Zoom Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_zoom}
 */
BKGWebMap.Control.createZoom = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var mapDivId = map.getTarget();

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (typeof options.onlyFullScreen === 'boolean' && options.onlyFullScreen === true) {
            this.onlyFullScreen = true;
        }

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.zoom.position;
            }
        }

        var onlyFullScreenClass = '';
        if (this.onlyFullScreen) {
            onlyFullScreenClass = ' bkgwebmap-onlyfullscreen ';
        }

        var zoom = document.createElement('div');
        zoom.className = 'bkgwebmap-zoom ol-unselectable ol-control' + onlyFullScreenClass;

        var tooltipExtraClass = ' bkgwebmap-tooltipinmaptext';
        if (position !== undefined) {
            if (!cssPosition && standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                zoom.classList.add('bkgwebmap-standardpositioncontrol', 'bkgwebmap-standardpositioncontrol' + rightLeft);
                if (rightLeft === 'right') {
                    tooltipExtraClass = ' bkgwebmap-tooltipzoomright';
                }
            } else if (cssPosition) {
                for (var prop in position) {
                    zoom.style[prop] = position[prop];
                }
            } else {
                return undefined;
            }
        }

        var showZoomLevel = BKGWebMap.CONTROLS.tools.zoom.showZoomLevel;
        if (typeof options.showZoomLevel === 'boolean') {
            showZoomLevel = options.showZoomLevel;
        }

        var zoomToFullExtent = BKGWebMap.CONTROLS.tools.zoom.zoomToFullExtent;
        if (typeof options.zoomToFullExtent === 'boolean') {
            zoomToFullExtent = options.zoomToFullExtent;
        }

        var history = BKGWebMap.CONTROLS.tools.zoom.history;
        if (typeof options.history === 'boolean') {
            history = options.history;
        }

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
            zoom.classList.add(customClass);
        }

        // Create DOM

        // Zoom
        var zoomButtons = document.createElement('div');
        zoomButtons.className = 'bkgwebmap-zoombuttonswrapper';
        var buttonPlus = document.createElement('button');
        buttonPlus.className = 'bkgwebmap-mapbutton';
        buttonPlus.innerHTML = '+';
        var buttonMinus = document.createElement('button');
        buttonMinus.className = 'bkgwebmap-mapbutton';
        buttonMinus.innerHTML = '\u2212';

        // Zoom level
        var buttonZoomLevel = document.createElement('button');
        buttonZoomLevel.className = 'bkgwebmap-mapbutton bkgwebmap-zoomlevel';
        buttonZoomLevel.innerHTML = map.getView().getZoom();
        buttonZoomLevel.style.display = 'inline';
        zoomButtons.appendChild(buttonPlus);
        zoomButtons.appendChild(buttonMinus);
        if (showZoomLevel) {
            zoomButtons.appendChild(buttonZoomLevel);
        }

        // Zoom to full extent
        var zoomToFullExtentDiv = document.createElement('div');
        zoomToFullExtentDiv.className = 'bkgwebmap-zoombuttonswrapper';
        var buttonZoomToFullExtent = document.createElement('button');
        buttonZoomToFullExtent.className = 'bkgwebmap-mapbutton bkgwebmap-zoomtofullextent bkgwebmap-paneltooltip';
        var parser = new DOMParser();
        var iconZoomToFullExtent = parser.parseFromString(BKGWebMap.PANEL_ICONS.ZOOM_TO_FULL_EXTENT, 'text/xml');
        buttonZoomToFullExtent.appendChild(iconZoomToFullExtent.documentElement);
        zoomToFullExtentDiv.appendChild(buttonZoomToFullExtent);

        var zoomToFullExtentTooltip = document.createElement('span');
        zoomToFullExtentTooltip.className = 'bkgwebmap-paneltooltiptext' + tooltipExtraClass;
        zoomToFullExtentTooltip.innerHTML = 'Auf&nbspdie&nbspvolle<br><br>Ausdehnung&nbspzoomen';
        buttonZoomToFullExtent.appendChild(zoomToFullExtentTooltip);

        // History
        var historyDiv = document.createElement('div');
        historyDiv.className = 'bkgwebmap-zoombuttonswrapper';
        var buttonPrevious = document.createElement('button');
        buttonPrevious.className = 'bkgwebmap-mapbutton bkgwebmap-paneltooltip';
        var parserZoomPrevious = new DOMParser();
        var iconPreviousNode = parserZoomPrevious.parseFromString(BKGWebMap.PANEL_ICONS.ZOOM_PREVIOUS, 'text/xml');
        buttonPrevious.appendChild(iconPreviousNode.documentElement);
        buttonPrevious.style.display = 'inline';
        var buttonPreviousTooltip = document.createElement('span');
        buttonPreviousTooltip.className = 'bkgwebmap-paneltooltiptext' + tooltipExtraClass;
        buttonPreviousTooltip.innerHTML = 'Letzte&nbspAnsicht';
        buttonPrevious.appendChild(buttonPreviousTooltip);
        var buttonNext = document.createElement('button');
        buttonNext.className = 'bkgwebmap-mapbutton bkgwebmap-paneltooltip';
        var parserZoomNext = new DOMParser();
        var iconNextNode = parserZoomNext.parseFromString(BKGWebMap.PANEL_ICONS.ZOOM_NEXT, 'text/xml');
        buttonNext.appendChild(iconNextNode.documentElement);
        buttonNext.style.display = 'inline';
        var buttonNextTooltip = document.createElement('span');
        buttonNextTooltip.className = 'bkgwebmap-paneltooltiptext' + tooltipExtraClass;
        buttonNextTooltip.innerHTML = 'Nächste&nbspAnsicht';
        buttonNext.appendChild(buttonNextTooltip);
        historyDiv.appendChild(buttonPrevious);
        historyDiv.appendChild(buttonNext);

        // Control div
        zoom.appendChild(zoomButtons);
        if (zoomToFullExtent) {
            zoom.appendChild(zoomToFullExtentDiv);
        }
        if (history) {
            zoom.appendChild(historyDiv);
            activateHistory();
        }

        // Change zoom level
        function changeZoom(delta) {
            var currentZoom = map.getView().getZoom();
            var view = map.getView();
            if (view.getAnimating()) {
                view.cancelAnimations();
            }
            view.animate({
                zoom: currentZoom + delta,
                duration: 250,
                easing: ol.easing.easeOut
            });
        }

        // Zoom to extent
        function zoomToExtent() {
            var extent = ol.extent.createEmpty();
            var projection = map.getView().getProjection();

            map.getLayers().forEach(function (layer) {
                var layerExtent = BKGWebMap.Util.getLayerExtent(layer, projection);
                ol.extent.extend(extent, layerExtent);
            });

            // clip to projection extent?
            extent = ol.extent.getIntersection(extent, projection.getExtent());

            // TODO: check if configured view extent is respected.
            map.getView().fit(extent);
        }

        // Activate history function
        function activateHistory() {
            buttonPrevious.disabled = true;
            buttonNext.disabled = true;

            var history = [];
            var currentIndex = -1;
            var shouldSave = false;
            var delay = 360; // OpenLayers render delay
            map.on('moveend', function () {
                if (shouldSave === false) {
                    if (currentIndex < history.length - 1) {
                        for (var i = history.length - 1; i > currentIndex; i--) {
                            history.pop();
                        }
                    }
                    history.push({
                        extent: map.getView().calculateExtent(map.getSize()),
                        size: map.getSize(),
                        zoom: map.getView().getZoom()
                    });
                    currentIndex += 1;
                    disableButtons();
                } else {
                    disableButtons();
                }
            });

            function disableButtons() {
                if (currentIndex === 0) {
                    buttonPrevious.disabled = true;
                } else {
                    buttonPrevious.disabled = false;
                }
                if (history.length - 1 === currentIndex) {
                    buttonNext.disabled = true;
                } else {
                    buttonNext.disabled = false;
                }
            }

            function navigationHistoryNext() {
                if (currentIndex < history.length - 1) {
                    shouldSave = true;
                    map.getView().fit(history[currentIndex + 1].extent, history[currentIndex + 1].size);
                    map.getView().setZoom(history[currentIndex + 1].zoom);
                    setTimeout(function () {
                        shouldSave = false;
                    }, delay);
                    currentIndex += 1;
                }
            }

            function navigationHistoryPrevious() {
                if (currentIndex > 0) {
                    shouldSave = true;
                    map.getView().fit(history[currentIndex - 1].extent, history[currentIndex - 1].size);
                    map.getView().setZoom(history[currentIndex - 1].zoom);
                    setTimeout(function () {
                        shouldSave = false;
                    }, delay);
                    currentIndex -= 1;
                }
            }

            function showTooltip(buttonTooltip) {
                var allTooltips = document.getElementsByClassName('bkgwebmap-paneltooltiptext');
                for (var i = 0; i < allTooltips.length; i++) {
                    allTooltips[i].style.visibility = '';
                }
                buttonTooltip.style.visibility = 'visible';
                setTimeout(function () {
                    buttonTooltip.style.visibility = '';
                }, 1200);
            }

            // History event listeners
            buttonNext.addEventListener('click', navigationHistoryNext, { passive: true });
            buttonPrevious.addEventListener('click', navigationHistoryPrevious, { passive: true });
            buttonPrevious.addEventListener('mouseenter', function () {
                showTooltip(buttonPreviousTooltip);
            }, false);
            buttonNext.addEventListener('mouseenter', function () {
                showTooltip(buttonNextTooltip);
            }, false);
            buttonZoomToFullExtent.addEventListener('mouseenter', function () {
                showTooltip(zoomToFullExtentTooltip);
            }, false);
        }

        // Event listeners
        buttonPlus.addEventListener('click', function () {
            changeZoom(1);
        }, { passive: true });
        buttonMinus.addEventListener('click', function () {
            changeZoom(-1);
        }, { passive: true });
        if (showZoomLevel) {
            map.getView().on('change:resolution', function () {
                var zoomLevel = map.getView().getZoom();
                buttonZoomLevel.innerHTML = Math.round(zoomLevel);
            });
        }
        if (zoomToFullExtent) {
            buttonZoomToFullExtent.addEventListener('click', zoomToExtent, { passive: true });
        }

        // Finalize control
        ol.control.Control.call(this, {
            element: zoom,
            target: target
        });
    };
};

/**
 * Create Legend Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_legend}
 */
BKGWebMap.Control.createLegend = function () {
    return function (map, controlName, options, panel) {
        var _this = this;

        var mapId = map.getTarget();
        var elementId = mapId;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
            elementId = target;
        } else {
            target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];
        }

        // Control title for panel
        var title = 'Legende';

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        // Tooltip position
        var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
        var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
        if (inPanel && panel.getPanelPosition() === 'right') {
            tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
            tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
        }

        // Create DOM
        var legend = document.createElement('div');
        legend.className = 'bkgwebmap-legend ' + tooltipClass + customClass;

        var parser = new DOMParser();
        var legendIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.LEGEND, 'text/xml');
        if (inPanel) {
            legendIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons bkgwebmap-paneliconsopen');
        } else {
            legendIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons');
        }
        legend.appendChild(legendIcon.documentElement);

        var legendTooltip = document.createElement('span');
        legendTooltip.className = tooltipTextClass;
        legendTooltip.innerHTML = title;
        legend.appendChild(legendTooltip);

        var legendContent = document.createElement('div');
        var legendContentClass = 'bkgwebmap-legendcontent bkgwebmap-selectable';
        legendContent.className = legendContentClass + ' bkgwebmap-panelsinglecontent';
        if (inPanel) {
            panel.addPanelContent(legendContent);
        } else {
            legend.appendChild(legendContent);
            legendContent.style.display = 'none';
        }

        function clickControl() {
            if (inPanel) {
                var activeContent = panel.getActiveContent();
                if (activeContent === '') {
                    panel.openPanel();
                    panel.changePanelContent(title, legendContentClass);
                    _this.activeIcon();
                } else if (activeContent === legendContentClass) {
                    panel.closePanel();
                } else {
                    panel.changePanelContent(title, legendContentClass);
                    _this.activeIcon();
                }
            } else if (legendContent.style.display === 'none') {
                legendContent.style.display = 'block';
            } else {
                legendContent.style.display = 'none';
            }
        }

        this.activeIcon = function () {
            legend.classList.add('bkgwebmap-panelactive');
        };

        function getNewLegendUrl(element, legendInfo, name, newParamsWMS) {
            var styleName;
            for (var i = 0; i < newParamsWMS.LAYERS.length; i++) {
                styleName = '';
                if (name === newParamsWMS.LAYERS[i]) {
                    element.classList.add('bkgwebmap-legendlayeractive');
                    styleName = newParamsWMS.STYLES[i];
                    if (legendInfo && typeof legendInfo[name] === 'object' && legendInfo[name].constructor === Object) {
                        return legendInfo[name][styleName];
                    }
                }
            }
            return undefined;
        }

        function reloadWmsLegend(layer, newParamsWMS) {
            var legendInfo = layer.getLegendInfo();
            var uniqueId = layer.getProperties().uniqueId;
            var wmsLayers = document.getElementById(elementId).querySelectorAll('[data-bkgwebmap-legendlayerid]');

            for (var i = 0; i < wmsLayers.length; i++) {
                var id = wmsLayers[i].getAttribute('data-bkgwebmap-legendlayerid');
                if (uniqueId === id) {
                    var nameElements = wmsLayers[i].querySelectorAll('[data-bkgwebmap-legendlayerwmsname]');
                    for (var k = 0; k < nameElements.length; k++) {
                        nameElements[k].classList.remove('bkgwebmap-legendlayeractive');
                        var name = nameElements[k].getAttribute('data-bkgwebmap-legendlayerwmsname');
                        var newUrl = getNewLegendUrl(nameElements[k], legendInfo, name, newParamsWMS);
                        if (newUrl) {
                            nameElements[k].getElementsByTagName('img')[0].setAttribute('src', newUrl);
                        }
                    }
                }
            }
        }

        /**
         * Add a legend of a new layer
         * @param {object} layer - Layer that should be added
         */
        this.addLayerToLegend = function (layer, inGroup, groupVisibility) {
            if (layer instanceof ol.layer.Group) {
                var groupLayerVisibility = layer.getVisible();
                layer.getLayers().forEach(function (sublayer) {
                    _this.addLayerToLegend(sublayer, true, groupLayerVisibility);
                });
            } else {
                var layerLegendDiv;
                var layerLegendDivTitle;
                var layerLegendDivImgDiv;
                var layerLegendDivImg;
                var url = layer.getProperties().legendUrl;
                var layerActive = false;
                if ((layer instanceof BKGWebMap.Layer.ImageWMS || layer instanceof BKGWebMap.Layer.TileWMS) && !url) {
                    var activateLegend = true;
                    var legendInfo = layer.getLegendInfo();
                    if (!legendInfo) {
                        return;
                    }

                    layerLegendDiv = document.createElement('div');
                    layerLegendDiv.className = 'bkgwebmap-legendlayer';
                    layerLegendDiv.setAttribute('data-bkgwebmap-legendlayerid', layer.getProperties().uniqueId);
                    legendContent.appendChild(layerLegendDiv);

                    layerLegendDivTitle = document.createElement('div');
                    layerLegendDivTitle.className = 'bkgwebmap-legendlayertitle';
                    layerLegendDivTitle.innerHTML = layer.getProperties().name;
                    layerLegendDiv.appendChild(layerLegendDivTitle);

                    var subLayers = layer.getLayers();

                    for (var i = 0; i < subLayers.length; i++) {
                        var legendUrl = '';

                        var layerLegendDivWms = document.createElement('div');
                        if (subLayers[i].visibility && layer.getVisible()) {
                            layerLegendDivWms.className = 'bkgwebmap-legendlayer bkgwebmap-legendlayerwms bkgwebmap-legendlayeractive';
                            layerActive = true;
                        } else {
                            layerLegendDivWms.className = 'bkgwebmap-legendlayer bkgwebmap-legendlayerwms';
                        }
                        layerLegendDivWms.setAttribute('data-bkgwebmap-legendlayerid', subLayers[i].uniqueId);
                        layerLegendDivWms.setAttribute('data-bkgwebmap-legendlayerwmsname', subLayers[i].layer);
                        layerLegendDiv.appendChild(layerLegendDivWms);

                        layerLegendDivTitle = document.createElement('div');
                        layerLegendDivTitle.className = 'bkgwebmap-legendlayertitle bkgwebmap-legendlayertitlewms';
                        layerLegendDivTitle.innerHTML = subLayers[i].name;
                        layerLegendDivWms.appendChild(layerLegendDivTitle);

                        layerLegendDivImgDiv = document.createElement('div');
                        layerLegendDivImgDiv.className = 'bkgwebmap-legendlayerimg';
                        layerLegendDivWms.appendChild(layerLegendDivImgDiv);

                        layerLegendDivImg = document.createElement('img');

                        if (legendInfo && (typeof legendInfo[subLayers[i].layer] === 'string' || legendInfo[subLayers[i].layer] instanceof String)) {
                            legendUrl = legendInfo[subLayers[i].layer];
                        } else if (legendInfo && typeof legendInfo[subLayers[i].layer] === 'object' && legendInfo[subLayers[i].layer].constructor === Object) {
                            if (subLayers[i].style) {
                                legendUrl = legendInfo[subLayers[i].layer][subLayers[i].style];
                            } else {
                                var counter = 0;
                                var defaultUrl = '';
                                for (var styleName in legendInfo[subLayers[i].layer]) {
                                    counter++;
                                    if (counter === 1) {
                                        legendUrl = legendInfo[subLayers[i].layer][styleName];
                                    }
                                    defaultUrl = legendInfo[subLayers[i].layer][styleName];
                                    if (styleName.toLowerCase().indexOf('default') !== -1) {
                                        legendUrl = legendInfo[subLayers[i].layer][styleName];
                                    }
                                }
                                if (counter === 1) {
                                    legendUrl = defaultUrl;
                                }
                            }
                        }
                        if (legendUrl) {
                            layerLegendDivImg.setAttribute('src', legendUrl);
                        } else {
                            activateLegend = false;
                        }

                        layerLegendDivImgDiv.appendChild(layerLegendDivImg);
                    }

                    if (inGroup && !groupVisibility) {
                        layerActive = false;
                    }

                    if (layerActive && legendInfo && activateLegend) {
                        layerLegendDiv.classList.add('bkgwebmap-legendlayeractive');
                    }
                } else if (url) {
                    layerLegendDiv = document.createElement('div');
                    layerActive = layer.getVisible();

                    if (inGroup && !groupVisibility) {
                        layerActive = false;
                    }

                    if (layerActive) {
                        layerLegendDiv.className = 'bkgwebmap-legendlayer bkgwebmap-legendlayeractive';
                    } else {
                        layerLegendDiv.className = 'bkgwebmap-legendlayer';
                    }
                    layerLegendDiv.setAttribute('data-bkgwebmap-legendlayerid', layer.getProperties().uniqueId);
                    legendContent.appendChild(layerLegendDiv);

                    layerLegendDivTitle = document.createElement('div');
                    layerLegendDivTitle.className = 'bkgwebmap-legendlayertitle';
                    layerLegendDivTitle.innerHTML = layer.getProperties().name;
                    layerLegendDiv.appendChild(layerLegendDivTitle);

                    layerLegendDivImgDiv = document.createElement('div');
                    layerLegendDivImgDiv.className = 'bkgwebmap-legendlayerimg';
                    layerLegendDiv.appendChild(layerLegendDivImgDiv);

                    layerLegendDivImg = document.createElement('img');
                    layerLegendDivImg.setAttribute('src', url);
                    layerLegendDivImgDiv.appendChild(layerLegendDivImg);
                }
            }
        };

        /**
         * Remove legend when removing a custom layer
         * @param {object} layer - Layer that should be removed
         */
        this.removeLayerFromLegend = function (layer) {
            var uniqueId = layer.getProperties().uniqueId;
            var legendElements = document.getElementById(elementId).querySelectorAll('[data-bkgwebmap-legendlayerid]');
            for (var k = 0; k < legendElements.length; k++) {
                var legendElementId = legendElements[k].getAttribute('data-bkgwebmap-legendlayerid');
                if (uniqueId === legendElementId) {
                    legendElements[k].parentNode.removeChild(legendElements[k]);
                }
            }
        };

        /**
         * Show/hide legend of a layer
         * @param {object} layer - Layer that should be used
         * @param {boolean} visible - Show or hide legend
         */
        this.changeLegend = function (layer, visible, newParamsWMS, inGroup, groupVisibility) {
            if (layer instanceof ol.layer.Group) {
                layer.getLayers().forEach(function (sublayer) {
                    _this.changeLegend(sublayer, visible, newParamsWMS, true, visible);
                });
            } else {
                var legendLayers = document.getElementById(elementId).getElementsByClassName('bkgwebmap-legendcontent')[0].querySelectorAll('[data-bkgwebmap-legendlayerid]');

                for (var i = 0; i < legendLayers.length; i++) {
                    if (legendLayers[i].getAttribute('data-bkgwebmap-legendlayerid') === layer.getProperties().uniqueId) {
                        if (inGroup) {
                            if (!groupVisibility) {
                                legendLayers[i].classList.remove('bkgwebmap-legendlayeractive');
                            } else if (layer.getVisible()) {
                                legendLayers[i].classList.add('bkgwebmap-legendlayeractive');
                            } else {
                                legendLayers[i].classList.remove('bkgwebmap-legendlayeractive');
                            }
                        } else if (visible) {
                            legendLayers[i].classList.add('bkgwebmap-legendlayeractive');
                        } else {
                            legendLayers[i].classList.remove('bkgwebmap-legendlayeractive');
                        }

                        if (legendLayers[i].getElementsByTagName('img')[0].src === '') {
                            legendLayers[i].classList.remove('bkgwebmap-legendlayeractive');
                        }
                    }
                }

                if (newParamsWMS) {
                    reloadWmsLegend(layer, newParamsWMS);
                }
            }
        };

        // Event listeners
        var elementForEvent = legend;
        if (!inPanel) {
            elementForEvent = legend.querySelector('svg');
        }
        elementForEvent.addEventListener('click', clickControl, { passive: true });
        elementForEvent.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            legendTooltip.style.visibility = 'visible';
            setTimeout(function () {
                legendTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: legend,
            target: target
        });
    };
};

/**
 * Create FullScreen Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_fullScreen}
 */
BKGWebMap.Control.createFullScreen = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var mapDivId = map.getTarget();
        // Check if control should be created
        if (options.active === false) {
            this.inactive = true;
            return this;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.fullScreen.position;
            }
        }


        var standardPositionClass = '';
        if (position !== undefined) {
            if (standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                standardPositionClass = ' bkgwebmap-standardpositioncontrol bkgwebmap-standardpositioncontrol' + rightLeft;
            } else if (cssPosition) {
                target = document.createElement('div');
                target.className = 'customFullscreen';
                target.style.position = 'absolute';
                document.getElementsByClassName('ol-overlaycontainer-stopevent')[0].appendChild(target);
                for (var prop in position) {
                    target.style[prop] = position[prop];
                }
            } else {
                this.inactive = true;
                return this;
            }
        }

        // Custom class
        var customClass = ' ';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        // Add class to map div
        map.getTargetElement().classList.add('bkgwebmap-fullscreen');

        // Parse icons
        var parser = new DOMParser();
        var iconMaximize = parser.parseFromString(BKGWebMap.PANEL_ICONS.MAXIMIZE, 'text/xml');
        iconMaximize = iconMaximize.documentElement;
        var iconMinimize = parser.parseFromString(BKGWebMap.PANEL_ICONS.MINIMIZE, 'text/xml');
        iconMinimize = iconMinimize.documentElement;

        // Tools avaibale only in full screen mode
        function fullScreenFunctions(isFullScreen) {
            var onlyFullScreenControls = [
                {
                    name: 'Zoom',
                    class: 'bkgwebmap-zoom'
                },
                {
                    name: 'Scalebar',
                    class: 'bkgwebmap-scalebar'
                },
                {
                    name: 'Copyright',
                    class: 'bkgwebmap-copyright'
                },
                {
                    name: 'OverviewMap',
                    class: 'bkgwebmap-overviewmap'
                },
                {
                    name: 'StaticLinks',
                    class: 'bkgwebmap-staticlinks'
                },
                {
                    name: 'StaticWindows',
                    class: 'bkgwebmap-staticwindows'
                }
            ];
            map.getControls().forEach(function (control) {
                for (var i = 0; i < onlyFullScreenControls.length; i++) {
                    if ((onlyFullScreenControls[i].name === 'StaticLinks' && control.controlName === 'StaticLinks') || (onlyFullScreenControls[i].name === 'StaticWindows' && control.controlName === 'StaticWindows')) {
                        if (control.onlyFullScreen) {
                            if (isFullScreen) {
                                if (control.getControlTarget()) {
                                    control.getControlTarget().classList.remove('bkgwebmap-onlyfullscreen');
                                }
                            } else if (control.getControlTarget()) {
                                control.getControlTarget().classList.add('bkgwebmap-onlyfullscreen');
                            }
                        }
                    } else if (BKGWebMap.Control[onlyFullScreenControls[i].name] && control instanceof BKGWebMap.Control[onlyFullScreenControls[i].name] && control.onlyFullScreen) {
                        if (isFullScreen) {
                            // Refresh overview map
                            var overviewMapCollapse = false;
                            var overviewMapCollapsible = false;
                            if (BKGWebMap.Control.OverviewMap && control instanceof BKGWebMap.Control.OverviewMap && control.om) {
                                if (!control.om.getCollapsible()) {
                                    control.om.setCollapsible(true);
                                    overviewMapCollapsible = true;
                                }
                                if (!control.om.getCollapsed()) {
                                    control.om.setCollapsed(true);
                                    overviewMapCollapse = true;
                                }
                            }

                            if (document.getElementById(mapDivId).getElementsByClassName(onlyFullScreenControls[i].class).length) {
                                document.getElementById(mapDivId).getElementsByClassName(onlyFullScreenControls[i].class)[0].classList.remove('bkgwebmap-onlyfullscreen');
                            }

                            // Refresh overview map
                            if (BKGWebMap.Control.OverviewMap && control instanceof BKGWebMap.Control.OverviewMap && control.om && overviewMapCollapse) {
                                setTimeout(function () {
                                    control.om.setCollapsed(false);
                                    if (overviewMapCollapsible) {
                                        control.om.setCollapsible(false);
                                    }
                                }, 100);
                            }
                        } else if (document.getElementById(mapDivId).getElementsByClassName(onlyFullScreenControls[i].class).length) {
                            document.getElementById(mapDivId).getElementsByClassName(onlyFullScreenControls[i].class)[0].classList.add('bkgwebmap-onlyfullscreen');
                        }
                    }
                }
            });
        }

        this.fullScreenListener = function () {
            document.addEventListener('webkitfullscreenchange', function () {
                if (document.webkitIsFullScreen) {
                    fullScreenFunctions(true);
                } else {
                    fullScreenFunctions(false);
                }
            });
            document.addEventListener('mozfullscreenchange', function () {
                if (document.mozFullScreen) {
                    fullScreenFunctions(true);
                } else {
                    fullScreenFunctions(false);
                }
            });
            document.addEventListener('fullscreenchange', function () {
                if (document.fullscreen) {
                    fullScreenFunctions(true);
                } else {
                    fullScreenFunctions(false);
                }
            });
            document.addEventListener('MSFullscreenChange', function () {
                if (document.msFullscreenElement) {
                    fullScreenFunctions(true);
                } else {
                    fullScreenFunctions(false);
                }
            });
        };

        // Finalize control
        ol.control.FullScreen.call(this, {
            className: 'bkgwebmap-mapbutton' + customClass + standardPositionClass + ' ',
            target: target,
            label: iconMaximize,
            labelActive: iconMinimize,
            tipLabel: 'Vollbildmodus umschalten'
        });
    };
};

/**
 * Create showCoordinates Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_showCoordinates}
 */
BKGWebMap.Control.createShowCoordinates = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var i;
        var mapDivId = map.getTarget();
        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.showCoordinates.position;
            }
        }

        var showCoordinates = document.createElement('div');
        showCoordinates.className = 'bkgwebmap-showcoordinates ol-unselectable ol-control';

        var tooltipExtraClass = ' bkgwebmap-tooltipinmaptext';
        var mapDivMiddle = document.getElementById(mapDivId).offsetWidth / 2;

        if (position !== undefined) {
            if (!cssPosition && standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                showCoordinates.classList.add('bkgwebmap-standardpositioncontrol', 'bkgwebmap-standardpositioncontrol' + rightLeft);
                if (rightLeft === 'right') {
                    tooltipExtraClass = ' bkgwebmap-tooltipshowcoordright';
                }
            } else if (cssPosition) {
                for (var prop in position) {
                    if (prop === 'left' && parseInt(position.left, 10) > mapDivMiddle) {
                        showCoordinates.style.right = document.getElementById(mapDivId).offsetWidth - parseInt(position.left, 10) + 'px';
                    } else {
                        showCoordinates.style[prop] = position[prop];
                    }
                }
            } else {
                return undefined;
            }
        }
        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
            showCoordinates.classList.add(customClass);
        }

        // Create DOM
        var showCoordinatesButton = document.createElement('button');
        showCoordinatesButton.className = 'bkgwebmap-mapbutton bkgwebmap-showcoordinatesbutton bkgwebmap-paneltooltip';
        if (position === 'bottom-right' || position === 'top-right' || (cssPosition && parseInt(position.left, 10) > mapDivMiddle) || (cssPosition && parseInt(position.right, 10) < mapDivMiddle)) {
            showCoordinatesButton.style.float = 'right';
        } else {
            showCoordinatesButton.style.float = 'left';
        }
        if (position === 'bottom-left' || position === 'bottom-right') {
            showCoordinatesButton.style.marginTop = '20px';
        }

        var parser = new DOMParser();
        var newIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.SHOW_COORDINATES, 'text/xml');
        showCoordinatesButton.appendChild(newIcon.documentElement);

        var showCoordinatesTooltip = document.createElement('span');
        showCoordinatesTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-tooltipshowcoord' + tooltipExtraClass;
        showCoordinatesTooltip.innerHTML = 'Koordinatenanzeige';
        showCoordinatesButton.appendChild(showCoordinatesTooltip);

        var showCoordinatesSelect = document.createElement('select');
        showCoordinatesSelect.className = 'bkgwebmap-showcoordinatesselect';
        var showCoordinatesSelectDiv = document.createElement('div');
        showCoordinatesSelectDiv.className = 'bkgwebmap-showcoordinatesselectdiv';

        var resizedSelect = document.createElement('select');
        var resizingOption = document.createElement('option');
        resizedSelect.appendChild(resizingOption);
        resizedSelect.style.display = 'none';

        var selectArrowUp = document.createElement('div');
        selectArrowUp.className = 'bkgwebmap-selectarrowdown';

        showCoordinatesSelectDiv.appendChild(selectArrowUp);
        showCoordinatesSelectDiv.appendChild(showCoordinatesSelect);
        showCoordinatesSelectDiv.appendChild(resizedSelect);

        var showCoordinatesDiv = document.createElement('div');
        showCoordinatesDiv.className = 'bkgwebmap-showcoordinatesdiv';
        showCoordinatesDiv.style.display = 'none';

        var showCoordinatesTextDiv = document.createElement('div');
        showCoordinatesTextDiv.className = 'bkgwebmap-showcoordinatestextdiv';


        showCoordinatesDiv.appendChild(showCoordinatesSelectDiv);
        showCoordinatesDiv.appendChild(showCoordinatesTextDiv);

        if (position === 'bottom-right' || position === 'top-right' || (cssPosition && parseInt(position.left, 10) > mapDivMiddle) || (cssPosition && parseInt(position.right, 10) < mapDivMiddle)) {
            showCoordinatesSelectDiv.style.float = 'right';
        } else {
            showCoordinatesSelectDiv.style.float = 'left';
        }

        showCoordinates.appendChild(showCoordinatesButton);
        showCoordinates.appendChild(showCoordinatesDiv);

        var csArray;

        if (options.coordinateSystems instanceof Array && options.coordinateSystems.length) {
            csArray = options.coordinateSystems;
        } else {
            csArray = [
                {
                    epsg: map.getView().getProjection().getCode(),
                    name: map.getView().getProjection().getCode()
                }
            ];
        }
        for (i = 0; i < csArray.length; i++) {
            var selectItem = document.createElement('option');
            selectItem.className = 'bkgwebmap-showcoordinatesselectitem';
            selectItem.value = csArray[i].epsg;
            if (csArray[i].name) {
                selectItem.innerHTML = csArray[i].name;
            } else {
                selectItem.innerHTML = csArray[i].epsg;
            }
            showCoordinatesSelect.appendChild(selectItem);
        }

        showCoordinatesButton.addEventListener('click', function () {
            if (showCoordinatesDiv.style.display === 'none') {
                showCoordinatesDiv.style.display = 'inline-block';
                resizingSelect();
            } else {
                showCoordinatesDiv.style.display = 'none';
            }
        }, { passive: true });

        // Default value of showCoordinates
        var centerDefault = [map.getView().getCenter()[0].toFixed(4), map.getView().getCenter()[1].toFixed(4)];
        var centerDefaultLength = centerDefault[0].length + centerDefault[1].length;
        var noCoordsArray = [];
        for (i = 0; i < centerDefaultLength; i++) {
            noCoordsArray.push('_');
        }
        var noCoords = noCoordsArray.join('');

        var defaultProjection = showCoordinatesSelect.options[showCoordinatesSelect.selectedIndex].value;

        var showCoordinatesValue = new ol.control.MousePosition({
            coordinateFormat: ol.coordinate.createStringXY(4),
            projection: defaultProjection,
            target: showCoordinatesTextDiv,
            className: 'bkgwebmap-showcoordinatesvalue',
            undefinedHTML: '<span style="color:rgba(255,255,255, 0)">' + noCoords + '</span>'
        });

        showCoordinatesSelect.addEventListener('change', function (event) {
            resizingSelect();
            showCoordinatesValue.setProjection(event.target.value);
        });

        function resizingSelect() {
            resizingOption.innerHTML = showCoordinatesSelect.options[showCoordinatesSelect.selectedIndex].textContent;
            resizedSelect.style.display = '';
            showCoordinatesSelect.style.width = resizedSelect.clientWidth + 'px';
            resizedSelect.style.display = 'none';
        }

        this.showCoordinatesValue = showCoordinatesValue;

        BKGWebMap.Control.ShowCoordinates.prototype.setMap = function (map) {
            this.showCoordinatesValue.setMap(map);
            ol.control.Control.prototype.setMap.call(this, map);
        };

        showCoordinatesButton.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            showCoordinatesTooltip.style.visibility = 'visible';
            setTimeout(function () {
                showCoordinatesTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: showCoordinates,
            target: target
        });
    };
};

/**
 * Create CopyCoordinates Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_copyCoordinates}
 */
BKGWebMap.Control.createCopyCoordinates = function () {
    return function (map, controlName, options, panel) {
        var mapId = map.getTarget();
        var _this = this;
        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
        }

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
        }

        // Control in panel
        var infoPanel = getInfoPanel();
        if (inPanel) {
            if (!infoPanel) {
                infoPanel = createInfopanel();
            }
            target = panel.element.getElementsByClassName('bkgwebmap-infopanelcontent')[0];
        }

        function createInfopanel() {
            var InfoPanelClass = BKGWebMap.Control.FACTORIES.infoPanel();
            var infoPanel = new InfoPanelClass(map, 'infoPanel', null, panel);
            map.addControl(infoPanel);
            return infoPanel;
        }

        function getInfoPanel() {
            var theControl = false;
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.InfoPanel && control instanceof BKGWebMap.Control.InfoPanel) {
                    theControl = control;
                }
            });
            return theControl;
        }

        var markerControl;
        map.getControls().forEach(function (control) {
            if (BKGWebMap.Control.Marker && control instanceof BKGWebMap.Control.Marker) {
                markerControl = control;
            }
        });

        if (!markerControl) {
            var Marker = BKGWebMap.Control.FACTORIES.marker();
            markerControl = new Marker(map);
            map.addControl(markerControl);
        }

        var copyCoordinates = document.createElement('div');
        copyCoordinates.className = 'bkgwebmap-copycoordinates ' + customClass;

        var copyCoordinatesInfo = document.createElement('div');
        copyCoordinatesInfo.innerHTML = 'Linksklick: Koordinatenabfrage';
        copyCoordinatesInfo.className = 'bkgwebmap-copycoordinatesinfo';
        copyCoordinates.appendChild(copyCoordinatesInfo);

        var copyCoordinatesInput = document.createElement('input');
        copyCoordinatesInput.className = 'bkgwebmap-copycoordinatesinput';
        copyCoordinatesInput.readOnly = true;
        copyCoordinatesInput.value = '';
        copyCoordinates.appendChild(copyCoordinatesInput);

        var copyCoordinatesSelect = document.createElement('select');
        copyCoordinatesSelect.className = 'bkgwebmap-copycoordinatesselect';
        var csArray;
        if (options.coordinateSystems && options.coordinateSystems instanceof Array && options.coordinateSystems.length) {
            csArray = options.coordinateSystems;
        } else {
            csArray = [
                {
                    epsg: map.getView().getProjection().getCode(),
                    name: map.getView().getProjection().getCode()
                }
            ];
        }
        for (var i = 0; i < csArray.length; i++) {
            var selectItem = document.createElement('option');
            selectItem.className = 'bkgwebmap-copycoordinatesselectitem';
            selectItem.value = csArray[i].epsg;
            if (csArray[i].name) {
                selectItem.innerHTML = csArray[i].name;
            } else {
                selectItem.innerHTML = csArray[i].epsg;
            }
            copyCoordinatesSelect.appendChild(selectItem);
        }
        copyCoordinates.appendChild(copyCoordinatesSelect);

        var copyCoordinatesButton = document.createElement('button');
        copyCoordinatesButton.className = 'bkgwebmap-copycoordinatesbutton';
        copyCoordinatesButton.innerHTML = 'Koordinaten kopieren';
        copyCoordinates.appendChild(copyCoordinatesButton);

        copyCoordinatesButton.addEventListener('click', copyCoordinatesFunction, { passive: true });

        function copyCoordinatesFunction() {
            copyCoordinatesInput.select();
            document.execCommand('copy');
            deselectAllText();
            map.getTargetElement().style.cursor = 'default';
        }

        var markerButton = document.createElement('button');
        markerButton.className = 'bkgwebmap-deletemarker';
        markerButton.innerHTML = 'Marker löschen';

        var customProjection = copyCoordinatesSelect.value;
        var mapProjection = map.getView().getProjection();
        var lastProjection = customProjection;

        copyCoordinatesSelect.onchange = function (evt) {
            customProjection = evt.target.value;
            var coordinatesString = copyCoordinatesInput.value;
            if (coordinatesString) {
                var coordinatesArray = coordinatesString.split(' ');
                copyCoordinatesInput.value = ol.coordinate.format(ol.proj.transform([parseFloat(coordinatesArray[0]), parseFloat(coordinatesArray[1])], lastProjection, customProjection), '{x} {y}', 5);
            }
            lastProjection = customProjection;
        };

        var coordinates;
        // Add click event on map
        this.clickCopyCoordinatesActivate = function (evt) {
            // Open info panel
            if (inPanel) {
                panel.openPanel();
                var activeContent = panel.getActiveContent();
                if (activeContent !== 'bkgwebmap-infopanelcontent') {
                    panel.changePanelContent('Info', 'bkgwebmap-infopanelcontent');
                }
                infoPanel.activeIcon();
            }
            coordinates = evt.coordinate;
            copyCoordinatesInput.style.display = 'block';
            copyCoordinatesInput.value = ol.coordinate.format(ol.proj.transform(coordinates, mapProjection, customProjection), '{x} {y}', 5);
            markerControl.setMarker(_this, coordinates);
            if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-deletemarker').length) {
                document.getElementById(mapId).getElementsByClassName('bkgwebmap-deletemarker')[0].remove();
            }
            var markerButtonClone = markerButton.cloneNode(true);
            copyCoordinates.appendChild(markerButtonClone);
            markerButtonClone.onclick = function () {
                markerControl.deleteMarker();
                markerButtonClone.remove();
            };
        };

        map.on('click', this.clickCopyCoordinatesActivate);

        function deselectAllText() {
            var element = document.activeElement;
            if (element && /INPUT|TEXTAREA/i.test(element.tagName)) {
                if ('selectionStart' in element) {
                    element.selectionEnd = element.selectionStart;
                }
                element.blur();
            }
            if (window.getSelection) {
                window.getSelection().removeAllRanges();
            } else if (document.selection) {
                document.selection.empty();
            }
        }

        // Finalize control
        ol.control.Control.call(this, {
            element: copyCoordinates,
            target: target
        });
    };
};

/**
 * Create StaticLinks Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_staticLinks}
 */
BKGWebMap.Control.createStaticLinks = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var mapDivId = map.getTarget();

        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (typeof options.onlyFullScreen === 'boolean' && options.onlyFullScreen === true) {
            this.onlyFullScreen = true;
        }

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.staticLinks[0].position;
            }
        }
        if (!options.url) {
            return undefined;
        }

        var title = '';
        if (options.title && options.title !== '') {
            title = options.title;
        }

        var staticLinks = document.createElement('div');

        var standardPositionClass = '';
        if (position !== undefined) {
            if (standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                standardPositionClass = ' bkgwebmap-standardpositioncontrol bkgwebmap-standardpositioncontrol' + rightLeft;
            } else if (cssPosition) {
                for (var prop in position) {
                    staticLinks.style[prop] = position[prop];
                }
            } else {
                return undefined;
            }
        }

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        var onlyFullScreenClass = '';
        if (this.onlyFullScreen) {
            onlyFullScreenClass = ' bkgwebmap-onlyfullscreen ';
        }

        // Create DOM
        staticLinks.className = 'bkgwebmap-staticlinks ol-unselectable ol-control' + onlyFullScreenClass + customClass + standardPositionClass;

        var staticLink = document.createElement('a');
        staticLink.href = options.url;
        staticLink.setAttribute('target', '_blank');
        staticLink.setAttribute('title', title);
        staticLink.innerHTML = options.content;
        staticLink.className = 'bkgwebmap-staticlink';

        staticLinks.appendChild(staticLink);

        this.controlName = 'StaticLinks';

        this.getControlTarget = function () {
            return staticLinks;
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: staticLinks,
            target: target
        });
    };
};

/**
 * Create StaticWindows Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_staticWindows}
 */
BKGWebMap.Control.createStaticWindows = function () {
    return function (map, controlName, options) {
        if (!options.size[0] || !options.size[1]) {
            return undefined;
        }

        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }

        if (typeof options.onlyFullScreen === 'boolean' && options.onlyFullScreen === true) {
            this.onlyFullScreen = true;
        }

        this.controlName = 'StaticWindows';

        // Check if control should be open or closed
        var active = BKGWebMap.CONTROLS.tools.staticWindows[0].active;
        if (typeof options.active === 'boolean') {
            active = options.active;
        }
        var staticWindowIcon;
        var staticWindowDisplay;
        if (active) {
            staticWindowIcon = '-';
            staticWindowDisplay = 'inline-block';
        } else {
            staticWindowIcon = '+';
            staticWindowDisplay = 'none';
        }

        var position;
        if (typeof options.position === 'string') {
            position = options.position;
        } else {
            position = BKGWebMap.CONTROLS.tools.staticWindows[0].position;
        }
        var cssPosition = BKGWebMap.Util.cssParser(position);

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        var onlyFullScreenClass = '';
        if (this.onlyFullScreen) {
            onlyFullScreenClass = ' bkgwebmap-onlyfullscreen ';
        }

        // Create DOM
        var staticWindows = document.createElement('div');
        staticWindows.className = 'bkgwebmap-staticwindows ol-unselectable ol-control' + onlyFullScreenClass + customClass;
        staticWindows.style.width = options.size[0] + 'px';
        staticWindows.style.margin = '1px';

        for (var prop in cssPosition) {
            staticWindows.style[prop] = [cssPosition[prop]];
        }

        var staticWindowTitle = document.createElement('div');
        staticWindowTitle.className = 'bkgwebmap-staticwindowtitle';
        staticWindowTitle.innerHTML = options.title;

        var staticWindowButton = document.createElement('div');
        staticWindowButton.className = 'bkgwebmap-staticwindowbutton';
        staticWindowButton.innerHTML = staticWindowIcon;

        var staticWindowWrapper = document.createElement('div');
        staticWindowWrapper.className = 'bkgwebmap-staticwindowwrapper';
        staticWindowWrapper.appendChild(staticWindowTitle);
        staticWindowWrapper.appendChild(staticWindowButton);

        var staticWindowContent = document.createElement('div');
        staticWindowContent.className = 'bkgwebmap-staticwindowcontent bkgwebmap-selectable';
        staticWindowContent.innerHTML = options.content;
        staticWindowContent.style.display = staticWindowDisplay;
        staticWindowContent.style.height = options.size[1] + 'px';

        var staticWindow = document.createElement('div');
        staticWindow.className = 'bkgwebmap-staticwindow';
        staticWindow.appendChild(staticWindowWrapper);
        staticWindow.appendChild(staticWindowContent);

        staticWindows.appendChild(staticWindow);

        dragWindow(staticWindows, staticWindowWrapper);

        staticWindowButton.addEventListener('click', function () {
            if (staticWindowContent.style.display === 'none') {
                staticWindowContent.style.display = 'inline-block';
                staticWindowButton.innerHTML = '-';
            } else {
                staticWindowContent.style.display = 'none';
                staticWindowButton.innerHTML = '+';
            }
        }, { passive: true });

        // Move window
        function dragWindow(div, header) {
            var mousePosition;
            var offset = [0, 0];
            var isDown = false;

            function mouseDown(e) {
                isDown = true;
                if (e.clientX && e.clientY) {
                    offset = [
                        div.offsetLeft - e.clientX,
                        div.offsetTop - e.clientY
                    ];
                } else if (e.touches && e.touches.length) {
                    offset = [
                        div.offsetLeft - e.touches[0].clientX,
                        div.offsetTop - e.touches[0].clientY
                    ];
                }

                document.addEventListener('mousemove', mouseMove);
                document.addEventListener('touchmove', mouseMove);
            }

            function mouseUp() {
                isDown = false;
                document.removeEventListener('mousemove', mouseMove);
                document.removeEventListener('touchmove', mouseMove);
            }

            function mouseMove(event) {
                event.preventDefault();
                if (isDown) {
                    if (event.clientX && event.clientY) {
                        mousePosition = {
                            x: event.clientX,
                            y: event.clientY
                        };
                    } else if (event.touches && event.touches.length) {
                        mousePosition = {
                            x: event.touches[0].clientX,
                            y: event.touches[0].clientY
                        };
                    }
                    div.style.left = (mousePosition.x + offset[0]) + 'px';
                    div.style.top = (mousePosition.y + offset[1]) + 'px';
                }
            }
            header.addEventListener('mousedown', mouseDown);
            header.addEventListener('touchstart', mouseDown);

            document.addEventListener('mouseup', mouseUp);
            document.addEventListener('touchend', mouseUp);
        }

        this.getControlTarget = function () {
            return staticWindows;
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: staticWindows,
            target: target
        });
    };
};

/**
 * Create Scalebar Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_scalebar}
 */
BKGWebMap.Control.createScalebar = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var _this = this;

        var mapDivId = map.getTarget();
        var scaleLineDiv;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (typeof options.onlyFullScreen === 'boolean' && options.onlyFullScreen === true) {
            this.onlyFullScreen = true;
        }

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.scalebar.position;
            }
        }

        var onlyFullScreenClass = '';
        if (this.onlyFullScreen) {
            onlyFullScreenClass = ' bkgwebmap-onlyfullscreen ';
        }

        var scalebar = document.createElement('div');
        scalebar.className = 'bkgwebmap-scalebar bkgwebmap-scalebarinit ol-unselectable ol-control' + onlyFullScreenClass;

        if (position !== undefined) {
            if (!cssPosition && standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                scalebar.classList.add('bkgwebmap-standardpositioncontrol', 'bkgwebmap-standardpositioncontrol' + rightLeft);
            } else if (cssPosition) {
                for (var prop in position) {
                    scalebar.style[prop] = position[prop];
                }
            } else {
                return undefined;
            }
        }

        var scalebarType = BKGWebMap.CONTROLS.tools.scalebar.scalebarType;
        var scalebarTypes = [
            'mapscale',
            'resolution',
            'distance',
            'mapscaleDistance',
            'resolutionDistance'
        ];

        if (scalebarTypes.indexOf(options.scalebarType) !== -1) {
            scalebarType = options.scalebarType;
        }

        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
            scalebar.classList.add(customClass);
        }

        if (scalebarType !== 'mapscale' && scalebarType !== 'resolution') {
            scaleLineDiv = document.createElement('div');
            scaleLineDiv.className = 'bkgwebmap-scalelinediv';
        }

        var scaleValueDiv = document.createElement('div');
        scaleValueDiv.className = 'bkgwebmap-scalevalue';

        scalebar.appendChild(scaleValueDiv);
        if (scaleLineDiv) {
            scalebar.appendChild(scaleLineDiv);
        }


        var units = map.getView().getProjection().getUnits();

        var DOTS_PER_INCH = 25.4 / 0.28;

        function getScale(resolution) {
            var metersPerUnit = map.getView().getProjection().getMetersPerUnit();
            var scale = 39.37 * DOTS_PER_INCH * resolution * metersPerUnit;
            scale = '1 : ' + Math.round(scale);
            return scale;
        }

        function getResolution(resolution) {
            var resolutionString;
            if (units === 'degrees') {
                resolutionString = (resolution * 3600).toFixed(2) + ' "/Pixel';
            } else {
                resolutionString = resolution.toFixed(2) + ' Meter/Pixel';
            }
            return resolutionString;
        }

        function getScaleResolution() {
            var resolution = map.getView().getResolution();
            switch (scalebarType) {
            case 'mapscaleDistance':
                scalebar.classList.remove('bkgwebmap-scalebarinit');
                scaleValueDiv.innerHTML = getScale(resolution);
                break;
            case 'resolutionDistance':
                scalebar.classList.remove('bkgwebmap-scalebarinit');
                scaleValueDiv.innerHTML = getResolution(resolution);
                break;
            case 'mapscale':
                scaleValueDiv.innerHTML = getScale(resolution);
                break;
            case 'resolution':
                scaleValueDiv.innerHTML = getResolution(resolution);
                break;
            default:
                scalebar.classList.remove('bkgwebmap-scalebarinit');
            }

            // Adjust scalebar width
            if (scaleLineDiv) {
                setTimeout(function () {
                    var scalebarWidth = _this.scaleLine.element.childNodes[0].clientWidth;
                    scaleLineDiv.style.width = scalebarWidth + 'px';
                }, 100);
            }
        }

        map.on('moveend', getScaleResolution);

        var mapUnits = units;
        if (units === 'm') {
            mapUnits = 'metric';
        }

        if (scaleLineDiv) {
            this.scaleLine = new ol.control.ScaleLine({
                target: scaleLineDiv,
                className: 'bkgwebmap-scaleline',
                units: mapUnits
            });

            BKGWebMap.Control.Scalebar.prototype.setMap = function (map) {
                this.scaleLine.setMap(map);
                ol.control.Control.prototype.setMap.call(this, map);
            };
        }

        // Finalize control
        ol.control.Control.call(this, {
            element: scalebar,
            target: target
        });
    };
};

/**
 * Create Copyright Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_copyright}
 */
BKGWebMap.Control.createCopyright = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var _this = this;
        var mapDivId = map.getTarget();
        var copyrightIsOpen = false;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (typeof options.onlyFullScreen === 'boolean' && options.onlyFullScreen === true) {
            this.onlyFullScreen = true;
        }

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.copyright.position;
            }
        }

        var onlyFullScreenClass = '';
        if (this.onlyFullScreen) {
            onlyFullScreenClass = ' bkgwebmap-onlyfullscreen ';
        }

        var copyright = document.createElement('div');
        copyright.className = 'bkgwebmap-copyright ol-unselectable ol-control' + onlyFullScreenClass;

        var tooltipExtraClass = ' bkgwebmap-tooltipinmaptext';
        if (position !== undefined) {
            if (!cssPosition && standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                copyright.classList.add('bkgwebmap-standardpositioncontrol', 'bkgwebmap-standardpositioncontrol' + rightLeft);
                if (rightLeft === 'right') {
                    tooltipExtraClass = ' bkgwebmap-tooltipcopyrightright';
                }
            } else if (cssPosition) {
                for (var prop in position) {
                    copyright.style[prop] = position[prop];
                }
            } else {
                return undefined;
            }
        }

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
            copyright.classList.add(customClass);
        }

        var maxWidth = BKGWebMap.CONTROLS.tools.copyright.maxWidth;
        if (options.maxWidth && options.maxWidth !== '') {
            maxWidth = options.maxWidth;
            if (maxWidth.indexOf('px') === -1) {
                maxWidth += 'px';
            }
        }

        var maxHeight = BKGWebMap.CONTROLS.tools.copyright.maxHeight;
        if (options.maxHeight && options.maxHeight !== '') {
            maxHeight = options.maxHeight;
            if (maxHeight.indexOf('px') === -1) {
                maxHeight += 'px';
            }
        }

        var copyrightButton = document.createElement('button');
        copyrightButton.className = 'bkgwebmap-mapbutton bkgwebmap-copyrightbutton bkgwebmap-paneltooltip';

        // Parse icons
        var parser = new DOMParser();
        var iconCopyright = parser.parseFromString(BKGWebMap.PANEL_ICONS.COPYRIGHT, 'text/xml');
        copyrightButton.appendChild(iconCopyright.documentElement);

        var copyrightTooltip = document.createElement('span');
        copyrightTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-tooltipcopyright' + tooltipExtraClass;
        copyrightTooltip.innerHTML = 'Copyright';
        copyrightButton.appendChild(copyrightTooltip);

        var copyrightList = document.createElement('ul');
        copyrightList.className = 'bkgwebmap-copyrightlist bkgwebmap-selectable';
        copyrightList.style.display = 'none';
        copyrightList.style.position = 'absolute';

        // Compute optimal size for copyright
        function adjustCopyrightSize() {
            var controlsTopLeft = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-left')[0];
            var controlsTopRight = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-top-right')[0];
            var controlsBottomLeft = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-left')[0];
            var controlsBottomRight = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-position-bottom-right')[0];

            var heightOfTopControls;
            if (controlsTopLeft.getBoundingClientRect().height > controlsTopRight.getBoundingClientRect().height) {
                heightOfTopControls = controlsTopLeft.getBoundingClientRect().height;
            } else {
                heightOfTopControls = controlsTopRight.getBoundingClientRect().height;
            }
            var heightOfBottomControls;
            if (controlsBottomLeft.getBoundingClientRect().height > controlsBottomRight.getBoundingClientRect().height) {
                heightOfBottomControls = controlsBottomLeft.getBoundingClientRect().height;
            } else {
                heightOfBottomControls = controlsBottomRight.getBoundingClientRect().height;
            }
            var offset = controlsTopLeft.offsetTop;

            var mapHeight = document.getElementById(mapDivId).offsetHeight;
            var newCopyrightHeight = mapHeight - (heightOfTopControls + heightOfBottomControls + (offset * 2) + 10);
            var mapDivWidth = document.getElementById(mapDivId).offsetWidth;
            var copyrightListWidth;
            if (mapDivWidth < 350) {
                copyrightListWidth = mapDivWidth - 80;
            } else {
                copyrightListWidth = mapDivWidth / 2;
            }
            copyrightList.style.width = copyrightListWidth + 'px';
            copyrightList.style.maxHeight = newCopyrightHeight + 'px';
            copyrightList.style.maxWidth = maxWidth;
            if (position === 'bottom-right' || position === 'bottom-left') {
                copyrightList.style.bottom = '100%';
            }
            if (position === 'bottom-right' || position === 'top-right') {
                copyrightList.style.right = '0';
            }
            if (cssPosition) {
                adjustCopyrightList(position, mapDivWidth, mapHeight);
            }
        }

        function adjustCopyrightList(position, mapWidth, mapHeight) {
            if (Object.prototype.hasOwnProperty.call(position, 'top')) {
                copyrightList.style.bottom = parseInt(position.top, 10) > mapHeight / 2 ? '100%' : 'auto';
            } else if (Object.prototype.hasOwnProperty.call(position, 'bottom')) {
                copyrightList.style.bottom = parseInt(position.bottom, 10) > mapHeight / 2 ? 'auto' : '100%';
            }
            if (Object.prototype.hasOwnProperty.call(position, 'left')) {
                copyrightList.style.right = parseInt(position.left, 10) > mapWidth / 2 ? '0' : 'auto';
            } else if (Object.prototype.hasOwnProperty.call(position, 'right')) {
                copyrightList.style.right = parseInt(position.right, 10) > mapWidth / 2 ? 'auto' : '0';
            }
        }

        setTimeout(adjustCopyrightSize, 1000);
        map.on('change:size', adjustCopyrightSize);

        copyright.appendChild(copyrightButton);
        copyright.appendChild(copyrightList);

        copyrightButton.addEventListener('click', function () {
            if (!copyrightList.children.length) {
                copyrightButton.style.position = '';
                copyrightList.style.display = 'none';
            } else if (copyrightList.style.display === 'none') {
                copyrightList.style.display = 'inline-block';
                copyrightIsOpen = true;
            } else {
                copyrightButton.style.position = '';
                copyrightList.style.display = 'none';
                copyrightIsOpen = false;
            }
        }, { passive: true });

        this.addLayerInCopyright = function (layer) {
            if (layer instanceof ol.layer.Group) {
                layer.getLayers().forEach(function (sublayer) {
                    _this.addLayerInCopyright(sublayer);
                });
                layer.on('change:visible', function () {
                    addCopyright(map);
                });
            } else {
                var copyrightInfo = layer.get('copyright');
                if (copyrightInfo) {
                    addCopyright(map);
                    layer.on('change:visible', function () {
                        addCopyright(map);
                    });
                }
            }
        };

        this.removeLayerFromCopyright = function () {
            addCopyright(map);
        };

        function addCopyright(map) {
            var arrayCopyright = [];
            copyrightList.innerHTML = '';
            map.getLayers().forEach(function (layer) {
                if (layer instanceof ol.layer.Group) {
                    if (layer.getVisible()) {
                        layer.getLayers().forEach(function (groupLayer) {
                            var visible = groupLayer.getVisible();
                            var copyrightInfo = groupLayer.get('copyright');
                            if (visible && copyrightInfo && arrayCopyright.indexOf(copyrightInfo) === -1) {
                                arrayCopyright.push(copyrightInfo);
                            }
                        });
                    }
                } else {
                    var visible = layer.getVisible();
                    var copyrightInfo = layer.get('copyright');
                    if (visible && copyrightInfo && arrayCopyright.indexOf(copyrightInfo) === -1) {
                        arrayCopyright.push(copyrightInfo);
                    }
                }
            });
            for (var i = 0; i < arrayCopyright.length; i++) {
                var li = document.createElement('li');
                li.className = 'bkgwebmap-copyrightlistitem';
                li.innerHTML = arrayCopyright[i];
                copyrightList.appendChild(li);
            }
            var copyrightLength = copyrightList.innerText.length;
            if (!copyrightLength) {
                copyrightButton.style.position = '';
                copyrightList.style.display = 'none';
            } else if (copyrightIsOpen) {
                copyrightList.style.display = 'inline-block';
                copyrightIsOpen = true;
            } else {
                copyrightButton.style.position = '';
                copyrightList.style.display = 'none';
                copyrightIsOpen = false;
            }
        }

        copyrightButton.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            copyrightTooltip.style.visibility = 'visible';
            setTimeout(function () {
                copyrightTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: copyright,
            target: target
        });
    };
};

/**
 * Create Measure Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_measure}
 */
BKGWebMap.Control.createMeasure = function () {
    return function (map, controlName, options, panel) {
        var _this = this;
        var mapId = map.getTarget();

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
        } else {
            target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];
        }

        // Control title for panel
        var title = 'Messen';

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        // Tooltip position
        var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
        var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
        if (inPanel && panel.getPanelPosition() === 'right') {
            tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
            tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
        }

        // Create DOM
        var measure = document.createElement('div');
        measure.className = 'bkgwebmap-measure';

        var measureToggle = document.createElement('div');
        measureToggle.className = 'bkgwebmap-measureToggle ' + tooltipClass + customClass;
        measure.appendChild(measureToggle);

        var measureTooltip = document.createElement('span');
        measureTooltip.className = tooltipTextClass;
        measureTooltip.innerHTML = title;
        measureToggle.appendChild(measureTooltip);

        var parser = new DOMParser();
        var measureIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.MEASURE_AREA, 'text/xml');
        measureIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons');
        measureToggle.appendChild(measureIcon.documentElement);

        var measureSidePanel = document.createElement('div');
        measureSidePanel.className = 'bkgwebmap-sidemultiplepanel';
        measure.appendChild(measureSidePanel);
        measureSidePanel.style.position = 'relative';
        if (inPanel) {
            measureSidePanel.style.width = document.getElementById(mapId).getElementsByClassName('bkgwebmap-panelbar')[0].style.width;
            if (panel.getPanelPosition() === 'right') {
                measureSidePanel.style.right = '50px';
            } else {
                measureSidePanel.style.left = '50px';
            }
            measureSidePanel.style.top = '-35px';
        }
        measureSidePanel.style.display = 'none';


        var measureDistance = document.createElement('div');
        measureDistance.className = 'bkgwebmap-sidepanelbuttons bkgwebmap-measurebuttons bkgwebmap-measuredistance ' + tooltipClass;

        var newNode = parser.parseFromString(BKGWebMap.PANEL_ICONS.MEASURE_DISTANCE, 'text/xml');
        newNode.documentElement.setAttribute('class', 'bkgwebmap-sidepanelicons');
        measureDistance.appendChild(newNode.documentElement);
        measureSidePanel.appendChild(measureDistance);

        var measureDistanceTooltip = document.createElement('span');
        measureDistanceTooltip.className = tooltipTextClass;
        measureDistanceTooltip.innerHTML = 'Strecke messen';
        measureDistance.appendChild(measureDistanceTooltip);

        var measureArea = document.createElement('div');
        measureArea.className = 'bkgwebmap-sidepanelbuttons bkgwebmap-measurebuttons bkgwebmap-measurearea ' + tooltipClass;
        measureArea.style.marginTop = '10px';

        newNode = parser.parseFromString(BKGWebMap.PANEL_ICONS.MEASURE_AREA, 'text/xml');
        newNode.documentElement.setAttribute('class', 'bkgwebmap-sidepanelicons');
        measureArea.appendChild(newNode.documentElement);
        measureSidePanel.appendChild(measureArea);

        var measureAreaTooltip = document.createElement('span');
        measureAreaTooltip.className = tooltipTextClass;
        measureAreaTooltip.innerHTML = 'Fläche messen';
        measureArea.appendChild(measureAreaTooltip);

        if (inPanel) {
            measureDistance.style.backgroundColor = '#407E40';
            measureArea.style.backgroundColor = '#407E40';
        }

        // Show tooltip on hover and hide all other
        function showHideTooltips(tooltip) {
            var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }

            tooltip.style.visibility = 'visible';
            setTimeout(function () {
                tooltip.style.visibility = '';
            }, 1200);
        }

        // Event listeners
        measureToggle.addEventListener('click', function () {
            _this.toggleSidePanels();
        }, true);
        measureArea.addEventListener('click', measureOn, false);
        measureArea.addEventListener('mouseenter', function () {
            showHideTooltips(measureAreaTooltip);
        }, false);
        measureDistance.addEventListener('click', measureOn, false);
        measureDistance.addEventListener('mouseenter', function () {
            showHideTooltips(measureDistanceTooltip);
        }, false);
        measureToggle.addEventListener('mouseenter', function () {
            showHideTooltips(measureTooltip);
        }, false);

        function hightlightMeasureButton(type) {
            if (type === 'area') {
                measureArea.classList.add('bkgwebmap-measureactive');
                removeStyleClass(measureDistance, 'bkgwebmap-measureactive');
            } else if (type === 'distance') {
                measureDistance.classList.add('bkgwebmap-measureactive');
                removeStyleClass(measureArea, 'bkgwebmap-measureactive');
            }
        }

        function removeStyleClass(element, cssClass) {
            if (element.classList.contains(cssClass)) {
                element.classList.remove(cssClass);
            }
        }

        // Functionality
        var measureControl = this;

        this.closeSidePanel = function (print) {
            if (!print) {
                if (draw) {
                    measureClearResults();
                    addAttributeListener();
                }
                measureSidePanel.style.display = 'none';
            } else {
                if (draw) {
                    addAttributeListener();
                }
                measureSidePanel.style.display = 'none';
            }
            removeStyleClass(measure, 'bkgwebmap-panelactive');
            removeStyleClass(measureArea, 'bkgwebmap-measureactive');
            removeStyleClass(measureDistance, 'bkgwebmap-measureactive');
        };

        document.onkeydown = function (evt) {
            evt = evt || window.event;
            var isEscape = false;
            if ('key' in evt) {
                isEscape = (evt.key === 'Escape' || evt.key === 'Esc');
            } else {
                isEscape = (evt.keyCode === 27);
            }
            if (isEscape) {
                if (draw) {
                    measureClearResults();
                    addAttributeListener();
                }
            }
        };

        function deactivateEdit() {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.Edit && control instanceof BKGWebMap.Control.Edit) {
                    control.removeEditInteractions();
                }
            });
        }

        /**
         * Open/close panel with measure buttons
         */
        this.toggleSidePanels = function () {
            deactivateEdit();
            if (inPanel) {
                if (measure.classList.contains('bkgwebmap-panelactive')) {
                    measure.classList.remove('bkgwebmap-panelactive');
                } else {
                    measure.classList.add('bkgwebmap-panelactive');
                }
            }
            panel.closePanel();
            if (measureSidePanel.style.display === 'none') {
                measureSidePanel.style.display = 'block';
            } else if (measureSidePanel.style.display === 'block') {
                measureControl.closeSidePanel();
            }
        };

        // Interaction for drawing
        var draw;
        // Layer for drawing
        var source = new ol.source.Vector();

        var vector = new ol.layer.Vector({
            source: source,
            measureLayer: true,
            uniqueId: 'measurelayer',
            style: new ol.style.Style({
                fill: new ol.style.Fill({
                    color: 'rgba(158, 11, 18, 0.2)'
                }),
                stroke: new ol.style.Stroke({
                    color: 'rgba(158, 11, 18, 1)',
                    width: 2
                }),
                image: new ol.style.Circle({
                    radius: 7,
                    fill: new ol.style.Fill({
                        color: '#ffcc33'
                    })
                })
            })
        });

        // Overlay to show the help messages
        var helpTooltip;

        // Overlay to show the measurement
        var measureTooltipOverlay;

        function removeAttributeListener() {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.ShowAttributes && control instanceof BKGWebMap.Control.ShowAttributes) {
                    map.un('click', control.clickAttributesActivate);
                }
                if (BKGWebMap.Control.GeoSearch && control instanceof BKGWebMap.Control.GeoSearch) {
                    map.un('click', control.geoSearchClickActivate);
                }
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    map.un('click', control.clickCopyCoordinatesActivate);
                }
            });
        }

        function addAttributeListener() {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.ShowAttributes && control instanceof BKGWebMap.Control.ShowAttributes) {
                    map.on('click', control.clickAttributesActivate);
                }
                if (BKGWebMap.Control.GeoSearch && control instanceof BKGWebMap.Control.GeoSearch) {
                    map.on('click', control.geoSearchClickActivate);
                }
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    map.on('click', control.clickCopyCoordinatesActivate);
                }
            });
        }

        function measureClearResults() {
            var i;
            map.removeInteraction(draw);
            map.removeOverlay(helpTooltip);
            source.clear();
            // remove tooltips
            var oldStaticTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-measureoverlay-tooltip-static');
            if (oldStaticTooltips.length) {
                for (i = 0; i < oldStaticTooltips.length; i++) {
                    oldStaticTooltips[i].parentNode.remove();
                }
            }
            var oldMeasureTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-measureoverlay-tooltip-measure');
            if (oldMeasureTooltips.length) {
                for (i = 0; i < oldMeasureTooltips.length; i++) {
                    oldMeasureTooltips[i].parentNode.remove();
                }
            }
            map.removeLayer(vector);
        }

        function measureOn() {
            removeAttributeListener();

            if (draw) {
                measureClearResults();
            }
            var typeMeasure;
            if (this.classList.contains('bkgwebmap-measurearea')) {
                typeMeasure = 'Polygon';
                hightlightMeasureButton('area');
            } else {
                typeMeasure = 'LineString';
                hightlightMeasureButton('distance');
            }

            // Currently drawn feature
            var sketch;

            // The help tooltip element
            var helpTooltipElement;

            // The measure tooltip element
            var measureTooltipElement;

            // Message to show when the user is drawing a polygon
            var continuePolygonMsg = 'Polygon-Stützpunkt setzen';

            // Message to show when the user is drawing a line
            var continueLineMsg = 'Linie-Stützpunkt setzen';

            // Handle pointer move
            var pointerMoveHandler = function (evt) {
                if (evt.dragging) {
                    return;
                }

                var helpMsg = 'Klicken, um zu messen';

                if (sketch) {
                    var geom = (sketch.getGeometry());
                    if (geom instanceof ol.geom.Polygon) {
                        helpMsg = continuePolygonMsg;
                    } else if (geom instanceof ol.geom.LineString) {
                        helpMsg = continueLineMsg;
                    }
                }

                helpTooltipElement.innerHTML = helpMsg;
                helpTooltip.setPosition(evt.coordinate);

                helpTooltipElement.classList.remove('hidden');
            };

            map.on('pointermove', pointerMoveHandler);

            map.getViewport().addEventListener('mouseout', function () {
                helpTooltipElement.classList.add('hidden');
            });

            var mapProjection = map.getView().getProjection();

            var wgs84Sphere = new ol.Sphere(6378137);

            // Format length output.
            var formatLength = function (line) {
                var length = 0;
                var coordinates = line.getCoordinates();
                for (var i = 0; i < coordinates.length - 1; i++) {
                    var c1 = ol.proj.transform(coordinates[i], mapProjection, 'EPSG:4326');
                    var c2 = ol.proj.transform(coordinates[i + 1], mapProjection, 'EPSG:4326');
                    length += wgs84Sphere.haversineDistance(c1, c2);
                }
                var output;
                if (length > 100) {
                    output = (Math.round(length / 1000 * 100) / 100) +
                        ' km';
                } else {
                    output = (Math.round(length * 100) / 100) +
                        ' m';
                }
                return output;
            };

            // Format area output.
            var formatArea = function (polygon) {
                var newPolygon = polygon.clone().transform(mapProjection, 'EPSG:4326');
                var coordPolygon = newPolygon.getLinearRing(0).getCoordinates();
                var area = Math.abs(wgs84Sphere.geodesicArea(coordPolygon));
                var output;
                if (area > 10000) {
                    output = (Math.round(area / 1000000 * 100) / 100) +
                        ' km<sup>2</sup>';
                } else {
                    output = (Math.round(area * 100) / 100) +
                        ' m<sup>2</sup>';
                }
                return output;
            };

            function addInteraction() {
                draw = new ol.interaction.Draw({
                    source: source,
                    type: typeMeasure,
                    style: new ol.style.Style({
                        fill: new ol.style.Fill({
                            color: 'rgba(158, 11, 18, 0.2)'
                        }),
                        stroke: new ol.style.Stroke({
                            color: 'rgba(158, 11, 18, 1)',
                            width: 3
                        }),
                        image: new ol.style.Circle({
                            radius: 5,
                            stroke: new ol.style.Stroke({
                                color: 'rgba(158, 11, 18, 0.7)'
                            }),
                            fill: new ol.style.Fill({
                                color: 'rgba(255, 255, 255, 0.2)'
                            })
                        })
                    })
                });
                map.addInteraction(draw);

                createMeasureTooltip();
                createHelpTooltip();
                var listener;
                draw.on('drawstart', function (evt) {
                    var oldTooltip = document.getElementById(mapId).getElementsByClassName('bkgwebmap-measureoverlay-tooltip-static');
                    if (oldTooltip.length) {
                        for (var i = 0; i < oldTooltip.length; i++) {
                            oldTooltip[i].parentNode.remove();
                        }
                    }
                    source.clear();
                    map.removeLayer(vector);

                    evt.feature.setProperties({
                        id: 'measurefeature'
                    });
                    // Set sketch
                    sketch = evt.feature;


                    var tooltipCoord = evt.coordinate;

                    listener = sketch.getGeometry().on('change', function (event) {
                        var geom = event.target;
                        var output;
                        if (geom instanceof ol.geom.Polygon) {
                            output = formatArea(geom);
                            tooltipCoord = geom.getInteriorPoint().getCoordinates();
                        } else if (geom instanceof ol.geom.LineString) {
                            output = formatLength(geom);
                            tooltipCoord = geom.getLastCoordinate();
                        }
                        measureTooltipElement.innerHTML = output;
                        measureTooltipOverlay.setPosition(tooltipCoord);
                    });
                }, this);

                draw.on('drawend', function () {
                    measureTooltipElement.className = 'bkgwebmap-measureoverlay-tooltip bkgwebmap-measureoverlay-tooltip-static';
                    measureTooltipOverlay.setOffset([0, -30]);
                    // Unset sketch
                    sketch = null;
                    // Unset tooltip so that a new one can be created
                    measureTooltipElement = null;
                    createMeasureTooltip();
                    ol.Observable.unByKey(listener);
                    map.addLayer(vector);
                }, this);
            }


            // Creates a new help tooltip
            function createHelpTooltip() {
                if (helpTooltipElement) {
                    helpTooltipElement.parentNode.removeChild(helpTooltipElement);
                }
                helpTooltipElement = document.createElement('div');
                helpTooltipElement.className = 'bkgwebmap-measureoverlay-tooltip hidden';
                helpTooltip = new ol.Overlay({
                    element: helpTooltipElement,
                    offset: [15, 0],
                    positioning: 'center-left'
                });
                map.addOverlay(helpTooltip);
            }

            // Creates a new measure tooltip
            function createMeasureTooltip() {
                if (measureTooltipElement) {
                    measureTooltipElement.parentNode.removeChild(measureTooltipElement);
                }
                measureTooltipElement = document.createElement('div');
                measureTooltipElement.className = 'bkgwebmap-measureoverlay-tooltip bkgwebmap-measureoverlay-tooltip-measure';
                measureTooltipOverlay = new ol.Overlay({
                    element: measureTooltipElement,
                    offset: [0, -50],
                    positioning: 'bottom-center'
                });
                map.addOverlay(measureTooltipOverlay);
            }

            addInteraction();
        }

        // Finalize control
        ol.control.Control.call(this, {
            element: measure,
            target: target
        });
    };
};

/**
 * Create Edit Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_edit}
 */
BKGWebMap.Control.createEdit = function () {
    return function (map, controlName, options, panel) {
        var _this = this;
        var mapId = map.getTarget();
        var interactionSelect;
        var globalLayer;
        var globalFeature;
        var editButtonSaveAttributes;
        var enterColumnInput;
        var enterColumnButton;
        var columnSelect;
        var formatSelect;
        var exportNameInput;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
        } else {
            target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];
        }

        // Control title for panel
        var title = 'Editieren';

        // Tooltip position
        var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
        var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
        if (inPanel && panel.getPanelPosition() === 'right') {
            tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
            tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
        }

        // Create DOM
        var editPanel = document.createElement('div');
        editPanel.className = 'bkgwebmap-editpanel ' + tooltipClass;

        editPanel.onclick = function () {
            clearDropdown(layerSelect);
            map.getLayers().forEach(function (layer) {
                _this.getEditableLayer(map, layer);
            });
        };

        var parser = new DOMParser();
        var editPanelIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.EDIT, 'text/xml');
        editPanelIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons bkgwebmap-paneliconsopen');
        editPanel.appendChild(editPanelIcon.documentElement);

        var editPanelTooltip = document.createElement('span');
        editPanelTooltip.className = tooltipTextClass;
        editPanelTooltip.innerHTML = title;
        editPanel.appendChild(editPanelTooltip);

        var editPanelContent = document.createElement('div');
        var editPanelContentClass = 'bkgwebmap-editpanelcontent';
        editPanelContent.className = editPanelContentClass + ' bkgwebmap-panelsinglecontent';

        var layerSelect = document.createElement('select');
        layerSelect.className = 'bkgwebmap-layerselect';
        layerSelect.setAttribute('data-bkgwebmap-lasteditlayer', '');

        var selectItem = document.createElement('option');
        selectItem.innerHTML = 'Layer auswählen';
        layerSelect.appendChild(selectItem);

        editPanelContent.appendChild(layerSelect);

        var editAccordionTitle = document.createElement('div');
        editAccordionTitle.innerHTML = 'Editierung';
        editAccordionTitle.className = 'bkgwebmap-editaccordionheader';

        var editAccordionHeader = document.createElement('div');
        editAccordionHeader.className = 'bkgwebmap-customlayerwmsheader';

        var editAccordionMinusDiv = document.createElement('div');
        editAccordionMinusDiv.className = 'bkgwebmap-editaccordionplusminus';
        editAccordionMinusDiv.innerHTML = '+';

        editAccordionHeader.appendChild(editAccordionTitle);
        editAccordionHeader.appendChild(editAccordionMinusDiv);

        editAccordionHeader.addEventListener('click', function () {
            var parent = this.parentNode;
            var minusPlus = parent.getElementsByClassName('bkgwebmap-editaccordionplusminus')[0];
            editInterfaceWrapper.style.display = editInterfaceWrapper.style.display === 'none' ? 'block' : 'none';
            minusPlus.innerHTML = minusPlus.innerHTML === '+' ? '-' : '+';
        });

        editPanelContent.appendChild(editAccordionHeader);

        // edit interface wrapper
        var editInterfaceWrapper = document.createElement('div');
        var editInterfaceSelectLayerSpan = document.createElement('span');
        editInterfaceSelectLayerSpan.innerHTML = 'Layer auswählen!';
        editInterfaceWrapper.appendChild(editInterfaceSelectLayerSpan);
        editInterfaceWrapper.style.display = 'none';
        editPanelContent.appendChild(editInterfaceWrapper);

        var exportAccordionTitle = document.createElement('div');
        exportAccordionTitle.innerHTML = 'Exportieren';
        exportAccordionTitle.className = 'bkgwebmap-exportaccordionheader';

        var exportAccordionHeader = document.createElement('div');
        exportAccordionHeader.className = 'bkgwebmap-customlayerwmsheader';

        var exportAccordionMinusDiv = document.createElement('div');
        exportAccordionMinusDiv.className = 'bkgwebmap-exportaccordionplusminus';
        exportAccordionMinusDiv.innerHTML = '+';

        exportAccordionHeader.appendChild(exportAccordionTitle);
        exportAccordionHeader.appendChild(exportAccordionMinusDiv);

        exportAccordionHeader.addEventListener('click', function () {
            var parent = this.parentNode;
            var minusPlus = parent.getElementsByClassName('bkgwebmap-exportaccordionplusminus')[0];
            exportInterfaceWrapper.style.display = exportInterfaceWrapper.style.display === 'none' ? 'block' : 'none';
            minusPlus.innerHTML = minusPlus.innerHTML === '+' ? '-' : '+';
        });

        editPanelContent.appendChild(exportAccordionHeader);

        var exportInterfaceWrapper = document.createElement('div');
        var exportInterfaceSelectLayerSpan = document.createElement('span');
        exportInterfaceSelectLayerSpan.innerHTML = 'Layer auswählen!';
        exportInterfaceWrapper.insertBefore(exportInterfaceSelectLayerSpan, exportInterfaceWrapper.childNodes[0]);
        exportInterfaceWrapper.style.display = 'none';
        editPanelContent.appendChild(exportInterfaceWrapper);

        var exportInterfaceInnerWrapper = document.createElement('div');
        exportInterfaceInnerWrapper.style.display = 'none';
        exportInterfaceWrapper.appendChild(exportInterfaceInnerWrapper);

        var editButtonPoint = document.createElement('div');
        editButtonPoint.className = 'bkgwebmap-editbutton bkgwebmap-paneltooltip bkgwebmap-paneltooltiptopright';
        editButtonPoint.setAttribute('data-bkgwebmap-editgeom', 'Point');
        var parserIconPoint = new DOMParser();
        var iconPoint = parserIconPoint.parseFromString(BKGWebMap.PANEL_ICONS.EDIT_POINT, 'text/xml');
        editButtonPoint.appendChild(iconPoint.documentElement);
        var editButtonPointTooltip = document.createElement('span');
        editButtonPointTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptexttopright';
        editButtonPointTooltip.innerHTML = 'Punkte hinzufügen oder verschieben';
        editButtonPoint.appendChild(editButtonPointTooltip);
        tooltipHoverEvent(editButtonPoint);
        editInterfaceWrapper.appendChild(editButtonPoint);

        var editButtonLine = document.createElement('div');
        editButtonLine.className = 'bkgwebmap-editbutton bkgwebmap-paneltooltip bkgwebmap-paneltooltiptopright';
        editButtonLine.setAttribute('data-bkgwebmap-editgeom', 'LineString');
        var parserIconLine = new DOMParser();
        var iconLine = parserIconLine.parseFromString(BKGWebMap.PANEL_ICONS.EDIT_LINE, 'text/xml');
        editButtonLine.appendChild(iconLine.documentElement);
        var editButtonLineTooltip = document.createElement('span');
        editButtonLineTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptexttopright';
        editButtonLineTooltip.innerHTML = 'Linien hinzufügen oder verschieben';
        editButtonLine.appendChild(editButtonLineTooltip);
        tooltipHoverEvent(editButtonLine);
        editInterfaceWrapper.appendChild(editButtonLine);

        var editButtonPolygon = document.createElement('div');
        editButtonPolygon.className = 'bkgwebmap-editbutton bkgwebmap-paneltooltip bkgwebmap-paneltooltiptopright';
        editButtonPolygon.setAttribute('data-bkgwebmap-editgeom', 'Polygon');
        var parserIconPolygon = new DOMParser();
        var iconPolygon = parserIconPolygon.parseFromString(BKGWebMap.PANEL_ICONS.EDIT_POLYGON, 'text/xml');
        editButtonPolygon.appendChild(iconPolygon.documentElement);
        var editButtonPolygonTooltip = document.createElement('span');
        editButtonPolygonTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptexttopright';
        editButtonPolygonTooltip.innerHTML = 'Polygone hinzufügen oder verschieben';
        editButtonPolygon.appendChild(editButtonPolygonTooltip);
        tooltipHoverEvent(editButtonPolygon);
        editInterfaceWrapper.appendChild(editButtonPolygon);

        var editButtonAttributes = document.createElement('div');
        editButtonAttributes.className = 'bkgwebmap-editbutton bkgwebmap-paneltooltip bkgwebmap-paneltooltiptopright';
        var parserIconAttributes = new DOMParser();
        var iconAttributes = parserIconAttributes.parseFromString(BKGWebMap.PANEL_ICONS.ATTRIBUTES, 'text/xml');
        editButtonAttributes.appendChild(iconAttributes.documentElement);
        var attributesTooltip = document.createElement('span');
        attributesTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptexttopright';
        attributesTooltip.innerHTML = 'Attribute';
        editButtonAttributes.appendChild(attributesTooltip);
        tooltipHoverEvent(editButtonAttributes);
        editInterfaceWrapper.appendChild(editButtonAttributes);

        var editButtonDelete = document.createElement('div');
        editButtonDelete.className = 'bkgwebmap-editbutton bkgwebmap-paneltooltip bkgwebmap-paneltooltiptopright';
        var parserIconDelete = new DOMParser();
        var iconDelete = parserIconDelete.parseFromString(BKGWebMap.PANEL_ICONS.DELETE, 'text/xml');
        editButtonDelete.appendChild(iconDelete.documentElement);
        var editButtonDeleteTooltip = document.createElement('span');
        editButtonDeleteTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptexttopright';
        editButtonDeleteTooltip.innerHTML = 'Features löschen';
        editButtonDelete.appendChild(editButtonDeleteTooltip);
        tooltipHoverEvent(editButtonDelete);
        editInterfaceWrapper.appendChild(editButtonDelete);

        var attributesContainer = document.createElement('div');
        editInterfaceWrapper.appendChild(attributesContainer);

        var deleteAttributesContainer = document.createElement('div');
        editInterfaceWrapper.appendChild(deleteAttributesContainer);

        var addAttributesContainer = document.createElement('div');
        editInterfaceWrapper.appendChild(addAttributesContainer);

        // check if export key exists; if not use default
        if (options.export === undefined) {
            options.export = BKGWebMap.CONTROLS.tools.edit.export;
        }

        var formats = BKGWebMap.CONTROLS.tools.edit.export.formats;
        // check if exporting is activated
        if (options.export.active) {
            if (options.export.formats instanceof Array && options.export.formats.length) {
                formats = options.export.formats;
            }

            var exportVectorButton = document.createElement('div');
            exportVectorButton.className = 'bkgwebmap-editbutton-visible';
            exportVectorButton.innerHTML = 'Layer exportieren';
            exportInterfaceInnerWrapper.appendChild(exportVectorButton);

            formatSelect = document.createElement('select');
            formatSelect.className = 'bkgwebmap-formatselect';

            selectItem = document.createElement('option');
            selectItem.className = 'bkgwebmap-formatselectitem';
            selectItem.innerHTML = 'Format auswählen';
            selectItem.setAttribute('data-bkgwebmap-export-format', 'none');
            formatSelect.appendChild(selectItem);

            var defaultFormats = BKGWebMap.CONTROLS.tools.edit.export.formats;
            var formatLowerCase;
            for (var i = 0; i < defaultFormats.length; i++) {
                if (formats.indexOf(defaultFormats[i]) !== -1) {
                    selectItem = document.createElement('option');
                    selectItem.className = 'bkgwebmap-formatselectitem';
                    selectItem.innerHTML = defaultFormats[i];
                    formatLowerCase = defaultFormats[i].toLowerCase();
                    selectItem.setAttribute('data-bkgwebmap-export-format', formatLowerCase);
                    formatSelect.appendChild(selectItem);
                }
            }

            exportInterfaceInnerWrapper.appendChild(formatSelect);

            exportNameInput = document.createElement('input');
            exportNameInput.type = 'text';
            exportNameInput.className = 'bkgwebmap-attributemaskinput';
            exportNameInput.placeholder = 'Dateinamen eingeben';
            exportInterfaceInnerWrapper.appendChild(exportNameInput);

            var exportNameExtension = document.createElement('span');
            exportInterfaceInnerWrapper.appendChild(exportNameExtension);

            exportVectorButton.onclick = exportVectorLayer;
            formatSelect.onchange = function () {
                var exportFormat = formatSelect.options[formatSelect.selectedIndex].getAttribute('data-bkgwebmap-export-format');
                exportNameExtension.innerHTML = '.' + exportFormat;
            };
        }

        // add all contents to panel
        if (inPanel) {
            panel.addPanelContent(editPanelContent);
        } else {
            editPanel.appendChild(editPanelContent);
            editPanelContent.style.display = 'none';
        }

        function clickControl() {
            if (inPanel) {
                var activeContent = panel.getActiveContent();
                if (activeContent === '') {
                    panel.openPanel();
                    panel.changePanelContent(title, editPanelContentClass);
                    hideEditButtons();
                    _this.activeIcon();
                } else if (activeContent === editPanelContentClass) {
                    panel.closePanel();
                } else {
                    panel.changePanelContent(title, editPanelContentClass);
                    hideEditButtons();
                    _this.activeIcon();
                }
            } else if (editPanelContent.style.display === 'none') {
                editPanelContent.style.display = 'block';
            } else {
                editPanelContent.style.display = 'none';
            }
        }

        this.activeIcon = function () {
            editPanel.classList.add('bkgwebmap-panelactive');
        };

        // clears all elements but the first one in a given select dropdown
        function clearDropdown(select) {
            var elements = select.length;
            for (var i = 0; i < elements - 1; i++) {
                select.remove(1);
            }
        }

        // Event listeners
        var elementForEvent = editPanel;
        if (!inPanel) {
            elementForEvent = editPanel.querySelector('svg');
        }
        elementForEvent.addEventListener('click', clickControl, { passive: true });
        elementForEvent.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            editPanelTooltip.style.visibility = 'visible';
            setTimeout(function () {
                editPanelTooltip.style.visibility = '';
            }, 1200);
        }, false);

        var editableLayersObject = {};

        _this.getEditableLayer = function (map, layer) {
            var layerProperties;

            // check if layer is a vector or a group
            // if group, iterate through group to find vectors
            // only add layers to dropdown if they are editable
            if (layer instanceof ol.layer.Vector) {
                layerProperties = layer.getProperties();
                if (layerProperties.edit && layer.getVisible() === true) {
                    selectItem = document.createElement('option');
                    selectItem.innerHTML = layerProperties.name;
                    selectItem.setAttribute('data-bkgwebmap-edit-layer', layerProperties.uniqueId);
                    layerSelect.appendChild(selectItem);
                    editableLayersObject[layerProperties.uniqueId] = layer;
                }
            } else if (layer instanceof ol.layer.Group) {
                // only if group is visible loop through it
                if (layer.getVisible() === true) {
                    layer.getLayers().forEach(function (subLayer) {
                        if (subLayer instanceof ol.layer.Vector && subLayer.getVisible() === true) {
                            layerProperties = subLayer.getProperties();
                            if (layerProperties.edit) {
                                selectItem = document.createElement('option');
                                selectItem.innerHTML = layerProperties.name;
                                selectItem.setAttribute('data-bkgwebmap-edit-layer', layerProperties.uniqueId);
                                layerSelect.appendChild(selectItem);
                                editableLayersObject[layerProperties.uniqueId] = subLayer;
                            }
                        }
                    });
                }
            }
        };

        // checks whether there are editable layers
        // this has nothing to do with visibility, but with what is in the config
        _this.editableLayerAvailable = function () {
            var layerProperties;
            var isAvailable = false;

            map.getLayers().forEach(function (layer) {
                if (layer instanceof ol.layer.Vector) {
                    layerProperties = layer.getProperties();
                    if (layerProperties.edit) {
                        isAvailable = true;
                    }
                } else if (layer instanceof ol.layer.Group) {
                    layer.getLayers().forEach(function (subLayer) {
                        if (subLayer instanceof ol.layer.Vector) {
                            layerProperties = subLayer.getProperties();
                            if (layerProperties.edit) {
                                isAvailable = true;
                            }
                        }
                    });
                }
            });

            return isAvailable;
        };

        // empty layer to be used when no editable layer is found
        var emptyLayerSource = new ol.source.Vector();

        var symbol = BKGWebMap.MAP_ICONS_ENCODED.circle.a + '%23ffcc33' + BKGWebMap.MAP_ICONS_ENCODED.circle.b + '%23ffcc33' + BKGWebMap.MAP_ICONS_ENCODED.circle.c;

        var emptyLayerVector = new ol.layer.Vector({
            source: emptyLayerSource,
            style: new ol.style.Style({
                fill: new ol.style.Fill({
                    color: 'rgba(255, 255, 255, 0.2)'
                }),
                stroke: new ol.style.Stroke({
                    color: '#ffcc33',
                    width: 2
                }),
                image: new ol.style.Icon(({
                    anchor: [0.5, 0.5],
                    anchorXUnits: 'fraction',
                    anchorYUnits: 'fraction',
                    imgSize: BKGWebMap.MAP_ICONS_ENCODED.circle.size,
                    src: 'data:image/svg+xml;charset=utf8,' + symbol
                }))
            })
        });

        emptyLayerVector.setProperties({
            edit: true,
            name: 'Neue Zeichnung',
            uniqueId: 'emptyLayerDigitizingVector',
            visibility: true
        });

        // adds the empty layer to the map
        // checks first whether the emptyLayer option is activated
        this.addEmptyLayer = function addEmptyLayer() {
            if (options.emptyLayer === true) {
                map.addLayer(emptyLayerVector);
                map.getControls().forEach(function (control) {
                    if (BKGWebMap.Control.LayerSwitcher && control instanceof BKGWebMap.Control.LayerSwitcher) {
                        control.addInLayerSwitcher(emptyLayerVector, false, false, true, null);
                    }
                });

                map.getLayers().forEach(function (layer) {
                    _this.getEditableLayer(map, layer);
                });
            }
        };

        layerSelect.onchange = function () {
            editInterfaceSelectLayerSpan.innerHTML = '';
            exportInterfaceSelectLayerSpan.innerHTML = '';
            removeAllButtonsHighlightings();
            var activeLayerId = getActiveLayerId();

            layerSelect.setAttribute('data-bkgwebmap-lasteditlayer', activeLayerId);
            hideEditButtons();
            if (activeLayerId != null) {
                _this.removeEditInteractions();
                var layerFeatures = editableLayersObject[activeLayerId].getSource().getFeatures();
                var editGeoms = BKGWebMap.Util.findGeometryType(layerFeatures);

                // if the digitizing vector is detected, allow all geoms
                if (activeLayerId === emptyLayerVector.getProperties().uniqueId) {
                    editGeoms = ['Point', 'LineString', 'Polygon'];
                }

                showEditButtons(editGeoms);
                globalLayer = editableLayersObject[activeLayerId];
                exportInterfaceInnerWrapper.style.display = 'block';
            } else {
                editInterfaceSelectLayerSpan.innerHTML = 'Layer auswählen!';
                exportInterfaceSelectLayerSpan.innerHTML = 'Layer auswählen!';
                exportInterfaceInnerWrapper.style.display = 'none';
            }

            createDeleteColumnMask();

            attributesContainer.innerHTML = '';
            addAttributesContainer.innerHTML = '';

            if (activeLayerId !== null) {
                createAddColumnMask();
            }
        };

        function getActiveLayerId() {
            var id = layerSelect.options[layerSelect.selectedIndex].getAttribute('data-bkgwebmap-edit-layer');
            return id;
        }

        function hideEditButtons() {
            editButtonPoint.style.display = 'none';
            editButtonLine.style.display = 'none';
            editButtonPolygon.style.display = 'none';
            editButtonAttributes.style.display = 'none';
            editButtonDelete.style.display = 'none';
        }

        function showEditButtons(editGeoms) {
            if (editGeoms.indexOf('Point') > -1) {
                editButtonPoint.style.display = 'inline-block';
            }
            if (editGeoms.indexOf('LineString') > -1) {
                editButtonLine.style.display = 'inline-block';
            }
            if (editGeoms.indexOf('Polygon') > -1) {
                editButtonPolygon.style.display = 'inline-block';
            }
            editButtonAttributes.style.display = 'inline-block';
            editButtonDelete.style.display = 'inline-block';
        }

        editButtonPoint.onclick = onClickEditButton;
        editButtonLine.onclick = onClickEditButton;
        editButtonPolygon.onclick = onClickEditButton;

        // when edit button is clicked
        function onClickEditButton() {
            var geomType = this.getAttribute('data-bkgwebmap-editgeom');
            higlightEditButton(geomType);
            var activeLayerId = getActiveLayerId();
            _this.removeEditInteractions();
            var layerSource = editableLayersObject[activeLayerId].getSource();
            addEditInteractions(layerSource, geomType);
        }

        function higlightEditButton(geomType) {
            removeAllButtonsHighlightings();
            if (geomType === 'Point') {
                editButtonPoint.classList.add('bkgwebmap-editbutton-active');
            } else if (geomType === 'LineString') {
                editButtonLine.classList.add('bkgwebmap-editbutton-active');
            } else if (geomType === 'Polygon') {
                editButtonPolygon.classList.add('bkgwebmap-editbutton-active');
            }
        }

        function removeAllButtonsHighlightings() {
            editButtonPoint.classList.remove('bkgwebmap-editbutton-active');
            editButtonLine.classList.remove('bkgwebmap-editbutton-active');
            editButtonPolygon.classList.remove('bkgwebmap-editbutton-active');
            editButtonAttributes.classList.remove('bkgwebmap-editbutton-active');
            editButtonDelete.classList.remove('bkgwebmap-editbutton-active');
        }

        var interactionDraw;
        var interactionModify;
        var interactionSnap;

        // adds draw, modify, snap interactions
        function addEditInteractions(layerSource, geomType) {
            _this.removeEditInteractions();
            removeAttributeListener();
            // define interactions
            interactionModify = new ol.interaction.Modify({ source: layerSource });
            interactionSnap = new ol.interaction.Snap({ source: layerSource });
            interactionDraw = new ol.interaction.Draw({
                source: layerSource,
                type: geomType
            });
            interactionDraw.on('drawend', onDrawEnd);
            // add interactions
            map.addInteraction(interactionModify);
            map.addInteraction(interactionSnap);
            map.addInteraction(interactionDraw);
        }

        // show the attribute mask and define a global layer and feature
        function onDrawEnd(e) {
            // get the columns that should be added to the new feature
            var availableProperties = getLayerProperties();

            var attributes = {};
            var columnName;

            // create columns with empty attributes
            for (var key in availableProperties) {
                if (Object.prototype.hasOwnProperty.call(availableProperties, key)) {
                    var propType = typeof (availableProperties[key]);

                    if ((propType === 'string' || propType === 'number') && key.length > 0) {
                        columnName = key;
                        attributes[columnName] = '';
                    }
                }
            }

            // add attributes to the feature
            e.feature.setProperties(attributes);

            var activeLayerId = getActiveLayerId();
            globalLayer = editableLayersObject[activeLayerId];
            globalFeature = e.feature;

            generateAttributesMask(attributes);
        }

        this.removeEditInteractions = function () {
            map.getInteractions().forEach(function (interaction) {
                if (interaction instanceof ol.interaction.Modify) {
                    map.removeInteraction(interaction);
                }
                if (interaction instanceof ol.interaction.Snap) {
                    map.removeInteraction(interaction);
                }
                if (interaction instanceof ol.interaction.Draw) {
                    map.removeInteraction(interaction);
                }

                if (interaction instanceof ol.interaction.Select) {
                    map.removeInteraction(interaction);
                }
                attributesContainer.innerHTML = '';
            });
        };

        editButtonDelete.onclick = addDeleteInteraction;

        function addDeleteInteraction() {
            removeAllButtonsHighlightings();
            editButtonDelete.classList.add('bkgwebmap-editbutton-active');
            var activeLayerId = getActiveLayerId();
            removeAttributeListener();
            _this.removeEditInteractions();
            var layerToBeSelected = editableLayersObject[activeLayerId];

            // multi means when features are overlapping; in that case all below the click will be selected, not just the top one
            interactionSelect = new ol.interaction.Select({
                layers: [layerToBeSelected],
                multi: false,
                hitTolerance: 5
            });
            interactionSelect.on('select', function () {
                var selectedFeature = interactionSelect.getFeatures().item(0);
                interactionSelect.getFeatures().forEach(function (feature) {
                    if (selectedFeature === feature) {
                        var deleteFeature = confirm('Objekt löschen?');
                        if (deleteFeature === true) {
                            layerToBeSelected.getSource().removeFeature(feature);
                            removeAllButtonsHighlightings();
                            _this.removeEditInteractions();
                        }
                    }
                });
            });
            map.addInteraction(interactionSelect);
        }

        editButtonAttributes.onclick = addAttributesInteraction;

        function addAttributesInteraction() {
            removeAllButtonsHighlightings();
            editButtonAttributes.classList.add('bkgwebmap-editbutton-active');
            var activeLayerId = getActiveLayerId();
            removeAttributeListener();
            _this.removeEditInteractions();
            var layerToBeSelected = editableLayersObject[activeLayerId];
            globalLayer = layerToBeSelected;

            // multi means when features are overlapping; in that case all below the click will be selected, not just the top one
            interactionSelect = new ol.interaction.Select({
                layers: [layerToBeSelected],
                multi: false
            });

            interactionSelect.on('select', function () {
                var selectedFeature = interactionSelect.getFeatures().item(0); // get the selected item

                if (selectedFeature === undefined) {
                    attributesContainer.innerHTML = '';
                } else {
                    interactionSelect.getFeatures().forEach(function (feature) {
                        if (selectedFeature === feature) {
                            var layerProperties = selectedFeature.getProperties();
                            globalFeature = selectedFeature;
                            generateAttributesMask(layerProperties);
                        }
                    });
                }
            });
            map.addInteraction(interactionSelect);
        }

        function generateAttributesMask(layerProperties) {
            var inputElement;
            var inputLabel;
            var lineBreak;
            var selectItem;
            attributesContainer.innerHTML = '';

            columnSelect = document.createElement('select');
            columnSelect.className = 'bkgwebmap-columnselect';
            for (var key in layerProperties) {
                if (Object.prototype.hasOwnProperty.call(layerProperties, key)) {
                    var propType = typeof (layerProperties[key]);

                    if ((propType === 'string' || propType === 'number') && key.length > 0) {
                        inputLabel = document.createElement('span');
                        inputLabel.innerHTML = '<b>' + key + '</b>';
                        attributesContainer.appendChild(inputLabel);

                        lineBreak = document.createElement('br');
                        attributesContainer.appendChild(lineBreak);

                        inputElement = document.createElement('input');
                        inputElement.type = 'text';
                        inputElement.value = layerProperties[key];
                        inputElement.className = 'bkgwebmap-attributemaskinput';
                        inputElement.setAttribute('data-bkgwebmap-attributekey', key);
                        attributesContainer.appendChild(inputElement);

                        lineBreak = document.createElement('br');
                        attributesContainer.appendChild(lineBreak);

                        selectItem = document.createElement('option');
                        selectItem.innerHTML = key;
                        selectItem.setAttribute('data-bkgwebmap-column', key);
                        columnSelect.appendChild(selectItem);
                    }
                }
            }

            editButtonSaveAttributes = document.createElement('div');
            editButtonSaveAttributes.className = 'bkgwebmap-editbutton-visible';
            editButtonSaveAttributes.innerHTML = 'Speichern';
            attributesContainer.appendChild(editButtonSaveAttributes);

            editButtonSaveAttributes.onclick = saveAttributes;
        }

        function addAttributeColumn() {
            var newColumnName = enterColumnInput.value;

            if (newColumnName.length === 0) {
                alert('Bitte Spaltennamen eingeben!');
            } else {
                var addColumn = confirm('Soll die Spalte ' + newColumnName + ' in allen Elementen der Ebene hinzugefügt werden?');

                if (addColumn === true) {
                    var newColumn = {};
                    var columnName = enterColumnInput.value;
                    newColumn[columnName] = '';

                    var features = globalLayer.getSource().getFeatures();

                    features.forEach(function (feature) {
                        feature.setProperties(newColumn);
                    });

                    enterColumnInput.value = '';

                    createDeleteColumnMask();

                    if (attributesContainer.innerHTML.length > 0) { // if attributes container is open, refresh it
                        var layerProperties = globalFeature.getProperties();
                        generateAttributesMask(layerProperties);
                    }
                }
            }
        }

        function deleteAttributeColumn() {
            var selectedColumn = columnSelect.options[columnSelect.selectedIndex].getAttribute('data-bkgwebmap-column');
            var deleteColumn = confirm('Soll die Spalte ' + selectedColumn + ' in allen Elementen der Ebene gelöscht werden?');

            if (deleteColumn === true) {
                var features = globalLayer.getSource().getFeatures();
                features.forEach(function (feature) {
                    var properties = feature.getProperties();
                    for (var key in properties) {
                        if (Object.prototype.hasOwnProperty.call(properties, key)) {
                            if (key === selectedColumn) {
                                feature.unset(key);
                                var layerProperties = feature.getProperties();

                                if (attributesContainer.innerHTML.length > 0) { // if attributes container is open, refresh it
                                    generateAttributesMask(layerProperties);
                                }
                            }
                        }
                    }
                });
                createDeleteColumnMask();
            }
        }

        function saveAttributes() {
            var inputElements = attributesContainer.getElementsByTagName('input');
            var key;
            var propertiesObject = {};

            for (var i = 0; i < inputElements.length; i++) {
                key = inputElements[i].getAttribute('data-bkgwebmap-attributekey');
                if (key !== 'newcolumnnameinputfield') {
                    propertiesObject[key] = inputElements[i].value;
                }
            }

            var features = globalLayer.getSource().getFeatures();
            features.forEach(function (feature) {
                if (feature === globalFeature) {
                    feature.setProperties(propertiesObject);
                    alert('Die Attribute wurden erfolgreich gespeichert.');
                }
            });
        }

        // gets the properties of the first feature in a vector
        function getLayerProperties() {
            var activeLayerId = getActiveLayerId();

            if (activeLayerId !== null) {
                var feature = editableLayersObject[activeLayerId].getSource().getFeatures()[0];

                if (feature !== undefined) {
                    var props = feature.getProperties();

                    return props;
                }
            }
        }

        function createDeleteColumnMask() {
            var deleteColumnButton;
            var selectItem;
            columnSelect = document.createElement('select');
            columnSelect.className = 'bkgwebmap-columnselect';

            deleteAttributesContainer.innerHTML = '';

            var layerProperties = getLayerProperties();

            var propertyCount = 0;

            for (var key in layerProperties) {
                if (Object.prototype.hasOwnProperty.call(layerProperties, key)) {
                    var propType = typeof (layerProperties[key]);

                    if ((propType === 'string' || propType === 'number') && key.length > 0) {
                        selectItem = document.createElement('option');
                        selectItem.innerHTML = key;
                        selectItem.setAttribute('data-bkgwebmap-column', key);
                        columnSelect.appendChild(selectItem);

                        propertyCount += 1;
                    }
                }
            }

            if (propertyCount > 0) {
                var dividingLine = document.createElement('hr');
                deleteAttributesContainer.appendChild(dividingLine);

                deleteColumnButton = document.createElement('div');
                deleteColumnButton.className = 'bkgwebmap-editbutton-visible';
                deleteColumnButton.innerHTML = 'Spalte löschen';
                deleteAttributesContainer.appendChild(deleteColumnButton);
                deleteAttributesContainer.appendChild(columnSelect);

                deleteColumnButton.onclick = deleteAttributeColumn;

                deleteAttributesContainer.appendChild(columnSelect);
            }
        }

        function createAddColumnMask() {
            addAttributesContainer.innerHTML = '';

            var dividingLine = document.createElement('hr');
            addAttributesContainer.appendChild(dividingLine);

            enterColumnButton = document.createElement('div');
            enterColumnButton.className = 'bkgwebmap-editbutton-visible';
            enterColumnButton.innerHTML = 'Neue Spalte';
            addAttributesContainer.appendChild(enterColumnButton);

            enterColumnInput = document.createElement('input');
            enterColumnInput.type = 'text';
            enterColumnInput.className = 'bkgwebmap-attributemaskinput';
            enterColumnInput.placeholder = 'Spaltennamen eingeben';
            enterColumnInput.setAttribute('data-bkgwebmap-attributekey', 'newcolumnnameinputfield');
            addAttributesContainer.appendChild(enterColumnInput);

            enterColumnButton.onclick = addAttributeColumn;
        }

        function exportVectorLayer() {
            var exportFormat;
            var features;
            var filename;
            var activeLayerId = getActiveLayerId();

            if (activeLayerId === null) {
                alert('Layer auswählen!');
            } else {
                exportFormat = formatSelect.options[formatSelect.selectedIndex].getAttribute('data-bkgwebmap-export-format');
                if (exportFormat === 'none') {
                    alert('Export Format auswählen!');
                } else {
                    var mapCrs = map.getView().getProjection().getCode();
                    features = editableLayersObject[activeLayerId].getSource().getFeatures();
                    filename = exportNameInput.value;

                    if (filename.length === 0) {
                        filename = 'bkg_export';
                    }

                    switch (exportFormat) {
                    case 'geojson':
                        exportFileGeoJson(mapCrs, features, filename);
                        break;
                    case 'gml':
                        exportFileGml(mapCrs, features, filename);
                        break;
                    case 'gpx':
                        exportFileGpx(mapCrs, features, filename);
                        break;
                    case 'kml':
                        exportFileKml(mapCrs, features, filename);
                        break;
                    case 'wkt':
                        exportFileWkt(mapCrs, features, filename);
                        break;
                        // no default
                    }
                }
            }
        }

        function exportFileGeoJson(mapCrs, features, filename) {
            var format = new ol.format.GeoJSON();
            var exportLayer = format.writeFeatures(features, {
                dataProjection: 'EPSG:4326',
                featureProjection: mapCrs
            });
            var blob = new Blob([exportLayer], { type: 'text/plain;charset=utf-8' });
            saveAs(blob, filename + '.geojson');
        }

        function exportFileGml(mapCrs, features, filename) {
            var format = new ol.format.GML3({
                featureType: ['topp'],
                featureNS: {
                    topp: 'topp'
                },
                srsName: mapCrs
            });

            var exportLayer = format.writeFeatures(features, {
                featureProjection: mapCrs,
                dataProjection: mapCrs
            });

            var blob = new Blob([exportLayer], { type: 'text/plain;charset=utf-8' });
            saveAs(blob, filename + '.gml');
        }

        function exportFileGpx(mapCrs, features, filename) {
            var format = new ol.format.GPX();

            var exportLayer = format.writeFeatures(features, {
                dataProjection: 'EPSG:4326',
                featureProjection: mapCrs
            });

            var blob = new Blob([exportLayer], { type: 'text/plain;charset=utf-8' });
            saveAs(blob, filename + '.gpx');
        }

        function exportFileKml(mapCrs, features, filename) {
            var format = new ol.format.KML();

            var exportLayer = format.writeFeatures(features, {
                dataProjection: 'EPSG:4326',
                featureProjection: mapCrs
            });

            var blob = new Blob([exportLayer], { type: 'text/plain;charset=utf-8' });
            saveAs(blob, filename + '.kml');
        }

        function exportFileWkt(mapCrs, features, filename) {
            var format = new ol.format.WKT();

            var exportLayer = format.writeFeatures(features, {
                dataProjection: 'EPSG:4326',
                featureProjection: mapCrs
            });

            var blob = new Blob([exportLayer], { type: 'text/plain;charset=utf-8' });
            saveAs(blob, filename + '.wkt');
        }

        // deactivates click handler for WMS feature request and GeoSearch
        function removeAttributeListener() {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.ShowAttributes && control instanceof BKGWebMap.Control.ShowAttributes) {
                    map.un('click', control.clickAttributesActivate);
                }
                if (BKGWebMap.Control.GeoSearch && control instanceof BKGWebMap.Control.GeoSearch) {
                    map.un('click', control.geoSearchClickActivate);
                }
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    map.un('click', control.clickCopyCoordinatesActivate);
                }
            });
        }

        // reactivates click handler for WMS feature request and GeoSearch
        this.addAttributeListener = function () {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.ShowAttributes && control instanceof BKGWebMap.Control.ShowAttributes) {
                    map.on('click', control.clickAttributesActivate);
                }
                if (BKGWebMap.Control.GeoSearch && control instanceof BKGWebMap.Control.GeoSearch) {
                    map.on('click', control.geoSearchClickActivate);
                }
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    map.on('click', control.clickCopyCoordinatesActivate);
                }
            });
        };

        // Show/hide tooltips
        function tooltipHoverEvent(tooltipButton) {
            tooltipButton.addEventListener('mouseenter', function () {
                var allTooltips = editPanelContent.getElementsByClassName('bkgwebmap-paneltooltiptext');
                for (var i = 0; i < allTooltips.length; i++) {
                    allTooltips[i].style.visibility = '';
                }

                var currentButton = tooltipButton.getElementsByClassName('bkgwebmap-paneltooltiptext')[0];
                currentButton.style.visibility = 'visible';

                setTimeout(function () {
                    currentButton.style.visibility = '';
                }, 1200);
            });
        }

        /**
         * Change menu with edit layers
         */
        this.adaptLayerMenu = function () {
            if (layerSelect.childElementCount === 2) {
                layerSelect.selectedIndex = 1;
                setTimeout(function () {
                    layerSelect.dispatchEvent(new CustomEvent('change'));
                }, 100);
            } else {
                var lastLayerId = layerSelect.getAttribute('data-bkgwebmap-lasteditlayer');
                var layersWithIds = layerSelect.querySelectorAll('[data-bkgwebmap-edit-layer]');
                if (layersWithIds.length) {
                    for (var i = 0; i < layersWithIds.length; i++) {
                        if (layersWithIds[i].getAttribute('data-bkgwebmap-edit-layer') === lastLayerId) {
                            layerSelect.selectedIndex = i + 1;
                            setTimeout(function () {
                                layerSelect.dispatchEvent(new CustomEvent('change'));
                            }, 100);
                        }
                    }
                }
            }
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: editPanel,
            target: target
        });
    };
};

/**
 * Create GeoSearch Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_geoSearch}
 */
BKGWebMap.Control.createGeoSearch = function () {
    return function (map, controlName, options, panel) {
        options = options || {};

        var geoSearchElement;
        var mapId = map.getTarget();
        var xhr = new XMLHttpRequest();
        var url;
        var useSelectionFilterBbox = false;
        var selectionFilter = {};
        var reverseGeoButtonDiv;
        var reverseGeoSearchTooltip;
        var searchButtonDiv;
        var searchTooltip;
        var filter;
        var wfsFeaturePrefix;
        var wfsFeatureType;
        var wfsSearchAttribute;
        var wfsShowAttributes;
        var wfsAutocomplete = true;
        var wfsProtocolFormat = 'GML3';
        var formatsList = {
            GEOJSON: {
                olClass: new ol.format.GeoJSON(),
                outputFormat: 'application/json'
            },
            GML2: {
                olClass: new ol.format.GML2(),
                outputFormat: 'GML2'
            },
            GML3: {
                olClass: new ol.format.WFS(),
                outputFormat: 'GML3'
            }
        };
        var gdzOrtssuchePropsToShow = ['text', 'typ'];
        var templatePopup;
        var templateList;
        var div;
        if (options.templatePopup) {
            div = document.createElement('div');
            div.innerHTML = options.templatePopup;
            templatePopup = div.innerHTML;
        }
        if (options.templateList) {
            div = document.createElement('div');
            div.innerHTML = options.templateList;
            templateList = div.innerHTML;
        }

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        // Control div
        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
        }

        // Parse protocol properties
        var protocol = BKGWebMap.CONTROLS.tools.geoSearch.defaultProtocol;
        if (options.protocol && (typeof options.protocol.type === 'string' || options.protocol.type instanceof String) && options.protocol.type !== '') {
            protocol = options.protocol.type;
        }
        if (options.protocol && (typeof options.protocol.url === 'string' || options.protocol.url instanceof String) && options.protocol.url !== '') {
            url = options.protocol.url;
        } else if (protocol === 'wfs') {
            window.console.log(BKGWebMap.ERROR.geoSearchUrlMissing);
            return undefined;
        } else {
            url = BKGWebMap.CONTROLS.tools.geoSearch.protocol[protocol];
        }

        // Add UUID
        if (BKGWebMap.SECURITY.UUID) {
            url = url + '__' + BKGWebMap.SECURITY.UUID;
        }

        // Parse count
        var suggestCount = BKGWebMap.CONTROLS.tools.geoSearch.suggestCount;
        if (typeof options.suggestCount === 'number') {
            suggestCount = options.suggestCount;
        }
        var resultsCount = BKGWebMap.CONTROLS.tools.geoSearch.resultsCount;
        if (typeof options.resultsCount === 'number') {
            resultsCount = options.resultsCount;
        }

        // Max zoom for results
        var resultsMaxZoom = BKGWebMap.CONTROLS.tools.geoSearch.resultsMaxZoom;
        if (typeof options.resultsMaxZoom === 'number') {
            resultsMaxZoom = options.resultsMaxZoom;
        }

        // Define wfs protocol properties
        if (protocol === 'wfs') {
            wfsAutocomplete = false;
            // featurePrefix
            if ((typeof options.protocol.featurePrefix === 'string' || options.protocol.featurePrefix instanceof String) && options.protocol.featurePrefix !== '') {
                wfsFeaturePrefix = options.protocol.featurePrefix;
            } else {
                window.console.log(BKGWebMap.ERROR.geoSearchFeaturePrefixMissing);
                return undefined;
            }
            // featureType
            if ((typeof options.protocol.featureType === 'string' || options.protocol.featureType instanceof String) && options.protocol.featureType !== '') {
                wfsFeatureType = options.protocol.featureType;
            } else {
                window.console.log(BKGWebMap.ERROR.geoSearchFeatureTypeMissing);
                return undefined;
            }
            // searchAttribute
            if ((typeof options.protocol.searchAttribute === 'string' || options.protocol.searchAttribute instanceof String) && options.protocol.searchAttribute !== '') {
                wfsSearchAttribute = options.protocol.searchAttribute;
            } else {
                window.console.log(BKGWebMap.ERROR.geoSearchSearchAttributeMissing);
                return undefined;
            }
            // showAttributes
            if (options.protocol.showAttributes instanceof Array && options.protocol.showAttributes.length) {
                wfsShowAttributes = options.protocol.showAttributes;
            } else {
                wfsShowAttributes = [wfsSearchAttribute];
            }

            // format
            if ((typeof options.protocol.format === 'string' || options.protocol.format instanceof String) && options.protocol.format !== '') {
                wfsProtocolFormat = options.protocol.format;
            }
        } else if (protocol === 'ortssuche') {
            // Define filter
            if (options.protocol && (typeof options.protocol.filter === 'string' || options.protocol.filter instanceof String) && options.protocol.filter !== '') {
                filter = options.protocol.filter;
            }

            // Define BBOX filter that can be selected by user
            if (BKGWebMap.Util.hasNestedProperty(options, 'protocol.bbox.coordinates')) {
                if (options.protocol.bbox.coordinates instanceof Array) {
                    selectionFilter.bbox = {};
                    selectionFilter.bbox.coordinates = options.protocol.bbox.coordinates;
                    useSelectionFilterBbox = true;
                }
                if (BKGWebMap.Util.hasNestedProperty(options, 'protocol.bbox.projection') && (typeof options.protocol.bbox.projection === 'string' || options.protocol.bbox.projection instanceof String)) {
                    selectionFilter.bbox.projection = options.protocol.bbox.projection;
                } else {
                    selectionFilter.bbox.projection = map.getView().getProjection().getCode();
                }
            }
        }

        // Reverse geocoding
        var reverseGeocoding = BKGWebMap.CONTROLS.tools.geoSearch.reverseGeocoding;
        if (typeof options.reverseGeocoding === 'object' && options.reverseGeocoding.constructor === Object) {
            reverseGeocoding = options.reverseGeocoding;
            if (typeof reverseGeocoding.active !== 'boolean') {
                reverseGeocoding.active = BKGWebMap.CONTROLS.tools.geoSearch.reverseGeocoding.active;
            }
        }

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
        }

        // Control in panel
        var searchPanelControl = searchPanelExists();
        if (inPanel) {
            if (!searchPanelControl) {
                createSearchpanel();
            }
            target = panel.element.getElementsByClassName('bkgwebmap-searchpanelcontent')[0];
        }

        // Add form for search
        var geoSearchFormDiv = document.createElement('div');
        geoSearchFormDiv.className = 'bkgwebmap-geosearchformdiv';
        var geoSearchForm = document.createElement('input');
        geoSearchForm.className = 'bkgwebmap-geosearchform';
        geoSearchForm.setAttribute('type', 'text');
        geoSearchForm.setAttribute('placeholder', 'Ort eingeben...');
        geoSearchFormDiv.appendChild(geoSearchForm);

        // search button
        searchButtonDiv = document.createElement('div');
        searchButtonDiv.className = 'bkgwebmap-geosearchbutton bkgwebmap-paneltooltip';
        var searchIconParser = new DOMParser();
        var searchIcon = searchIconParser.parseFromString(BKGWebMap.PANEL_ICONS.SEARCH_GEOCODING, 'text/xml');
        searchButtonDiv.appendChild(searchIcon.documentElement);
        geoSearchFormDiv.appendChild(searchButtonDiv);

        searchTooltip = document.createElement('span');
        searchTooltip.className = 'bkgwebmap-paneltooltiptext';
        searchTooltip.innerHTML = 'Suche';
        searchButtonDiv.appendChild(searchTooltip);

        // Add reverse geocoding button
        if (protocol !== 'wfs' && reverseGeocoding.active) {
            reverseGeoButtonDiv = document.createElement('div');
            reverseGeoButtonDiv.className = 'bkgwebmap-reversegeosearchbutton bkgwebmap-reversegeoactive bkgwebmap-paneltooltip';
            var reverseGeoSearchIconParser = new DOMParser();
            var reverseGeoSearchIcon = reverseGeoSearchIconParser.parseFromString(BKGWebMap.PANEL_ICONS.REVERSE_GEOCODING, 'text/xml');
            reverseGeoButtonDiv.appendChild(reverseGeoSearchIcon.documentElement);
            geoSearchFormDiv.appendChild(reverseGeoButtonDiv);

            reverseGeoSearchTooltip = document.createElement('span');
            reverseGeoSearchTooltip.className = 'bkgwebmap-paneltooltiptext';
            reverseGeoSearchTooltip.innerHTML = 'Reverse Geokodierung';
            reverseGeoButtonDiv.appendChild(reverseGeoSearchTooltip);

            geoSearchForm.classList.add('bkgwebmap-geosearchformreverse');

            configureReverseGeocoding();
        }

        // Button to delete results
        var deleteResultsButtonDiv = document.createElement('div');
        deleteResultsButtonDiv.className = 'bkgwebmap-geosearchdelete bkgwebmap-paneltooltip';
        var deleteResultsIconParser = new DOMParser();
        var deleteResultsIcon = deleteResultsIconParser.parseFromString(BKGWebMap.PANEL_ICONS.DELETE_SEARCH, 'text/xml');
        deleteResultsButtonDiv.appendChild(deleteResultsIcon.documentElement);
        geoSearchFormDiv.appendChild(deleteResultsButtonDiv);

        var deleteResultsTooltip = document.createElement('span');
        deleteResultsTooltip.className = 'bkgwebmap-paneltooltiptext';
        deleteResultsTooltip.innerHTML = 'Ergebnisse löschen';
        deleteResultsButtonDiv.appendChild(deleteResultsTooltip);

        var geoSearchContent = document.createElement('div');
        if (inPanel) {
            geoSearchContent.className = 'bkgwebmap-geosearchcontent ' + customClass;
        } else {
            geoSearchContent.className = 'bkgwebmap-geosearchcontent';
        }

        var suggestionDiv = document.createElement('div');
        suggestionDiv.className = 'bkgwebmap-geosearchsuggestion';
        geoSearchContent.appendChild(suggestionDiv);

        var resultDiv = document.createElement('div');
        resultDiv.className = 'bkgwebmap-geosearchresult';
        resultDiv.innerHTML = '';
        geoSearchContent.appendChild(resultDiv);

        if (inPanel) {
            document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltitlewrapper')[0].insertBefore(geoSearchFormDiv, document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltitlebutton')[0]);
            geoSearchElement = geoSearchContent;
        } else {
            var geoSearchWrapper = document.createElement('div');
            geoSearchWrapper.className = customClass;
            geoSearchWrapper.appendChild(geoSearchFormDiv);
            geoSearchWrapper.appendChild(geoSearchContent);
            geoSearchElement = geoSearchWrapper;
        }

        // Popup
        var popupDiv = document.createElement('div');
        popupDiv.className = 'bkgwebmap-geosearchpopup';
        var popupCloser = document.createElement('a');
        popupCloser.className = 'bkgwebmap-geosearchpopupcloser';
        popupCloser.setAttribute('href', '#');
        popupDiv.appendChild(popupCloser);
        var popupContent = document.createElement('div');
        popupContent.className = 'bkgwebmap-geosearchpopupcontent bkgwebmap-selectable';
        popupDiv.appendChild(popupContent);

        var popup = new ol.Overlay({
            element: popupDiv,
            offset: [0, -20]
        });
        map.addOverlay(popup);

        // Create style for vector layer
        function createVectorStyle() {
            var svgFillColor = '%230374ad';
            var svgStrokeColor = '%23FFFFFF';
            var symbol = BKGWebMap.MAP_ICONS_ENCODED.marker.a + svgFillColor + BKGWebMap.MAP_ICONS_ENCODED.marker.b + svgStrokeColor + BKGWebMap.MAP_ICONS_ENCODED.marker.c;
            var vectorStyle = new ol.style.Style({
                image: new ol.style.Icon(({
                    anchor: [0.5, 1],
                    anchorXUnits: 'fraction',
                    anchorYUnits: 'fraction',
                    imgSize: BKGWebMap.MAP_ICONS_ENCODED.marker.size,
                    src: 'data:image/svg+xml;charset=utf8,' + symbol
                }))
            });
            return vectorStyle;
        }

        function createSelectionStyle() {
            var svgFillColor = '%23ff0000';
            var svgStrokeColor = '%23FFFFFF';
            var symbol = BKGWebMap.MAP_ICONS_ENCODED.marker.a + svgFillColor + BKGWebMap.MAP_ICONS_ENCODED.marker.b + svgStrokeColor + BKGWebMap.MAP_ICONS_ENCODED.marker.c;
            var vectorStyle = new ol.style.Style({
                image: new ol.style.Icon(({
                    anchor: [0.5, 1],
                    anchorXUnits: 'fraction',
                    anchorYUnits: 'fraction',
                    imgSize: BKGWebMap.MAP_ICONS_ENCODED.marker.size,
                    src: 'data:image/svg+xml;charset=utf8,' + symbol
                }))
            });
            return vectorStyle;
        }

        var vectorStyle = createVectorStyle();
        var selectionStyle = createSelectionStyle();

        var vectorLayer = createVectorLayer();
        vectorLayer.setZIndex(1001);
        map.addLayer(vectorLayer);

        var selectInteraction = new ol.interaction.Select({
            layers: [vectorLayer],
            condition: ol.events.condition.pointerMove,
            style: selectionStyle,
            hitTolerance: 10
        });

        selectInteraction.on('select', function (event) {
            var selectedId;
            var table;
            var rowId;
            if (event.target.getFeatures().getArray().length) {
                selectedId = event.target.getFeatures().getArray()[0].getProperties().featureId;
            }
            if (resultDiv.childNodes.length) {
                table = resultDiv.childNodes[0];
                if (table.childNodes.length) {
                    for (var i = 0; i < table.childNodes.length; i++) {
                        rowId = table.childNodes[i].getAttribute('data-bkgwebmap-searchid');
                        if (rowId === selectedId) {
                            table.childNodes[i].classList.add('bkgwebmap-geosearchresultselect');
                        } else {
                            table.childNodes[i].classList.remove('bkgwebmap-geosearchresultselect');
                        }
                    }
                }
            }
        });

        map.addInteraction(selectInteraction);

        // Create layer for results
        function createVectorLayer() {
            var vectorSource = new ol.source.Vector();
            var layer = new ol.layer.Vector({
                source: vectorSource,
                style: vectorStyle,
                uniqueId: 'geosearchlayer'
            });
            layer.setProperties({ edit: false });
            return layer;
        }

        // Create search panel if it doesn't exist
        function createSearchpanel() {
            var SearchPanelClass = BKGWebMap.Control.FACTORIES.searchPanel();
            var searchPanel = new SearchPanelClass(map, 'searchpanel', true, panel);
            map.addControl(searchPanel);
            return searchPanel;
        }

        // Find if search panel exists
        function searchPanelExists() {
            var exists = false;
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.SearchPanel && control instanceof BKGWebMap.Control.SearchPanel) {
                    exists = true;
                }
            });
            return exists;
        }

        // Delete search results list and features
        function deleteResults() {
            vectorLayer.getSource().clear();
            geoSearchForm.value = '';
            suggestionDiv.style.display = 'none';
            resultDiv.innerHTML = '';
            popupContent.innerHTML = '';
            popup.setPosition(undefined);
        }

        // Get center of features extent (polygons to points)
        function getCenterOfExtent(Extent) {
            var X = Extent[0] + (Extent[2] - Extent[0]) / 2;
            var Y = Extent[1] + (Extent[3] - Extent[1]) / 2;
            return [X, Y];
        }

        // Add geojson to vector layer
        function addGeojson(geojson) {
            var vectorSource = vectorLayer.getSource();
            vectorSource.clear();
            var format = new ol.format.GeoJSON();
            var features = format.readFeatures(geojson);
            var computedExtent = ol.extent.createEmpty();
            features.forEach(function (feature) {
                var createPolygon = false;
                var bbox;
                var extent;
                if (BKGWebMap.Util.hasNestedProperty(feature.getProperties(), 'bbox.type') && BKGWebMap.Util.hasNestedProperty(feature.getProperties(), 'bbox.coordinates')) {
                    var bboxType = feature.getProperties().bbox.type;
                    if (bboxType === 'Polygon') {
                        bbox = feature.getProperties().bbox.coordinates;
                        if (bbox instanceof Array) {
                            createPolygon = true;
                        }
                    }
                }

                if (createPolygon) {
                    var polygon = new ol.geom.Polygon(bbox);
                    extent = polygon.getExtent();
                } else {
                    extent = feature.getGeometry().getExtent();
                }
                var center = getCenterOfExtent(extent);
                var properties = feature.getProperties();
                properties.extent = extent;

                var point = new ol.geom.Point(center);
                var pointFeature = new ol.Feature({
                    geometry: point
                });
                pointFeature.setProperties(properties);
                pointFeature.setProperties({
                    featureId: BKGWebMap.Util.uniqueId()
                });
                vectorSource.addFeature(pointFeature);
                ol.extent.extend(computedExtent, extent);
            });
            if (features.length) {
                map.getView().fit(computedExtent, { size: map.getSize() });
            }
            createResultTable(vectorLayer);
        }

        function highlightFeature(id) {
            var selectedFeature;
            vectorLayer.getSource().getFeatures().forEach(function (feature) {
                feature.setStyle(null);
                var featureId = feature.getProperties().featureId;
                if (featureId === id) {
                    selectedFeature = feature;
                }
            });
            if (selectedFeature) {
                selectedFeature.setStyle(selectionStyle);
            }
        }

        function unHighlightFeatures() {
            vectorLayer.getSource().getFeatures().forEach(function (feature) {
                feature.setStyle(null);
            });
        }

        function zoomToFeature(id) {
            var selectedFeature;
            vectorLayer.getSource().getFeatures().forEach(function (feature) {
                feature.setStyle(null);
                var featureId = feature.getProperties().featureId;
                if (featureId === id) {
                    selectedFeature = feature;
                }
            });

            if (selectedFeature) {
                var content = getPopupContent(selectedFeature);
                if (content) {
                    var coordinates = selectedFeature.getGeometry().getCoordinates();
                    popupContent.innerHTML = content;
                    popup.setPosition(coordinates);
                    if (selectedFeature.getProperties().extent) {
                        map.getView().fit(selectedFeature.getProperties().extent, { size: map.getSize() });
                    } else if (selectedFeature.getGeometry().getExtent()) {
                        map.getView().fit(selectedFeature.getGeometry().getExtent(), { size: map.getSize() });
                    }
                    map.getView().setCenter(coordinates);
                    map.getView().setZoom(resultsMaxZoom);
                } else {
                    popupContent.innerHTML = '';
                    popup.setPosition(undefined);
                }
            }
        }

        // Create result table
        function createResultTable(vectorLayer) {
            popupContent.innerHTML = '';
            popup.setPosition(undefined);

            resultDiv.innerHTML = '';

            var table = document.createElement('table');
            table.className = 'bkgwebmap-geosearchresulttable bkgwebmap-selectable';

            vectorLayer.getSource().getFeatures().forEach(function (feature) {
                var properties = feature.getProperties();
                var propertiesToShow;
                var tr;
                var td;
                var text;
                var textDiv;
                tr = document.createElement('tr');
                tr.setAttribute('data-bkgwebmap-searchid', properties.featureId);
                table.appendChild(tr);
                td = document.createElement('td');
                tr.appendChild(td);
                if (templateList) {
                    var coordinates = feature.getGeometry().getCoordinates();
                    td.innerHTML = getContentWithTemplate(templateList, properties, coordinates);
                } else {
                    if (protocol === 'wfs') {
                        propertiesToShow = wfsShowAttributes;
                    } else if (protocol === 'ortssuche') {
                        propertiesToShow = gdzOrtssuchePropsToShow;
                    }
                    for (var i = 0; i < propertiesToShow.length; i++) {
                        if (Object.prototype.hasOwnProperty.call(properties, propertiesToShow[i])) {
                            text = properties[propertiesToShow[i]];
                            textDiv = document.createElement('div');
                            if (i !== 0) {
                                textDiv.className = 'bkgwebmap-geosearchresulttype';
                            }
                            textDiv.innerHTML = text;
                            td.appendChild(textDiv);
                        }
                    }
                }
                tr.addEventListener('mouseover', function () {
                    var id = this.getAttribute('data-bkgwebmap-searchid');
                    this.classList.add('bkgwebmap-geosearchresultselect');
                    map.removeInteraction(selectInteraction);
                    highlightFeature(id);
                });
                tr.addEventListener('mouseout', function () {
                    this.classList.remove('bkgwebmap-geosearchresultselect');
                    unHighlightFeatures();
                    map.addInteraction(selectInteraction);
                });
                tr.addEventListener('click', function () {
                    var id = this.getAttribute('data-bkgwebmap-searchid');
                    zoomToFeature(id);
                });
            });
            showResultTable(table);
        }

        // Create suggestion list shown as html table
        function createSuggestionTable(suggestion) {
            suggestionDiv.innerHTML = '';

            var table = document.createElement('table');
            table.className = 'bkgwebmap-geosearchsuggestiontable';

            var tr;
            var td;
            var link;
            var data;

            if (!suggestion.length) {
                table.innerHTML = 'Keine Ergebnisse!';
            }

            for (var i = 0; i < suggestion.length; i++) {
                if (Object.prototype.hasOwnProperty.call(suggestion[i], 'highlighted') && Object.prototype.hasOwnProperty.call(suggestion[i], 'suggestion')) {
                    tr = document.createElement('tr');
                    tr.setAttribute('data-bkgwebmap-suggestion', suggestion[i].suggestion);
                    table.appendChild(tr);
                    td = document.createElement('td');
                    link = document.createElement('a');
                    link.setAttribute('href', '#');
                    td.appendChild(link);
                    data = document.createElement('span');
                    data.className = 'bkgwebmap-geosearchsuggestiondata';
                    link.appendChild(data);
                    data.innerHTML = suggestion[i].highlighted;

                    tr.appendChild(td);

                    tr.addEventListener('click', function () {
                        var suggestionName = this.getAttribute('data-bkgwebmap-suggestion');
                        geosearch(suggestionName);
                    });

                    tr.addEventListener('mouseenter', function () {
                        this.childNodes[0].childNodes[0].focus();
                        var allRows = document.getElementById(mapId).getElementsByClassName('bkgwebmap-geosearchsuggestiontable')[0].querySelectorAll('[data-bkgwebmap-suggestion]');
                        for (var i = 0; i < allRows.length; i++) {
                            allRows[i].classList.remove('bkgwebmap-geosearchhighlight');
                        }
                        this.classList.add('bkgwebmap-geosearchhighlight');
                    });

                    link.addEventListener('focus', function () {
                        var rowFocus = this.parentElement.parentElement;
                        rowFocus.addEventListener('keydown', pressArrows);
                    });
                }
            }
            return table;
        }

        // Press up-down arrows in suggestion table
        function pressArrows(event) {
            var allRows;
            var i;
            if (event.key && event.keyCode === 40) {
                event.preventDefault();

                allRows = document.getElementById(mapId).getElementsByClassName('bkgwebmap-geosearchsuggestiontable')[0].querySelectorAll('[data-bkgwebmap-suggestion]');
                var nextSibling = event.target.parentNode.parentNode.nextSibling;
                if (nextSibling) {
                    for (i = 0; i < allRows.length; i++) {
                        allRows[i].classList.remove('bkgwebmap-geosearchhighlight');
                    }

                    nextSibling.classList.add('bkgwebmap-geosearchhighlight');
                    nextSibling.childNodes[0].childNodes[0].focus();
                }
            } else if (event.key && event.keyCode === 38) {
                event.preventDefault();

                allRows = document.getElementById(mapId).getElementsByClassName('bkgwebmap-geosearchsuggestiontable')[0].querySelectorAll('[data-bkgwebmap-suggestion]');
                var previousSibling = event.target.parentNode.parentNode.previousSibling;
                if (previousSibling) {
                    for (i = 0; i < allRows.length; i++) {
                        allRows[i].classList.remove('bkgwebmap-geosearchhighlight');
                    }

                    previousSibling.classList.add('bkgwebmap-geosearchhighlight');
                    previousSibling.childNodes[0].childNodes[0].focus();
                }
            }
        }

        // Show result table and hide suggestions
        function showResultTable(table) {
            resultDiv.appendChild(table);
            suggestionDiv.style.display = 'none';
            resultDiv.style.display = 'block';
        }

        // Show suggestion table and hide results
        function showSuggestionTable(table) {
            suggestionDiv.appendChild(table);
            suggestionDiv.style.display = 'block';
        }

        // Activate reverse geocoding
        function activateReverseGeocoding() {
            reverseGeoButtonDiv.addEventListener('click', useReverseGeocoding);
            reverseGeoButtonDiv.addEventListener('mouseenter', reverseGeocodingHover);
            reverseGeoButtonDiv.classList.add('bkgwebmap-reversegeoactive');
        }

        // Deactivate reverse geocoding
        function deactivateReverseGeocoding() {
            reverseGeoButtonDiv.removeEventListener('click', useReverseGeocoding);
            reverseGeoButtonDiv.removeEventListener('mouseenter', reverseGeocodingHover);
            reverseGeoButtonDiv.classList.remove('bkgwebmap-reversegeoactive');
        }

        // Initialize reverse geocoding
        function configureReverseGeocoding() {
            if (reverseGeocoding.minResolution || reverseGeocoding.maxResolution || reverseGeocoding.minZoom || reverseGeocoding.maxZoom) {
                var initZoom = map.getView().getZoom();
                var initResolution = map.getView().getResolution();
                adjustReverseGeocoding(initZoom, initResolution);
                map.getView().on('change:resolution', function () {
                    var zoom = map.getView().getZoom();
                    var resolution = map.getView().getResolution();
                    adjustReverseGeocoding(zoom, resolution);
                });
            }
        }

        function adjustReverseGeocoding(zoom, resolution) {
            if ((reverseGeocoding.minZoom && zoom < reverseGeocoding.minZoom) || (reverseGeocoding.maxZoom && zoom > reverseGeocoding.maxZoom)) {
                deactivateReverseGeocoding();
            } else if (reverseGeocoding.minZoom || reverseGeocoding.maxZoom) {
                activateReverseGeocoding();
            }
            if ((reverseGeocoding.minResolution && resolution < reverseGeocoding.minResolution) || (reverseGeocoding.maxResolution && resolution > reverseGeocoding.maxResolution)) {
                deactivateReverseGeocoding();
            } else if (reverseGeocoding.minResolution || reverseGeocoding.maxResolution) {
                activateReverseGeocoding();
            }
        }

        // Show tooltip for reverse geocoding button
        function reverseGeocodingHover() {
            searchTooltip.style.visibility = '';
            deleteResultsTooltip.style.visibility = '';
            reverseGeoSearchTooltip.style.visibility = 'visible';
            setTimeout(function () {
                reverseGeoSearchTooltip.style.visibility = '';
            }, 1200);
        }

        // Show tooltip for reverse wfs geocoding button
        function searchButtonHover() {
            if (reverseGeoSearchTooltip) {
                reverseGeoSearchTooltip.style.visibility = '';
            }
            if (deleteResultsTooltip) {
                deleteResultsTooltip.style.visibility = '';
            }
            searchTooltip.style.visibility = 'visible';
            setTimeout(function () {
                searchTooltip.style.visibility = '';
            }, 1200);
        }

        function deleteButtonHover() {
            if (reverseGeoSearchTooltip) {
                reverseGeoSearchTooltip.style.visibility = '';
            }
            if (searchTooltip) {
                searchTooltip.style.visibility = '';
            }
            deleteResultsTooltip.style.visibility = 'visible';
            setTimeout(function () {
                deleteResultsTooltip.style.visibility = '';
            }, 1200);
        }

        // Deactivate click event for attributes
        function removeAttributeListener() {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.ShowAttributes && control instanceof BKGWebMap.Control.ShowAttributes) {
                    map.un('click', control.clickAttributesActivate);
                }
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    map.un('click', control.clickCopyCoordinatesActivate);
                }
            });
        }

        // Activate click event for attributes
        function addAttributeListener() {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.ShowAttributes && control instanceof BKGWebMap.Control.ShowAttributes) {
                    map.on('click', control.clickAttributesActivate);
                }
                if (BKGWebMap.Control.CopyCoordinates && control instanceof BKGWebMap.Control.CopyCoordinates) {
                    map.on('click', control.clickCopyCoordinatesActivate);
                }
            });
        }

        // -- AJAX interactions ----------------------------------------------------------------------------------------

        // Get geojson with ajax request
        function getGeoJson(suggestionName, geojsonUrl) {
            suggestionDiv.innerHTML = '';
            geoSearchForm.value = suggestionName;
            popupContent.innerHTML = '';
            popup.setPosition(undefined);

            xhr.open('GET', geojsonUrl);

            xhr.onload = function () {
                if (xhr.status === 200) {
                    var geojson = JSON.parse(xhr.responseText);
                    addGeojson(geojson);
                }
            };

            xhr.onerror = function () {
                window.console.log(BKGWebMap.ERROR.xhrError);
            };

            xhr.send();
        }

        // constructs the url
        function buildUrl(url, params) {
            if (!params) return url;

            url += '?';
            for (var key in params) {
                url += key + '=' + encodeURIComponent(params[key]) + '&';
            }
            return url.replace(/&$/, '');
        }

        // perform geosearch request using gdz_ortssuche protocol
        function geosearch(queryString) {
            if (queryString === null || queryString.trim().length === 0) { return; }

            var projection = map.getView().getProjection().getCode();

            var params = {
                query: queryString,
                count: resultsCount,
                srsName: projection
            };
            if (filter) {
                params.filter = filter;
            }
            if (useSelectionFilterBbox) {
                params.bbox = selectionFilter.bbox.coordinates;
            }
            getGeoJson(queryString, buildUrl(url + '/geosearch.json', params));
        }

        // perform suggest request gdz_ortssuche protocol
        function suggest(searchString, suggestionCallback) {
            var params = {
                query: searchString,
                count: suggestCount
            };
            if (useSelectionFilterBbox) {
                params.bbox = selectionFilter.bbox.coordinates;
                params.srsName = selectionFilter.bbox.projection;
            }
            if (filter) {
                params.filter = filter;
            }

            xhr.open('GET', buildUrl(url + '/suggest.json', params));

            xhr.onload = function () {
                if (xhr.status === 200) {
                    var suggestion = JSON.parse(xhr.responseText);

                    suggestionCallback(createSuggestionTable(suggestion));
                }
            };

            xhr.onerror = function () {
                window.console.log(BKGWebMap.ERROR.xhrError);
            };

            xhr.send();
        }

        // Reverse geocoding function
        function useReverseGeocoding() {
            var bbox = map.getView().calculateExtent(map.getSize());
            var epsg = map.getView().getProjection().getCode();

            if (useSelectionFilterBbox) {
                var filterBbox = ol.proj.transformExtent(selectionFilter.bbox.coordinates, selectionFilter.bbox.projection, epsg);
                var intersected = ol.extent.intersects(bbox, filterBbox);
                if (intersected) {
                    var intersectedBbox = ol.extent.getIntersection(bbox, filterBbox);
                    if (intersectedBbox.indexOf(Infinity) === -1 && intersectedBbox.indexOf(Infinity) === -1) {
                        bbox = intersectedBbox;
                    }
                } else {
                    bbox = false;
                }
            }

            if (!bbox) {
                return;
            }

            var params = {
                filter: BKGWebMap.CONTROLS.tools.geoSearch.reverseGeocoding.defaultFilter,
                count: resultsCount,
                bbox: bbox,
                srsName: epsg
            };
            if (filter) {
                params.filter = filter;
            }

            xhr.open('GET', buildUrl(url + '/geosearch', params));
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var geojson = JSON.parse(xhr.responseText);
                    popupContent.innerHTML = '';
                    popup.setPosition(undefined);
                    geoSearchForm.value = '';
                    addGeojson(geojson);
                }
            };

            xhr.onerror = function () {
                window.console.log(BKGWebMap.ERROR.xhrError);
            };

            xhr.send();
        }

        // Custom WFS for geocoding
        function getWfs(searchString) {
            var epsg = map.getView().getProjection().getCode();
            var search = searchString + '*';
            var format = formatsList[wfsProtocolFormat].olClass;
            var outputFormat = formatsList[wfsProtocolFormat].outputFormat;
            var filterToUse = ol.format.filter.like(wfsSearchAttribute, search);
            var maxFeatures = resultsCount;

            var featureRequest = new ol.format.WFS().writeGetFeature({
                srsName: epsg,
                featurePrefix: wfsFeaturePrefix,
                featureTypes: [wfsFeatureType],
                outputFormat: outputFormat,
                filter: filterToUse,
                maxFeatures: maxFeatures
            });
            var bodyRequest = new XMLSerializer().serializeToString(featureRequest);

            xhr.open('POST', url);

            xhr.onload = function () {
                if (xhr.status === 200) {
                    var vectorSource = vectorLayer.getSource();
                    vectorSource.clear();
                    var features = format.readFeatures(xhr.responseText, {
                        dataProjection: epsg,
                        featureProjection: epsg
                    });

                    features.forEach(function (feature) {
                        var extent = feature.getGeometry().getExtent();
                        var center = getCenterOfExtent(extent);
                        var properties = feature.getProperties();

                        var point = new ol.geom.Point(center);
                        var pointFeature = new ol.Feature({
                            geometry: point
                        });
                        pointFeature.setProperties(properties);
                        pointFeature.setProperties({
                            featureId: BKGWebMap.Util.uniqueId()
                        });
                        vectorSource.addFeature(pointFeature);
                    });

                    if (features.length) {
                        map.getView().fit(vectorSource.getExtent(), { size: map.getSize() });
                    }

                    createResultTable(vectorLayer);
                }
            };

            xhr.onerror = function () {
                window.console.log(BKGWebMap.ERROR.xhrError);
            };

            xhr.send(bodyRequest);
        }

        function useSearch() {
            var searchString = geoSearchForm.value;
            if (protocol === 'wfs') {
                getWfs(searchString);
            } else {
                geosearch(searchString);
            }
        }

        // Event listener to start searching
        if (wfsAutocomplete) {
            geoSearchForm.addEventListener('input', function () {
                var searchString = geoSearchForm.value;
                if (searchString === '') {
                    suggestionDiv.innerHTML = '';
                    suggestionDiv.style.display = 'none';
                    if (resultDiv.innerHTML !== '') {
                        resultDiv.style.display = 'block';
                    }
                } else if (protocol === 'ortssuche') {
                    setTimeout(function () {
                        if (geoSearchForm.value === '') {
                            suggestionDiv.innerHTML = '';
                            suggestionDiv.style.display = 'none';
                            if (resultDiv.innerHTML !== '') {
                                resultDiv.style.display = 'block';
                            }
                        } else {
                            suggest(searchString, function (table) {
                                showSuggestionTable(table);
                            });
                        }
                    }, 500);
                } else {
                    window.console.log(BKGWebMap.ERROR.geoSearchWrongProtocol);
                }
            }, false);

            geoSearchForm.addEventListener('keydown', function (event) {
                if (protocol === 'ortssuche') {
                    if (event.key && event.key === 'Enter') {
                        var suggestionName = event.target.value;
                        var geojsonUrl;
                        var projection = map.getView().getProjection().getCode();
                        if (useSelectionFilterBbox) {
                            geojsonUrl = url + '/geosearch.json?query=' + suggestionName + '&count=' + resultsCount + '&srsName=' + projection + '&bbox=' + selectionFilter.bbox.coordinates;
                        } else {
                            geojsonUrl = url + '/geosearch.json?query=' + suggestionName + '&count=' + resultsCount + '&srsName=' + projection;
                        }
                        getGeoJson(suggestionName, geojsonUrl);
                    } else if (suggestionDiv.style.display === 'none' && event.key && event.keyCode === 40) {
                        event.preventDefault();
                        suggestionDiv.style.display = 'block';
                    } else if (event.key && event.keyCode === 40) {
                        event.preventDefault();
                        var suggestionTable = document.getElementById(mapId).getElementsByClassName('bkgwebmap-geosearchsuggestiontable');
                        if (suggestionTable && suggestionTable.length) {
                            var row = suggestionTable[0].childNodes;
                            if (row && row.length) {
                                row[0].childNodes[0].childNodes[0].focus();
                                row[0].classList.add('bkgwebmap-geosearchhighlight');
                            }
                        }
                    } else if (event.key && event.key === 'Escape' || event.keyCode === 27) {
                        suggestionDiv.style.display = 'none';
                        if (resultDiv.innerHTML !== '') {
                            resultDiv.style.display = 'block';
                        }
                    }
                }
            }, false);
        }

        function getContentWithTemplate(template, properties, coordinates) {
            var content = template;
            for (var prop in properties) {
                if (content.indexOf('${' + prop + '}') > -1 && prop !== 'geometry') {
                    content = content.replace('${' + prop + '}', properties[prop]);
                } else if (prop === 'geometry') {
                    if (content.indexOf('${geometry.x}') > -1) {
                        content = content.replace('${geometry.x}', coordinates[0].toFixed(5));
                    }
                    if (content.indexOf('${geometry.y}') > -1) {
                        content = content.replace('${geometry.y}', coordinates[1].toFixed(5));
                    }
                }
            }
            content = content.replace(/(\$\{\w+\})/mg, '');
            return content;
        }

        // Read content for feature popup
        function getPopupContent(feature) {
            var properties = feature.getProperties();
            var coordinates = feature.getGeometry().getCoordinates();
            var content = '';
            var propertiesToShow;
            if (templatePopup) {
                content = getContentWithTemplate(templatePopup, properties, coordinates);
            } else {
                if (protocol === 'wfs') {
                    propertiesToShow = wfsShowAttributes;
                } else if (protocol === 'ortssuche') {
                    propertiesToShow = gdzOrtssuchePropsToShow;
                }
                for (var i = 0; i < propertiesToShow.length; i++) {
                    if (Object.prototype.hasOwnProperty.call(properties, propertiesToShow[i])) {
                        content += propertiesToShow[i];
                        content += ': <i>';
                        content += properties[propertiesToShow[i]].replace(/ /g, '&nbsp;');
                        content += '</i><br>';
                    }
                }
                content += '(';
                content += coordinates[0].toFixed(5);
                content += ',&nbsp;';
                content += coordinates[1].toFixed(5);
                content += ')';
            }
            return content;
        }

        // Find feature when clicked on map
        function findFeature(pixel) {
            var feature = map.forEachFeatureAtPixel(pixel, function (feature) {
                return feature;
            }, {
                layerFilter: function (layer) {
                    return layer === vectorLayer;
                },
                hitTolerance: 5
            });

            if (feature) {
                var content = getPopupContent(feature);
                if (content) {
                    var coordinates = feature.getGeometry().getCoordinates();
                    popupContent.innerHTML = content;
                    popup.setPosition(coordinates);
                    removeAttributeListener();
                } else {
                    popupContent.innerHTML = '';
                    popup.setPosition(undefined);
                    addAttributeListener();
                }
            } else {
                popupContent.innerHTML = '';
                popup.setPosition(undefined);
                addAttributeListener();
            }
        }

        /**
         * Activate click event to show popup
         * @param event
         */
        this.geoSearchClickActivate = function (event) {
            var pixel = event.pixel;
            findFeature(pixel);
        };

        map.on('click', this.geoSearchClickActivate);

        // Event listener for enter on search form
        geoSearchForm.addEventListener('keydown', function (event) {
            if (event.key && event.key === 'Enter') {
                useSearch();
            }
        });

        // Event listener for delete button (mouseenter an click)
        deleteResultsButtonDiv.addEventListener('mouseenter', deleteButtonHover, false);
        deleteResultsButtonDiv.addEventListener('click', function () {
            deleteResults();
        }, false);

        // Event listener for reverse geocoding button (mouseenter and click)
        if (reverseGeoButtonDiv) {
            reverseGeoButtonDiv.addEventListener('mouseenter', reverseGeocodingHover);
            reverseGeoButtonDiv.addEventListener('click', useReverseGeocoding);
        }

        // Event listener for search button (mouseenter and click)
        searchButtonDiv.addEventListener('mouseenter', searchButtonHover);
        searchButtonDiv.addEventListener('click', useSearch);

        // Event listener for popup close
        popupCloser.addEventListener('click', function () {
            popup.setPosition(undefined);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: geoSearchElement,
            target: target
        });
    };
};

/**
 * Create SearchCoordinates Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_searchCoordinates}
 */
BKGWebMap.Control.createSearchCoordinates = function () {
    return function (map, controlName, options, panel) {
        var _this = this;
        var mapId = map.getTarget();
        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '')) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        var target;
        var inPanel = true;
        if (options.div && options.div !== '') {
            target = options.div;
            inPanel = false;
        }

        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
        }

        // Control in panel
        var searchPanelControl = searchPanelExists();
        if (inPanel) {
            if (!searchPanelControl) {
                createSearchpanel();
            }
            target = panel.element.getElementsByClassName('bkgwebmap-searchpanelcontent')[0];
        }

        function createSearchpanel() {
            var SearchPanelClass = BKGWebMap.Control.FACTORIES.searchPanel();
            var searchPanel = new SearchPanelClass(map, 'searchpanel', false, panel);
            map.addControl(searchPanel);
            return searchPanel;
        }

        function searchPanelExists() {
            var exists = false;
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.SearchPanel && control instanceof BKGWebMap.Control.SearchPanel) {
                    exists = true;
                }
            });
            return exists;
        }

        var markerControl;
        map.getControls().forEach(function (control) {
            if (BKGWebMap.Control.Marker && control instanceof BKGWebMap.Control.Marker) {
                markerControl = control;
            }
        });

        if (!markerControl) {
            var Marker = BKGWebMap.Control.FACTORIES.marker();
            markerControl = new Marker(map);
            map.addControl(markerControl);
        }

        var searchCoordinates = document.createElement('div');
        var searchCoordinatesClass = 'bkgwebmap-searchcoordinates ' + customClass;
        searchCoordinates.className = searchCoordinatesClass;

        var searchCoordinatesTitle = document.createElement('div');
        searchCoordinatesTitle.className = 'bkgwebmap-searchcoordinatestitle';
        searchCoordinatesTitle.innerHTML = 'Zu Koordinaten springen';
        var searchCoordinatesText = document.createElement('div');
        searchCoordinatesText.className = 'bkgwebmap-searchcoordinatestext';
        searchCoordinatesText.innerHTML = 'Koordinatenbezugssystem wählen und Koordinaten eingeben (Dezimalformat).';
        searchCoordinates.appendChild(searchCoordinatesTitle);
        searchCoordinates.appendChild(searchCoordinatesText);

        var searchCoordinatesSelect = document.createElement('select');
        searchCoordinatesSelect.className = 'bkgwebmap-searchcoordinatesselect';
        var csArray;
        if (options.coordinateSystems && options.coordinateSystems instanceof Array && options.coordinateSystems.length) {
            csArray = options.coordinateSystems;
        } else {
            csArray = [
                {
                    epsg: map.getView().getProjection().getCode(),
                    name: map.getView().getProjection().getCode()
                }
            ];
        }
        for (var i = 0; i < csArray.length; i++) {
            var selectItem = document.createElement('option');
            selectItem.className = 'bkgwebmap-searchcoordinatesselectitem';
            selectItem.value = csArray[i].epsg;
            if (csArray[i].name) {
                selectItem.innerHTML = csArray[i].name;
            } else {
                selectItem.innerHTML = csArray[i].epsg;
            }
            searchCoordinatesSelect.appendChild(selectItem);
        }
        searchCoordinates.appendChild(searchCoordinatesSelect);

        var searchCoordinatesLonInput = document.createElement('input');
        searchCoordinatesLonInput.className = 'bkgwebmap-searchcoordinatesinput bkgwebmap-searchcoordinateslon';
        searchCoordinatesLonInput.placeholder = 'Länge/Rechts';

        var searchCoordinatesLatInput = document.createElement('input');
        searchCoordinatesLatInput.className = 'bkgwebmap-searchcoordinatesinput bkgwebmap-searchcoordinateslat';
        searchCoordinatesLatInput.placeholder = 'Breite/Hoch';

        var searchCoordinatesInputs = document.createElement('div');
        searchCoordinatesInputs.className = 'bkgwebmap-searchcoordinatesinputs';
        searchCoordinatesInputs.appendChild(searchCoordinatesLatInput);
        searchCoordinatesInputs.appendChild(searchCoordinatesLonInput);
        searchCoordinates.appendChild(searchCoordinatesInputs);

        var searchCoordinatesButton = document.createElement('button');
        searchCoordinatesButton.className = 'bkgwebmap-searchcoordinatesbutton';
        searchCoordinatesButton.innerHTML = 'zu Koordinate springen';
        searchCoordinates.appendChild(searchCoordinatesButton);

        searchCoordinatesButton.addEventListener('click', zoomToCoordinates, { passive: true });

        var markerButton = document.createElement('button');
        markerButton.className = 'bkgwebmap-deletemarker';
        markerButton.innerHTML = 'Marker löschen';

        function zoomToCoordinates() {
            var lat = parseFloat(searchCoordinatesLatInput.value.replace(',', '.'));
            var lon = parseFloat(searchCoordinatesLonInput.value.replace(',', '.'));
            var proj = searchCoordinatesSelect.value;
            var mapProj = map.getView().getProjection();
            if (!isNaN(lat) && !isNaN(lon)) {
                var coordinates = [lon, lat];
                map.getView().setCenter(ol.proj.transform(coordinates, proj, mapProj));
                markerControl.setMarker(_this, ol.proj.transform(coordinates, proj, mapProj));
                if (document.getElementById(mapId).getElementsByClassName('bkgwebmap-deletemarker').length) {
                    document.getElementById(mapId).getElementsByClassName('bkgwebmap-deletemarker')[0].remove();
                }
                var markerButtonClone = markerButton.cloneNode(true);
                searchCoordinates.appendChild(markerButtonClone);
                markerButtonClone.onclick = function () {
                    markerControl.deleteMarker();
                    markerButtonClone.remove();
                };
            }
        }

        // Finalize control
        ol.control.Control.call(this, {
            element: searchCoordinates,
            target: target
        });
    };
};

/**
 * Create Print Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_print}
 */
BKGWebMap.Control.createPrint = function () {
    return function (map, options, panel) {
        options = options || {};

        var mapId = map.getTarget();

        // Add user defined stylesheet if set in options
        if ((typeof options.stylesheet === 'string' || options.stylesheet instanceof String) && options.stylesheet !== '') {
            var pathToStylesheet = options.stylesheet;
            var printStylesheet = document.createElement('link');
            printStylesheet.rel = 'stylesheet';
            printStylesheet.href = pathToStylesheet;
            document.head.appendChild(printStylesheet);
        }

        var target;
        if (panel.element) {
            target = panel.element.getElementsByClassName('bkgwebmap-sharepanelcontent')[0];
        } else {
            target = panel.getElementsByClassName('bkgwebmap-sharepanelcontent')[0];
        }

        var print = document.createElement('div');
        print.className = 'bkgwebmap-print';

        // add intro text
        var printMapInfo = document.createElement('div');
        printMapInfo.className = 'bkgwebmap-printmapinfo';
        print.appendChild(printMapInfo);

        // add button to print map
        var printButton = document.createElement('button');
        printButton.className = 'bkgwebmap-printmapbutton';
        printButton.innerHTML = 'Karte drucken';
        print.appendChild(printButton);

        // function to print map
        function printThisMap(mapId) {
            // add media query for map in style-tag
            var printStyle = document.createElement('style');
            printStyle.id = 'bkgwebmap-printstyle';
            printStyle.innerHTML = '@media print {body *{visibility:hidden; font-family: Arial, "Helvetica Neue", Helvetica, sans-serif;}img{max-width:100%}.bkgwebmap-maptoprint,.bkgwebmap-maptoprint *{display:inherit;visibility:visible}.bkgwebmap-maptoprint .ol-control,.bkgwebmap-maptoprint .ol-control *{visibility:hidden!important}.print-element{display:block!important;margin-top:15px} sup {display: inline !important} .bkgwebmap-measureoverlay-tooltip {visibility: hidden;} .bkgwebmap-scalevalue {visibility: hidden}}';
            document.head.appendChild(printStyle);

            // set some variables
            var mapContainer = document.getElementById(mapId);
            var olAttribution = mapContainer.getElementsByClassName('bkgwebmap-copyrightlist')[0];
            var copyrightDiv = document.createElement('div');

            var olScale = mapContainer.getElementsByClassName('bkgwebmap-scalebar')[0];
            var scaleDiv = document.createElement('div');

            var olLegend = mapContainer.getElementsByClassName('bkgwebmap-legendcontent')[0];
            var legendDiv = document.createElement('div');

            // insert copyright information if available
            if (olAttribution) {
                // create new container for copyright information
                copyrightDiv.classList.add('print-element');
                copyrightDiv.style.display = 'none';

                // insert copyright information
                copyrightDiv.innerHTML = '<b>Copyright</b>' + olAttribution.innerHTML;
            }

            // insert scale if available
            if (olScale) {
                // create new container for scale
                scaleDiv.classList.add('print-element');
                scaleDiv.classList.add('scale-div-print');
                scaleDiv.style.display = 'none';


                // insert scale
                scaleDiv.innerHTML = olScale.innerHTML;
            }

            // insert legend if available
            if (olLegend) {
                // create new container for legend
                legendDiv.classList.add('print-element');
                legendDiv.style.display = 'none';

                // insert legend
                legendDiv.innerHTML = olLegend.innerHTML;
            }

            // insert measure result if available
            var measureDiv = document.createElement('div');
            measureDiv.classList.add('print-element');
            measureDiv.style.display = 'none';

            var measureTooltip = document.getElementsByClassName('bkgwebmap-measureoverlay-tooltip-static')[0];

            if (measureTooltip !== undefined) {
                var measureResult = measureTooltip.innerHTML;
                var measureMessage;
                if (measureResult.indexOf('<sup>') !== -1) {
                    measureMessage = 'Gemessene Fläche: ' + measureResult;
                } else {
                    measureMessage = 'Gemessene Strecke: ' + measureResult;
                }

                measureDiv.innerHTML = measureMessage;
            }

            // add scaleDiv, measureDiv, copyrightDiv, le  to page
            mapContainer.appendChild(scaleDiv);
            mapContainer.appendChild(measureDiv);
            mapContainer.appendChild(copyrightDiv);
            mapContainer.appendChild(legendDiv);

            // add class to set all but this map invisible, print and then remove class again
            mapContainer.classList.add('bkgwebmap-maptoprint');

            // print map
            window.print();

            // remove created elements again
            document.head.removeChild(document.getElementById('bkgwebmap-printstyle'));
            mapContainer.removeChild(scaleDiv);
            mapContainer.removeChild(measureDiv);
            mapContainer.removeChild(copyrightDiv);
            mapContainer.removeChild(legendDiv);
            mapContainer.classList.remove('bkgwebmap-maptoprint');
        }

        // add EventListener
        printButton.addEventListener('click', function () {
            printThisMap(mapId);
        }, { passive: true });

        // Finalize control
        ol.control.Control.call(this, {
            element: print,
            target: target
        });
    };
};

/**
 * Create PermaLink Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_permaLink}
 */
BKGWebMap.Control.createPermaLink = function () {
    return function (map) {
        var _this = this;

        // Use property 'active' to check later if control is activated. We need to add later the layers.
        this.active = true;

        var layersInHash;
        this.readLayersFromPermaLink = false;

        var mapProjection = map.getView().getProjection().getCode();
        var shouldUpdate = true;

        function replaceMultipleKeys(hash, keys) {
            for (var i = 0; i < keys.length; i++) {
                hash = hash.replace(keys[i], '');
            }
            return hash;
        }

        if (window.location.hash !== '') {
            var keysToReplace = ['#lat=', 'lon=', 'zoom='];
            var hash = replaceMultipleKeys(window.location.hash, keysToReplace);
            var parts = hash.split('&');
            if (parts.length >= 3) {
                var zoom = parseInt(parts[2], 10);
                var center = ol.proj.transform([parseFloat(parts[1]), parseFloat(parts[0])], 'EPSG:4326', mapProjection);
                map.getView().setZoom(zoom);
                map.getView().setCenter(center);
            }
            if (parts.length > 3) {
                _this.readLayersFromPermaLink = true;
                layersInHash = '&' + parts.slice(3).join('&');
            }
        }

        function updatePermalink() {
            if (!shouldUpdate) {
                shouldUpdate = true;
                return;
            }

            var newCenter = map.getView().getCenter();
            var center4326 = ol.proj.transform(newCenter, mapProjection, 'EPSG:4326');
            var lon = center4326[0].toFixed(4);
            var lat = center4326[1].toFixed(4);
            var newZoom = map.getView().getZoom();

            var newHash = '#lat=' + lat + '&lon=' + lon + '&zoom=' + newZoom;
            if (layersInHash) {
                newHash += layersInHash;
            }
            var state = {
                center: newCenter,
                zoom: newZoom,
                layers: layersInHash
            };
            window.history.pushState(state, 'BKG_permaLink', newHash);
        }

        function constructLayersHash(layer) {
            if (layer.getProperties().customLayer || !layer.getProperties().id) {
                return '';
            }
            var id = layer.getProperties().id;
            var visible = layer.getVisible();
            var layerHash = '&' + id + '=' + visible;
            return layerHash;
        }

        // Change layer order and visibility in permalink
        this.changeLayersInPermalink = function () {
            var layersHash = '';
            var singleHash = '';
            map.getLayers().forEach(function (layer) {
                singleHash = constructLayersHash(layer);
                layersHash += singleHash;
                if (layer instanceof ol.layer.Group) {
                    layer.getLayers().forEach(function (layerInGroup) {
                        singleHash = constructLayersHash(layerInGroup);
                        layersHash += singleHash;
                    });
                }
            });
            layersInHash = layersHash;
            updatePermalink();
        };

        // Change layer order in group layer
        function changeGroupOrder(hashParts, groupLayer) {
            var subLayersArray = groupLayer.getLayers().getArray();
            var newSubLayersAray = [];
            var hashPartsTemp;
            for (var i = 1; i < hashParts.length; i++) {
                hashPartsTemp = hashParts[i].split('=');
                for (var k = subLayersArray.length - 1; k >= 0; k--) {
                    if (subLayersArray[k].getProperties().id && subLayersArray[k].getProperties().id === hashPartsTemp[0]) {
                        var visible = (hashPartsTemp[1] === 'true');
                        subLayersArray[k].setVisible(visible);
                        newSubLayersAray.push(subLayersArray[k]);
                        subLayersArray.splice(k, 1);
                    }
                }
            }
            newSubLayersAray = subLayersArray.concat(newSubLayersAray);
            var newCollection = new ol.Collection(newSubLayersAray);
            groupLayer.setLayers(newCollection);
            return groupLayer;
        }

        /**
         * Change layer order using permalink parameteres
         * @param layers
         * @returns {{baseLayers: Array, overlays: Array}}
         */
        this.changeLayersOrder = function (layers) {
            var newLayers = {
                baseLayers: [],
                overlays: []
            };
            var hashParts = layersInHash.split('&');
            var hashPartsTemp;
            var visible;
            for (var i = hashParts.length - 1; i >= 0; i--) {
                hashPartsTemp = hashParts[i].split('=');
                for (var k = layers.overlays.length - 1; k >= 0; k--) {
                    if (layers.overlays[k] && layers.overlays[k].getProperties().id && layers.overlays[k].getProperties().id === hashPartsTemp[0]) {
                        if (layers.overlays[k] instanceof ol.layer.Group) {
                            layers.overlays[k] = changeGroupOrder(hashParts, layers.overlays[k]);
                        }
                        visible = (hashPartsTemp[1] === 'true');
                        layers.overlays[k].setVisible(visible);
                        newLayers.overlays.push(layers.overlays[k]);
                        layers.overlays.splice(k, 1);
                    }
                }

                for (var j = layers.baseLayers.length - 1; j >= 0; j--) {
                    if (layers.baseLayers[j] && layers.baseLayers[j].getProperties().id && layers.baseLayers[j].getProperties().id === hashPartsTemp[0]) {
                        visible = (hashPartsTemp[1] === 'true');
                        layers.baseLayers[j].setVisible(visible);
                        newLayers.baseLayers.push(layers.baseLayers[j]);
                        layers.baseLayers.splice(j, 1);
                    }
                }
            }
            newLayers.overlays = layers.overlays.concat(newLayers.overlays);
            newLayers.baseLayers = layers.baseLayers.concat(newLayers.baseLayers);
            return newLayers;
        };

        map.on('moveend', updatePermalink);

        window.addEventListener('popstate', function (event) {
            if (event.state === null) {
                return;
            }
            map.getView().setCenter(event.state.center);
            map.getView().setZoom(event.state.zoom);
            shouldUpdate = false;
        });
    };
};

/**
 * Create JsonExport Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_jsonExport}
 */
BKGWebMap.Control.createJsonExport = function () {
    return function (map, options, panel) {
        options = options || {};

        var appName = BKGWebMap.CONTROLS.tools.share.jsonExport.appName;
        if ((typeof options.appName === 'string' || options.appName instanceof String) && options.appName !== '') {
            appName = options.appName;
        }

        var target;
        if (panel.element) {
            target = panel.element.getElementsByClassName('bkgwebmap-sharepanelcontent')[0];
        } else {
            target = panel.getElementsByClassName('bkgwebmap-sharepanelcontent')[0];
        }

        var jsonExport = document.createElement('div');
        jsonExport.className = 'bkgwebmap-jsonexport';

        var exportButton = document.createElement('button');
        exportButton.className = 'bkgwebmap-jsonexportbutton';
        exportButton.innerHTML = 'Konfigurationsdatei exportieren';
        jsonExport.appendChild(exportButton);

        var importDiv = document.createElement('div');
        importDiv.className = 'bkgwebmap-jsonimportfilediv';
        jsonExport.appendChild(importDiv);

        var importButtonLabel = document.createElement('label');
        importButtonLabel.className = 'bkgwebmap-jsonimportfilelabel';
        importButtonLabel.innerHTML = 'Konfigurationsdatei importieren';
        jsonExport.appendChild(importButtonLabel);

        var importButton = document.createElement('input');
        importButton.className = 'bkgwebmap-jsonimportbutton';
        importButton.setAttribute('type', 'file');
        importButton.setAttribute('accept', '.json');

        importButtonLabel.appendChild(importButton);

        // Read configuration from layer properties
        function getLayersConfig(layer) {
            if (layer.getProperties().originalConfig) {
                return layer.getProperties().originalConfig;
            }
        }

        // Create configuration for custom layers
        function getCustomLayer(layer) {
            var singleLayerConfig;

            if (layer instanceof BKGWebMap.Layer.CSV || layer instanceof BKGWebMap.Layer.XLS || layer instanceof BKGWebMap.Layer.GPS) {
                var visible = false;
                var name = 'Custom Layer';
                var style = '';
                var features = layer.getSource().getFeatures();
                var format = new ol.format.GeoJSON();
                var geojson = format.writeFeatures(features, {
                    dataProjection: 'EPSG:4326',
                    featureProjection: map.getView().getProjection().getCode()
                });
                geojson = JSON.parse(geojson);
                if (BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'originalConfig.visibility')) {
                    visible = layer.getProperties().originalConfig.visibility;
                }
                if (BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'originalConfig.name')) {
                    name = layer.getProperties().originalConfig.name;
                }
                if (BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'originalConfig.styleName')) {
                    style = layer.getProperties().originalConfig.styleName;
                }
                singleLayerConfig = {
                    type: 'VECTOR',
                    name: name,
                    visibility: visible,
                    style: style,
                    features: geojson
                };
            } else {
                singleLayerConfig = getLayersConfig(layer);
            }
            return singleLayerConfig;
        }

        // Create layers configuration
        function getLayers() {
            var layers = {
                baseLayers: [],
                overlays: []
            };
            map.getLayers().forEach(function (layer) {
                var singleLayerConfig = getLayersConfig(layer);
                if (layer.getProperties().isBaseLayer === true) {
                    layers.baseLayers.push(singleLayerConfig);
                } else if (layer.getProperties().isBaseLayer === false) {
                    if (BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'customLayer') && layer.getProperties().customLayer === true) {
                        singleLayerConfig = getCustomLayer(layer);
                    } else if (layer instanceof ol.layer.Group) {
                        singleLayerConfig.layers = [];
                        layer.getLayers().forEach(function (subLayer) {
                            var subLayerConfig = getLayersConfig(subLayer);
                            singleLayerConfig.layers.push(subLayerConfig);
                        });
                    }
                    layers.overlays.push(singleLayerConfig);
                }
            });
            return layers;
        }

        // Export file
        function exportJson() {
            var filename = 'BKG-WebMap';
            var date = new Date();
            var json = {
                description: 'BKG WebMap: Kartenkonfiguration',
                version: BKGWebMap.VERSION,
                generatedAt: date.toLocaleString(),
                appName: appName,
                map: {
                    projection: map.getView().getProjection().getCode(),
                    center: {
                        lat: parseFloat(map.getView().getCenter()[1].toFixed(4)),
                        lon: parseFloat(map.getView().getCenter()[0].toFixed(4))
                    },
                    zoom: map.getView().getZoom(),
                    minResolution: map.getView().getMinResolution(),
                    maxResolution: map.getView().getMaxResolution()
                },
                layers: getLayers()
            };
            var jsonString = JSON.stringify(json, null, 2);
            var blob = new Blob([jsonString], { type: 'text/plain;charset=utf-8' });
            saveAs(blob, filename + '.json');
        }

        // Add persistence configuration to session storage. It will be used to load configuration after refreshing the page.
        function addJsonToSessionStorage(json) {
            try {
                // Save json to sessionStorage
                window.sessionStorage.setItem('bkgwebmap', json);
                // Reload page without PermaLink
                window.location = window.location.protocol + '//' + window.location.host + window.location.pathname;
            } catch (err) {
                alert(BKGWebMap.ERROR.enableCookiesImport);
            }
        }

        // Add EventListeners
        exportButton.addEventListener('click', function () {
            exportJson();
        }, { passive: true });

        importButton.onchange = function (evt) {
            var input = evt.target;
            var reader = new FileReader();
            reader.readAsText(input.files[0]);
            reader.onload = function (event) {
                var json = event.target.result;
                addJsonToSessionStorage(json);
            };
            importButton.value = '';
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: jsonExport,
            target: target
        });
    };
};

/**
 * Create Share Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_share}
 */
BKGWebMap.Control.createShare = function () {
    return function (map, controlName, options, panel) {
        var mapId = map.getTarget();
        var addPrint;
        var addPermaLink;
        var addJsonExport;
        var print;
        var _this = this;


        if (typeof options.print === 'object' && options.print.constructor === Object && typeof options.print.active === 'boolean') {
            addPrint = options.print.active;
        } else {
            addPrint = BKGWebMap.CONTROLS.tools.share.print.active;
        }
        if (typeof options.jsonExport === 'object' && options.jsonExport.constructor === Object && typeof options.jsonExport.active === 'boolean') {
            addJsonExport = options.jsonExport.active;
        } else {
            addJsonExport = BKGWebMap.CONTROLS.tools.share.jsonExport.active;
        }
        if (typeof options.permaLink === 'object' && options.permaLink.constructor === Object && typeof options.permaLink.active === 'boolean') {
            addPermaLink = options.permaLink.active;
        } else {
            addPermaLink = BKGWebMap.CONTROLS.tools.share.permaLink.active;
        }

        // Check if control should be created
        if (options.active === false || (!addPrint && !addJsonExport && !addPermaLink)) {
            return undefined;
        }

        // If no panel exists and no other div ID is defined, do not create this control
        if (!panel && (!options.div || options.div === '') && (addPrint || addJsonExport)) {
            window.console.log(BKGWebMap.ERROR.noPanelNoDivForControl + controlName);
            return undefined;
        }

        // Add permaLink control
        if (addPermaLink) {
            var PermaLinkClass = BKGWebMap.Control.FACTORIES.permaLink();
            this.permaLink = new PermaLinkClass(map);
        }

        if (!addPrint && !addJsonExport && addPermaLink) {
            BKGWebMap.Util.onlyPermaLink = true;
        }

        if (!BKGWebMap.Util.onlyPermaLink) {
            var target;
            var inPanel = true;
            if (options.div && options.div !== '') {
                target = options.div;
                inPanel = false;
            } else {
                target = panel.element.getElementsByClassName('bkgwebmap-panelbar')[0];
            }

            // Control title for panel
            var title = 'Teilen';

            // Tooltip position
            var tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipleft';
            var tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextleft';
            if (inPanel && panel.getPanelPosition() === 'right') {
                tooltipClass = 'bkgwebmap-paneltooltip bkgwebmap-paneltooltipright';
                tooltipTextClass = 'bkgwebmap-paneltooltiptext bkgwebmap-paneltooltiptextright';
            }

            // Create DOM
            var sharePanel = document.createElement('div');
            sharePanel.className = 'bkgwebmap-sharepanel ' + tooltipClass;

            var parser = new DOMParser();
            var sharePanelIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.SHARE, 'text/xml');
            sharePanelIcon.documentElement.setAttribute('class', 'bkgwebmap-panelicons bkgwebmap-paneliconsopen');
            sharePanel.appendChild(sharePanelIcon.documentElement);

            var sharePanelTooltip = document.createElement('span');
            sharePanelTooltip.className = tooltipTextClass;
            sharePanelTooltip.innerHTML = title;
            sharePanel.appendChild(sharePanelTooltip);

            var sharePanelContent = document.createElement('div');
            var sharePanelContentClass = 'bkgwebmap-sharepanelcontent';
            sharePanelContent.className = sharePanelContentClass + ' bkgwebmap-panelsinglecontent';

            if (inPanel) {
                panel.addPanelContent(sharePanelContent);
            } else {
                sharePanel.appendChild(sharePanelContent);
                sharePanelContent.style.display = 'none';
            }

            // Add print control
            if (addPrint) {
                var PrintClass = BKGWebMap.Control.FACTORIES.print();
                if (inPanel) {
                    print = new PrintClass(map, options.print, panel);
                } else {
                    print = new PrintClass(map, options.print, sharePanel);
                }
                map.addControl(print);
            }

            // Add jsonExport control
            if (addJsonExport) {
                var JsonExportClass = BKGWebMap.Control.FACTORIES.jsonExport();
                var jsonExport;
                if (inPanel) {
                    jsonExport = new JsonExportClass(map, options.jsonExport, panel);
                } else {
                    jsonExport = new JsonExportClass(map, options.jsonExport, sharePanel);
                }
                map.addControl(jsonExport);
            }

            function clickControl() {
                if (inPanel) {
                    var activeContent = panel.getActiveContent();
                    if (activeContent === '') {
                        panel.openPanel(print);
                        panel.changePanelContent(title, sharePanelContentClass);
                        _this.activeIcon();
                    } else if (activeContent === sharePanelContentClass) {
                        panel.closePanel();
                    } else {
                        panel.changePanelContent(title, sharePanelContentClass);
                        _this.activeIcon();
                    }
                } else if (sharePanelContent.style.display === 'none') {
                    sharePanelContent.style.display = 'block';
                } else {
                    sharePanelContent.style.display = 'none';
                }
            }

            this.activeIcon = function () {
                sharePanel.classList.add('bkgwebmap-panelactive');
            };

            // Event listeners
            sharePanel.addEventListener('click', clickControl, { passive: true });
            sharePanel.addEventListener('mouseenter', function () {
                var allTooltips = document.getElementById(mapId).getElementsByClassName('bkgwebmap-paneltooltiptext');
                for (var i = 0; i < allTooltips.length; i++) {
                    allTooltips[i].style.visibility = '';
                }
                sharePanelTooltip.style.visibility = 'visible';
                setTimeout(function () {
                    sharePanelTooltip.style.visibility = '';
                }, 1200);
            }, false);

            // Finalize control
            ol.control.Control.call(this, {
                element: sharePanel,
                target: target
            });
        } else {
            // Finalize control
            ol.control.Control.call(this, {
                element: document.createElement('span')
            });
        }
    };
};

/**
 * Create OverviewMap Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_overviewMap}
 */
BKGWebMap.Control.createOverviewMap = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var mapDivId = map.getTarget();
        var _this = this;

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        var layers = BKGWebMap.CONTROLS.tools.overviewMap.layers;
        if (options.layers instanceof Array) {
            layers = options.layers;
        }

        var collapsible = BKGWebMap.CONTROLS.tools.overviewMap.collapsible;
        if (typeof options.collapsible === 'boolean') {
            collapsible = options.collapsible;
        }

        var collapsed = BKGWebMap.CONTROLS.tools.overviewMap.collapsed;
        if (typeof options.collapsed === 'boolean') {
            collapsed = options.collapsed;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (typeof options.onlyFullScreen === 'boolean' && options.onlyFullScreen === true) {
            this.onlyFullScreen = true;
        }

        var onlyFullScreenClass = '';
        if (this.onlyFullScreen) {
            onlyFullScreenClass = ' bkgwebmap-onlyfullscreen ';
        }

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.scalebar.position;
            }
        }

        var overviewMap = document.createElement('div');

        var label = '\u00BB';
        var collapseLabel = '\u00AB';

        var standardPositionClass = '';
        if (position !== undefined) {
            if (standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                standardPositionClass = ' bkgwebmap-standardpositioncontrol bkgwebmap-standardpositioncontrol' + rightLeft;
                if (rightLeft === 'right') {
                    label = '\u00AB';
                    collapseLabel = '\u00BB';
                }
            } else if (cssPosition) {
                for (var prop in position) {
                    overviewMap.style.position = 'absolute';
                    overviewMap.style[prop] = position[prop];
                }
            } else {
                return undefined;
            }
        }

        // Custom class
        var customClass = ' ';
        if (options.style && options.style !== '') {
            customClass = ' ' + options.style;
        }

        // Activate ol.control.OverviewMap with layers defined by user
        this.activateOverviewMap = function () {
            var layersToUse = [];

            map.getLayers().forEach(function (layer) {
                if (layer.getProperties().id && layers.indexOf(layer.getProperties().id) !== -1) {
                    layersToUse.push(layer);
                }
                if (layer instanceof ol.layer.Group) {
                    layer.getLayers().forEach(function (layerInGroup) {
                        if (layerInGroup.getProperties().id && layers.indexOf(layerInGroup.getProperties().id) !== -1) {
                            layersToUse.push(layerInGroup);
                        }
                    });
                }
            });

            if (!layersToUse.length) {
                map.getLayers().forEach(function (layer) {
                    if ((layer instanceof BKGWebMap.Layer.ImageWMS || layer instanceof BKGWebMap.Layer.TileWMS) && (layer.getTimeInfo() !== undefined && Object.keys(layer.getTimeInfo()).length)) {
                        return;
                    } else if (layer instanceof ol.layer.Group) {
                        layer.getLayers().forEach(function (layerInGroup) {
                            if ((layerInGroup instanceof BKGWebMap.Layer.ImageWMS || layer instanceof BKGWebMap.Layer.TileWMS) && (layerInGroup.getTimeInfo() !== undefined && Object.keys(layerInGroup.getTimeInfo()).length)) {
                                return;
                            } else {
                                layersToUse.push(layerInGroup);
                            }
                        });
                    } else {
                        layersToUse.push(layer);
                    }
                });
            }

            _this.om = new ol.control.OverviewMap({
                className: 'ol-overviewmap bkgwebmap-overviewmap' + onlyFullScreenClass + customClass + standardPositionClass + ' ',
                target: overviewMap,
                collapsed: collapsed,
                collapsible: collapsible,
                collapseLabel: collapseLabel,
                label: label,
                layers: layersToUse,
                view: new ol.View({
                    projection: map.getView().getProjection().getCode()
                }),
                tipLabel: 'Übersichtskarte'
            });
            _this.om.setMap(map);
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: overviewMap,
            target: target
        });
    };
};

/**
 * Create timeSlider Control
 * @type function
 * @returns {function} See parameters of return function in {@link BKGWebMap.Control.FACTORIES.timeSlider}
 */
BKGWebMap.Control.createTimeSlider = function () {
    return function (map, controlName, options, panel, standardPositionControls) {
        var mapDivId = map.getTarget();
        var layerInfo = {};

        // Check if control should be created
        if (options.active === false) {
            return undefined;
        }

        // Find div ID for control
        var target;
        if (options.div && options.div !== '') {
            target = options.div;
        }
        var position;
        var cssPosition = false;

        if (target === undefined) {
            if (typeof options.position === 'string' && BKGWebMap.STANDARD_POSITION.indexOf(options.position) !== -1) {
                position = options.position;
            } else if (typeof options.position === 'string' && options.position.match(/top|left|bottom|right/)) {
                cssPosition = true;
                position = BKGWebMap.Util.cssParser(options.position);
            } else {
                position = BKGWebMap.CONTROLS.tools.timeSlider.position;
            }
        }

        var timeSlider = document.createElement('div');
        timeSlider.className = 'bkgwebmap-timeslider ol-unselectable ol-control';

        var tooltipExtraClass = ' bkgwebmap-tooltipinmaptext';
        var mapDivMiddle = document.getElementById(mapDivId).offsetWidth / 2;

        if (position !== undefined) {
            if (!cssPosition && standardPositionControls[position]) {
                var targetClass = standardPositionControls[position].getClass();
                target = document.getElementById(mapDivId).getElementsByClassName(targetClass)[0];
                var rightLeft = position.split('-')[1];
                timeSlider.classList.add('bkgwebmap-standardpositioncontrol', 'bkgwebmap-standardpositioncontrol' + rightLeft);
                if (rightLeft === 'right') {
                    tooltipExtraClass = ' bkgwebmap-tooltiptimesliderright';
                }
            } else if (cssPosition) {
                for (var prop in position) {
                    if (prop === 'left' && parseInt(position.left, 10) > mapDivMiddle) {
                        timeSlider.style.right = document.getElementById(mapDivId).offsetWidth - parseInt(position.left, 10) + 'px';
                    } else {
                        timeSlider.style[prop] = position[prop];
                    }
                }
            } else {
                return undefined;
            }
        }
        // Custom class
        var customClass = '';
        if (options.style && options.style !== '') {
            customClass = options.style;
            timeSlider.classList.add(customClass);
        }

        // Create DOM
        var timeSliderButton = document.createElement('button');
        timeSliderButton.className = 'bkgwebmap-mapbutton bkgwebmap-timesliderbutton bkgwebmap-paneltooltip';
        if (position === 'bottom-right' || position === 'top-right' || (cssPosition && parseInt(position.left, 10) > mapDivMiddle) || (cssPosition && parseInt(position.right, 10) < mapDivMiddle)) {
            timeSliderButton.style.float = 'right';
        } else {
            timeSliderButton.style.float = 'left';
        }

        var parser = new DOMParser();
        var newIcon = parser.parseFromString(BKGWebMap.PANEL_ICONS.TIMESLIDER, 'text/xml');
        timeSliderButton.appendChild(newIcon.documentElement);

        var timeSliderTooltip = document.createElement('span');
        timeSliderTooltip.className = 'bkgwebmap-paneltooltiptext bkgwebmap-tooltiptimeslider' + tooltipExtraClass;
        timeSliderTooltip.innerHTML = 'Zeitschieberegler';
        timeSliderButton.appendChild(timeSliderTooltip);

        var timeSliderSelect = document.createElement('select');
        timeSliderSelect.className = 'bkgwebmap-timesliderselect';
        var timeSliderSelectDiv = document.createElement('div');
        timeSliderSelectDiv.className = 'bkgwebmap-timesliderselectdiv';

        timeSliderSelectDiv.appendChild(timeSliderSelect);

        var timeSliderInput = document.createElement('input');
        timeSliderInput.setAttribute('type', 'range');
        timeSliderInput.className = 'bkgwebmap-timesliderinput';

        var timeSliderSingleInput = document.createElement('div');
        timeSliderSingleInput.className = 'bkgwebmap-timeslidersingleinput';
        timeSliderSingleInput.appendChild(timeSliderInput);

        var timeSliderOutput = document.createElement('output');
        timeSliderOutput.className = 'bkgwebmap-timeslidervalue';

        var timeSliderOutputDiv = document.createElement('div');
        timeSliderOutputDiv.className = 'bkgwebmap-timeslideroutputdiv';
        timeSliderOutputDiv.appendChild(timeSliderOutput);

        var timeSliderSpinner = document.createElement('a');
        timeSliderSpinner.className = 'bkgwebmap-timesliderspinner';
        timeSliderSpinner.setAttribute('href', 'javascript:void(0)');

        var timeSliderInputDiv = document.createElement('div');
        timeSliderInputDiv.className = 'bkgwebmap-timesliderinputdiv';

        timeSliderInputDiv.appendChild(timeSliderSingleInput);
        timeSliderInputDiv.appendChild(timeSliderOutputDiv);

        var timeSliderPeriodDiv = document.createElement('div');
        timeSliderPeriodDiv.className = 'bkgwebmap-timesliderperioddiv';

        var timeSliderPeriodInput = document.createElement('input');
        timeSliderPeriodInput.type = 'checkbox';
        timeSliderPeriodInput.className = 'bkgwebmap-timesliderperiod';

        var timeSliderLabelPeriod = document.createElement('label');
        timeSliderLabelPeriod.innerHTML = 'Zeitintervall';

        timeSliderPeriodDiv.appendChild(timeSliderPeriodInput);
        timeSliderPeriodDiv.appendChild(timeSliderLabelPeriod);

        var timeSliderDiv = document.createElement('div');
        timeSliderDiv.className = 'bkgwebmap-timesliderdiv';
        timeSliderDiv.style.display = 'none';

        timeSliderDiv.appendChild(timeSliderPeriodDiv);
        timeSliderDiv.appendChild(timeSliderInputDiv);
        timeSliderDiv.appendChild(timeSliderSelectDiv);

        timeSlider.appendChild(timeSliderButton);
        timeSlider.appendChild(timeSliderDiv);

        var timeSliderMultipleInputDiv = document.createElement('div');
        timeSliderMultipleInputDiv.className = 'bkgwebmap-timeslidermultiplediv';

        var timeSliderMultipleInput = document.createElement('div');
        timeSliderMultipleInput.className = 'bkgwebmap-timeslidermultiple';

        var timeSliderHandle = document.createElement('div');
        timeSliderHandle.className = 'bkgwebmap-timesliderhandle';

        var timeSliderFill = document.createElement('div');
        timeSliderFill.className = 'bkgwebmap-timesliderfill';

        timeSliderPeriodInput.addEventListener('change', function () {
            var layerId = timeSliderSelect.value;
            var periodInput = this.checked;
            initTimeSlider(layerId, periodInput);
        });

        timeSliderSelect.addEventListener('change', function () {
            var layerId = timeSliderSelect.value;
            var periodInput = layerInfo[layerId].period;
            initTimeSlider(layerId, periodInput);
        });

        var timeSliderModes = ['period', 'time', 'all'];

        this.addLayerInTimeSlider = function (layer) {
            if (layer instanceof BKGWebMap.Layer.ImageWMS || layer instanceof BKGWebMap.Layer.TileWMS) {
                var timeInfo = layer.getTimeInfo();
                var layerId = layer.get('uniqueId');
                var config = layer.getProperties().originalConfig;
                var optionTimeSlider;
                var initPeriod;
                var initFormat;
                // Timeslider mode by default is 'all'
                var initMode = 'all';
                if ((timeInfo && Object.keys(timeInfo).length) || (config.time && config.time.active && config.time.values)) {
                    // Collect layer info and add to select menu
                    optionTimeSlider = document.createElement('option');
                    optionTimeSlider.value = layerId;
                    optionTimeSlider.innerHTML = layer.get('name');
                    timeSliderSelect.appendChild(optionTimeSlider);
                    timeSliderSelect.value = layerId;
                    layerInfo[layerId] = {};
                    if (config && config.time) {
                        if (config.time.mode && timeSliderModes.indexOf(config.time.mode) !== -1) {
                            initMode = config.time.mode;
                        }
                        if ((config.time.default && initMode !== 'time' && config.time.default.indexOf('/') !== -1) || initMode === 'period') {
                            initPeriod = true;
                        }
                        if (config.time.format && (config.time.format.indexOf('yy') !== -1 || config.time.format.indexOf('mm') !== -1 || config.time.format.indexOf('dd') !== -1)) {
                            initFormat = config.time.format;
                        }
                    }
                    layerInfo[layerId].mode = initMode;
                    layerInfo[layerId].period = initPeriod;
                    layerInfo[layerId].format = initFormat;

                    initTimeSlider(layerId, initPeriod);
                }
            }
        };

        var widthSlider;
        var widthStep;
        var multipleSlider = {};
        var wmsLayer;
        var singleSliderDiv;
        var singleOutputDiv;
        var singleSlider;
        var singleOutput;
        var minOutput;
        var maxOutput;
        var plusSpinner;
        var minusSpinner;

        function initTimeSlider(layerId, periodInput) {
            var inputDiv;
            var multipleOutputDiv;
            var mode = layerInfo[layerId].mode;
            if (position !== undefined) {
                inputDiv = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-timesliderinputdiv')[0];
            } else if (document.getElementById(target) && document.getElementById(target).getElementsByClassName('bkgwebmap-timesliderinputdiv').length) {
                inputDiv = document.getElementById(target).getElementsByClassName('bkgwebmap-timesliderinputdiv')[0];
            } else {
                return;
            }
            // create DOM timeslider elements
            inputDiv.innerHTML = '';
            if (periodInput && mode !== 'time') {
                if (!timeSliderPeriodInput.checked || timeSliderPeriodInput.disabled) {
                    timeSliderPeriodInput.disabled = false;
                    timeSliderPeriodInput.checked = true;
                }
                timeSliderPeriodInput.disabled = mode === 'period';

                multipleSlider.input = timeSliderMultipleInput.cloneNode(false);
                multipleSlider.leftHandle = timeSliderHandle.cloneNode(false);
                multipleSlider.leftHandle.classList.add('bkgwebmap-timesliderlefthandle');
                multipleSlider.rightHandle = timeSliderHandle.cloneNode(false);
                multipleSlider.rightHandle.classList.add('bkgwebmap-timesliderrighthandle');
                multipleSlider.fill = timeSliderFill.cloneNode(false);
                multipleSlider.input.appendChild(multipleSlider.leftHandle);
                multipleSlider.input.appendChild(multipleSlider.rightHandle);
                multipleSlider.input.appendChild(multipleSlider.fill);
                inputDiv.appendChild(timeSliderMultipleInputDiv.cloneNode(false));
                inputDiv.firstChild.appendChild(multipleSlider.input);

                multipleOutputDiv = timeSliderOutputDiv.cloneNode(false);
                inputDiv.appendChild(multipleOutputDiv);
            } else {
                timeSliderPeriodInput.disabled = mode === 'time';
                if (timeSliderPeriodInput.checked) {
                    timeSliderPeriodInput.checked = false;
                }
                singleSliderDiv = timeSliderSingleInput.cloneNode(false);
                singleSliderDiv.appendChild(timeSliderInput.cloneNode(false));
                singleOutputDiv = timeSliderOutputDiv.cloneNode(false);
                singleSlider = singleSliderDiv.childNodes[0];
                inputDiv.appendChild(singleSliderDiv);
                inputDiv.appendChild(singleOutputDiv);
            }
            // get layer lime info and adjust timeslider
            map.getLayers().forEach(function (layer) {
                if (layer instanceof ol.layer.Group) {
                    layer.getLayers().forEach(function (grouplayer) {
                        if ((grouplayer instanceof BKGWebMap.Layer.ImageWMS || grouplayer instanceof BKGWebMap.Layer.TileWMS) && grouplayer.get('uniqueId') === layerId) {
                            wmsLayer = grouplayer;
                        }
                    });
                } else if ((layer instanceof BKGWebMap.Layer.ImageWMS || layer instanceof BKGWebMap.Layer.TileWMS) && layer.get('uniqueId') === layerId) {
                    wmsLayer = layer;
                }
            });
            if (wmsLayer === undefined) {
                return;
            }
            var config = wmsLayer.getProperties().originalConfig;
            var timeInfo = wmsLayer.getTimeInfo();
            var defaultValue;
            var valuesArray = !layerInfo[layerId].values ? parseTimeInfo(wmsLayer) : layerInfo[layerId].values;
            widthSlider = 200;
            widthStep = widthSlider / (valuesArray.length - 1);

            // create standart timeslider, if number of values < 50
            if (valuesArray.length <= 50) {
                widthStep = Math.floor(200 / (valuesArray.length - 1));
                if (widthStep < 2) {
                    widthStep = 2;
                }
                widthSlider = widthStep * (valuesArray.length - 1);
                timeSliderInputDiv.style.width = widthSlider + 'px';
            }

            if (!periodInput) {
                singleSlider.style.width = widthSlider + 'px';
                singleSlider.setAttribute('min', '0');
                singleSlider.setAttribute('max', valuesArray.length - 1);
                singleSlider.setAttribute('step', '1');
                if (layerInfo[wmsLayer.get('uniqueId')].lastValue && !layerInfo[wmsLayer.get('uniqueId')].period) {
                    singleSlider.value = layerInfo[wmsLayer.get('uniqueId')].lastValue;
                } else if (config.time.default && config.time.default.indexOf('/') === -1) {
                    defaultValue = new Date(config.time.default);
                    if (valuesArray.indexOf(defaultValue.getTime()) !== -1) {
                        singleSlider.value = valuesArray.indexOf(defaultValue.getTime());
                    }
                } else if (!config.time.default && timeInfo && timeInfo.default) {
                    defaultValue = new Date(timeInfo.default);
                    if (valuesArray.indexOf(defaultValue.getTime()) !== -1) {
                        singleSlider.value = valuesArray.indexOf(defaultValue.getTime());
                    }
                } else {
                    singleSlider.value = 0;
                }
                if (valuesArray.length <= 50) {
                    // output
                    singleOutputDiv.appendChild(timeSliderOutput.cloneNode(false));
                    singleOutput = singleOutputDiv.childNodes[0];
                    // input styles
                    singleSlider.style.background = '-webkit-repeating-linear-gradient(0deg, #fff, #fff 1px, transparent 1px, transparent ' + widthStep + 'px) no-repeat 0px 50%';
                    singleSlider.style.background = '-moz-repeating-linear-gradient(0deg, #fff, #fff 1px, transparent 1px, transparent ' + widthStep + 'px) no-repeat 0px 50%';
                    singleSlider.style.background = 'repeating-linear-gradient(90deg, #fff, #fff 1px, transparent 1px, transparent ' + widthStep + 'px) no-repeat 0px 50%;';
                    singleSlider.style.backgroundSize = widthSlider + 'px 15px';
                } else {
                    // singleOutput = timeSliderOutputDiv.cloneNode(false);
                    singleOutput = editableOutput(singleOutputDiv);
                    // inputDiv.appendChild(singleOutputDiv);
                    singleOutput.ondblclick = editOutput;
                }
                updateParams(false);
                // Event listner
                singleSlider.addEventListener('input', updateParams, { passive: true });
                // IE
                singleSlider.addEventListener('change', updateParams, { passive: true });
            } else {
                multipleSlider.input.style.width = widthSlider + 'px';
                if (valuesArray.length <= 50) {
                    // output
                    minOutput = timeSliderOutput.cloneNode(false);
                    minOutput.classList.add('bkgwebmap-timesliderminvalue');
                    maxOutput = timeSliderOutput.cloneNode(false);
                    maxOutput.classList.add('bkgwebmap-timeslidermaxvalue');
                    multipleOutputDiv.appendChild(maxOutput);
                    multipleOutputDiv.appendChild(minOutput);
                    multipleSlider.input.style.background = '-webkit-repeating-linear-gradient(0deg, #fff, #fff 1px, transparent 1px, transparent ' + widthStep + 'px) no-repeat 0px 50%';
                    multipleSlider.input.style.background = '-moz-repeating-linear-gradient(0deg, #fff, #fff 1px, transparent 1px, transparent ' + widthStep + 'px) no-repeat 0px 50%';
                    multipleSlider.input.style.background = 'repeating-linear-gradient(90deg, #fff, #fff 1px, transparent 1px, transparent ' + widthStep + 'px) no-repeat 0px 50%;';
                    multipleSlider.input.style.backgroundSize = widthSlider + 'px 15px';
                } else {
                    minOutput = editableOutput(multipleOutputDiv, 'bkgwebmap-timesliderminvalue');
                    maxOutput = editableOutput(multipleOutputDiv, 'bkgwebmap-timeslidermaxvalue');
                    minOutput.ondblclick = editOutput;
                    maxOutput.ondblclick = editOutput;
                }
                multipleSlider.max = valuesArray.length - 1;
                multipleSlider.min = 0;
                multipleSlider.leftHandle.style.left = '0%';
                multipleSlider.leftHandle.style.marginLeft = '-' + (multipleSlider.leftHandle.offsetWidth / 2) + 'px';
                multipleSlider.rightHandle.style.right = '50%';
                multipleSlider.rightHandle.style.marginRight = '-' + (multipleSlider.rightHandle.offsetWidth / 2) + 'px';
                multipleSlider.position = {};
                if (layerInfo[wmsLayer.get('uniqueId')].lastValue && layerInfo[wmsLayer.get('uniqueId')].period) {
                    multipleSlider.position.left = layerInfo[wmsLayer.get('uniqueId')].lastValue[0];
                    multipleSlider.position.right = layerInfo[wmsLayer.get('uniqueId')].lastValue[1];
                } else if (config.time.default && config.time.default.indexOf('/') !== -1) {
                    var defaultValueMin = new Date(config.time.default.substr(0, config.time.default.indexOf('/')));
                    multipleSlider.position.left = valuesArray.indexOf(defaultValueMin.getTime()) !== -1 && valuesArray.indexOf(defaultValueMin.getTime()) < valuesArray.length - 1 ? valuesArray.indexOf(defaultValueMin.getTime()) : 0;
                    var defaultValueMax = new Date(config.time.default.substr(config.time.default.indexOf('/') + 1, config.time.default.length - 1));
                    multipleSlider.position.right = valuesArray.indexOf(defaultValueMax.getTime()) !== -1 && defaultValueMax > defaultValueMin ? valuesArray.indexOf(defaultValueMax.getTime()) : valuesArray.length - 1;
                } else {
                    multipleSlider.position.left = 0;
                    multipleSlider.position.right = valuesArray.length - 1;
                }
                moveElements(multipleSlider.position, wmsLayer);
                // Event listner
                multipleSlider.leftHandle.onmousedown = startEvent;
                multipleSlider.leftHandle.ontouchstart = startEvent;
                multipleSlider.rightHandle.onmousedown = startEvent;
                multipleSlider.rightHandle.ontouchstart = startEvent;
                multipleSlider.input.onclick = adjustMultipleSlider;
            }
        }

        function editableOutput(outputDiv, className) {
            var outputWrapper = document.createElement('div');
            outputWrapper.className = 'bkgwebmap-timeslidervalue';
            if (className) {
                outputWrapper.classList.add(className);
            }
            var output = timeSliderOutput.cloneNode(false);
            output.classList.remove('bkgwebmap-timeslidervalue');

            minusSpinner = timeSliderSpinner.cloneNode(false);
            minusSpinner.classList.add('down');
            minusSpinner.innerHTML = '-';

            plusSpinner = timeSliderSpinner.cloneNode(false);
            plusSpinner.classList.add('up');
            plusSpinner.innerHTML = '+';

            outputWrapper.appendChild(minusSpinner);
            outputWrapper.appendChild(output);
            outputWrapper.appendChild(plusSpinner);

            outputDiv.appendChild(outputWrapper);

            minusSpinner.addEventListener('click', function (event) {
                changeValue(event.target.parentNode, event.target);
            });
            plusSpinner.addEventListener('click', function (event) {
                changeValue(event.target.parentNode, event.target);
            });
            return output;
        }

        function changeValue(slider, spinner, value) {
            var newValue;
            var params = layerInfo[wmsLayer.get('uniqueId')];
            if (slider.classList.contains('bkgwebmap-timesliderminvalue') || slider.classList.contains('bkgwebmap-timeslidermaxvalue')) {
                if (slider.classList.contains('bkgwebmap-timesliderminvalue')) {
                    if (spinner && spinner.classList.contains('up')) {
                        newValue = params.lastValue[0] + 1;
                    } else if (spinner && spinner.classList.contains('down')) {
                        newValue = params.lastValue[0] - 1;
                    } else {
                        newValue = value;
                    }
                    if (newValue < multipleSlider.position.right && newValue >= 0) {
                        multipleSlider.position.left = newValue;
                    }
                } else if (slider.classList.contains('bkgwebmap-timeslidermaxvalue')) {
                    if (spinner && spinner.classList.contains('up')) {
                        newValue = params.lastValue[1] + 1;
                    } else if (spinner && spinner.classList.contains('down')) {
                        newValue = params.lastValue[1] - 1;
                    } else {
                        newValue = value;
                    }
                    if (newValue > multipleSlider.position.left && newValue <= params.values.length - 1) {
                        multipleSlider.position.right = newValue;
                    }
                }
                moveElements(multipleSlider.position, wmsLayer);
            } else {
                if (spinner && spinner.classList.contains('up')) {
                    newValue = parseInt(singleSlider.value, 10) + 1;
                } else if (spinner && spinner.classList.contains('down')) {
                    newValue = parseInt(singleSlider.value, 10) - 1;
                } else {
                    newValue = value;
                }
                if (newValue >= 0 && newValue <= params.values.length - 1) {
                    singleSlider.value = newValue;
                    var evt = document.createEvent('HTMLEvents');
                    evt.initEvent('change', false, true);
                    singleSlider.dispatchEvent(evt);
                }
            }
        }

        // Get values from capabilities or config
        function parseTimeInfo(layer) {
            var defaultValues;
            var valuesArray;
            var config = layer.getProperties().originalConfig;
            var capabilitiesInfo = layer.getTimeInfo();
            var layerId = layer.get('uniqueId');
            if (capabilitiesInfo) {
                layer.getLayers().forEach(function (sublayer) {
                    for (var prop in capabilitiesInfo) {
                        if (prop === sublayer.layer) {
                            defaultValues = config.time.values ? config.time.values : capabilitiesInfo[prop].values;
                        }
                    }
                });
            } else {
                defaultValues = config.time.values;
            }
            valuesArray = getArray(defaultValues);
            layerInfo[layerId].values = valuesArray;
            return valuesArray;
        }

        function getArray(values) {
            var valuesArray = [];
            var minTime;
            var maxTime;
            var minTimeISO;
            var maxTimeISO;
            var timeResolution;
            var period;
            var i;
            var valuesArrayDefault;
            if (values.indexOf(',') !== -1) {
                singleSlider.value = 0;
                valuesArrayDefault = values.split(',');
                for (i = 0; i < valuesArrayDefault.length; i++) {
                    var dateISO = new Date(valuesArrayDefault[i]);
                    valuesArray[i] = dateISO.getTime();
                }
            } else if (values.indexOf('/') !== -1) {
                valuesArrayDefault = values.split('/');

                if (valuesArrayDefault.length === 3) {
                    minTimeISO = new Date(valuesArrayDefault[0]);
                    maxTimeISO = new Date(valuesArrayDefault[1]);
                    minTime = minTimeISO.getTime();
                    maxTime = maxTimeISO.getTime();
                    timeResolution = valuesArrayDefault[2];
                    if (isNaN(minTimeISO.getDate()) || isNaN(maxTimeISO.getDate())) {
                        return;
                    }
                } else if (valuesArrayDefault.length === 2) {
                    minTimeISO = new Date(valuesArrayDefault[0]);
                    minTime = minTimeISO.getTime();
                    maxTime = minTime;
                    timeResolution = valuesArrayDefault[1];
                    if (isNaN(minTimeISO.getDate())) {
                        return;
                    }
                }
                period = parseTimePeriod(timeResolution);
                valuesArray[0] = minTime;
                if (minTime !== maxTime) {
                    i = 0;
                    var newValue = minTime;
                    while (newValue < maxTime) {
                        i++;
                        var startTime = new Date(valuesArrayDefault[0]);
                        if (period.years) {
                            startTime.setUTCFullYear(startTime.getUTCFullYear() + i * period.years);
                        }
                        if (period.months) {
                            startTime.setUTCMonth(startTime.getUTCMonth() + i * period.months);
                        }
                        newValue = startTime.getTime() + i * (period.weeks * 7 * 24 * 60 * 60 + period.days * 24 * 60 * 60 + period.hours * 60 * 60 + period.minutes * 60 + period.seconds) * 1000;
                        if (newValue <= maxTime) {
                            valuesArray.push(newValue);
                        }
                    }
                }
            }
            return valuesArray;
        }

        function updateParams(period, dataLeft, dataRight) {
            var valuesArray = layerInfo[wmsLayer.get('uniqueId')].values;
            var format = layerInfo[wmsLayer.get('uniqueId')].format;
            if (period && !(period instanceof Event)) {
                var minDate = new Date(valuesArray[dataLeft]);
                var maxDate = new Date(valuesArray[dataRight]);
                if (minDate !== undefined) {
                    minOutput.innerHTML = dateToString(minDate);
                    minOutput.setAttribute('timevalue', valuesArray[dataLeft]);
                    if (valuesArray.length <= 50) {
                        positioningInputsTooltip(minOutput, multipleSlider.leftHandle);
                    } else {
                        positioningInputsTooltip(minOutput.parentNode, multipleSlider.leftHandle);
                    }
                }
                if (maxDate !== undefined) {
                    maxOutput.innerHTML = dateToString(maxDate);
                    maxOutput.setAttribute('timevalue', valuesArray[dataRight]);
                    if (valuesArray.length <= 50) {
                        positioningInputsTooltip(maxOutput, multipleSlider.rightHandle);
                    } else {
                        positioningInputsTooltip(maxOutput.parentNode, multipleSlider.rightHandle);
                    }
                }
                if (minDate !== undefined && maxDate !== undefined) {
                    wmsLayer.getSource().updateParams({ TIME: dateToFormat(minDate.getTime(), format) + '/' + dateToFormat(maxDate.getTime(), format) });
                    layerInfo[wmsLayer.get('uniqueId')].period = true;
                    layerInfo[wmsLayer.get('uniqueId')].lastValue = [dataLeft, dataRight];
                }
            } else {
                var currentDate = new Date(valuesArray[parseInt(singleSlider.value, 10)]);
                wmsLayer.getSource().updateParams({ TIME: dateToFormat(currentDate.getTime(), format) });
                singleOutput.innerHTML = dateToString(currentDate);
                singleOutput.setAttribute('timevalue', valuesArray[parseInt(singleSlider.value, 10)]);
                if (valuesArray.length <= 50) {
                    positioningInputsTooltip(singleOutput, singleSlider);
                } else {
                    positioningInputsTooltip(singleOutput.parentNode, singleSlider);
                }
                layerInfo[wmsLayer.get('uniqueId')].period = false;
                layerInfo[wmsLayer.get('uniqueId')].lastValue = singleSlider.value;
            }
        }

        function dateToFormat(date, format) {
            var formatDate = new Date(date);
            if (format) {
                if (format.indexOf('yyyy') > -1) {
                    format = format.replace('yyyy', formatDate.getUTCFullYear());
                } else if (format.indexOf('yy') > -1) {
                    format = format.replace('yy', formatDate.getUTCFullYear().slice(-2));
                }
                if (format.indexOf('mm')) {
                    format = format.replace('mm', formatDate.getUTCMonth());
                }
                if (format.indexOf('dd')) {
                    format = format.replace('dd', formatDate.getUTCDate());
                }
                formatDate = format;
            } else {
                formatDate = formatDate.toISOString();
            }
            return formatDate;
        }

        function editOutput(event) {
            var output = event.target;
            var timeValue = output.getAttribute('timevalue');
            var oldTime = new Date(parseInt(timeValue, 10));
            var wrapper = output.parentNode;

            for (var i = 0; i < wrapper.childNodes.length; i++) {
                wrapper.childNodes[i].style.display = 'none';
            }

            var input = document.createElement('input');
            input.className = 'bkgwebmap-timeslidereditinput';
            input.setAttribute('type', 'text');
            if (layerInfo[wmsLayer.get('uniqueId')].tooltipMode && layerInfo[wmsLayer.get('uniqueId')].tooltipMode === 'time') {
                input.value = oldTime.toISOString();
            } else {
                input.value = dateToString(oldTime);
            }
            wrapper.appendChild(input);
            input.focus();
            input.addEventListener('blur', function () {
                wrapper.removeChild(input);
                for (var i = 0; i < wrapper.childNodes.length; i++) {
                    wrapper.childNodes[i].style.display = 'inline-block';
                }
            });
            input.addEventListener('keydown', function (event) {
                if (event.key && event.key === 'Enter') {
                    var date;
                    if (layerInfo[wmsLayer.get('uniqueId')].tooltipMode && layerInfo[wmsLayer.get('uniqueId')].tooltipMode === 'time') {
                        date = new Date(input.value);
                    } else {
                        date = stringToDate(input.value, oldTime);
                    }
                    var time = date.getTime();
                    if (!isNaN(date.getDate()) && layerInfo[wmsLayer.get('uniqueId')].values.indexOf(time) !== -1) {
                        changeValue(wrapper, false, layerInfo[wmsLayer.get('uniqueId')].values.indexOf(time));
                    }
                    input.blur();
                }
            });
        }

        function dateToString(date) {
            var string;
            if (layerInfo[wmsLayer.get('uniqueId')].tooltipMode && layerInfo[wmsLayer.get('uniqueId')].tooltipMode === 'time') {
                string = date.toLocaleString();
            } else {
                string = date.getDate() + '.' + (date.getUTCMonth() + 1) + '.' + date.getUTCFullYear();
            }
            return string;
        }

        function stringToDate(str, date) {
            var dateArray = str.split('.');
            var newDate = new Date(date);
            newDate.setUTCFullYear(parseInt(dateArray[2], 10));
            newDate.setUTCMonth(parseInt((dateArray[1] - 1), 10));
            newDate.setUTCDate(parseInt(dateArray[0], 10));
            return newDate;
        }

        function adjustMultipleSlider(event) {
            event.preventDefault();
            var sliderLeft = multipleSlider.input.getBoundingClientRect().left;
            var sliderRight = multipleSlider.input.getBoundingClientRect().right;
            var posLeftHandle = sliderLeft + parseFloat(multipleSlider.fill.style.left);
            var posRightHandle = sliderRight - parseFloat(multipleSlider.fill.style.right);

            if (event.clientX > sliderLeft && (event.clientX < posLeftHandle || event.clientX < (posLeftHandle + (posRightHandle - posLeftHandle) / 2))) {
                multipleSlider.position.left = Math.round(parseFloat(event.clientX - sliderLeft) / widthStep);
            } else if (event.clientX < sliderRight && (event.clientX > posRightHandle || event.clientX > (posLeftHandle + (posRightHandle - posLeftHandle) / 2))) {
                multipleSlider.position.right = Math.round(parseFloat(event.clientX - sliderLeft) / widthStep);
            }
            moveElements(multipleSlider.position);
        }

        function moveElements(data) {
            if (typeof data === 'object') {
                if (data.left || data.left === 0) {
                    if (data.left > multipleSlider.max - 1) {
                        data.left = multipleSlider.max - 1;
                    }
                    var posLeft = data.left * widthStep;
                    multipleSlider.leftHandle.style.left = posLeft + 'px';
                    multipleSlider.fill.style.left = posLeft + 'px';
                }
                if (data.right) {
                    if (data.right < multipleSlider.min + 1) {
                        data.right = multipleSlider.min + 1;
                    }
                    var posRight = (multipleSlider.max - data.right) * widthStep;
                    multipleSlider.rightHandle.style.right = posRight + 'px';
                    multipleSlider.fill.style.right = posRight + 'px';
                }
            }
            updateParams(true, data.left, data.right);
        }

        function startEvent(event) {
            event.preventDefault();
            multipleSlider.dragObj = {};
            multipleSlider.dragObj.elNode = event.target;

            while (!multipleSlider.dragObj.elNode.classList.contains('bkgwebmap-timesliderhandle')) {
                multipleSlider.dragObj.elNode = multipleSlider.dragObj.elNode.parentNode;
            }
            // direction
            multipleSlider.dragObj.dir = multipleSlider.dragObj.elNode.classList.contains('bkgwebmap-timesliderlefthandle') ? 'left' : 'right';
            var x;
            var y;
            x = (typeof event.clientX !== 'undefined' ? event.clientX : event.touches[0].pageX) + (window.scrollX || window.pageXOffset);
            y = (typeof event.clientY !== 'undefined' ? event.clientY : event.touches[0].pageY) + (window.scrollY || window.pageYOffset);
            multipleSlider.dragObj.cursorStartX = x;
            multipleSlider.dragObj.cursorStartY = y;
            multipleSlider.dragObj.elStartLeft = parseFloat(multipleSlider.dragObj.elNode.style.left);
            multipleSlider.dragObj.elStartRight = parseFloat(multipleSlider.dragObj.elNode.style.right);
            if (isNaN(multipleSlider.dragObj.elStartLeft)) multipleSlider.dragObj.elStartLeft = 0;
            if (isNaN(multipleSlider.dragObj.elStartRight)) multipleSlider.dragObj.elStartRight = 0;
            document.addEventListener('mousemove', movingHandler, true);
            document.addEventListener('mouseup', stopHandler, true);
            document.addEventListener('touchmove', movingHandler, true);
            document.addEventListener('touchend', stopHandler, true);
        }

        function movingHandler(event) {
            event.preventDefault();
            var x = (typeof event.clientX !== 'undefined' ? event.clientX :
                event.touches[0].pageX) + (window.scrollX || window.pageXOffset);
            var calculatedVal = 0;
            if (multipleSlider.dragObj.dir === 'left') {
                calculatedVal = multipleSlider.dragObj.elStartLeft + (Math.round((x - multipleSlider.dragObj.cursorStartX) / widthStep) * widthStep);
            } else if (multipleSlider.dragObj.dir === 'right') {
                calculatedVal = multipleSlider.dragObj.elStartRight + (Math.round((multipleSlider.dragObj.cursorStartX - x) / widthStep) * widthStep);
            }
            if (calculatedVal < 0) {
                calculatedVal = 0;
            } else if (calculatedVal > widthSlider) {
                calculatedVal = widthSlider;
            }
            calculatedVal = Math.abs(calculatedVal);
            var remaining = 0;
            var handleOffset = multipleSlider.rightHandle.offsetWidth / 2;
            if (multipleSlider.dragObj.dir === 'left') {
                remaining = (widthSlider - handleOffset) - multipleSlider.fill.style.right.replace('px', '');
                if (remaining <= calculatedVal + widthStep) {
                    calculatedVal = remaining - widthStep;
                }
                multipleSlider.dragObj.elNode.style.left = calculatedVal + 'px';
                multipleSlider.fill.style.left = calculatedVal + 'px';
            } else {
                remaining = (widthSlider - handleOffset) - multipleSlider.fill.style.left.replace('px', '');
                if (remaining <= calculatedVal + widthStep) {
                    calculatedVal = remaining - widthStep;
                }

                multipleSlider.dragObj.elNode.style.right = calculatedVal + 'px';
                multipleSlider.fill.style.right = calculatedVal + 'px';
            }
            multipleSlider.position.left = Math.round(parseFloat(multipleSlider.fill.style.left) / widthStep);
            multipleSlider.position.right = Math.round((widthSlider - parseFloat(multipleSlider.fill.style.right)) / widthStep);
            updateParams(true, multipleSlider.position.left, multipleSlider.position.right);
        }

        function stopHandler(event) {
            event.preventDefault();
            document.removeEventListener('mousemove', movingHandler, true);
            document.removeEventListener('mouseup', stopHandler, true);
            document.removeEventListener('touchmove', movingHandler, true);
            document.removeEventListener('touchend', stopHandler, true);
        }

        function positioningInputsTooltip(output, input) {
            var single;
            var widthTooltip = output.offsetWidth ? output.offsetWidth : 60;
            if (!output.classList.contains('bkgwebmap-timesliderminvalue') && !output.classList.contains('bkgwebmap-timeslidermaxvalue')) {
                single = true;
            } else {
                single = false;
            }
            var newPlace;
            var newPoint;
            var wrapperWidth;
            var valuesArray = layerInfo[wmsLayer.get('uniqueId')].values;
            if (position !== undefined) {
                wrapperWidth = document.getElementById(mapDivId).getElementsByClassName('bkgwebmap-timesliderdiv')[0].offsetWidth;
            } else if (document.getElementById(target) && document.getElementById(target).getElementsByClassName('bkgwebmap-timesliderdiv').length) {
                wrapperWidth = document.getElementById(target).getElementsByClassName('bkgwebmap-timesliderdiv')[0].offsetWidth;
            } else {
                return;
            }
            if (single) {
                newPoint = parseInt((input.value), 10) / (valuesArray.length - 1);
            } else if (input.classList.contains('bkgwebmap-timesliderlefthandle')) {
                newPoint = input.style.left.replace('px', '') / widthSlider;
            } else {
                newPoint = (widthSlider - input.style.right.replace('px', '')) / widthSlider;
            }
            if (newPoint < 0) {
                newPlace = 0;
            } else if (newPoint > 1) {
                newPlace = widthSlider;
            } else {
                newPlace = widthSlider * newPoint;
            }
            if (layerInfo[wmsLayer.get('uniqueId')].tooltipMode && layerInfo[wmsLayer.get('uniqueId')].tooltipMode === 'time') {
                if (wrapperWidth > 260) {
                    output.style.left = newPlace + widthTooltip / 3 + 'px';
                } else {
                    output.style.left = newPlace + widthTooltip / 3 - 60 + 'px';
                }
            } else {
                output.style.left = newPlace + widthTooltip / 3 + 55 + 'px';
            }
        }

        function parseTimePeriod(timePeriod) {
            timePeriod = timePeriod.substr(1);
            var ymd;
            var hms;
            timePeriod = timePeriod.toLowerCase();
            if (timePeriod.indexOf('t') > -1) {
                ymd = timePeriod.substr(0, timePeriod.indexOf('t'));
                hms = timePeriod.substr(timePeriod.indexOf('t') + 1, timePeriod.length - 1);
            } else {
                ymd = timePeriod;
                hms = '';
            }

            var period = {};
            var arrayProperties = ['y', 'm', 'w', 'd', 'h', 'm', 's'];
            var arrayPeriod = ['years', 'months', 'weeks', 'days', 'hours', 'minutes', 'seconds'];
            var i;
            for (i = 0; i < 4; i++) {
                if (ymd.indexOf(arrayProperties[i]) > -1) {
                    period[arrayPeriod[i]] = ymd.substr(0, ymd.indexOf(arrayProperties[i]));
                    ymd = ymd.substr(ymd.indexOf(arrayProperties[i]) + 1);
                } else {
                    period[arrayPeriod[i]] = 0;
                }
            }
            for (i = 4; i < arrayProperties.length; i++) {
                if (hms.indexOf(arrayProperties[i]) > -1) {
                    period[arrayPeriod[i]] = hms.substr(0, hms.indexOf(arrayProperties[i]));
                    hms = hms.substr(hms.indexOf(arrayProperties[i]) + 1);
                } else {
                    period[arrayPeriod[i]] = 0;
                }
            }
            if (period.hours || period.minutes || period.seconds) {
                layerInfo[wmsLayer.get('uniqueId')].tooltipMode = 'time';
            } else {
                layerInfo[wmsLayer.get('uniqueId')].tooltipMode = 'days';
            }

            return period;
        }

        timeSliderButton.addEventListener('click', function () {
            var tooltips;
            var input;
            var targetElement;
            if (position !== undefined) {
                targetElement = document.getElementById(mapDivId);
            } else if (document.getElementById(target)) {
                targetElement = document.getElementById(target);
            }
            if (targetElement.getElementsByClassName('bkgwebmap-timesliderselect')[0].getElementsByTagName('option').length) {
                if (timeSliderDiv.style.display === 'none') {
                    timeSliderDiv.style.display = 'inline-block';
                    tooltips = targetElement.getElementsByClassName('bkgwebmap-timeslidervalue');
                    for (var i = 0; i < tooltips.length; i++) {
                        if (tooltips[i].classList.contains('bkgwebmap-timesliderminvalue')) {
                            input = targetElement.getElementsByClassName('bkgwebmap-timesliderlefthandle')[0];
                        } else if (tooltips[i].classList.contains('bkgwebmap-timeslidermaxvalue')) {
                            input = targetElement.getElementsByClassName('bkgwebmap-timesliderrighthandle')[0];
                        } else {
                            input = targetElement.getElementsByClassName('bkgwebmap-timesliderinput')[0];
                        }
                        positioningInputsTooltip(tooltips[i], input);
                    }
                } else {
                    timeSliderDiv.style.display = 'none';
                }
            }
        }, { passive: true });

        timeSliderButton.addEventListener('mouseenter', function () {
            var allTooltips = document.getElementsByClassName('bkgwebmap-paneltooltiptext');
            for (var i = 0; i < allTooltips.length; i++) {
                allTooltips[i].style.visibility = '';
            }
            timeSliderTooltip.style.visibility = 'visible';
            setTimeout(function () {
                timeSliderTooltip.style.visibility = '';
            }, 1200);
        }, false);

        // Finalize control
        ol.control.Control.call(this, {
            element: timeSlider,
            target: target
        });
    };
};

/**
 * Create Marker Control
 * @type function
 * @returns {function} See parameters of return function in {@link CONTROL_FACTORIES_marker}
 */
BKGWebMap.Control.createMarker = function () {
    return function (map) {
        var marker = document.createElement('div');
        marker.className = 'bkgwebmap-markercontrol ol-unselectable ol-control';
        var overlayMarkerId = BKGWebMap.Util.uniqueId();
        var parserMarkerIcon = new DOMParser();
        var markerColor = '#407e40';
        var markerIcon = BKGWebMap.MAP_ICONS.marker.a + markerColor + BKGWebMap.MAP_ICONS.marker.b + markerColor + BKGWebMap.MAP_ICONS.marker.c;
        var layerDownIcon = parserMarkerIcon.parseFromString(markerIcon, 'text/xml');
        var overlayMarker = new ol.Overlay({
            element: layerDownIcon.documentElement,
            offset: [0, 5],
            positioning: 'bottom-center',
            uniqueId: overlayMarkerId
        });
        var overlayPosition;

        this.setMarker = function (control, coord) {
            overlayPosition = overlayMarker.getPosition();
            if (!overlayPosition) {
                map.addOverlay(overlayMarker);
            }
            overlayMarker.setPosition(coord);
        };

        this.deleteMarker = function () {
            overlayPosition = overlayMarker.getPosition();
            if (overlayPosition) {
                map.removeOverlay(overlayMarker);
                overlayMarker.setPosition(null);
            }
        };

        // Finalize control
        ol.control.Control.call(this, {
            element: marker
        });
    };
};

/**
 * @namespace BKGWebMap.Style
 * @type {object}
 */
BKGWebMap.Style = BKGWebMap.Style || {};

/**
 * Create OpenLayer style to be used in vector layers
 * @param stylesArray - Array with configuration of styles
 * @return {object} - An object with OpenLayers style classes
 */
BKGWebMap.Style.createStyles = function (stylesArray) {
    var styles = {};
    var singleStyle;
    for (var i = 0; i < stylesArray.length; i++) {
        singleStyle = stylesArray[i];
        if (typeof singleStyle.name !== 'string' || singleStyle.name === '') {
            window.console.log(BKGWebMap.ERROR.missingStyleName + JSON.stringify(singleStyle));
            continue;
        }

        switch (singleStyle.type) {
        case 'symbol':
            if (typeof singleStyle.symbol !== 'string' || singleStyle.symbol === '') {
                window.console.log(BKGWebMap.ERROR.missingStyleSymbol + JSON.stringify(singleStyle));
                continue;
            } else if (!Object.prototype.hasOwnProperty.call(BKGWebMap.MAP_ICONS, singleStyle.symbol)) {
                window.console.log(BKGWebMap.ERROR.wrongStyleSymbol + JSON.stringify(singleStyle));
                continue;
            }
            styles[singleStyle.name] = BKGWebMap.Style.createSymbolStyle(singleStyle);
            break;
        case 'custom':
            styles[singleStyle.name] = BKGWebMap.Style.createCustomStyle(singleStyle);
            break;
        default:
            window.console.log(BKGWebMap.ERROR.wrongStyleType + JSON.stringify(singleStyle));
            continue;
        }
    }
    return styles;
};

/**
 * Create OpenLayers style class for symbol styles
 * @param {object} singleStyle - Configuration of style
 * @returns {object}
 */
BKGWebMap.Style.createSymbolStyle = function (singleStyle) {
    singleStyle.fillColor = BKGWebMap.Style.sanitizeColor(singleStyle.fillColor);
    singleStyle.strokeColor = BKGWebMap.Style.sanitizeColor(singleStyle.strokeColor);
    var svgFillColor = BKGWebMap.Style.svgColor(singleStyle.fillColor);
    var svgStrokeColor = BKGWebMap.Style.svgColor(singleStyle.strokeColor);
    var symbol = BKGWebMap.MAP_ICONS_ENCODED[singleStyle.symbol].a + svgFillColor + BKGWebMap.MAP_ICONS_ENCODED[singleStyle.symbol].b + svgStrokeColor + BKGWebMap.MAP_ICONS_ENCODED[singleStyle.symbol].c;
    var anchor = [0.5, 0.5];
    if (singleStyle.symbol === 'marker') {
        anchor = [0.5, 1];
    }

    var style = new ol.style.Style({
        fill: new ol.style.Fill({
            color: singleStyle.fillColor
        }),
        stroke: new ol.style.Stroke({
            color: singleStyle.strokeColor,
            width: 1
        }),
        image: new ol.style.Icon(({
            anchor: anchor,
            anchorXUnits: 'fraction',
            anchorYUnits: 'fraction',
            imgSize: BKGWebMap.MAP_ICONS_ENCODED[singleStyle.symbol].size,
            src: 'data:image/svg+xml;charset=utf8,' + symbol
        }))
    });
    style.getImage().anchor = anchor;
    return style;
};

/**
 * Use OpenLayers style class for custom styles
 * @param singleStyle - Configuration of style
 * @returns {string}
 */
BKGWebMap.Style.createCustomStyle = function (singleStyle) {
    var fill = BKGWebMap.Style.fill(singleStyle.fill);
    var stroke = BKGWebMap.Style.stroke(singleStyle.stroke);

    // Image
    // If user has defined multiple Image classes, then this reading order will be used:
    // regularShape -> icon -> circle
    var image;
    if (typeof singleStyle.image === 'object' && singleStyle.image.constructor === Object) {
        // Regular shape
        if (singleStyle.image.regularShape && singleStyle.image.regularShape) {
            if (singleStyle.image.regularShape instanceof ol.style.RegularShape) {
                image = singleStyle.image.regularShape;
            } else if (typeof singleStyle.image.regularShape === 'object' && singleStyle.image.regularShape.constructor === Object) {
                singleStyle.image.regularShape.fill = BKGWebMap.Style.fill(singleStyle.image.regularShape.fill);
                singleStyle.image.regularShape.stroke = BKGWebMap.Style.stroke(singleStyle.image.regularShape.stroke);
                image = new ol.style.RegularShape(singleStyle.image.regularShape);
            }
        }

        // Icon
        if (singleStyle.image.icon && singleStyle.image.icon) {
            if (singleStyle.image.icon instanceof ol.style.Icon) {
                image = singleStyle.image.icon;
            } else if (typeof singleStyle.image.icon === 'object' && singleStyle.image.icon.constructor === Object) {
                image = new ol.style.Icon(singleStyle.image.icon);
            }
        }

        // Circle
        if (singleStyle.image.circle && singleStyle.image.circle) {
            if (singleStyle.image.circle instanceof ol.style.Circle) {
                image = singleStyle.image.circle;
            } else if (typeof singleStyle.image.circle === 'object' && singleStyle.image.circle.constructor === Object) {
                singleStyle.image.circle.fill = BKGWebMap.Style.fill(singleStyle.image.circle.fill);
                singleStyle.image.circle.stroke = BKGWebMap.Style.stroke(singleStyle.image.circle.stroke);
                image = new ol.style.Circle(singleStyle.image.circle);
            }
        }
    }


    var style = new ol.style.Style({
        fill: fill,
        stroke: stroke,
        image: image
    });
    return style;
};

/**
 * Be sure to have # in HEX string
 * @param {string} color - Color HEX
 * @returns {string}
 */
BKGWebMap.Style.sanitizeColor = function (color) {
    if (color && color.slice(0, 1) !== '#') {
        color = '#' + color;
    }
    return color;
};

/**
 * Replace # with %23 for svg color. # in URI body is deprecated
 * @param {string} color - Color HEX
 * @returns {string}
 */
BKGWebMap.Style.svgColor = function (color) {
    color = color.replace('#', '%23');
    return color;
};

/**
 * Use ol.style.Fill class
 * @param {object|undefined} singleStyleFill - ol.style.Fill
 * @returns {object|undefined}
 */
BKGWebMap.Style.fill = function (singleStyleFill) {
    var fill;
    if (singleStyleFill instanceof ol.style.Fill) {
        fill = singleStyleFill;
    } else if (typeof singleStyleFill === 'object' && singleStyleFill.constructor === Object) {
        fill = new ol.style.Fill(singleStyleFill);
    }
    return fill;
};

/**
 * Use ol.style.Stroke class
 * @param {object|undefined} singleStyleStroke - ol.style.Stroke
 * @returns {object|undefined}
 */
BKGWebMap.Style.stroke = function (singleStyleStroke) {
    var stroke;
    if (singleStyleStroke instanceof ol.style.Stroke) {
        stroke = singleStyleStroke;
    } else if (typeof singleStyleStroke === 'object' && singleStyleStroke.constructor === Object) {
        stroke = new ol.style.Stroke(singleStyleStroke);
    }
    return stroke;
};

/**
 * @namespace BKGWebMap.View
 * @type {object}
 */
BKGWebMap.View = BKGWebMap.View || {};

/**
 * Creates a View instance using a configuration object.
 * @param {object} config - An object with valid options for ol.View.
 * @returns {object}
 */
BKGWebMap.View.create = function (config) {
    return new ol.View(config);
};

/**
 * Find best resolution for map
 * @param {object} config - An object with valid options for ol.View.
 * @param {ol.Map} map - Map to calculate best resolution.
 * @returns {number}
 */
BKGWebMap.View.findBestResolution = function (config, map) {
    var projExtent = BKGWebMap.PROJECTIONS_EXTENTS[config.projection];
    var startResolution = ol.extent.getWidth(projExtent) / 256;
    var resolutions = new Array(22);
    for (var i = 0, ii = resolutions.length; i < ii; ++i) {
        resolutions[i] = startResolution / Math.pow(2, i);
    }

    var getResolutionForExtent = function (extent, size) {
        var xResolution = ol.extent.getWidth(extent) / size[0];
        var yResolution = ol.extent.getHeight(extent) / size[1];
        return Math.max(xResolution, yResolution);
    };

    var bestResolution;
    var resolution = getResolutionForExtent(BKGWebMap.PROJECTIONS_EXTENTS[config.projection], map.getSize());
    var k = 0;
    do {
        bestResolution = resolutions[k];
        k++;
    } while (resolutions[k] > resolution);

    return bestResolution;
};

/**
 * @namespace BKGWebMap.Layer
 * @type {object}
 */
BKGWebMap.Layer = BKGWebMap.Layer || {};

/**
 * WMS image layer constructor
 * @param {WMS} config - Configuration (/layers/baseLayers|overlays/items/WMS and tiles: false)
 * @constructor
 */
BKGWebMap.Layer.ImageWMS = function (config) {
    this.getLayers = function () {
        return config.layers;
    };
    this.getStyleInfo = function () {
        return config.styleInfo;
    };
    this.getLegendInfo = function () {
        return config.legendInfo;
    };
    this.getTimeInfo = function () {
        return config.timeInfo;
    };
    ol.layer.Image.call(this, config);
};

/**
 * WMS tile layer constructor
 * @param {WMS} config - Configuration (/layers/baseLayers|overlays/items/WMS and tiles: true)
 * @constructor
 */
BKGWebMap.Layer.TileWMS = function (config) {
    this.getLayers = function () {
        return config.layers;
    };
    this.getStyleInfo = function () {
        return config.styleInfo;
    };
    this.getLegendInfo = function () {
        return config.legendInfo;
    };
    this.getTimeInfo = function () {
        return config.timeInfo;
    };
    ol.layer.Tile.call(this, config);
};

/**
 * WMTS layer constructor
 * @param {WMTS} config - Configuration (/layers/baseLayers|overlays/items/WMTS)
 * @constructor
 */
BKGWebMap.Layer.WMTS = function (config) {
    ol.layer.Tile.call(this, config);
};

/**
 * WFS layer constructor
 * @param {WFS} config - Configuration (/layers/baseLayers|overlays/items/WFS)
 * @constructor
 */
BKGWebMap.Layer.WFS = function (config) {
    ol.layer.Vector.call(this, config);
};

/**
 * MARKER layer constructor
 * @param {MARKER} config - Configuration (/layers/baseLayers|overlays/items/MARKER)
 * @constructor
 */
BKGWebMap.Layer.MARKER = function (config) {
    ol.layer.Vector.call(this, config);
};

/**
 * CSV layer constructor
 * @param {CSV} config - Configuration (/layers/baseLayers|overlays/items/CSV)
 * @constructor
 */
BKGWebMap.Layer.CSV = function (config) {
    ol.layer.Vector.call(this, config);
};

/**
 * XLS layer constructor
 * @param {XLS} config - Configuration (/layers/baseLayers|overlays/items/XLS)
 * @constructor
 */
BKGWebMap.Layer.XLS = function (config) {
    ol.layer.Vector.call(this, config);
};

/**
 * GPS layer constructor
 * @param {GPS} config - Configuration (/layers/baseLayers|overlays/items/GPS)
 * @constructor
 */
BKGWebMap.Layer.GPS = function (config) {
    ol.layer.Vector.call(this, config);
};

/**
 * VECTOR layer constructor
 * @param {object} config - Configuration for custom Vector layers imported by user. This class used to persist these layers. The geometry is saved as GeoJSON in this configuration object.
 * @constructor
 */
BKGWebMap.Layer.VECTOR = function (config) {
    ol.layer.Vector.call(this, config);
};

/**
 * GROUP layer constructor
 * @param {GROUP} config - (/layers/baseLayers/items/GPS)
 * @constructor
 */
BKGWebMap.Layer.GROUP = function (config) {
    ol.layer.Group.call(this, config);
};

/**
 * NONE (Empty) layer constructor
 * @param {NONE} config - Configuration (/layers/baseLayers/items/NONE)
 * @constructor
 */
BKGWebMap.Layer.NONE = function (config) {
    ol.layer.Image.call(this, config);
};

/**
 * Create WMS layer
 * @typedef {function} LAYER_FACTORIES_WMS
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {WMS} config - WMS configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create WMTS layer
 * @typedef {function} LAYER_FACTORIES_WMTS
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {WMTS} config - WMTS configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create WFS layer
 * @typedef {function} LAYER_FACTORIES_WFS
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {WFS} config - WFS configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create MARKER layer
 * @typedef {function} LAYER_FACTORIES_MARKER
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {MARKER} config - MARKER configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create CSV layer
 * @typedef {function} LAYER_FACTORIES_MARKER
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {CSV} config - CSV configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create XLS layer
 * @typedef {function} LAYER_FACTORIES_XLS
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {XLS} config - XLS configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create GPS layer
 * @typedef {function} LAYER_FACTORIES_GPS
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {GPS} config - GPS configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create VECTOR layer
 * @typedef {function} LAYER_FACTORIES_VECTOR
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {object} config - VECTOR configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create GROUP layer
 * @typedef {function} LAYER_FACTORIES_GROUP
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {GROUP} config - GROUP configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create BKG layer
 * @typedef {function} LAYER_FACTORIES_BKG
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {BKG} config - BKG configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Create NONE (empty) layer
 * @typedef {function} LAYER_FACTORIES_NONE
 * @param {BKGWebMap.ParseConfig} createConfig - BKGWebMap.ParseConfig object
 * @param {object} map - Map object
 * @param {NONE} config - NONE configuration
 * @param {object} styles - Object with styles ({@link symbol_style}|{@link custom_style})
 * @param {boolean} bkg - This layer is generated from a BKG Layer
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {object}
 */
/**
 * Factory functions to generate layers
 * @type {object}
 * @memberof BKGWebMap.Layer
 * @property {function} WMS - Method to create WMS layer. See {@link LAYER_FACTORIES_WMS}
 * @property {function} WMTS - Method to create WMTS layer. See {@link LAYER_FACTORIES_WMTS}
 * @property {function} WFS - Method to create WFS layer. See {@link LAYER_FACTORIES_WFS}
 * @property {function} MARKER - Method to create MARKER layer. See {@link LAYER_FACTORIES_MARKER}
 * @property {function} CSV - Method to create CSV layer. See {@link LAYER_FACTORIES_MARKER}
 * @property {function} XLS - Method to create XLS layer. See {@link LAYER_FACTORIES_XLS}
 * @property {function} GPS - Method to create GPS layer. See {@link LAYER_FACTORIES_GPS}
 * @property {function} VECTOR - Method to create VECTOR layer. See {@link LAYER_FACTORIES_VECTOR}
 * @property {function} GROUP - Method to create GROUP layer. See {@link LAYER_FACTORIES_GROUP}
 * @property {function} BKG - Method to create BKG layer. See {@link LAYER_FACTORIES_BKG}
 * @property {function} NONE - Method to create NONE layer. See {@link LAYER_FACTORIES_NONE}
 *
 */
BKGWebMap.Layer.FACTORIES = {
    WMS: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        // For export json
        if (config.bkg) {
            bkg = config.bkg;
        } else if (bkg) {
            originalConfig.bkg = bkg;
        }

        var i;
        var source;
        var url = config.url;
        var sourceParams = {};
        var version = BKGWebMap.LAYERS.WMS.VERSION;
        var projection = BKGWebMap.PROJECTION;
        var copyright = '';
        var styleInfo = {};
        var legendInfo = {};
        var timeInfo = {};
        function defineLayer(source, config, extent) {
            var layer;
            if (config.tiles === false) {
                layer = new BKGWebMap.Layer.ImageWMS(config);
            } else {
                layer = new BKGWebMap.Layer.TileWMS(config);
            }
            if (extent) {
                layer.extent = extent;
            }
            layer.setSource(source);
            // Update request according to resolution limits
            resolutionLimitsSublayers(layer, config);

            return callback(layer);
        }

        function resolutionLimitsSublayers(layer, config) {
            if (BKGWebMap.Util.hasNestedProperty(layer.getProperties(), 'originalConfig.layers')) {
                config = layer.getProperties().originalConfig;
            }
            var updateParams;
            for (var i = 0; i < config.layers.length; i++) {
                if (config.layers[i].minResolution || config.layers[i].maxResolution) {
                    updateParams = true;
                }
            }
            if (updateParams) {
                map.getView().on('change:resolution', function () {
                    var mapResolution = map.getView().getResolution();
                    var visibility = config.visibility === undefined ? true : config.visibility;
                    var sublayersArray = config.layers.reduce(function (filtered, singleLayer) {
                        var checkLayerMinResolution = !((singleLayer.minResolution && mapResolution < singleLayer.minResolution));
                        var checkLayerMaxResolution = !((singleLayer.maxResolution && mapResolution > singleLayer.maxResolution));
                        if (singleLayer.visibility !== false && checkLayerMinResolution && checkLayerMaxResolution) {
                            filtered.push(singleLayer.layer);
                        }
                        return filtered;
                    }, []);
                    var sublayersStyleArray = config.layers.reduce(function (filtered, singleLayer) {
                        var checkLayerMinResolution = !((singleLayer.minResolution && mapResolution < singleLayer.minResolution));
                        var checkLayerMaxResolution = !((singleLayer.maxResolution && mapResolution > singleLayer.maxResolution));
                        if (singleLayer.visibility !== false && checkLayerMinResolution && checkLayerMaxResolution) {
                            filtered.push(singleLayer.style);
                        }
                        return filtered;
                    }, []);
                    layer.getSource().updateParams({ LAYERS: sublayersArray.join(), STYLES: sublayersStyleArray.join() });
                    if (!sublayersArray.length) {
                        layer.setVisible(false);
                    } else {
                        layer.setVisible(visibility);
                    }
                });
            }
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.WMS.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Source -> URL
        if (typeof url !== 'string' || url === '') {
            window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
            return callback(undefined);
        }

        // If function is called through a BKG layer, try to use UUID
        if (bkg && BKGWebMap.SECURITY.UUID) {
            url = url + '__' + BKGWebMap.SECURITY.UUID;
        }

        // Source -> version
        if (config.version && (config.version === '1.1.0' || config.version === '1.1.1')) {
            version = config.version;
        }

        // Source -> Projection (srsName)
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            projection = config.srsName;
        }

        if (!config.layers || !(config.layers instanceof Array)) {
            return callback(undefined);
        }

        // Add visibility, unique id and selectStyle url for sublayers. Get default legend URL.
        for (i = 0; i < config.layers.length; i++) {
            if (!Object.prototype.hasOwnProperty.call(config.layers[i], 'visibility')) {
                config.layers[i].visibility = BKGWebMap.LAYERS.WMS.VISIBLE;
            }
            if (!Object.prototype.hasOwnProperty.call(config.layers[i], 'selectStyle')) {
                config.layers[i].selectStyle = BKGWebMap.LAYERS.WMS.SELECT_STYLE;
            }
            config.layers[i].uniqueId = BKGWebMap.Util.uniqueId();

            if (config.layers[i].legendUrl && (typeof config.layers[i].legendUrl === 'string' || config.layers[i].legendUrl instanceof String) && config.layers[i].legendUrl !== '') {
                legendInfo[config.layers[i].layer] = config.layers[i].legendUrl;
            } else {
                legendInfo[config.layers[i].layer] = '';
            }
        }

        // Filter sublayers. Request only the ones that should be visible
        var mapResolution = map.getView().getResolution();
        var sublayersArray = config.layers.reduce(function (filtered, singleLayer) {
            var checkLayerMinResolution = !((singleLayer.minResolution && mapResolution < singleLayer.minResolution));
            var checkLayerMaxResolution = !((singleLayer.maxResolution && mapResolution > singleLayer.maxResolution));
            if (singleLayer.visibility !== false && checkLayerMinResolution && checkLayerMaxResolution) {
                filtered.push(singleLayer.layer);
            }
            return filtered;
        }, []);

        // Filter styles
        var sublayersStyleArray = config.layers.reduce(function (filtered, singleLayer) {
            var checkLayerMinResolution = !((singleLayer.minResolution && mapResolution < singleLayer.minResolution));
            var checkLayerMaxResolution = !((singleLayer.maxResolution && mapResolution > singleLayer.maxResolution));
            if (singleLayer.visibility !== false && checkLayerMinResolution && checkLayerMaxResolution) {
                filtered.push(singleLayer.style);
            }
            return filtered;
        }, []);

        // Use all sublayers to get layer extent
        var allSublayersArray = config.layers.reduce(function (filtered, singleLayer) {
            filtered.push(singleLayer.layer);
            return filtered;
        }, []);

        // Source params (If the user has tried to use a params property in config, use it! Hidden feature..)
        if (config.params && (typeof config.params === 'object' && config.params.constructor === Object)) {
            sourceParams = config.params;
        } else {
            sourceParams = {
                LAYERS: sublayersArray.join(),
                VERSION: version,
                STYLES: sublayersStyleArray.join()
            };
        }

        // add additional request parameters if present in config
        var extraSourceParams = ['bgcolor'];
        for (i = 0; i < extraSourceParams.length; i++) {
            var key = extraSourceParams[i];
            if (config[key]) {
                sourceParams[key] = config[key];
            }
        }

        // Object with source options
        var sourceOptions = {
            url: url,
            params: sourceParams,
            projection: projection
        };

        // Source -> All other possible source OpenLayers options should be added silently to source class
        // They are not part of BKG WebMap Documentation.
        var extraSourceOptionsImage = [
            'attributions',
            'crossOrigin',
            'hidpi',
            'serverType',
            'imageLoadFunction',
            'logo',
            'ratio',
            'resolutions'
        ];
        var extraSourceOptionsTile = [
            'attributions',
            'cacheSize',
            'crossOrigin',
            'gutter',
            'hidpi',
            'logo',
            'tileClass',
            'tileGrid',
            'reprojectionErrorThreshold',
            'serverType',
            'tileLoadFunction',
            'urls',
            'wrapX',
            'transition'
        ];

        if (Object.prototype.hasOwnProperty.call(config, 'tiles') && config.tiles === false) {
            for (i = 0; i < extraSourceOptionsImage.length; i++) {
                if (config[extraSourceOptionsImage[i]]) {
                    sourceOptions[extraSourceOptionsImage[i]] = config[extraSourceOptionsImage[i]];
                }
            }
            // Image WMS
            ol.inherits(BKGWebMap.Layer.ImageWMS, ol.layer.Image);
            source = new ol.source.ImageWMS(sourceOptions);
        } else {
            for (i = 0; i < extraSourceOptionsTile.length; i++) {
                if (config[extraSourceOptionsTile[i]]) {
                    sourceOptions[extraSourceOptionsTile[i]] = config[extraSourceOptionsTile[i]];
                }
            }
            // Tile WMS
            ol.inherits(BKGWebMap.Layer.TileWMS, ol.layer.Tile);
            source = new ol.source.TileWMS(sourceOptions);
        }

        function parseLayersInfoWMS(arrayLayers, config, extentParsed, mapEPSG, extent, mapProjection) {
            for (var i = 0; i < arrayLayers.length; i++) {
                if (arrayLayers[i].Layer && arrayLayers[i].Layer instanceof Array && arrayLayers[i].Layer.length) {
                    parseLayersInfoWMS(arrayLayers[i].Layer, config, extentParsed, mapEPSG, extent, mapProjection);
                } else if (allSublayersArray.indexOf(arrayLayers[i].Name) !== -1) {
                    // extent
                    if (arrayLayers[i].BoundingBox instanceof Array) {
                        var tempBbox = arrayLayers[i].BoundingBox;
                        for (var x = 0; x < tempBbox.length; x++) {
                            if (tempBbox[x].crs === mapEPSG && tempBbox[x].extent instanceof Array) {
                                ol.extent.extend(extent, tempBbox[x].extent);
                                extentParsed = true;
                            }
                        }
                    }
                    if (!extentParsed && arrayLayers[i].EX_GeographicBoundingBox instanceof Array) {
                        var tempExtent = ol.proj.transformExtent(arrayLayers[i].EX_GeographicBoundingBox, 'EPSG:4326', mapProjection);
                        ol.extent.extend(extent, tempExtent);
                    }
                }


                // Style
                for (var k = 0; k < config.layers.length; k++) {
                    if (config.layers[k].layer === arrayLayers[i].Name) {
                        if (arrayLayers[i].Style && arrayLayers[i].Style instanceof Array) {
                            styleInfo[arrayLayers[i].Name] = arrayLayers[i].Style;

                            // Get legend url
                            if (legendInfo[arrayLayers[i].Name] === '') {
                                legendInfo[arrayLayers[i].Name] = {};
                                for (var j = 0; j < arrayLayers[i].Style.length; j++) {
                                    if (arrayLayers[i].Style[j].LegendURL) {
                                        legendInfo[arrayLayers[i].Name][arrayLayers[i].Style[j].Name] = arrayLayers[i].Style[j].LegendURL[0].OnlineResource;
                                    }
                                }
                            }
                        }
                        if (config.time && config.time.active && arrayLayers[i].Dimension && arrayLayers[i].Dimension instanceof Array) {
                            for (var d = 0; d < arrayLayers[i].Dimension.length; d++) {
                                if (arrayLayers[i].Dimension[d].name === 'time') {
                                    timeInfo[arrayLayers[i].Name] = arrayLayers[i].Dimension[d];
                                }
                            }
                        }
                    }
                }
            }
        }

        // GetCapabilities to get extent and copyright
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url + '?SERVICE=WMS&VERSION=1.3.0&REQUEST=GetCapabilities');
        xhr.onload = function () {
            if (xhr.status === 200) {
                var parser = new ol.format.WMSCapabilities();
                var result = parser.read(xhr.responseText);
                var mapProjection = map.getView().getProjection();
                var mapEPSG = mapProjection.getCode();
                var extent = ol.extent.createEmpty();
                var extentParsed = false;
                if (BKGWebMap.Util.hasNestedProperty(result, 'Capability.Layer.Layer')) {
                    if (result.Capability.Layer.Layer && result.Capability.Layer.Layer instanceof Array && result.Capability.Layer.Layer.length > 0) {
                        var arrayLayers = result.Capability.Layer.Layer;
                        parseLayersInfoWMS(arrayLayers, config, extentParsed, mapEPSG, extent, mapProjection);
                    }
                }

                if (BKGWebMap.Util.hasNestedProperty(result, 'Capability.Request.GetFeatureInfo.Format') && result.Capability.Request.GetFeatureInfo.Format.length) {
                    var formats = result.Capability.Request.GetFeatureInfo.Format;
                    for (var m = 0; m < BKGWebMap.GETFEATUREINFO_FORMATS.length; m++) {
                        if (formats.indexOf(BKGWebMap.GETFEATUREINFO_FORMATS[m]) !== -1) {
                            config.GetFeatureInfoFormat = BKGWebMap.GETFEATUREINFO_FORMATS[m];
                            break;
                        }
                    }
                }

                if (extent.indexOf(Infinity) !== -1) {
                    extent = null;
                }

                if (!copyright) {
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Service.Fees') && result.Service.Fees !== '' && result.Service.Fees !== 'NONE') {
                        copyright += result.Service.Fees + ' ';
                    }
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Service.AccessConstraints') && result.Service.AccessConstraints !== '' && result.Service.AccessConstraints !== 'NONE') {
                        copyright += result.Service.AccessConstraints + ' ';
                    }
                }
                config.styleInfo = styleInfo;
                config.legendInfo = legendInfo;
                config.timeInfo = timeInfo;
                if (copyright) {
                    config.copyright = copyright;
                }
                defineLayer(source, config, extent);
            }
        };
        xhr.onerror = function () {
            defineLayer(source, config);
        };
        xhr.send();
    },
    WMTS: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        // For export json
        if (config.bkg) {
            bkg = config.bkg;
        } else if (bkg) {
            originalConfig.bkg = bkg;
        }

        var i;
        var url = config.url;
        var wmtsLayer = config.layer;
        var copyright = '';

        // Source -> Projection (srsName)
        var layerProjection;
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            layerProjection = config.srsName;
        } else {
            layerProjection = map.getView().getProjection();
        }

        function defineLayer(sourceOptions, extent) {
            var source = new ol.source.WMTS(sourceOptions);
            ol.inherits(BKGWebMap.Layer.WMTS, ol.layer.Tile);
            var layer = new BKGWebMap.Layer.WMTS(config);
            if (extent) {
                extent = ol.proj.transformExtent(extent, 'EPSG:4326', layerProjection);
                layer.extent = extent;
            }
            layer.setSource(source);
            return callback(layer);
        }

        // Layer
        if (typeof wmtsLayer !== 'string' || wmtsLayer === '') {
            window.console.log(BKGWebMap.ERROR.wmtsLayerName);
            return callback(undefined);
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.WMTS.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Source -> URL
        var xhr;
        if (typeof url !== 'string' || url === '') {
            window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
            return callback(undefined);
        } else if (url.slice(url.length - 4, url.length) === '.xml') {
            // If the link ends with .xml, then access WMTS from a GetCapabilities response
            xhr = new XMLHttpRequest();
            xhr.open('GET', url);
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var parser = new ol.format.WMTSCapabilities();
                    var result = parser.read(xhr.responseText);
                    var extent;
                    var legendUrl;
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Contents.Layer') && result.Contents.Layer.length) {
                        if (result.Contents.Layer[0].WGS84BoundingBox && result.Contents.Layer[0].WGS84BoundingBox.length === 4) {
                            for (var j = 0; j < result.Contents.Layer.length; j++) {
                                var layerConfig = result.Contents.Layer[j];
                                if (wmtsLayer !== layerConfig.Identifier) {
                                    continue;
                                }
                                if (layerConfig.WGS84BoundingBox && layerConfig.WGS84BoundingBox.length === 4) {
                                    extent = layerConfig.WGS84BoundingBox;
                                }
                            }
                        }
                    }
                    if (!copyright) {
                        if (BKGWebMap.Util.hasNestedProperty(result, 'ServiceIdentification.Fees') && result.ServiceIdentification.Fees !== '' && result.ServiceIdentification.Fees !== 'NONE') {
                            copyright += result.ServiceIdentification.Fees + ' ';
                        }
                        if (BKGWebMap.Util.hasNestedProperty(result, 'ServiceIdentification.AccessConstraints') && result.ServiceIdentification.AccessConstraints !== '' && result.ServiceIdentification.AccessConstraints !== 'NONE') {
                            copyright += result.ServiceIdentification.AccessConstraints + ' ';
                        }
                    }
                    if (!config.legendUrl && BKGWebMap.Util.hasNestedProperty(result, 'Contents.Layer') && result.Contents.Layer.length) {
                        if (result.Contents.Layer[0].Style && result.Contents.Layer[0].Style.length && result.Contents.Layer[0].Style[0].LegendURL && result.Contents.Layer[0].Style[0].LegendURL.length) {
                            legendUrl = result.Contents.Layer[0].Style[0].LegendURL[0].href;
                        }
                    }
                    if (legendUrl) {
                        config.legendUrl = legendUrl;
                    }
                    var options = ol.source.WMTS.optionsFromCapabilities(result, {
                        layer: wmtsLayer,
                        matrixSet: config.matrixSet
                    });

                    // If function is called through a BKG layer, try to use UUID
                    if (bkg && BKGWebMap.SECURITY.UUID && options.urls instanceof Array) {
                        for (var i = 0; i < options.urls.length; i++) {
                            options.urls[i] = options.urls[i].replace('/tile/', '__' + BKGWebMap.SECURITY.UUID + '/tile/');
                        }
                    }
                    if (copyright) {
                        config.copyright = copyright;
                    }
                    defineLayer(options, extent);
                } else if (xhr.status !== 200) {
                    return callback(undefined);
                }
            };

            xhr.onerror = function () {
                window.console.log(BKGWebMap.ERROR.wmtsGetCapabilities);
                return callback(undefined);
            };

            xhr.send();
        } else {
            // Create WMTS request manually
            var projection = BKGWebMap.PROJECTION;
            var style = BKGWebMap.LAYERS.WMTS.DEFAULTSTYLE;
            var tileGrid;

            // Source -> Projection (srsName)
            if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
                projection = config.srsName;
            }

            if (!config.tileGrid || typeof config.tileGrid !== 'object') {
                window.console.log(BKGWebMap.ERROR.wmtsTileGrid);
                return callback(undefined);
            } else if (config.tileGrid instanceof ol.tilegrid.WMTS) {
                tileGrid = config.tileGrid;
            } else {
                tileGrid = new ol.tilegrid.WMTS(config.tileGrid);
            }

            if (config.style && typeof config.style === 'string' && config.style !== '') {
                style = config.style;
            }

            // If function is called through a BKG layer, try to use UUID
            if (bkg && BKGWebMap.SECURITY.UUID) {
                url = url + '__' + BKGWebMap.SECURITY.UUID;
            }

            // Object with source options
            var sourceOptions = {
                url: url,
                layer: wmtsLayer,
                projection: projection,
                tileGrid: tileGrid,
                style: style
            };

            // All other possible WMTS source options, even those not included in Documentation
            var extraSourceOptions = [
                'attributions',
                'cacheSize',
                'crossOrigin',
                'logo',
                'reprojectionErrorThreshold',
                'requestEncoding',
                'tileClass',
                'tilePixelRatio',
                'version',
                'format',
                'matrixSet',
                'dimensions',
                'tileLoadFunction',
                'urls',
                'wrapX',
                'transition'
            ];

            for (i = 0; i < extraSourceOptions.length; i++) {
                if (config[extraSourceOptions[i]]) {
                    sourceOptions[extraSourceOptions[i]] = config[extraSourceOptions[i]];
                }
            }

            // GetCapabilities to get extent
            xhr = new XMLHttpRequest();
            xhr.open('GET', url + '/1.0.0/WMTSCapabilities.xml');
            xhr.onload = function () {
                if (xhr.status === 200) {
                    var parser = new ol.format.WMTSCapabilities();
                    var result = parser.read(xhr.responseText);
                    var extent;
                    var legendUrl;
                    if (BKGWebMap.Util.hasNestedProperty(result, 'Contents.Layer') && result.Contents.Layer.length) {
                        if (result.Contents.Layer[0].WGS84BoundingBox && result.Contents.Layer[0].WGS84BoundingBox.length === 4) {
                            for (var j = 0; j < result.Contents.Layer.length; j++) {
                                var layerConfig = result.Contents.Layer[j];
                                if (wmtsLayer !== layerConfig.Identifier) {
                                    continue;
                                }
                                if (layerConfig.WGS84BoundingBox && layerConfig.WGS84BoundingBox.length === 4) {
                                    extent = layerConfig.WGS84BoundingBox;
                                }
                            }
                        }
                    }
                    if (!copyright) {
                        if (BKGWebMap.Util.hasNestedProperty(result, 'ServiceIdentification.Fees') && result.ServiceIdentification.Fees !== '' && result.ServiceIdentification.Fees !== 'NONE') {
                            copyright += result.ServiceIdentification.Fees + ' ';
                        }
                        if (BKGWebMap.Util.hasNestedProperty(result, 'ServiceIdentification.AccessConstraints') && result.ServiceIdentification.AccessConstraints !== '' && result.ServiceIdentification.AccessConstraints !== 'NONE') {
                            copyright += result.ServiceIdentification.AccessConstraints + ' ';
                        }
                    }
                    if (copyright) {
                        config.copyright = copyright;
                    }

                    if (!config.legendUrl && BKGWebMap.Util.hasNestedProperty(result, 'Contents.Layer') && result.Contents.Layer.length) {
                        if (result.Contents.Layer[0].Style.length && result.Contents.Layer[0].Style[0].LegendURL.length) {
                            legendUrl = result.Contents.Layer[0].Style[0].LegendURL[0].href;
                        }
                    }
                    if (legendUrl) {
                        config.legendUrl = legendUrl;
                    }
                    defineLayer(sourceOptions, extent);
                }
            };
            xhr.onerror = function () {
                defineLayer(sourceOptions);
            };
            xhr.send();
        }
    },
    WFS: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        // Style
        var styleObject = BKGWebMap.Style.createStyles([BKGWebMap.DEFAULT_STYLE]);
        var style = styleObject['bkgwebmap-defaultstyle'];
        if (styles && Object.prototype.hasOwnProperty.call(styles, config.style)) {
            config.styleName = config.style;
            style = styles[config.style];
        }
        config.style = style;

        var copyright = '';
        var url = config.url;
        var wfsDataProjection = BKGWebMap.PROJECTION;
        var mapProjection = map.getView().getProjection().getCode();
        var version = BKGWebMap.LAYERS.WFS.VERSION;
        var format = BKGWebMap.LAYERS.WFS.FORMAT;
        var edit = BKGWebMap.LAYERS.WFS.EDIT;
        var typename = config.typename;
        var tiles = BKGWebMap.LAYERS.WFS.TILES;

        var formats = {
            GEOJSON: {
                olClass: new ol.format.GeoJSON(),
                outputFormat: 'application/json'
            },
            GML2: {
                olClass: new ol.format.GML2(),
                outputFormat: 'gml2'
            },
            GML3: {
                olClass: new ol.format.WFS(),
                outputFormat: 'gml3'
            }
        };

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Edit is always false for WFS
        config.edit = edit;

        // Source -> URL
        if (typeof url !== 'string' || url === '') {
            window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
            return callback(undefined);
        }

        // Source -> Projection (srsName)
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            wfsDataProjection = config.srsName;
        }

        // Source -> typename
        if (typeof typename !== 'string' || url === '') {
            window.console.log(BKGWebMap.ERROR.wfsTypename);
            return callback(undefined);
        }

        // Be sure to use only once '?' in url
        if (url.charAt(url.length - 1) !== '?') {
            url += '?';
        }

        // Source -> version
        if (config.version && typeof config.version === 'string' && config.version !== '') {
            version = config.version;
        }

        // Source -> format
        if (config.format && (config.format === 'GML2' || config.format === 'GML3' || config.format === 'GEOJSON')) {
            format = config.format;
        }

        // Tiles
        if (typeof config.tiles === 'boolean') {
            tiles = config.tiles;
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.WFS.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        ol.inherits(BKGWebMap.Layer.WFS, ol.layer.Vector);
        var layer = new BKGWebMap.Layer.WFS(config);

        var bboxDataProjection;
        if (version === '1.0.0') {
            bboxDataProjection = '';
        } else {
            bboxDataProjection = ',' + wfsDataProjection;
        }

        var strategy;
        if (tiles) {
            strategy = ol.loadingstrategy.tile(ol.tilegrid.createXYZ());
        } else {
            strategy = ol.loadingstrategy.bbox;
        }
        var typenameKey = (version === '2.0.0') ? 'typenames' : 'typename';
        var sourceOptions = {
            format: formats[format].olClass,
            loader: function (extent) {
                var extentTransform = ol.proj.transformExtent(extent, mapProjection, wfsDataProjection);
                var urlString = [
                    url,
                    'service=WFS',
                    'version=' + version,
                    'request=GetFeature',
                    typenameKey + '=' + typename,
                    'outputFormat=' + formats[format].outputFormat,
                    'srsname=' + wfsDataProjection,
                    'bbox=' + extentTransform.join(',') + bboxDataProjection
                ].join('&');

                var xhr = new XMLHttpRequest();
                xhr.open('GET', urlString);
                var onError = function () {
                    source.removeLoadedExtent(extent);
                    return undefined;
                };
                xhr.onerror = onError;
                xhr.onload = function () {
                    if (xhr.status === 200) {
                        source.addFeatures(source.getFormat().readFeatures(xhr.responseText, {
                            dataProjection: wfsDataProjection,
                            featureProjection: mapProjection
                        }));
                    } else {
                        onError();
                    }
                };
                xhr.send();
            },
            strategy: strategy
        };

        // All other possible WFS source options, even those not included in Documentation
        var extraSourceOptions = [
            'attributions',
            'logo',
            'overlaps',
            'useSpatialIndex',
            'wrapX'
        ];
        for (var i = 0; i < extraSourceOptions.length; i++) {
            if (config[extraSourceOptions[i]]) {
                sourceOptions[extraSourceOptions[i]] = config[extraSourceOptions[i]];
            }
        }
        var source = new ol.source.Vector(sourceOptions);
        layer.setSource(source);

        // GetCapabilities to get copyright
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url + 'REQUEST=GetCapabilities&VERSION=1.3.0&SERVICE=wfs');
        xhr.onload = function () {
            if (xhr.status === 200) {
                var parser = new DOMParser();
                var resultXml = parser.parseFromString(xhr.responseText, 'text/xml');
                var result = BKGWebMap.Util.xmlToJson(resultXml);
                var extent = new ol.extent.createEmpty();
                if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.FeatureTypeList.FeatureType') && result['wfs:WFS_Capabilities'].FeatureTypeList.FeatureType instanceof Array) {
                    var featuresWFS = result['wfs:WFS_Capabilities'].FeatureTypeList.FeatureType;
                    for (var i = 0; i < featuresWFS.length; i++) {
                        if (BKGWebMap.Util.hasNestedProperty(featuresWFS[i], 'ows:WGS84BoundingBox.ows:LowerCorner.#text') && BKGWebMap.Util.hasNestedProperty(featuresWFS[i], 'ows:WGS84BoundingBox.ows:UpperCorner.#text')) {
                            var extentFeature = [parseFloat(featuresWFS[i]['ows:WGS84BoundingBox']['ows:LowerCorner']['#text'].split(' ')[0]), parseFloat(featuresWFS[i]['ows:WGS84BoundingBox']['ows:LowerCorner']['#text'].split(' ')[1]), parseFloat(featuresWFS[i]['ows:WGS84BoundingBox']['ows:UpperCorner']['#text'].split(' ')[0]), parseFloat(featuresWFS[i]['ows:WGS84BoundingBox']['ows:UpperCorner']['#text'].split(' ')[1])];
                            var transformExtent = ol.proj.transformExtent(extentFeature, 'EPSG:4326', mapProjection);
                            extent = new ol.extent.extend(extent, transformExtent);
                        }
                    }
                }
                layer.fullExtent = extent;
                if (!copyright) {
                    if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.ows:ServiceIdentification.ows:Fees.#text') && result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:Fees']['#text'] !== '' && result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:Fees']['#text'] !== 'NONE') {
                        copyright += result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:Fees']['#text'] + ' ';
                    } else if (BKGWebMap.Util.hasNestedProperty(result, 'WFS_Capabilities.ows:ServiceIdentification.ows:Fees.#text') && result.WFS_Capabilities['ows:ServiceIdentification']['ows:Fees']['#text'] !== '' && result.WFS_Capabilities['ows:ServiceIdentification']['ows:Fees']['#text'] !== 'NONE') {
                        copyright += result.WFS_Capabilities['ows:ServiceIdentification']['ows:Fees']['#text'] + ' ';
                    }
                    if (BKGWebMap.Util.hasNestedProperty(result, 'wfs:WFS_Capabilities.ows:ServiceIdentification.ows:AccessConstraints.#text') && result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:AccessConstraints']['#text'] !== '' && result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:AccessConstraints']['#text'] !== 'NONE') {
                        copyright += result['wfs:WFS_Capabilities']['ows:ServiceIdentification']['ows:AccessConstraints']['#text'] + ' ';
                    } else if (BKGWebMap.Util.hasNestedProperty(result, 'WFS_Capabilities.ows:ServiceIdentification.ows:AccessConstraints.#text') && result.WFS_Capabilities['ows:ServiceIdentification']['ows:AccessConstraints']['#text'] !== '' && result.WFS_Capabilities['ows:ServiceIdentification']['ows:AccessConstraints']['#text'] !== 'NONE') {
                        copyright += result.WFS_Capabilities['ows:ServiceIdentification']['ows:AccessConstraints']['#text'] + ' ';
                    }
                }
                if (copyright) {
                    config.copyright = copyright;
                }
                return callback(layer);
            }
        };
        xhr.onerror = function () {
            return callback(layer);
        };
        xhr.send();
    },
    MARKER: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        var i;
        var features = [];
        var copyright = '';
        var edit = BKGWebMap.LAYERS.MARKER.EDIT;

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Edit
        if (typeof config.edit !== 'boolean') {
            config.edit = edit;
        }

        // Style
        var styleObject = BKGWebMap.Style.createStyles([BKGWebMap.DEFAULT_STYLE]);
        var style = styleObject['bkgwebmap-defaultstyle'];
        if (Object.prototype.hasOwnProperty.call(styles, config.style)) {
            config.styleName = config.style;
            style = styles[config.style];
        }
        config.style = style;

        var mapProjection = map.getView().getProjection().getCode();
        var markerProjection = BKGWebMap.LAYERS.MARKER.PROJECTION;

        // Source -> Projection (srsName)
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            markerProjection = config.srsName;
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.MARKER.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Source -> Features
        if (!config.markers || !(config.markers instanceof Array)) {
            window.console.log(BKGWebMap.ERROR.markersMissing);
            return callback(undefined);
        }
        for (i = 0; i < config.markers.length; i++) {
            if (config.markers[i] instanceof ol.Feature) {
                // In case the user has used directly the class ol.Feature (hidden feature...)
                features.push(config.markers[i]);
            } else if (config.markers[i].coordinates && config.markers[i].coordinates.lat && typeof config.markers[i].coordinates.lat === 'number' && config.markers[i].coordinates.lon && typeof config.markers[i].coordinates.lon === 'number') {
                features.push(new ol.Feature({
                    geometry: new ol.geom.Point(ol.proj.transform([config.markers[i].coordinates.lon, config.markers[i].coordinates.lat], markerProjection, mapProjection)),
                    name: config.markers[i].content
                }));
            }
        }

        if (features.length === 0) {
            window.console.log(BKGWebMap.ERROR.markersMissing);
            return callback(undefined);
        }

        ol.inherits(BKGWebMap.Layer.MARKER, ol.layer.Vector);
        var layer = new BKGWebMap.Layer.MARKER(config);

        var sourceOptions = {
            features: features
        };
        // All other possible Vector source options, even those not included in Documentation
        var extraSourceOptions = [
            'attributions',
            'logo',
            'overlaps',
            'useSpatialIndex',
            'wrapX'
        ];
        for (i = 0; i < extraSourceOptions.length; i++) {
            if (config[extraSourceOptions[i]]) {
                sourceOptions[extraSourceOptions[i]] = config[extraSourceOptions[i]];
            }
        }

        var source = new ol.source.Vector(sourceOptions);
        layer.setSource(source);

        if (copyright) {
            config.copyright = copyright;
        }

        return callback(layer);
    },
    CSV: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        var url = config.url;
        var mapProjection = map.getView().getProjection().getCode();
        var csvProjection = BKGWebMap.LAYERS.CSV.PROJECTION;
        var copyright = '';
        var edit = BKGWebMap.LAYERS.CSV.EDIT;

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Edit
        if (typeof config.edit !== 'boolean') {
            config.edit = edit;
        }

        // Style
        var styleObject = BKGWebMap.Style.createStyles([BKGWebMap.DEFAULT_STYLE]);
        var style = styleObject['bkgwebmap-defaultstyle'];
        if (Object.prototype.hasOwnProperty.call(styles, config.style)) {
            config.styleName = config.style;
            style = styles[config.style];
        }
        config.style = style;

        // Source -> Projection (srsName)
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            csvProjection = config.srsName;
        }

        // Options
        if (!config.csvOptions || ((typeof config.csvOptions !== 'object' && config.csvOptions.constructor !== Object))) {
            window.console.log(BKGWebMap.ERROR.csvExcelOptions + config.type);
            return callback(undefined);
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.CSV.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Source -> URL
        if (typeof url === 'string' && url === '') {
            window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
            return callback(undefined);
        } else if (url instanceof Array) {
            // Used from custom layers control
            // createFeaturesFromJson(url);
            BKGWebMap.Layer.Util.parseCsvExcelJson('CSV', url, config, config.csvOptions, csvProjection, mapProjection, copyright, callback);
        }

        // Load csv
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url);
        xhr.responseType = 'blob';
        var onError = function () {
            return callback(undefined);
        };
        xhr.onerror = onError;
        xhr.onload = function () {
            if (xhr.status === 200) {
                // Encoding
                var encoding = BKGWebMap.LAYERS.CSV.ENCODING;
                if (config.csvOptions && config.csvOptions.encoding && typeof config.csvOptions.encoding === 'string' && config.csvOptions.encoding !== '') {
                    encoding = config.csvOptions.encoding;
                }

                // Delimiter
                var delimiter = BKGWebMap.LAYERS.CSV.DELIMITER;
                if (config.csvOptions && config.csvOptions.delimiter && typeof config.csvOptions.delimiter === 'string' && config.csvOptions.delimiter !== '') {
                    delimiter = config.csvOptions.delimiter;
                }

                var reader = new FileReader();
                reader.readAsText(xhr.response, encoding);
                reader.onload = function (e) {
                    var result = 'sep=' + delimiter + '\n' + e.target.result;
                    var workbook = XLSX.read(result, { type: 'binary' });
                    var sheet = workbook.Sheets[workbook.SheetNames[0]];
                    var json = XLSX.utils.sheet_to_json(sheet, { header: 1 });
                    BKGWebMap.Layer.Util.parseCsvExcelJson('CSV', json, config, config.csvOptions, csvProjection, mapProjection, copyright, callback);
                };
            } else {
                onError();
            }
        };
        if (!(url instanceof Array)) {
            xhr.send();
        }
    },
    XLS: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        var url = config.url;
        var mapProjection = map.getView().getProjection().getCode();
        var excelProjection = BKGWebMap.LAYERS.XLS.PROJECTION;
        var copyright = '';
        var edit = BKGWebMap.LAYERS.XLS.EDIT;

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Edit
        if (typeof config.edit !== 'boolean') {
            config.edit = edit;
        }

        // Style
        var styleObject = BKGWebMap.Style.createStyles([BKGWebMap.DEFAULT_STYLE]);
        var style = styleObject['bkgwebmap-defaultstyle'];
        if (Object.prototype.hasOwnProperty.call(styles, config.style)) {
            config.styleName = config.style;
            style = styles[config.style];
        }
        config.style = style;

        // Source -> Projection (srsName)
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            excelProjection = config.srsName;
        }

        // Options
        if (!config.excelOptions || ((typeof config.excelOptions !== 'object' && config.excelOptions.constructor !== Object))) {
            window.console.log(BKGWebMap.ERROR.csvExcelOptions + config.type);
            return callback(undefined);
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.XLS.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Source -> URL
        if (typeof url === 'string' && url === '') {
            window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
            return callback(undefined);
        } else if (url instanceof Array) {
            // Used from custom layers control
            BKGWebMap.Layer.Util.parseCsvExcelJson('XLS', url, config, config.excelOptions, excelProjection, mapProjection, copyright, callback);
        }

        // Load excel
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url);
        xhr.responseType = 'arraybuffer';
        var onError = function () {
            return callback(undefined);
        };
        xhr.onerror = onError;
        xhr.onload = function () {
            if (xhr.status === 200) {
                var response = new Uint8Array(xhr.response);
                var workbook = XLSX.read(response, { type: 'array' });
                // Get data from first Sheet ONLY
                var data = workbook.Sheets[workbook.SheetNames[0]];
                var json = XLSX.utils.sheet_to_json(data, { header: 1 });
                BKGWebMap.Layer.Util.parseCsvExcelJson('XLS', json, config, config.excelOptions, excelProjection, mapProjection, copyright, callback);
            } else {
                onError();
            }
        };
        if (!(url instanceof Array)) {
            xhr.send();
        }
    },
    GPS: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        var url = config.url;
        var copyright = '';
        var edit = BKGWebMap.LAYERS.GPS.EDIT;
        var mapProjection = map.getView().getProjection().getCode();
        var gpsProjection = 'EPSG:4326';

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Edit
        if (typeof config.edit !== 'boolean') {
            config.edit = edit;
        }

        // Style
        var styleObject = BKGWebMap.Style.createStyles([BKGWebMap.DEFAULT_STYLE]);
        var style = styleObject['bkgwebmap-defaultstyle'];
        if (Object.prototype.hasOwnProperty.call(styles, config.style)) {
            config.styleName = config.style;
            style = styles[config.style];
        }
        config.style = style;

        // Visible
        config.visible = BKGWebMap.LAYERS.GPS.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Source -> URL
        if (typeof url === 'string' && url === '') {
            window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
            return callback(undefined);
        } else if (url instanceof Array) {
            // Used from custom layers control
            BKGWebMap.Layer.Util.createFeaturesForGps(url[0], config, gpsProjection, mapProjection, callback);
        } else {
            ol.inherits(BKGWebMap.Layer.GPS, ol.layer.Vector);
            var layer = new BKGWebMap.Layer.GPS(config);

            var source = new ol.source.Vector({
                url: url,
                format: new ol.format.GPX()
            });
            layer.setSource(source);

            if (copyright) {
                config.copyright = copyright;
            }

            return callback(layer);
        }
    },
    VECTOR: function (createConfig, map, config, styles, bkg, callback) {
        var mapProjection = map.getView().getProjection().getCode();
        var copyright = '';
        var geojson;
        var edit = BKGWebMap.LAYERS.VECTOR.EDIT;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        if (!config.features || ((typeof config.features !== 'object' && config.features.constructor !== Object))) {
            return callback(undefined);
        }

        geojson = config.features;

        // Copyright
        if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
            copyright = config.copyright;
        }

        // Edit
        if (typeof config.edit !== 'boolean') {
            config.edit = edit;
        }


        // Style
        var styleObject = BKGWebMap.Style.createStyles([BKGWebMap.DEFAULT_STYLE]);
        var style = styleObject['bkgwebmap-defaultstyle'];
        if (Object.prototype.hasOwnProperty.call(styles, config.style)) {
            config.styleName = config.style;
            style = styles[config.style];
        }
        config.style = style;

        // Visible
        config.visible = BKGWebMap.LAYERS.VECTOR.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        ol.inherits(BKGWebMap.Layer.VECTOR, ol.layer.Vector);
        var layer = new BKGWebMap.Layer.VECTOR(config);

        if (copyright) {
            config.copyright = copyright;
        }

        var source = new ol.source.Vector();
        layer.setSource(source);

        var format = new ol.format.GeoJSON();

        var features = format.readFeatures(geojson, {
            dataProjection: 'EPSG:4326',
            featureProjection: mapProjection
        });

        source.addFeatures(features);
        return callback(layer);
    },
    GROUP: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        delete originalConfig.layers;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        var layers = [];
        var layerListLength = config.layers.length;
        var counter = 0;

        var layerGroup;
        if (config.isBaseLayer === true) {
            layerGroup = 'baseLayers';
        } else {
            layerGroup = 'overlays';
        }

        // Visible
        config.visible = BKGWebMap.LAYERS.GROUP.VISIBLE;
        if (typeof config.visibility === 'boolean' && config.visibility === false) {
            config.visible = config.visibility;
        }
        delete config.visibility;

        // Layers
        if (!config.layers || !(config.layers instanceof Array) || config.layers.length === 0) {
            window.console.log(BKGWebMap.ERROR.missingLayersGroup);
            return callback(undefined);
        }

        for (var i = 0; i < layerListLength; i++) {
            (function () {
                var k = i;
                createConfig.createLayer(createConfig, map, config.layers[k], layerGroup, styles, bkg, function (singleLayer) {
                    counter++;
                    if (singleLayer !== undefined) {
                        singleLayer.setProperties({
                            isBaseLayer: false,
                            uniqueId: BKGWebMap.Util.uniqueId()
                        });
                    }
                    layers[k] = singleLayer;

                    // Use layers array only if we have loaded all layers
                    if (counter === layerListLength) {
                        // Remove undefined from layers array
                        for (var j = layers.length - 1; j >= 0; j--) {
                            if (layers[j] === undefined) {
                                layers.splice(j, 1);
                            }
                        }

                        layers.reverse();

                        // Change layers property of config object
                        config.layers = layers;

                        ol.inherits(BKGWebMap.Layer.GROUP, ol.layer.Group);
                        var layer = new BKGWebMap.Layer.GROUP(config);

                        return callback(layer);
                    }
                });
            }());
        }
    },
    BKG: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        var projection = map.getView().getProjection().getCode();
        var registryUrl = BKGWebMap.SERVICE_REGISTRY;
        var ref = config.ref;
        var properties = {};
        var layerGroup;
        if (config.isBaseLayer === true) {
            layerGroup = 'baseLayers';
        } else {
            layerGroup = 'overlays';
        }

        // Find if we already have CookieCheck control. If not, add it and activate it only if there is no UUID (or appID).
        var cookieCheckControl = false;
        if (!BKGWebMap.SECURITY.UUID && !BKGWebMap.CONTROLS.tools.cookieCheck.doNotActivate) {
            map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.CookieCheck && control instanceof BKGWebMap.Control.CookieCheck) {
                    cookieCheckControl = true;
                    if (!control.active) {
                        control.activateCookieTest();
                    }
                }
            });
            if (!cookieCheckControl) {
                var CookieCheckClass = BKGWebMap.Control.FACTORIES.cookieCheck();
                var cookieCheck = new CookieCheckClass(map, 'cookieCheck', {}, null);
                map.addControl(cookieCheck);
                BKGWebMap.Controls.cookieCheck = cookieCheck;
                cookieCheck.activateCookieTest();
            }
        }

        // ref
        if (typeof ref !== 'string' || ref === '') {
            window.console.log(BKGWebMap.ERROR.missingRefInBkg);
            return callback(undefined);
        }

        // Source -> Projection (srsName)
        if (config.srsName && typeof config.srsName === 'string' && config.srsName !== '') {
            projection = config.srsName;
        }

        // Properties that overwrite preconfigured values
        if (config.properties || ((typeof config.properties === 'object' && config.properties.constructor === Object))) {
            properties = config.properties;
        }

        // Use parameters for GET request
        var params = '/' + ref + '?srsname=' + projection;

        // Find layer info from registry
        var xhr = new XMLHttpRequest();
        xhr.open('GET', registryUrl + params);
        var onError = function () {
            return callback(undefined);
        };
        xhr.onerror = onError;
        xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
        xhr.onload = function () {
            var jsonConfig = null;
            if (xhr.status === 200) {
                jsonConfig = JSON.parse(xhr.responseText);

                // Create URL
                // Source -> URL
                if (typeof jsonConfig.url !== 'string' || jsonConfig.url === '') {
                    window.console.log(BKGWebMap.ERROR.wrongUrl + config.type);
                    return callback(undefined);
                }

                // Be sure to have only one slash in url
                if (jsonConfig.url.slice(0, 1) === '/') {
                    jsonConfig.url = jsonConfig.url.slice(1);
                }
                if (BKGWebMap.BASE_URL.slice(BKGWebMap.BASE_URL.length - 1, BKGWebMap.BASE_URL.length) !== '/') {
                    BKGWebMap.BASE_URL += '/';
                }

                jsonConfig.url = BKGWebMap.BASE_URL + jsonConfig.url;

                // Ovewrite name
                if (config.name && typeof config.name === 'string' && config.srsName !== '') {
                    jsonConfig.name = config.name;
                }

                // Ovewrite default visibility
                if (typeof config.visibility === 'boolean') {
                    jsonConfig.visibility = config.visibility;
                }

                // Ovewrite opacity
                if (config.opacity && typeof config.opacity === 'number') {
                    jsonConfig.opacity = config.opacity;
                }

                // Ovewrite minResolution
                if (config.minResolution && typeof config.minResolution === 'number') {
                    jsonConfig.minResolution = config.minResolution;
                }

                // Ovewrite maxResolution
                if (config.maxResolution && typeof config.maxResolution === 'number') {
                    jsonConfig.maxResolution = config.maxResolution;
                }

                // Add legendUrl
                if (config.legendUrl && typeof config.legendUrl === 'string' && config.legendUrl !== '') {
                    jsonConfig.legendUrl = config.legendUrl;
                }

                // Add copyright
                if (config.copyright && typeof config.copyright === 'string' && config.copyright !== '') {
                    jsonConfig.copyright = config.copyright;
                }

                // Add user id
                if (config.id && typeof config.id === 'string' && config.id !== '') {
                    jsonConfig.id = config.id;
                }

                // Use properties that overwrite preconfigured values
                jsonConfig = BKGWebMap.Util.extend(jsonConfig, properties);

                createConfig.createLayer(createConfig, map, jsonConfig, layerGroup, styles, true, function (singleLayer) {
                    return callback(singleLayer);
                });
            } else {
                onError();
            }
        };
        xhr.send();
    },
    NONE: function (createConfig, map, config, styles, bkg, callback) {
        var originalConfig = BKGWebMap.Util.deepCopy(config);
        delete originalConfig.isBaseLayer;
        config.originalConfig = originalConfig;

        config.name = BKGWebMap.LAYERS.NONE.NAME;
        config.visible = false;
        config.uniqueId = BKGWebMap.Util.uniqueId();

        if (!config.id) {
            config.id = BKGWebMap.Util.generateLayerId();
        }

        ol.inherits(BKGWebMap.Layer.NONE, ol.layer.Image);
        var layer = new BKGWebMap.Layer.NONE(config);
        layer.setSource(null);
        return callback(layer);
    }
};

/**
 * Helper functions for layers
 * @namespace BKGWebMap.Layer.Util
 * @type {object}
 */
BKGWebMap.Layer.Util = BKGWebMap.Layer.Util || {};

/**
 * Create features for CSV and XLS layers
 * @param {array} json - Data from CSV or XLS
 * @param {CSV|XLS} config - CSV/XLS Configuration
 * @param {string} type - Layer type (CSV/XLS)
 * @param {string} dataProjection - Projection of coordinates in CSV/XLS
 * @param {string} mapProjection - Map projection
 * @returns {object|undefined}
 */
BKGWebMap.Layer.Util.createFeaturesForCsvExcel = function (json, config, type, dataProjection, mapProjection) {
    var features = [];
    var i;

    // Header
    var header = BKGWebMap.LAYERS[type].HEADER;
    if (typeof config.header === 'boolean') {
        header = config.header;
    }
    var headerArray = [];

    var startPosition = 0;
    if (header) {
        startPosition = 1;
        headerArray = json[0];
    } else {
        startPosition = 0;
        if (config.columnNames && config.columnNames instanceof Array) {
            headerArray = config.columnNames;
        }
    }

    // Columns to parse
    var columns = null;
    var typeOfcolumnsToParse;
    if (config.columnsToParse && config.columnsToParse instanceof Array) {
        columns = config.columnsToParse;
        typeOfcolumnsToParse = typeof columns[0];
    }

    // Create an array with column positions using header names
    if (columns && typeOfcolumnsToParse === 'string' && json[0] instanceof Array) {
        var tempColumns = [];
        var position;
        for (i = 0; i < columns.length; i++) {
            position = json[0].indexOf(columns[i]);
            if (position !== -1) {
                tempColumns.push(position + 1);
            }
        }
        columns = tempColumns;
    }

    if (!columns && json[0] instanceof Array) {
        columns = [];
        for (i = 0; i < json[0].length; i++) {
            columns.push(i + 1);
        }
    }

    if (config.LatColumn && config.LonColumn && json[0] instanceof Array) {
        var latColumn;
        var lonColumn;
        var lat;
        var lon;

        if (typeof config.LatColumn === 'string') {
            var latPosition = json[0].indexOf(config.LatColumn);
            if (latPosition !== -1) {
                latColumn = latPosition + 1;
            }

            var lonPosition = json[0].indexOf(config.LonColumn);
            if (lonPosition !== -1) {
                lonColumn = lonPosition + 1;
            }
        } else {
            latColumn = config.LatColumn;
            lonColumn = config.LonColumn;
        }

        for (i = startPosition; i < json.length; i++) {
            if (!json[i][latColumn - 1] || !json[i][lonColumn - 1]) {
                continue;
            }
            lat = parseFloat(json[i][latColumn - 1].replace(',', '.').replace(' ', ''));
            lon = parseFloat(json[i][lonColumn - 1].replace(',', '.').replace(' ', ''));
            if (isNaN(lat) || isNaN(lon)) {
                continue;
            }
            var properties = {};
            for (var k = 0; k < columns.length; k++) {
                var key = '';
                var value = '';
                if (typeof columns[k] === 'number') {
                    if (header) {
                        // Try to use titles from 1st line
                        if (header && headerArray[columns[k] - 1] !== undefined) {
                            key = headerArray[columns[k] - 1];
                        }
                    } else if (headerArray[k] !== undefined && headerArray[k] !== '') {
                        // Try to use titles defined by user (columnNames)
                        key = headerArray[k];
                    } else {
                        key = 'key' + k;
                    }
                    if (json[i][columns[k] - 1] !== undefined) {
                        value = json[i][columns[k] - 1];
                    }
                    properties[key] = value;
                }
            }
            properties.geometry = new ol.geom.Point(ol.proj.transform([lon, lat], dataProjection, mapProjection));
            features.push(new ol.Feature(properties));
        }
        return features;
    }
    return undefined;
};

/**
 * Parse JSON with CSV/XLS data
 * @param {string} format - Layer type (CSV/XLS)
 * @param {array} json - Array with CSV/XLS data
 * @param {CSV|XLS} config - CSV/XLS Configuration
 * @param {object} options - Options used to parse data from XLS/CSV
 * @param {string} featureProjection - EPSG Code of data projection in XLS/CSV
 * @param {string} mapProjection - EPSG Code of map projection
 * @param {string|undefined} copyright - Data copyright
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {function}
 */
BKGWebMap.Layer.Util.parseCsvExcelJson = function (format, json, config, options, featureProjection, mapProjection, copyright, callback) {
    var features = BKGWebMap.Layer.Util.createFeaturesForCsvExcel(json, options, config.type, featureProjection, mapProjection);
    if (features.length === 0) {
        window.console.log(BKGWebMap.ERROR.csvExcelCoordMissing + config.type);
        return callback(undefined);
    }

    ol.inherits(BKGWebMap.Layer[format], ol.layer.Vector);
    var layer = new BKGWebMap.Layer[format](config);

    var sourceOptions = {
        features: features
    };
    // All other possible Vector source options, even those not included in Documentation
    var extraSourceOptions = [
        'attributions',
        'logo',
        'overlaps',
        'useSpatialIndex',
        'wrapX'
    ];
    for (var i = 0; i < extraSourceOptions.length; i++) {
        if (config[extraSourceOptions[i]]) {
            sourceOptions[extraSourceOptions[i]] = config[extraSourceOptions[i]];
        }
    }

    var source = new ol.source.Vector(sourceOptions);
    layer.setSource(source);

    if (copyright) {
        config.copyright = copyright;
    }

    return callback(layer);
};

/**
 * Create features for GPS through a custom layer
 * @param {object} gpx - GPX data
 * @param {GPS} config - GPS Configuration
 * @param {string} gpsProjection - EPSG Code of GPX data projection
 * @param mapProjection - EPSG Code of map projection
 * @param {function} callback - Callback function. It will be called when all information of layer are parsed.
 * @returns {function}
 */
BKGWebMap.Layer.Util.createFeaturesForGps = function (gpx, config, gpsProjection, mapProjection, callback) {
    ol.inherits(BKGWebMap.Layer.GPS, ol.layer.Vector);
    var layer = new BKGWebMap.Layer.GPS(config);
    var gpxFormat = new ol.format.GPX();
    var source = new ol.source.Vector();
    layer.setSource(source);

    var features = gpxFormat.readFeatures(gpx, {
        dataProjection: gpsProjection,
        featureProjection: mapProjection
    });
    source.addFeatures(features);
    return callback(layer);
};

/**
 * Find configuration for layers that are programmatically added
 * @param {object} layer - Layer added
 * @returns {object|string}
 */
BKGWebMap.Layer.Util.programmaticLayerConfig = function (layer) {
    var config = {};
    var layersArray;
    var i;
    var urls;

    if (layer.getSource() instanceof ol.source.ImageWMS) {
        config.type = 'WMS';
        config.tiles = false;
        config.layers = [];
        if (layer.getSource().getParams().LAYERS) {
            layersArray = layer.getSource().getParams().LAYERS.split(',');
            if (layersArray.length) {
                for (i = 0; i < layersArray.length; i++) {
                    config.layers.push({
                        layer: layersArray[i]
                    });
                }
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }
        if (layer.getProperties().name) {
            config.name = layer.getProperties().name;
        } else {
            config.name = 'WMS Layer';
        }

        if (layer.getProperties().copyright) {
            config.copyright = layer.getProperties().copyright;
        }

        if (layer.getProperties().legendUrl) {
            config.legendUrl = layer.getProperties().legendUrl;
        }

        if (typeof layer.getSource().getUrl === 'function') {
            var url = layer.getSource().getUrl();
            if (url) {
                config.url = url;
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }
        return config;
    } else if (layer.getSource() instanceof ol.source.TileWMS) {
        config.type = 'WMS';
        config.tiles = true;
        config.layers = [];
        if (layer.getSource().getParams().LAYERS) {
            layersArray = layer.getSource().getParams().LAYERS.split(',');
            if (layersArray.length) {
                for (i = 0; i < layersArray.length; i++) {
                    config.layers.push({
                        layer: layersArray[i]
                    });
                }
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }
        if (layer.getProperties().name) {
            config.name = layer.getProperties().name;
        } else {
            config.name = 'WMS Layer';
        }

        if (layer.getProperties().copyright) {
            config.copyright = layer.getProperties().copyright;
        }

        if (layer.getProperties().legendUrl) {
            config.legendUrl = layer.getProperties().legendUrl;
        }

        if (typeof layer.getSource().getUrls === 'function') {
            urls = layer.getSource().getUrls();
            if (urls.length) {
                config.url = urls[0];
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }
        return config;
    } else if (layer.getSource() instanceof ol.source.WMTS) {
        if (typeof layer.getSource().getLayer === 'function') {
            var layerToLoad = layer.getSource().getLayer();
            if (layerToLoad) {
                config.layer = layerToLoad;
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }

        if (layer.getProperties().name) {
            config.name = layer.getProperties().name;
        } else {
            config.name = 'WMTS Layer';
        }

        if (typeof layer.getSource().getUrls === 'function') {
            urls = layer.getSource().getUrls();
            if (urls.length) {
                config.url = urls[0];
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }


        if (typeof layer.getSource().getMatrixSet === 'function') {
            var matrixSet = layer.getSource().getMatrixSet();
            if (matrixSet) {
                config.matrixSet = matrixSet;
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }

        if (typeof layer.getSource().getTileGrid === 'function') {
            var tileGrid = layer.getSource().getTileGrid();
            if (tileGrid) {
                config.tileGrid = tileGrid;
            } else {
                return undefined;
            }
        } else {
            return undefined;
        }
        return config;
    } else if (layer instanceof ol.layer.Vector) {
        var uniqueId = BKGWebMap.Util.uniqueId();
        return uniqueId;
    }
};

/**
 * @classdesc Class to test if json config file exists and then parse it.
 * @constructor BKGWebMap.ParseConfig
 * */
BKGWebMap.ParseConfig = function () {
    this.exists = false;
    this.json = null;
};

/**
 * Tests if config JSON exists in Server
 * @memberOf BKGWebMap.ParseConfig
 * @param {boolean} configFile - Find if the configuration will be loaded from a file
 * @param {null|string|object} configUrlOrJson - URL of JSON configuration file or object with configuration
 * @param {function} callback - Callback to use JSON
 * @returns {function}
 */
BKGWebMap.ParseConfig.prototype.LoadJSON = function (configFile, configUrlOrJson, callback) {
    var _this = this;

    // Neither JSON as parameter nor JSON file
    if (!configFile && configUrlOrJson === null) {
        _this.exists = false;
        return callback();
    }

    // JSON as parameter
    if (!configFile && configUrlOrJson !== null) {
        _this.exists = true;
        _this.json = configUrlOrJson;
        return callback();
    }

    // JSON file
    var xhr = new XMLHttpRequest();
    xhr.open('GET', configUrlOrJson);
    xhr.setRequestHeader('Content-Type', 'application/json');
    xhr.onload = function () {
        var json = null;
        if (xhr.status === 200) {
            json = JSON.parse(xhr.responseText);
            _this.exists = true;
            _this.json = json;
        } else if (xhr.status !== 200) {
            _this.exists = false;
            window.console.log(BKGWebMap.ERROR.jsonFile + configUrlOrJson);
        }
        return callback();
    };
    xhr.send();
};

/**
 * Parse map target.
 * @param {string} div - ID of map div.
 * @param {boolean} setTarget - Boolean to check if div ID is defined in setTarget()
 * @returns {string}
 */
BKGWebMap.ParseConfig.prototype.createConfigTarget = function (div, setTarget) {
    var targetInJson = null;
    if (BKGWebMap.Util.hasNestedProperty(this.json, 'map.div')) {
        targetInJson = this.json.map.div;
    }

    // Overwrite div id only if is defined in JSON and setTarget() was not used
    if (targetInJson && !setTarget) {
        div = this.json.map.div;
    }
    return div;
};

/**
 * Parse map view configuration.
 * @param {object} defaultConfigView - Default view configuration.
 * @param {object} userConfigView - View configuration defined in setView().
 * @param {boolean} setView - Boolean to check if setView() is used.
 * @returns {object}
 */
BKGWebMap.ParseConfig.prototype.createConfigView = function (defaultConfigView, userConfigView, setView) {
    // Priority: Code -> JSON -> Defaults

    // Key: name of property / Value: json path in dot notation
    // Place projection as first key
    var keysToParse = {
        projection: 'map.projection',
        extent: null,
        resolution: 'map.resolution',
        zoom: 'map.zoom',
        center: 'map.center',
        resolutions: 'map.resolutions',
        // scales: 'map.scales',
        minResolution: 'map.minResolution',
        maxResolution: 'map.maxResolution',
        minZoom: 'map.minZoom',
        maxZoom: 'map.maxZoom'
    };

    var viewConfig = {};
    var isKeyinCode = {};
    var isKeyInJSON = {};
    var projection = defaultConfigView.projection;

    // Parse function for View parameters that are not possible to be defined in config JSON
    function notDefinedInJSON(_this, keyInCode, paramName) {
        var viewConfigValue;
        if (setView && keyInCode) {
            viewConfigValue = userConfigView[paramName];
        } else {
            switch (paramName) {
            case 'extent':
                // If user uses a different projection than the default
                // without defining extent, do not use default extent.
                // Use an extent of the right projection
                if (viewConfig.projection !== defaultConfigView.projection) {
                    viewConfigValue = BKGWebMap.PROJECTIONS_EXTENTS[viewConfig.projection];
                } else {
                    viewConfigValue = defaultConfigView.extent;
                }
                break;
            default:
                viewConfigValue = defaultConfigView[paramName];
            }
        }
        return viewConfigValue;
    }

    // Parse function for View parameters that are possible to be defined in config JSON
    function definedInJSON(_this, keyInCode, keyInJSON, paramName, jsonPath) {
        var viewConfigValue;
        var lon;
        var lat;
        if (setView && keyInCode) {
            switch (paramName) {
            case 'center':
                lon = BKGWebMap.Util.getObjValueFromStringPath(userConfigView, ('center.lon'));
                lat = BKGWebMap.Util.getObjValueFromStringPath(userConfigView, ('center.lat'));
                if ((lon || lon === 0) && (lat || lat === 0)) {
                    viewConfigValue = [lon, lat];
                }
                break;
            default:
                viewConfigValue = userConfigView[paramName];
            }
        } else if (keyInJSON) {
            if (BKGWebMap.Util.getObjValueFromStringPath(_this.json, jsonPath)) {
                switch (paramName) {
                case 'center':
                    lon = BKGWebMap.Util.getObjValueFromStringPath(_this.json, (jsonPath + '.lon'));
                    lat = BKGWebMap.Util.getObjValueFromStringPath(_this.json, (jsonPath + '.lat'));
                    if (lon && lat) {
                        viewConfigValue = [lon, lat];
                    }
                    break;
                default:
                    viewConfigValue = BKGWebMap.Util.getObjValueFromStringPath(_this.json, jsonPath);
                }
            }
        } else if (paramName === 'projection') {
            return projection;
        }
        return viewConfigValue;
    }

    // OpenLayers: If we have resolution, the property zoom will not be used
    function clearResolution(_this) {
        var resolutionInCode = BKGWebMap.Util.hasNestedProperty(userConfigView, 'resolution');
        var resolutionInJSON = BKGWebMap.Util.hasNestedProperty(_this.json, 'map.resolution');
        var zoomInCode = BKGWebMap.Util.hasNestedProperty(userConfigView, 'zoom');
        var zoomInJSON = BKGWebMap.Util.hasNestedProperty(_this.json, 'map.zoom');

        // Code: zoom(Y), resolution(N)
        // JSON: resolution(Y)
        // Action: Remove resolution
        if (setView && zoomInCode && !resolutionInCode && resolutionInJSON && _this.json.map.resolution) {
            delete viewConfig.resolution;
        }

        // Code: zoom(N), resolution(N)
        // JSON: zoom(Y), resolution(N)
        // Action: Remove resolution
        if (setView && !zoomInCode && !resolutionInCode && zoomInJSON && (!resolutionInJSON || !_this.json.map.resolution)) {
            if (_this.json.map.zoom) {
                delete viewConfig.resolution;
            }
        }
    }

    function clearResolutions() {
        // If resolutions are not defined in setView() or in JSON,
        // use default resolutions according to projection
        if (!viewConfig.resolutions && viewConfig.projection) {
            var projection = ol.proj.get(viewConfig.projection);
            var units = projection.getUnits();
            switch (units) {
            case 'm':
                viewConfig.resolutions = BKGWebMap.RESOLUTIONS;
                break;
            case 'degrees':
                viewConfig.resolutions = BKGWebMap.RESOLUTIONS_DEGREE;
                break;
            default:
                return;
            }
        }

        // If minResolution and maxResolution OR minZoom and maxZoom
        // are defined in setView() or in JSON, them remove resolutions
        if ((viewConfig.minResolution && viewConfig.maxResolution) || (viewConfig.minZoom && viewConfig.maxZoom)) {
            delete viewConfig.resolutions;
        }
    }

    function addExtraKeys() {
        // Add to View all other keys that are defined in setDiv().
        // They will be automatically used, if they are legal OpenLayers options of ol.View().
        if (setView) {
            for (var param in userConfigView) {
                if (!keysToParse[param]) {
                    viewConfig[param] = userConfigView[param];
                }
            }
        }
    }

    for (var param in keysToParse) {
        // Find if parameter is used in setView()
        isKeyinCode[param] = BKGWebMap.Util.hasNestedProperty(userConfigView, param);

        // Find if parameter is defined in config JSON
        if (keysToParse[param]) {
            isKeyInJSON[keysToParse[param]] = BKGWebMap.Util.hasNestedProperty(this.json, keysToParse[param]);
        }

        if (!keysToParse[param]) {
            // Not possible to be defined in config JSON
            viewConfig[param] = notDefinedInJSON(this, isKeyinCode[param], param);
        } else {
            // Possible to be defined in config JSON
            viewConfig[param] = definedInJSON(this, isKeyinCode[param], isKeyInJSON[keysToParse[param]], param, keysToParse[param]);
            if (viewConfig[param] === undefined) {
                // Remove undefined properties
                delete viewConfig[param];
            }
        }
    }

    // Resolve conflicts between resolution and zoom in setView() and in JSON
    clearResolution(this);

    // Resolve problems created by resolutions
    clearResolutions();

    // Add any other OpenLayers options parsed by setView()
    addExtraKeys();

    return viewConfig;
};

/**
 * Create panel control
 * @param {Object} map - OpenLayers map
 * @param {Object|null} controlsConfig - Controls configuration defined by user
 * @param {boolean} setControls - Boolean to check if setControls() is used
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {Object|boolean}
 */
BKGWebMap.ParseConfig.prototype.createControlPanel = function (map, controlsConfig, setControls, standardPositionControls) {
    var controls = {};
    if (this.exists && !setControls && Object.prototype.hasOwnProperty.call(this.json, 'options')) {
        if (Object.prototype.hasOwnProperty.call(this.json, 'options') && (typeof this.json.options === 'object' && this.json.options.constructor === Object)) {
            controls = this.json.options;
        } else {
            controls = BKGWebMap.CONTROLS;
        }
    } else if (setControls) {
        controls = controlsConfig;
    } else {
        controls = BKGWebMap.CONTROLS;
    }

    // Find if we need panel
    var createPanel = BKGWebMap.Util.shouldCreatePanel(controls);

    if (createPanel) {
        var panelPosition = controls.panelPosition;
        var initialize = controls.initialize;
        var Panel = BKGWebMap.Control.FACTORIES.panel();
        var panelControl = new Panel(map, panelPosition, initialize, standardPositionControls);
        // Add panel control
        if (Object.keys(panelControl).length > 0) {
            return panelControl;
        }
    }
    return false;
};

/**
 * Create controls
 * @param {Object} map - OpenLayers map
 * @param {Object|null} controlsConfig - Controls configuration defined by user
 * @param {boolean} setControls - Boolean to check if setControls() is used
 * @param {Object|boolean} panel - Panel object
 * @param {object} standardPositionControls - Object with standardPositionControls
 * @returns {Array}
 */
BKGWebMap.ParseConfig.prototype.createControls = function (map, controlsConfig, setControls, panel, standardPositionControls) {
    var controls = {};
    var controlsArray = [];
    if (this.exists && !setControls && Object.prototype.hasOwnProperty.call(this.json, 'options')) {
        if (Object.prototype.hasOwnProperty.call(this.json.options, 'tools') && (typeof this.json.options.tools === 'object' && this.json.options.tools.constructor === Object)) {
            for (var tool in this.json.options.tools) {
                controls[tool] = this.json.options.tools[tool];
            }
        } else {
            controls = BKGWebMap.CONTROLS.tools;
        }
    } else if (setControls && Object.prototype.hasOwnProperty.call(controlsConfig, 'tools')) {
        controls = controlsConfig.tools;
    } else {
        controls = BKGWebMap.CONTROLS.tools;
    }
    // Filter controls and define order in which they will be generated
    var controlsList = [
        'geoSearch',
        'searchCoordinates',
        'copyCoordinates',
        'showAttributes',
        'legend',
        'layerSwitcher',
        'customLayers',
        'zoom',
        'scalebar',
        'copyright',
        'showCoordinates',
        'staticLinks',
        'staticWindows',
        'fullScreen',
        'measure',
        'edit',
        'share',
        'overviewMap',
        'timeSlider'
    ];

    var SingleControlClass;
    var singleControl;
    for (var i = 0; i < controlsList.length; i++) {
        if (controls[controlsList[i]] && ((typeof controls[controlsList[i]] === 'object' && controls[controlsList[i]].constructor === Object))) {
            SingleControlClass = BKGWebMap.Control.FACTORIES[controlsList[i]]();
            singleControl = new SingleControlClass(map, controlsList[i], controls[controlsList[i]], panel, standardPositionControls);
            // Remove extra classes from FullScreen control DIV and button (to prevent div getting the button style)
            if (singleControl instanceof ol.control.FullScreen && !singleControl.inactive) {
                singleControl.element.classList.remove('bkgwebmap-mapbutton');
                singleControl.element.children[0].classList.remove('bkgwebmap-standardpositioncontrol');
                singleControl.element.children[0].classList.remove('bkgwebmap-standardpositioncontrolleft');
                singleControl.element.children[0].classList.remove('bkgwebmap-standardpositioncontrolright');
            }
            // Add controls
            if (Object.keys(singleControl).length > 0 && !singleControl.inactive) {
                controlsArray.push(singleControl);
                BKGWebMap.Controls[controlsList[i]] = singleControl;
            }
        } else if (controls[controlsList[i]] && controls[controlsList[i]] instanceof Array) {
            var multipleControlsClass = {};
            var multipleControls = {};
            for (var k = 0; k < controls[controlsList[i]].length; k++) {
                multipleControlsClass[k] = BKGWebMap.Control.FACTORIES[controlsList[i]](k);
                multipleControls[k] = new multipleControlsClass[k](map, controlsList[i], controls[controlsList[i]][k], panel, standardPositionControls);
                // Add controls
                if (Object.keys(multipleControls[k]).length > 0 && !multipleControls[k].inactive) {
                    controlsArray.push(multipleControls[k]);
                    BKGWebMap.Controls[controlsList[i] + k] = multipleControls[k];
                }
            }
        }
    }
    return controlsArray;
};

/**
 * Parse styles
 * @param {array} stylesArray - Styles configuration defined by user
 * @param {boolean} defineStyles - Boolean to check if defineStyles() is used
 * @returns {Object}
 */
BKGWebMap.ParseConfig.prototype.createConfigStyles = function (stylesArray, defineStyles) {
    var styles;
    if (this.exists && !defineStyles && Object.prototype.hasOwnProperty.call(this.json, 'styles')) {
        styles = BKGWebMap.Style.createStyles(this.json.styles);
    } else {
        styles = BKGWebMap.Style.createStyles(stylesArray);
    }
    return styles;
};

/**
 * Parse layers configuration
 * @param {object} map - Map object
 * @param {object} defaultConfigLayers - Default layers configuration
 * @param {object|array} userConfigLayers - Layers configuration defined by user
 * @param {boolean} setLayers - Boolean to check if setLayers() is used.
 * @param {function} callback - Callback function
 * @returns {function}
 */
BKGWebMap.ParseConfig.prototype.createConfigLayers = function (map, defaultConfigLayers, userConfigLayers, styles, setLayers, callback) {
    var _this = this;

    var layers = {
        baseLayers: [],
        overlays: []
    };

    // No JSON, no setLayers(): use defaults
    if (!this.exists && !setLayers) {
        userConfigLayers = defaultConfigLayers;
    }

    // Only JSON: use JSON only if key 'layers' is available
    if (this.exists && !setLayers && Object.prototype.hasOwnProperty.call(this.json, 'layers')) {
        userConfigLayers = this.json.layers;
    } else if (this.exists && !setLayers && !Object.prototype.hasOwnProperty.call(this.json, 'layers')) {
        userConfigLayers = defaultConfigLayers;
        // ERROR: layersInJson
        window.console.log(BKGWebMap.ERROR.missingLayersJson);
    }

    // Only setLayers or JSON and setLayers(): use setLayers()
    // If array with ol.layer class, use them as base layers
    if (setLayers && userConfigLayers instanceof Array) {
        userConfigLayers = {
            baseLayers: userConfigLayers
        };
    }

    this.createLayer = function (_this, map, config, layerGroup, styles, bkg, createLayerCallback) {
        var typesList = ['WMS', 'WMTS', 'WFS', 'MARKER', 'CSV', 'XLS', 'GPS', 'BKG', 'GROUP', 'VECTOR', 'NONE'];
        if (config instanceof ol.layer.Base) {
            // ol.layer class
            return createLayerCallback(config);
        } else if (!Object.prototype.hasOwnProperty.call(config, 'type')) {
            // false json without layer 'type' key
            window.console.log(BKGWebMap.ERROR.missingTypeLayersJson);
            return createLayerCallback(undefined);
        } else if (typesList.indexOf(config.type) === -1) {
            // false json with illegal layer type
            window.console.log(BKGWebMap.ERROR.wrongTypeLayersJson + config.type);
            return createLayerCallback(undefined);
        }

        if (layerGroup === 'baseLayers') {
            config.isBaseLayer = true;
        } else if (layerGroup === 'overlays') {
            config.isBaseLayer = false;
        }

        BKGWebMap.Layer.FACTORIES[config.type](_this, map, config, styles, bkg, function (layer) {
            return createLayerCallback(layer);
        });
    };

    // Create instances of ol.layer

    // Find how many layers we need to load (baselayers and overlays)
    var sumLayerListLength = 0;
    if (Object.prototype.hasOwnProperty.call(userConfigLayers, 'baseLayers')) {
        sumLayerListLength += userConfigLayers.baseLayers.length;
    }
    if (Object.prototype.hasOwnProperty.call(userConfigLayers, 'overlays')) {
        sumLayerListLength += userConfigLayers.overlays.length;
    }

    // The requests for the layers can be asynchronous
    // (e.g. when we first make a getCapabilities before loading a WMTS)
    // To preserve the original layer order defined by user, we implement a counter
    var counter = 0;
    for (var layerGroup in layers) {
        if (Object.prototype.hasOwnProperty.call(userConfigLayers, layerGroup)) {
            var layerGroupLength = userConfigLayers[layerGroup].length;
            for (var i = 0; i < layerGroupLength; i++) {
                (function () {
                    var k = i;
                    var _layerGroup = layerGroup;
                    _this.createLayer(_this, map, userConfigLayers[_layerGroup][k], layerGroup, styles, false, function (singleLayer) {
                        counter++;
                        // Do not use false json. There is no problem with an undefined layer. OL does not make any request.
                        if (singleLayer === undefined) {
                            if (counter >= sumLayerListLength) {
                                return callback(layers);
                            }
                            return;
                        }
                        layers[_layerGroup][k] = singleLayer;
                        // Return layers array only if we have loaded all layers
                        if (counter >= sumLayerListLength) {
                            return callback(layers);
                        }
                    });
                }());
            }
        }
    }
};

/**
 * Options for generating and using UUID for secure BKG services
 * @param {Object} securityConfig - Security parameters
 * @param {boolean} setSecurity - If setSecurity() was used in code
 * @param {function} callback - Callback function
 * @returns {function}
 */
BKGWebMap.ParseConfig.prototype.getSecurityOptions = function (map, securityConfig, setSecurity, callback) {
    var security;

    if (this.exists && !setSecurity && Object.prototype.hasOwnProperty.call(this.json, 'options')) {
        if (Object.prototype.hasOwnProperty.call(this.json.options, 'security') && (typeof this.json.options.security === 'object' && this.json.options.security.constructor === Object)) {
            security = this.json.options.security;
        } else {
            security = BKGWebMap.SECURITY;
        }
    } else if (setSecurity) {
        security = securityConfig;
    } else {
        security = BKGWebMap.SECURITY;
    }

    // Check if control should be created
    var addCookieTest = BKGWebMap.CONTROLS.tools.cookieCheck.active;
    if (typeof security.cookieCheck === 'boolean') {
        if (security.cookieCheck === false) {
            BKGWebMap.CONTROLS.tools.cookieCheck.doNotActivate = true;
        }
        addCookieTest = security.cookieCheck;
    }

    if (addCookieTest) {
        var CookieCheckClass = BKGWebMap.Control.FACTORIES.cookieCheck();
        var cookieCheck = new CookieCheckClass(map, 'cookieCheck', {}, null);
        map.addControl(cookieCheck);
        BKGWebMap.Controls.cookieCheck = cookieCheck;
        cookieCheck.activateCookieTest();
    }

    // Polyfill String.prototype.startsWith() for IE11
    if (!String.prototype.startsWith) {
        String.prototype.startsWith = function (search, pos) {
            return this.substr(!pos || pos < 0 ? 0 : +pos, search.length) === search;
        };
    }

    if (!security.UUID && (security.appID && security.appDomain)) {
        BKGWebMap.Util.getSessionToken(security.appID, security.appDomain, function (sessionID) {
            if (sessionID.startsWith('sess-')) {
                security.UUID = sessionID;
            }
            return callback(security);
        });
    } else {
        return callback(security);
    }
};

/**
 * @classdesc Factory-Class to create a Webmapping Application.
 *
 * It creates a Webmapping Application using the configuration provided.
 * To configure the map, you can use the following methods:
 * setLayers(), setControls(), setTarget(), setView(), defineStyles(), setSecurity(), loadConfig().
 * You can initialize the map using the method create().
 *
 * @constructor BKGWebMap.MapBuilder
 * */
BKGWebMap.MapBuilder = function () {
    /**
     * Find if initialize methods have been used
     * @type {object}
     * @memberOf BKGWebMap.MapBuilder
     * @property {boolean} setTarget - Method setTarget()
     * @property {boolean} setView - Method setView()
     * @property {boolean} setLayers - Method setLayers()
     * @property {boolean} defineStyles - Method defineStyles()
     * @property {boolean} setControls - Method setControls()
     * @property {boolean} loadConfig - Method loadConfig()
     * @property {boolean} setSecurity - Method setSecurity()
     */
    this.called = {
        setTarget: false,
        setView: false,
        setLayers: false,
        defineStyles: false,
        setControls: false,
        loadConfig: false,
        setSecurity: false
    };

    /**
     * Standard configuration for view object.
     * @type {object}
     * @memberOf BKGWebMap.MapBuilder
     * @property {string} projection - Default map projection.
     * @property {array} extent - Default map extent.
     */
    this.DEFAULT_VIEW_CONFIG = {
        projection: BKGWebMap.PROJECTION,
        extent: BKGWebMap.EXTENTS[BKGWebMap.PROJECTION]
    };

    /**
     * Standard configuration for layers
     * @type {Object}
     * @memberOf BKGWebMap.MapBuilder
     * @property {array} baseLayers - Array with default baselayers configuration
     */
    this.DEFAULT_LAYERS_CONFIG = {
        baseLayers: [
            BKGWebMap.DEFAULT_LAYER
        ]
    };

    /**
     * OpenLayers map object.
     * @memberOf BKGWebMap.MapBuilder
     * @type {ol.Map|null}
     */
    this.map = null;

    /**
     * ID of HTML-Element that contains the map.
     * @memberOf BKGWebMap.MapBuilder
     * @type {string}
     */
    this.div = BKGWebMap.DEFAULT_MAP_DIV;

    /**
     * Configuration of view object.
     * @memberOf BKGWebMap.MapBuilder
     * @type {object|null}
     */
    this.viewConfig = null;

    /**
     * Configuration of controls object.
     * @memberOf BKGWebMap.MapBuilder
     * @type {object|null}
     */
    this.controlsConfig = null;

    /**
     * Configuration of layers object.
     * @memberOf BKGWebMap.MapBuilder
     * @type {object|null}
     */

    this.layersConfig = null;

    /**
     * Find if the configuration will be loaded from a file
     * @memberOf BKGWebMap.MapBuilder
     * @type {boolean}
     */
    this.configFile = false;

    /**
     * URL of JSON configuration file or object with configuration
     * @memberOf BKGWebMap.MapBuilder
     * @type (null|string|object)
     */
    this.configUrlOrJson = null;

    /**
     * Array with styles configuration that will be used for vector layers
     * @type {array}
     */
    this.stylesArray = [];

    /**
     * BKG WebMap controls
     * @type {array|null}
     */
    this.controls = null;

    /**
     * Object with style names and OpenLayers style classes.
     * @type {object|null}
     */
    this.styles = null;

    /**
     * Current class name
     * @type {string}
     * @constant BKGWebMap.MapBuilder.CLASS_NAME
     */
    this.CLASS_NAME = 'BKGWebMap.MapBuilder';
};

/**
 * Sets the HTML-Element that contains the map
 * @memberOf BKGWebMap.MapBuilder
 * @param {string} div - ID of HMTL-Element that contains the map
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.setTarget = function (div) {
    if (typeof div !== 'undefined' && div !== '') {
        this.div = div;
        this.called.setTarget = true;
    }
    return this;
};

/**
 * Parse configuration for view.
 * Parses the view configuration which is used for creating the map view when calling create.
 * @memberOf BKGWebMap.MapBuilder
 * @param {object|ol.View} viewConfig - Object with configuration parameters for view or ol.View class
 * @param {string} viewConfig.projection - Map projection (/map/projection)
 * @param {object} viewConfig.center - Initial center of map (The coordinate system is defined through the projection) (/map/center)
 * @param {number} viewConfig.center.lat - Map center latitude. (/map/center/lat)
 * @param {number} viewConfig.center.lon - Map center longitude. (/map/center/lon)
 * @param {number|null} viewConfig.resolution - Initial resolution. If null, zoom will be used. (/map/resolution)
 * @param {number[]|null} viewConfig.resolutions - Array with numbers. If set, scales, maxResolution, minResolution, minZoom, and maxZoom are ignored. (/map/resolutions)
 * @param {number[]|null} viewConfig.scales - Array with numbers. It will be used only if resolutions is null. If set, maxResolution, minResolution, minZoom, and maxZoom are ignored. (/map/scales)
 * @param {integer|null} viewConfig.zoom - Initial zoom. It will be used only if resolution is null. (/map/zoom)
 * @param {number[]|null} viewConfig.mapExtent - Initial map extent. Array with numbers: [minX, minY, maxX, maxY] (/map/mapExtent)
 * @param {number|null} viewConfig.maxResolution - Maximum resolution. It will be used only if resolutions and scales are null. If null, maxZoom will be used. (/map/maxResolution)
 * @param {number|null} viewConfig.minResolution - Minimum resolution. It will be used only if resolutions and scales are null. If null, minZoom will be used. (/map/minResolution)
 * @param {integer|null} viewConfig.maxZoom - Maximum zoom. It will be used only if maxResolution, resolutions and scales are null. (/map/maxZoom)
 * @param {integer|null} viewConfig.minZoom - Minimum zoom. It will be used only if minResolution, resolutions and scales are null. (/map/minZoom)
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.setView = function (viewConfig) {
    if (viewConfig && ((typeof viewConfig === 'object' && viewConfig.constructor === Object) || viewConfig instanceof ol.View)) {
        this.viewConfig = viewConfig;
        this.called.setView = true;
    } else {
        this.viewConfig = this.DEFAULT_VIEW_CONFIG;
    }
    return this;
};

/**
 * Parses the controls configuration which is used for creating the interactive control elements of the map when calling create.
 * @memberOf BKGWebMap.MapBuilder
 *
 * @param {object} controlsConfig - Object with configuration parameters for controls. (/options)
 *
 * @param {string} controlsConfig.panelPosition - Panel position (Values: "left", "right") (/options/panelPosition)
 * @param {string|null} controlsConfig.initialize - Tool that should be shown, when starting the Application. If empty or null, then panel will be closed. (Values: "geoSearch", "searchCoordinates", "layerSwitcher", "legend", "showAttributes", "copyCoordinates", "measure", "edit", "share") (/options/initialize)
 * @param {object} controlsConfig.tools - Tools in panel. (/options/tools)
 *
 * @param {object} controlsConfig.tools.geoSearch - Search a place through name. (/options/tools/geoSearch). See properties in {@link geoSearch_options}
 * @param {object} controlsConfig.tools.searchCoordinates - Tools in panel. (/options/tools/searchCoordinates). See properties in {@link searchCoordinates_options}
 * @param {object} controlsConfig.tools.layerSwitcher - Layer menu. (/options/tools/layerSwitcher). See properties in {@link layerSwitcher_options}
 * @param {object} controlsConfig.tools.customLayers - User can add new layers. (/options/tools/customLayers). See properties in {@link customLayers_options}
 * @param {object} controlsConfig.tools.legend - Show legend. (/options/tools/legend). See properties in {@link legend_options}
 * @param {object} controlsConfig.tools.showAttributes - Show attributes with click on map. (/options/tools/showAttributes). See properties in {@link showAttributes_options}
 * @param {object} controlsConfig.tools.copyCoordinates - Tool to copy coordinates. (/options/tools/copyCoordinates). See properties in {@link copyCoordinates_options}
 * @param {object} controlsConfig.tools.measure - Measure tool. (/options/tools/measure). See properties in {@link measure_options}
 * @param {object} controlsConfig.tools.edit - Edit vector layers tool. (/options/tools/edit). See properties in {@link edit_options}
 * @param {object} controlsConfig.tools.share - Share map. (/options/tools/share). See properties in {@link share_options}
 * @param {object} controlsConfig.tools.zoom - Zoom control. (/options/tools/zoom). See properties in {@link zoom_options}
 * @param {object} controlsConfig.tools.scalebar - Scalebar control. (/options/tools/scalebar). See properties in {@link scalebar_options}
 * @param {object} controlsConfig.tools.copyright - Copyright control. (/options/tools/copyright). See properties in {@link copyright_options}
 * @param {object} controlsConfig.tools.showCoordinates - Show coordinates of cursor position. (/options/tools/showCoordinates). See properties in {@link showCoordinates_options}
 * @param {object[]} controlsConfig.tools.staticLinks - Static links on map. (/options/tools/staticLinks) <br> See properties <b>of each Object in Array</b> in {@link staticLinks_options}
 * @param {object[]} controlsConfig.tools.staticWindows - Static windows on map. (/options/tools/staticWindows) <br> See properties <b>of each Object in Array</b> in {@link staticWindows_options}
 * @param {object} controlsConfig.tools.fullScreen - Full screen tool. (/options/tools/fullScreen). See properties in {@link fullScreen_options}
 * @param {object} controlsConfig.tools.overviewMap - Overview map tool. (/options/tools/overviewMap). See properties in {@link overviewMap_options}
 * @param {object} controlsConfig.tools.timeSlider - Timeslider tool for WMS-T. (/options/tools/timeSlider). See properties in {@link timeSlider_options}
 *
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.setControls = function (controlsConfig) {
    if (controlsConfig && (typeof controlsConfig === 'object' && controlsConfig.constructor === Object) || controlsConfig instanceof Array) {
        this.controlsConfig = controlsConfig;
        this.called.setControls = true;
    }
    return this;
};

/**
 * WMS layer (/layers/baseLayer|overlays/items/WMS)
 * @typedef {object} WMS
 * @property {string} type - Type of layer: WMS (/layers/baseLayer|overlays/items/WMS/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/WMS/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/WMS/name)
 * @property {string} url - Service-URL. (/layers/baseLayer|overlays/items/WMS/url)
 * @property {object[]} layers - Layers of specific service that should be loaded. If empty, then all available layers will be loaded. (/layers/baseLayer|overlays/items/WMS/layers) <br> <b>Below are properties of each Object in Array:</b>
 * @property {string|null} layers.id - Unique ID. (/layers/baseLayer|overlays/items/WMS/layers/id)
 * @property {string} layers.name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/WMS/layers/name)
 * @property {string} layers.layer - Name of layer to load. (/layers/baseLayer|overlays/items/WMS/layers/layer)
 * @property {boolean} layers.visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/WMS/layers/visibility)
 * @property {string|null} layers.style - Style of layer. (/layers/baseLayer|overlays/items/WMS/layers/style)
 * @property {boolean} layers.selectStyle - The user is able to select a style for this layer. (/layers/baseLayer|overlays/items/WMS/layers/selectStyle)
 * @property {string|null} layers.legendUrl - URL for legend. If empty or null, legend will be loaded using GetLegendGraphic. (/layers/baseLayer|overlays/items/WMS/layers/legendUrl)
 * @property {number} layers.minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/WMS/layers/minResolution)
 * @property {number} layers.maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/WMS/layers/maxResolution)
 * @property {boolean} visibility - Selected visibility of layer. (/layers/baseLayer|overlays/items/WMS/visibility)
 * @property {boolean} tiles - Load tiles or single image. (/layers/baseLayer|overlays/items/WMS/tiles)
 * @property {string|null} version - WMS version. If null, 1.3.0 will be used. (Values: "1.1.0", "1.1.1", 1.3.0") (/layers/baseLayer|overlays/items/WMS/version)
 * @property {string|null} srsName - Projection of layer. If null, then EPSG 25832 will be used. (/layers/baseLayer|overlays/items/WMS/srsName)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/WMS/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/WMS/maxResolution)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/WMS/opacity)
 * @property {string|null} legendUrl - URL for legend. If empty or null, legend will be loaded using GetLegendGraphic. It has priority over legendUrl in each WMS-Layer (/layers/WMS/layers/items/legendUrl). (/layers/baseLayer|overlays/items/WMS/legendUrl)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/WMS/copyright)
 * @property {object} time - Time options for WMS-T. (/layers/baseLayer|overlays/items/WMS/time)
 * @property {boolean} time.active - Activate tool. (/layers/baseLayer|overlays/items/WMS/time/active)
 * @property {string} time.values - Specify time range and interval in ISO 8601 format. Example: '2016-03-10T23:00:00.000Z/2016-03-15T23:00:00.000Z/P1D'. Infos: https://en.wikipedia.org/wiki/ISO_8601. (/layers/baseLayer|overlays/items/WMS/time/values)
 * @property {string} time.mode - Time slider mode. Values: 'period|time'. If not defined, both modes will be used.
 * @property {string} time.default - Default value for time slider
 */
/**
 * WTMS layer (/layers/baseLayer|overlays/items/WTMS)
 * @typedef {object} WMTS
 * @property {string} type - Type of layer: WMTS (/layers/baseLayer|overlays/items/WMTS/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/WMTS/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/WMTS/name)
 * @property {string} url - Service-URL. (/layers/baseLayer|overlays/items/WMTS/url)
 * @property {string} layer - Service-URL. If the URL ends with .xml, then make a getCapabilites request and use the response to load the layer.(/layers/baseLayer|overlays/items/WMTS/layer)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/WMTS/visibility)
 * @property {string|null} srsName - Projection of layer. If null, then EPSG 25832 will be used. (/layers/baseLayer|overlays/items/WMTS/srsName)
 * @property {object} tileGrid - Tile grid options (/layers/baseLayer|overlays/items/WMTS/tileGrid)
 * @property {array|null} tileGrid.origin - Tile grid origin. Array with numbers [lon, lat] or null. (/layers/baseLayer|overlays/items/WMTS/tileGrid/origin)
 * @property {array|null} tileGrid.resolutions - Array with numbers. (/layers/baseLayer|overlays/items/WMTS//tileGrid/resolutions)
 * @property {array|null} tileGrid.matrixIds - Array with strings. The length of this array needs to match the length of the resolutions array. (/layers/baseLayer|overlays/items/WMTS//tileGrid/matrixIds)
 * @property {string|null} version - WMTS version. Always 1.0.0 (/layers/baseLayer|overlays/items/WMTS/version)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/WMTS/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/WMTS/maxResolution)
 * @property {string|null} style - Style of WMTS. If null, default will be loaded. (/layers/baseLayer|overlays/items/WMTS/style)
 * @property {string|null} matrixSet - Matrix set. (/layers/baseLayer|overlays/items/WMTS/matrixSet)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/WMTS/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/WMTS/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/WMS/layers/items/legendUrl). (/layers/baseLayer|overlays/items/WMTS/legendUrl)
 */
/**
 * WFS layer (/layers/baseLayer|overlays/items/WFS)
 * @typedef {object} WFS
 * @property {string} type - Type of layer: WFS (/layers/baseLayer|overlays/items/WFS/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/WFS/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/WFS/name)
 * @property {string} typename - Typename of WFS (namespace:featuretype). (/layers/baseLayer|overlays/items/WFS/typename)
 * @property {string} url - Service-URL. (/layers/baseLayer|overlays/items/WFS/url)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/WFS/visibility)
 * @property {string|null} srsName - Projection of layer. If null, then EPSG 25832 will be used. (/layers/baseLayer|overlays/items/WFS/srsName)
 * @property {string|null} format - Format for WFS layers. If null, then GML3 will be used. (Values: "GEOJSON", "GML2" ,"GML3") (/layers/baseLayer|overlays/items/WFS/format)
 * @property {string|null} version - WFS version. If null, 1.1.0 will be used. (Values: "1.0.0", "1.1.0", 2.0.0") (/layers/baseLayer|overlays/items/WFS/version)
 * @property {boolean} tiles - Load layer using tile strategy. (/layers/baseLayer|overlays/items/WFS/tiles)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/WFS/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/WFS/maxResolution)
 * @property {boolean} edit - Enable edit layer. Always false. (/layers/baseLayer|overlays/items/WFS/edit)
 * @property {string|null} style - Style of WFS. Use /styles/items/name. (/layers/baseLayer|overlays/items/WFS/style)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/WFS/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/WFS/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/baseLayer|overlays/items/WFS/legendUrl)
 */
/**
 * MARKER layer (/layers/baseLayer|overlays/items/MARKER)
 * @typedef {object} MARKER
 * @property {string} type - Type of layer: MARKER (/layers/baseLayer|overlays/items/MARKER/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/MARKER/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/MARKER/name)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/MARKER/visibility)
 * @property {string|null} srsName - Projection of layer. If null, then EPSG 4326 will be used. (/layers/baseLayer|overlays/items/MARKER/srsName)
 * @property {object[]} markers - List of markers. (/layers/baseLayer|overlays/items/MARKER/markers) <br> <b>Below are properties of each Object in Array:</b>
 * @property {object} coordinates - Coordinates of marker. The coordinate system is defined through srsName.  (/layers/baseLayer|overlays/items/MARKER/coordinates)
 * @property {number} coordinates.lat - Marker latitude. (/layers/baseLayer|overlays/items/MARKER/coordinates/lat)
 * @property {number} coordinates.lon - Marker longitude. (/layers/baseLayer|overlays/items/MARKER/coordinates/lon)
 * @property {string} markers.content - Content for info area. Markup is allowed. (/layers/baseLayer|overlays/items/MARKER/markers/content)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/MARKER/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/MARKER/maxResolution)
 * @property {boolean} edit - Enable edit layer. Always false. (/layers/baseLayer|overlays/items/MARKER/edit)
 * @property {string|null} style - Style of WFS. Use /styles/items/name. (/layers/baseLayer|overlays/items/MARKER/style)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/MARKER/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/MARKER/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/baseLayer|overlays/items/MARKER/legendUrl)
 */
/**
 * CSV layer (/layers/baseLayer|overlays/items/CSV)
 * @typedef {object} CSV
 * @property {string} type - Type of layer: CSV (/layers/baseLayer|overlays/items/CSV/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/CSV/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/CSV/name)
 * @property {string} url - URL of CSV file. (/layers/baseLayer|overlays/items/CSV/url)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/CSV/visibility)
 * @property {string|null} srsName - Projection of layer. If null, then EPSG 4326 will be used. (/layers/baseLayer|overlays/items/CSV/srsName)
 * @property {object} csvOptions - Options only for CSV layer. (/layers/baseLayer|overlays/items/CSV/csvOptions)
 * @property {boolean} csvOptions.header - Should the first row be used as header. (/layers/baseLayer|overlays/items/CSV/csvOptions/header)
 * @property {string} csvOptions.delimiter - Delimiter used in CSV file (default: ";"). (/layers/baseLayer|overlays/items/CSV/csvOptions/delimiter)
 * @property {integer[]} csvOptions.columnsToParse - Names (strings) or positions (integer) of columns that should be used as attributes. 1 is the start position. If null, then all columns will be used. (/layers/baseLayer|overlays/items/CSV/csvOptions/columnsToParse)
 * @property {integer[]} csvOptions.columnNames - ADefine custom column names. Used only if header is false. The length should be the same as in columnsToParse.. (/layers/baseLayer|overlays/items/CSV/csvOptions/columnNames)
 * @property {string|integer} csvOptions.LatColumn - Name (string) or position (integer) of column with coordinates (Lat). The coordinate system is defined through srsName. (/layers/baseLayer|overlays/items/CSV/csvOptions/LatColumn)
 * @property {string|integer} csvOptions.LonColumn - Name (string) or position (integer) of column with coordinates (Lon). The coordinate system is defined through srsName. (/layers/baseLayer|overlays/items/CSV/csvOptions/LonColumn)
 * @property {string} csvOptions.encoding - The encoding to use when opening the file (default: "UTF-8"). (/layers/baseLayer|overlays/items/CSV/csvOptions/encoding)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/CSV/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/CSV/maxResolution)
 * @property {boolean} edit - Enable edit layer. Always false. (/layers/baseLayer|overlays/items/CSV/edit)
 * @property {string|null} style - Style of WFS. Use /styles/items/name. (/layers/baseLayer|overlays/items/CSV/style)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/CSV/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/CSV/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/baseLayer|overlays/items/CSV/legendUrl)
 */
/**
 * XLS layer (/layers/baseLayer|overlays/items/XLS)
 * @typedef {object} XLS
 * @property {string} type - Type of layer: XLS (/layers/baseLayer|overlays/items/XLS/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/XLS/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/XLS/name)
 * @property {string} url - URL of Excel file. (/layers/baseLayer|overlays/items/XLS/url)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/XLS/visibility)
 * @property {string|null} srsName - Projection of layer. If null, then EPSG 4326 will be used. (/layers/baseLayer|overlays/items/XLS/srsName)
 * @property {object} excelOptions - Options only for XLS layer. (/layers/baseLayer|overlays/items/XLS/csvOptions)
 * @property {boolean} excelOptions.header - Should the first row be used as header. (/layers/baseLayer|overlays/items/XLS/excelOptions/header)
 * @property {integer[]} excelOptions.columnsToParse - Names (strings) or positions (integer) of columns that should be used as attributes. 1 is the start position. If null, then all columns will be used. (/layers/baseLayer|overlays/items/XLS/excelOptions/columnsToParse)
 * @property {integer[]} excelOptions.columnNames - ADefine custom column names. Used only if header is false. The length should be the same as in columnsToParse.. (/layers/baseLayer|overlays/items/XLS/excelOptions/columnNames)
 * @property {string|integer} excelOptions.LatColumn - Name (string) or position (integer) of column with coordinates (Lat). The coordinate system is defined through srsName. (/layers/baseLayer|overlays/items/XLS/excelOptions/LatColumn)
 * @property {string|integer} excelOptions.LonColumn - Name (string) or position (integer) of column with coordinates (Lon). The coordinate system is defined through srsName. (/layers/baseLayer|overlays/items/XLS/excelOptions/LonColumn)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/XLS/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/XLS/maxResolution)
 * @property {boolean} edit - Enable edit layer. Always false. (/layers/baseLayer|overlays/items/XLS/edit)
 * @property {string|null} style - Style of WFS. Use /styles/items/name. (/layers/baseLayer|overlays/items/XLS/style)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/XLS/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/XLS/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/baseLayer|overlays/items/XLS/legendUrl)
 */
/**
 * GPS layer (/layers/baseLayer|overlays/items/GPS)
 * @typedef {object} GPS
 * @property {string} type - Type of layer: GPS (/layers/baseLayer|overlays/items/GPS/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/GPS/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/GPS/name)
 * @property {string} url - URL of GPX file. (/layers/baseLayer|overlays/items/GPS/url)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/GPS/visibility)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/GPS/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/GPS/maxResolution)
 * @property {boolean} edit - Enable edit layer. Always false. (/layers/baseLayer|overlays/items/GPS/edit)
 * @property {string|null} style - Style of WFS. Use /styles/items/name. (/layers/baseLayer|overlays/items/GPS/style)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/GPS/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/GPS/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/baseLayer|overlays/items/GPS/legendUrl)
 */
/**
 * BKG layer (/layers/baseLayer|overlays/items/BKG)
 * @typedef {object} BKG
 * @property {string} type - Type of layer: BKG (/layers/baseLayer|overlays/items/BKG/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer|overlays/items/BKG/id)
 * @property {string} name - Name of layer shown in Menu. (/layers/baseLayer|overlays/items/BKG/name)
 * @property {string} ref - Reference of layer in BKG layer registry. This is the name of BKG layer to load. (/layers/baseLayer|overlays/items/BKG/ref)
 * @property {boolean} visibility - Initial visibility of layer. (/layers/baseLayer|overlays/items/BKG/visibility)
 * @property {string|null} srsName - Projection of layer. If null, then map projection will be used. (/layers/baseLayer|overlays/items/BKG/srsName)
 * @property {number} minResolution - Minimum resolution. (/layers/baseLayer|overlays/items/BKG/minResolution)
 * @property {number} maxResolution - Maximum resolution. (/layers/baseLayer|overlays/items/BKG/maxResolution)
 * @property {object} properties - Updates for the layer that will overwrite the preconfigured values. The complete set of available properties depends on the preconfigured layer class. (/layers/baseLayer|overlays/items/BKG/properties)
 * @property {number} opacity - Default Opacity. (Values: 0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9, 1)(/layers/baseLayer|overlays/items/BKG/opacity)
 * @property {string|null} copyright - Copyright. If null or empty it will be parsed from GetCapabilities. (/layers/baseLayer|overlays/items/BKG/copyright)
 * @property {string|null} legendUrl - URL for legend. (/layers/baseLayer|overlays/items/BKG/legendUrl)
 */
/**
 * GROUP layer (/layers/overlays/items/GROUP)
 * @typedef {object} GROUP
 * @property {string} type - Type of layer: GROUP (/layers/overlays/items/GROUP/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/overlays/items/GROUP/id)
 * @property {string} name - Name of group. (/layers/overlays/items/GROUP/name)
 *
 * @property {object[]} layers - List of layers in a group. The position in this list will determine the position on map. (Array values: {@link WMS}, {@link WMTS}, {@link WFS}, {@link MARKER}, {@link CSV}, {@link CSV}, {@link XLS}, {@link GPS}, {@link BKG}) (/layers/overlays/items/GROUP/layers)
 *
 * @property {boolean} visibility - Initial visibility of layer. (/layers/overlays/items/GROUP/visibility)
 */
/**
 * NONE layer (/layers/baseLayer/items/NONE)
 * @typedef {object} NONE
 * @property {string} type - Type of layer: NONE (/layers/baseLayer/items/NONE/type)
 * @property {string|null} id - Unique ID. It will be used in permaLink and persistence JSON. If not available, it will be added by Framework. (/layers/baseLayer/items/NONE/id)
 */
/**
 * Parses layer configuration used for creating map layers when calling create.
 * @memberOf BKGWebMap.MapBuilder
 * @param {object|array} layersConfig -Object with configuration parameters for layers or array with ol.layer class. If OpenLayers classes are directly used, all layers are in basemaps group. (/layers)
 * @param {WMS[]|WMTS[]|WFS[]|MARKER[]|CSV[]|XLS[]|GPS[]|BKG[]|NONE[]} layersConfig.baseLayers - Base layers. The order of layers will be used in menu. The array can have any of the following layer definitions: WMS, WMTS, WFS, MARKER, CSV, XLS, GPS, BKG, NONE (/layers/baseLayers)
 * @param {WMS[]|WMTS[]|WFS[]|MARKER[]|CSV[]|XLS[]|GPS[]|BKG[]|GROUP[]} layersConfig.overlays - Layers and group of layers that will be loaded as overlays. The order of layers will be used in menu. The array can have any of the following layer definitions: WMS, WMTS, WFS, MARKER, CSV, XLS, GPS, BKG, GROUP (/layers/overlays)
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.setLayers = function (layersConfig) {
    // Parse only objects or arrays
    if (layersConfig && ((typeof layersConfig === 'object' && layersConfig.constructor === Object) || layersConfig instanceof Array)) {
        this.layersConfig = layersConfig;
        this.called.setLayers = true;
    } else {
        this.layersConfig = this.DEFAULT_LAYERS_CONFIG;
    }
    return this;
};

/**
 * GROUP layer (/styles/items/symbol)
 * @typedef {object} symbol_style
 * @property {string} name - Name of style. This should be used as reference for a layer. (/styles/items/symbol/name)
 * @property {string} type - Type of style: symbol. (/styles/items/symbol/type)
 * @property {string} fillColor - Fill color for vector layers. A hexadecimal value. (/styles/items/symbol/fillColor)
 * @property {string} strokeColor - Stroke color for vector layers. A hexadecimal value. (/styles/items/symbol/strokeColor)
 * @property {string} symbol - Symbol for vector layers (points). (Values: "marker", "star", "circle", "dottedCircle", "pentagon") (/styles/items/symbol/symbol)
 */
/**
 * GROUP layer (/styles/items/custom)
 * @typedef {object} custom_style
 * @property {string} name - Name of style. This should be used as reference for a layer. (/styles/items/custom/name)
 * @property {string} type - Type of style: custom. (/styles/items/custom/type)
 * @property {object} fill - Properties of OpenLayers Class ol.style.Fill. (/styles/items/custom/fill)
 * @property {object} stroke - SProperties of OpenLayers Class ol.style.Stroke. (/styles/items/custom/stroke)
 * @property {object} image - Styling points. Use only one key of the following. If more than one keys are used, this is the reading order: regularShape->icon->circle (last overwrites first) (/styles/items/custom/image)
 * @property {object} image.circle - Properties of OpenLayers Class ol.style.Circle (/styles/items/custom/image/circle)
 * @property {object} image.icon - Properties of OpenLayers Class ol.style.Icon (/styles/items/custom/image/icon)
 * @property {object} image.regularShape - Properties of OpenLayers Class ol.style.RegularShape (/styles/items/custom/image/regularShape)
 */
/**
 * Parse styles used for vector layers
 * @param {symbol_style[]|custom_style[]} stylesConfig - Array with style configuration (/styles)
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.defineStyles = function (stylesConfig) {
    // Parse only arrays
    if (stylesConfig && stylesConfig instanceof Array) {
        this.stylesArray = stylesConfig;
        this.called.defineStyles = true;
    }
    return this;
};

/**
 * Parse configuration for security. Define cookieCheck and information about secure BKG Services.
 * @memberOf BKGWebMap.MapBuilder
 * @param {object} securityConfig - Security options. (/security)
 * @param {boolean} securityConfig.cookieCheck - Should the application use cookie test. (/security/cookieCheck)
 * @param {string} securityConfig.UUID - BKG UUID. (/security/UUID)
 * @param {string} securityConfig.appID - BKG Application ID. (/security/appID)
 * @param {string} securityConfig.appDomain - Domain for BKG Application ID. (/security/appDomain)
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.setSecurity = function (securityConfig) {
    if (securityConfig && (typeof securityConfig === 'object' && securityConfig.constructor === Object)) {
        this.securityConfig = securityConfig;
        this.called.setSecurity = true;
    }
    return this;
};

/**
 * Parses a configuration JSON for BKG WebMap. It can be either the URL of a JSON file or the JSON itself.
 * @memberOf BKGWebMap.MapBuilder
 * @param {string|object} config - JSON or filename or JSON with BKG WebMap configuration. (/)
 * @return {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.loadConfig = function (config) {
    if (typeof config === 'string' || config instanceof String) {
        this.configFile = true;
        this.configUrlOrJson = config;
    } else if (config && typeof config === 'object' && config.constructor === Object) {
        this.configFile = false;
        this.configUrlOrJson = config;
    }
    this.called.loadConfig = true;
    return this;
};

/**
 * Callback for getting ready map object. You can use the parameter to change the map.
 * @callback createCallback
 * @param {ol.Map} _this.map - OpenLayer map object.
 */
/**
 * Creates the map with current configuration and returns MapBuilder object.
 * @memberOf BKGWebMap.MapBuilder
 * @param {createCallback} callback - Callback for getting ready map object. You can use it to change the map.
 * @returns {BKGWebMap.MapBuilder}
 */
BKGWebMap.MapBuilder.prototype.create = function (callback) {
    var _this = this;

    // Find and parse config json
    var jsonConfig = new BKGWebMap.ParseConfig();

    // Test if we load app using an user-imported JSON file
    // The content if file is saved in sessionStorage
    try {
        if (window.sessionStorage.getItem('bkgwebmap')) {
            _this.configFile = false;

            // Read sessionStorage 'bkgwebmap' key
            var json = window.sessionStorage.getItem('bkgwebmap');
            _this.configUrlOrJson = JSON.parse(json);

            _this.viewConfig = null;
            _this.layersConfig = null;
            _this.called.setTarget = false;
            _this.called.setView = false;
            _this.called.setLayers = false;
            _this.called.loadConfig = true;

            // Remove sessionStorage 'bkgwebmap' key
            window.sessionStorage.removeItem('bkgwebmap');

            if (_this.configUrlOrJson.version && _this.configUrlOrJson.version !== BKGWebMap.VERSION) {
                window.console.log(BKGWebMap.ERROR.wrongPersistenceVersion);
            }
        }
    } catch (err) {
        window.console.log(BKGWebMap.ERROR.enableCookiesImport);
    }

    jsonConfig.LoadJSON(_this.configFile, _this.configUrlOrJson, function () {
        _this.map = new ol.Map({
            controls: ol.control.defaults({
                attribution: false,
                zoom: false,
                rotate: false
            })
        });

        _this.map.getInteractions().forEach(function (interaction) {
            if (interaction instanceof ol.interaction.KeyboardPan) {
                _this.map.removeInteraction(interaction);
            }
        });


        if (_this.called.setView) {
            _this.div = jsonConfig.createConfigTarget(_this.div, _this.called.setTarget);
            // If OpenLayers class ol.View is used, do not parse View from json
            if (!(_this.viewConfig instanceof ol.View)) {
                _this.viewConfig = jsonConfig.createConfigView(_this.DEFAULT_VIEW_CONFIG, _this.viewConfig, _this.called.setView);
            }
        } else if (jsonConfig.exists) {
            _this.div = jsonConfig.createConfigTarget(_this.div, _this.called.setTarget);
            // If OpenLayers class ol.View is used, do not parse View from json
            if (!(_this.viewConfig instanceof ol.View)) {
                _this.viewConfig = jsonConfig.createConfigView(_this.DEFAULT_VIEW_CONFIG, _this.viewConfig, _this.called.setView);
            }
        } else {
            _this.viewConfig = _this.DEFAULT_VIEW_CONFIG;
        }

        var mapDiv = document.getElementById(_this.div);

        // Error: mapDiv
        if (mapDiv === null || mapDiv === undefined) {
            window.console.log(BKGWebMap.ERROR.mapDiv + _this.div);
            return;
        }

        _this.map.setTarget(_this.div);

        // ***** View *****
        // Create and use view
        var view;
        if (_this.viewConfig instanceof ol.View) {
            view = _this.viewConfig;
        } else {
            view = BKGWebMap.View.create(_this.viewConfig);
        }

        // Define right extent for map projection
        var projectionCode = view.getProjection().getCode();
        var projection = ol.proj.get(projectionCode);
        projection.setExtent(BKGWebMap.PROJECTIONS_EXTENTS[projectionCode]);

        _this.map.setView(view);

        // If there either zoom nor resolution defined, find best resolution for map
        if (!_this.viewConfig.zoom && !_this.viewConfig.resolution && !(_this.viewConfig instanceof ol.View)) {
            _this.viewConfig.resolution = BKGWebMap.View.findBestResolution(_this.viewConfig, _this.map);
            view.setResolution(_this.viewConfig.resolution);
        }

        // Use mapExent and if there is no center defined, fit map to default extent
        if (_this.viewConfig.mapExtent && _this.viewConfig.mapExtent instanceof Array) {
            view.fit(_this.viewConfig.mapExtent, { size: _this.map.getSize() });

            view.calculateExtent(_this.map.getSize());
        } else if (!_this.viewConfig.center && !(_this.viewConfig instanceof ol.View)) {
            view.fit(BKGWebMap.EXTENTS[_this.viewConfig.projection], { size: _this.map.getSize() });
        }
        // ***************

        // ***** Styles *****
        _this.styles = jsonConfig.createConfigStyles(_this.stylesArray, _this.called.defineStyles);
        // ******************

        // ***** Security *****
        // Generate UUID first and then load layers and controls
        jsonConfig.getSecurityOptions(_this.map, _this.securityConfig, _this.called.setSecurity, function (security) {
            BKGWebMap.SECURITY = security;

            // ***** Controls *****
            // Create control for standard control icons position
            var standardPositionControls = {};
            var standardPositions = BKGWebMap.Control.FACTORIES.standardPosition();
            for (var standardPosition in standardPositions) {
                standardPositionControls[standardPosition] = new standardPositions[standardPosition](_this.map, standardPosition);
                if (Object.keys(standardPositionControls[standardPosition]).length > 0) {
                    _this.map.addControl(standardPositionControls[standardPosition]);
                }
            }
            // Firstly add panel if it is defined in config and get a boolean indicating if a panel exists
            var panel = jsonConfig.createControlPanel(_this.map, _this.controlsConfig, _this.called.setControls, standardPositionControls);
            if (panel) {
                _this.map.addControl(panel);
            }
            // Then add all other controls
            var controls = jsonConfig.createControls(_this.map, _this.controlsConfig, _this.called.setControls, panel, standardPositionControls);
            BKGWebMap.Util.each(controls, function (index, control) {
                if (control) {
                    _this.map.addControl(control);
                }
            });

            // Find if we have layerswitcher, custom layers, legend, copyright and edit control
            var layerSwitcher;
            var customLayers;
            var legend;
            var copyright;
            var edit;
            var permaLink;
            var overviewMap;
            var timeSlider;
            _this.map.getControls().forEach(function (control) {
                if (BKGWebMap.Control.LayerSwitcher && control instanceof BKGWebMap.Control.LayerSwitcher) {
                    layerSwitcher = control;
                    _this.map.getView().on('change:resolution', function () {
                        _this.map.getLayers().forEach(function (layer) {
                            layerSwitcher.resolutionLimits(layer);
                        });
                    });
                }
                if (BKGWebMap.Control.CustomLayers && control instanceof BKGWebMap.Control.CustomLayers) {
                    customLayers = control;
                    customLayers.initializeControl(layerSwitcher, _this.styles);
                }
                if (BKGWebMap.Control.Legend && control instanceof BKGWebMap.Control.Legend) {
                    legend = control;
                }
                if (BKGWebMap.Control.Copyright && control instanceof BKGWebMap.Control.Copyright) {
                    copyright = control;
                }
                if (BKGWebMap.Control.Edit && control instanceof BKGWebMap.Control.Edit) {
                    edit = control;
                }
                if (BKGWebMap.Control.Share && control instanceof BKGWebMap.Control.Share) {
                    if (Object.prototype.hasOwnProperty.call(control, 'permaLink') && Object.prototype.hasOwnProperty.call(control.permaLink, 'active')) {
                        permaLink = control.permaLink;
                    }
                }
                if (BKGWebMap.Control.OverviewMap && control instanceof BKGWebMap.Control.OverviewMap) {
                    overviewMap = control;
                }
                if (BKGWebMap.Control.TimeSlider && control instanceof BKGWebMap.Control.TimeSlider) {
                    timeSlider = control;
                }
                if (BKGWebMap.Control.FullScreen && control instanceof BKGWebMap.Control.FullScreen) {
                    control.fullScreenListener();
                }
            });
            // ********************

            // *****Layers*****
            jsonConfig.createConfigLayers(_this.map, _this.DEFAULT_LAYERS_CONFIG, _this.layersConfig, _this.styles, _this.called.setLayers, function (layers) {
                var readLayersFromPermaLink = false;
                if (permaLink) {
                    readLayersFromPermaLink = permaLink.readLayersFromPermaLink;
                }
                if (permaLink && readLayersFromPermaLink) {
                    layers = permaLink.changeLayersOrder(layers);
                }

                BKGWebMap.Util.reverseEach(layers.baseLayers, function (index, layer) {
                    if (layer) {
                        _this.map.addLayer(layer);
                        if (layerSwitcher) {
                            layerSwitcher.addInLayerSwitcher(layer, true, false, true, null);
                            layerSwitcher.resolutionLimits(layer);
                            layerSwitcher.ajaxLoader(layer);
                        }
                        if (legend) {
                            legend.addLayerToLegend(layer);
                        }
                        if (copyright) {
                            copyright.addLayerInCopyright(layer);
                        }
                        if (timeSlider) {
                            timeSlider.addLayerInTimeSlider(layer);
                        }
                    }
                });
                BKGWebMap.Util.reverseEach(layers.overlays, function (index, layer) {
                    if (layer) {
                        _this.map.addLayer(layer);
                        if (layerSwitcher) {
                            layerSwitcher.addInLayerSwitcher(layer, false, false, true, null);
                            layerSwitcher.resolutionLimits(layer);
                            layerSwitcher.ajaxLoader(layer);
                        }
                        if (legend) {
                            legend.addLayerToLegend(layer);
                        }
                        if (copyright) {
                            copyright.addLayerInCopyright(layer);
                        }
                        if (edit) {
                            edit.getEditableLayer(_this.map, layer);
                            var editableLayerAvailable = edit.editableLayerAvailable();
                            if (editableLayerAvailable === false) {
                                edit.addEmptyLayer();
                            }
                        }
                        if (timeSlider) {
                            timeSlider.addLayerInTimeSlider(layer);
                        }
                    }
                });

                if (!layers.overlays.length && edit) {
                    var editableLayerAvailable = edit.editableLayerAvailable();
                    if (editableLayerAvailable === false) {
                        edit.addEmptyLayer();
                    }
                }
                if (permaLink && !readLayersFromPermaLink) {
                    permaLink.changeLayersInPermalink();
                }

                if (layerSwitcher) {
                    layerSwitcher.permaLinkActivated = true;
                }

                if (overviewMap) {
                    setTimeout(function () {
                        overviewMap.activateOverviewMap();
                    }, 500);
                }

                // Open panel if needed
                if (panel) {
                    panel.initialize();
                }

                // Add layer event
                _this.map.getLayers().on('add', function (event) {
                    function createLayer(map, config, layerGroup, styles, bkg, createLayerCallback) {
                        config.isBaseLayer = false;
                        BKGWebMap.Layer.FACTORIES[config.type](null, map, config, styles, bkg, function (layer) {
                            return createLayerCallback(layer);
                        });
                    }

                    function adjustControls(addedLayer) {
                        _this.map.getControls().forEach(function (control) {
                            var changeVisibility = BKGWebMap.CONTROLS.tools.customLayers.changeVisibility;
                            if (BKGWebMap.Control.CustomLayers && control instanceof BKGWebMap.Control.CustomLayers) {
                                changeVisibility = control.changeVisibility;
                            }
                            if (BKGWebMap.Control.LayerSwitcher && control instanceof BKGWebMap.Control.LayerSwitcher) {
                                control.addInLayerSwitcher(addedLayer, false, false, false, changeVisibility);
                                control.resolutionLimits(addedLayer);
                                control.ajaxLoader(addedLayer);
                            }
                            if (BKGWebMap.Control.Legend && control instanceof BKGWebMap.Control.Legend) {
                                control.addLayerToLegend(addedLayer, false, false, true);
                            }
                            if (BKGWebMap.Control.Copyright && control instanceof BKGWebMap.Control.Copyright) {
                                control.addLayerInCopyright(addedLayer);
                            }
                        });
                    }
                    var layer = event.element;
                    if (layer.getProperties().measureLayer) {
                        return;
                    }
                    if (!layer.getProperties().uniqueId) {
                        _this.map.removeLayer(layer);
                        var config = BKGWebMap.Layer.Util.programmaticLayerConfig(layer);
                        if (config) {
                            if (typeof config === 'object') {
                                createLayer(_this.map, config, 'overlays', null, false, function (layerToAdd) {
                                    _this.map.addLayer(layerToAdd);
                                    adjustControls(layerToAdd);
                                });
                            } else if (typeof config === 'string' && config !== '') {
                                layer.setProperties({ uniqueId: config });
                                _this.map.addLayer(layer);
                                adjustControls(layer);
                            }
                        }
                    }
                });

                if (callback) {
                    return callback(_this.map);
                }
            });
            // ***************

            return undefined;
        });
        // ********************
    });
    return this;
};

/**
 * Getter: It returns the map object, but it is not ready with all elements. Better use the callback of create(): {@link createCallback}
 * @type {function}
 * @memberOf BKGWebMap.MapBuilder
 * @returns {ol.Map}
 */
BKGWebMap.MapBuilder.prototype.getMap = function () {
    return this.map;
};

/**
 * Namespace: okapi
 *
 * The okapi object provides a namespace for all geo.okapi things.
 *
 * <br/>
 *
 * Created by thalheim on 30.11.2018.
 *
 * @namespace okapi
 * @constructor okapi
 * @returns {object}
 * @author <a href="dirk.thalheim@bkg.bund.de">Dirk Thalheim</a>
 */

var okapi = BKGWebMap;

